/* ZoomWidget.c generated by valac 0.56.14, the Vala compiler
 * generated from ZoomWidget.vala, do not modify */

/*
* Copyright (c) 2021 (https://github.com/phase1geo/Outliner)
*
* This program is free software; you can redistribute it and/or
* modify it under the terms of the GNU General Public
* License as published by the Free Software Foundation; either
* version 2 of the License, or (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
* General Public License for more details.
*
* You should have received a copy of the GNU General Public
* License along with this program; if not, write to the
* Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
* Boston, MA 02110-1301 USA
*
* Authored by: Trevor Williams <phase1geo@gmail.com>
*/
#if !defined VALA_STRICT_C && defined __GNUC__ && __GNUC__ >= 14
#pragma GCC diagnostic warning "-Wimplicit-function-declaration"
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#pragma GCC diagnostic warning "-Wint-conversion"
#pragma GCC diagnostic warning "-Wreturn-mismatch"
#endif

#include <gtk/gtk.h>
#include <glib-object.h>
#include <glib.h>
#include <stdlib.h>
#include <string.h>
#include <glib/gi18n-lib.h>
#include <float.h>
#include <math.h>

#if !defined(VALA_EXTERN)
#if defined(_MSC_VER)
#define VALA_EXTERN __declspec(dllexport) extern
#elif __GNUC__ >= 4
#define VALA_EXTERN __attribute__((visibility("default"))) extern
#else
#define VALA_EXTERN extern
#endif
#endif

#define TYPE_ZOOM_WIDGET (zoom_widget_get_type ())
#define ZOOM_WIDGET(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_ZOOM_WIDGET, ZoomWidget))
#define ZOOM_WIDGET_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_ZOOM_WIDGET, ZoomWidgetClass))
#define IS_ZOOM_WIDGET(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_ZOOM_WIDGET))
#define IS_ZOOM_WIDGET_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_ZOOM_WIDGET))
#define ZOOM_WIDGET_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_ZOOM_WIDGET, ZoomWidgetClass))

typedef struct _ZoomWidget ZoomWidget;
typedef struct _ZoomWidgetClass ZoomWidgetClass;
typedef struct _ZoomWidgetPrivate ZoomWidgetPrivate;
enum  {
	ZOOM_WIDGET_0_PROPERTY,
	ZOOM_WIDGET_MIN_PROPERTY,
	ZOOM_WIDGET_MAX_PROPERTY,
	ZOOM_WIDGET_STEP_PROPERTY,
	ZOOM_WIDGET_VALUE_PROPERTY,
	ZOOM_WIDGET_FACTOR_PROPERTY,
	ZOOM_WIDGET_NUM_PROPERTIES
};
static GParamSpec* zoom_widget_properties[ZOOM_WIDGET_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
enum  {
	ZOOM_WIDGET_ZOOM_CHANGED_SIGNAL,
	ZOOM_WIDGET_NUM_SIGNALS
};
static guint zoom_widget_signals[ZOOM_WIDGET_NUM_SIGNALS] = {0};

struct _ZoomWidget {
	GtkBox parent_instance;
	ZoomWidgetPrivate * priv;
};

struct _ZoomWidgetClass {
	GtkBoxClass parent_class;
};

struct _ZoomWidgetPrivate {
	GtkButton* _zoom_out;
	GtkButton* _zoom_actual;
	GtkButton* _zoom_in;
	gint _min;
	gint _max;
	gint _value;
	gint _step;
};

static gint ZoomWidget_private_offset;
static gpointer zoom_widget_parent_class = NULL;

VALA_EXTERN GType zoom_widget_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (ZoomWidget, g_object_unref)
VALA_EXTERN ZoomWidget* zoom_widget_new (gint min,
                             gint max,
                             gint step,
                             gboolean fill);
VALA_EXTERN ZoomWidget* zoom_widget_construct (GType object_type,
                                   gint min,
                                   gint max,
                                   gint step,
                                   gboolean fill);
VALA_EXTERN void zoom_widget_set_min (ZoomWidget* self,
                          gint value);
VALA_EXTERN void zoom_widget_set_max (ZoomWidget* self,
                          gint value);
VALA_EXTERN void zoom_widget_set_step (ZoomWidget* self,
                           gint value);
VALA_EXTERN gchar* utils_tooltip_with_accel (const gchar* tooltip,
                                 const gchar* accel);
VALA_EXTERN void zoom_widget_zoom_out (ZoomWidget* self);
static void _zoom_widget_zoom_out_gtk_button_clicked (GtkButton* _sender,
                                               gpointer self);
VALA_EXTERN void zoom_widget_zoom_actual (ZoomWidget* self);
static void _zoom_widget_zoom_actual_gtk_button_clicked (GtkButton* _sender,
                                                  gpointer self);
VALA_EXTERN void zoom_widget_zoom_in (ZoomWidget* self);
static void _zoom_widget_zoom_in_gtk_button_clicked (GtkButton* _sender,
                                              gpointer self);
static void zoom_widget_update_state (ZoomWidget* self);
VALA_EXTERN gint zoom_widget_get_value (ZoomWidget* self);
VALA_EXTERN gint zoom_widget_get_max (ZoomWidget* self);
VALA_EXTERN gint zoom_widget_get_min (ZoomWidget* self);
VALA_EXTERN gint zoom_widget_get_step (ZoomWidget* self);
VALA_EXTERN void zoom_widget_set_value (ZoomWidget* self,
                            gint value);
VALA_EXTERN gdouble zoom_widget_get_factor (ZoomWidget* self);
static void zoom_widget_finalize (GObject * obj);
static GType zoom_widget_get_type_once (void);
static void _vala_zoom_widget_get_property (GObject * object,
                                     guint property_id,
                                     GValue * value,
                                     GParamSpec * pspec);
static void _vala_zoom_widget_set_property (GObject * object,
                                     guint property_id,
                                     const GValue * value,
                                     GParamSpec * pspec);
static inline gpointer _vala_memdup2 (gconstpointer mem,
                        gsize byte_size);

static inline gpointer
zoom_widget_get_instance_private (ZoomWidget* self)
{
	return G_STRUCT_MEMBER_P (self, ZoomWidget_private_offset);
}

static void
_zoom_widget_zoom_out_gtk_button_clicked (GtkButton* _sender,
                                          gpointer self)
{
#line 93 "../src/ZoomWidget.vala"
	zoom_widget_zoom_out ((ZoomWidget*) self);
#line 162 "ZoomWidget.c"
}

static void
_zoom_widget_zoom_actual_gtk_button_clicked (GtkButton* _sender,
                                             gpointer self)
{
#line 98 "../src/ZoomWidget.vala"
	zoom_widget_zoom_actual ((ZoomWidget*) self);
#line 171 "ZoomWidget.c"
}

static void
_zoom_widget_zoom_in_gtk_button_clicked (GtkButton* _sender,
                                         gpointer self)
{
#line 103 "../src/ZoomWidget.vala"
	zoom_widget_zoom_in ((ZoomWidget*) self);
#line 180 "ZoomWidget.c"
}

ZoomWidget*
zoom_widget_construct (GType object_type,
                       gint min,
                       gint max,
                       gint step,
                       gboolean fill)
{
	ZoomWidget * self = NULL;
	GtkStyleContext* _tmp0_;
	GtkButton* _tmp1_;
	GtkButton* _tmp2_;
	GtkButton* _tmp3_;
	gchar* _tmp4_;
	gchar* _tmp5_;
	GtkButton* _tmp6_;
	GtkButton* _tmp7_;
	GtkButton* _tmp8_;
	GtkButton* _tmp9_;
	gchar* _tmp10_;
	gchar* _tmp11_;
	GtkButton* _tmp12_;
	GtkButton* _tmp13_;
	GtkButton* _tmp14_;
	GtkButton* _tmp15_;
	gchar* _tmp16_;
	gchar* _tmp17_;
	GtkButton* _tmp18_;
	GtkButton* _tmp19_;
	GtkButton* _tmp20_;
	GtkButton* _tmp21_;
#line 80 "../src/ZoomWidget.vala"
	self = (ZoomWidget*) g_object_new (object_type, NULL);
#line 82 "../src/ZoomWidget.vala"
	zoom_widget_set_min (self, min);
#line 83 "../src/ZoomWidget.vala"
	zoom_widget_set_max (self, max);
#line 84 "../src/ZoomWidget.vala"
	zoom_widget_set_step (self, step);
#line 86 "../src/ZoomWidget.vala"
	gtk_box_set_homogeneous ((GtkBox*) self, TRUE);
#line 88 "../src/ZoomWidget.vala"
	_tmp0_ = gtk_widget_get_style_context ((GtkWidget*) self);
#line 88 "../src/ZoomWidget.vala"
	gtk_style_context_add_class (_tmp0_, GTK_STYLE_CLASS_LINKED);
#line 90 "../src/ZoomWidget.vala"
	_tmp1_ = (GtkButton*) gtk_button_new_from_icon_name ("zoom-out-symbolic", (GtkIconSize) GTK_ICON_SIZE_SMALL_TOOLBAR);
#line 90 "../src/ZoomWidget.vala"
	g_object_ref_sink (_tmp1_);
#line 90 "../src/ZoomWidget.vala"
	_g_object_unref0 (self->priv->_zoom_out);
#line 90 "../src/ZoomWidget.vala"
	self->priv->_zoom_out = _tmp1_;
#line 91 "../src/ZoomWidget.vala"
	_tmp2_ = self->priv->_zoom_out;
#line 91 "../src/ZoomWidget.vala"
	gtk_button_set_relief (_tmp2_, GTK_RELIEF_NORMAL);
#line 92 "../src/ZoomWidget.vala"
	_tmp3_ = self->priv->_zoom_out;
#line 92 "../src/ZoomWidget.vala"
	_tmp4_ = utils_tooltip_with_accel (_ ("Zoom Out"), "<Control>minus");
#line 92 "../src/ZoomWidget.vala"
	_tmp5_ = _tmp4_;
#line 92 "../src/ZoomWidget.vala"
	gtk_widget_set_tooltip_markup ((GtkWidget*) _tmp3_, _tmp5_);
#line 92 "../src/ZoomWidget.vala"
	_g_free0 (_tmp5_);
#line 93 "../src/ZoomWidget.vala"
	_tmp6_ = self->priv->_zoom_out;
#line 93 "../src/ZoomWidget.vala"
	g_signal_connect_object (_tmp6_, "clicked", (GCallback) _zoom_widget_zoom_out_gtk_button_clicked, self, 0);
#line 95 "../src/ZoomWidget.vala"
	_tmp7_ = (GtkButton*) gtk_button_new_with_label ("100%");
#line 95 "../src/ZoomWidget.vala"
	g_object_ref_sink (_tmp7_);
#line 95 "../src/ZoomWidget.vala"
	_g_object_unref0 (self->priv->_zoom_actual);
#line 95 "../src/ZoomWidget.vala"
	self->priv->_zoom_actual = _tmp7_;
#line 96 "../src/ZoomWidget.vala"
	_tmp8_ = self->priv->_zoom_actual;
#line 96 "../src/ZoomWidget.vala"
	gtk_button_set_relief (_tmp8_, GTK_RELIEF_NORMAL);
#line 97 "../src/ZoomWidget.vala"
	_tmp9_ = self->priv->_zoom_actual;
#line 97 "../src/ZoomWidget.vala"
	_tmp10_ = utils_tooltip_with_accel (_ ("Zoom Actual"), "<Control>0");
#line 97 "../src/ZoomWidget.vala"
	_tmp11_ = _tmp10_;
#line 97 "../src/ZoomWidget.vala"
	gtk_widget_set_tooltip_markup ((GtkWidget*) _tmp9_, _tmp11_);
#line 97 "../src/ZoomWidget.vala"
	_g_free0 (_tmp11_);
#line 98 "../src/ZoomWidget.vala"
	_tmp12_ = self->priv->_zoom_actual;
#line 98 "../src/ZoomWidget.vala"
	g_signal_connect_object (_tmp12_, "clicked", (GCallback) _zoom_widget_zoom_actual_gtk_button_clicked, self, 0);
#line 100 "../src/ZoomWidget.vala"
	_tmp13_ = (GtkButton*) gtk_button_new_from_icon_name ("zoom-in-symbolic", (GtkIconSize) GTK_ICON_SIZE_SMALL_TOOLBAR);
#line 100 "../src/ZoomWidget.vala"
	g_object_ref_sink (_tmp13_);
#line 100 "../src/ZoomWidget.vala"
	_g_object_unref0 (self->priv->_zoom_in);
#line 100 "../src/ZoomWidget.vala"
	self->priv->_zoom_in = _tmp13_;
#line 101 "../src/ZoomWidget.vala"
	_tmp14_ = self->priv->_zoom_in;
#line 101 "../src/ZoomWidget.vala"
	gtk_button_set_relief (_tmp14_, GTK_RELIEF_NORMAL);
#line 102 "../src/ZoomWidget.vala"
	_tmp15_ = self->priv->_zoom_in;
#line 102 "../src/ZoomWidget.vala"
	_tmp16_ = utils_tooltip_with_accel (_ ("Zoom In"), "<Control>plus");
#line 102 "../src/ZoomWidget.vala"
	_tmp17_ = _tmp16_;
#line 102 "../src/ZoomWidget.vala"
	gtk_widget_set_tooltip_markup ((GtkWidget*) _tmp15_, _tmp17_);
#line 102 "../src/ZoomWidget.vala"
	_g_free0 (_tmp17_);
#line 103 "../src/ZoomWidget.vala"
	_tmp18_ = self->priv->_zoom_in;
#line 103 "../src/ZoomWidget.vala"
	g_signal_connect_object (_tmp18_, "clicked", (GCallback) _zoom_widget_zoom_in_gtk_button_clicked, self, 0);
#line 105 "../src/ZoomWidget.vala"
	_tmp19_ = self->priv->_zoom_out;
#line 105 "../src/ZoomWidget.vala"
	gtk_box_pack_start ((GtkBox*) self, (GtkWidget*) _tmp19_, FALSE, fill, (guint) 0);
#line 106 "../src/ZoomWidget.vala"
	_tmp20_ = self->priv->_zoom_actual;
#line 106 "../src/ZoomWidget.vala"
	gtk_box_pack_start ((GtkBox*) self, (GtkWidget*) _tmp20_, FALSE, fill, (guint) 0);
#line 107 "../src/ZoomWidget.vala"
	_tmp21_ = self->priv->_zoom_in;
#line 107 "../src/ZoomWidget.vala"
	gtk_box_pack_start ((GtkBox*) self, (GtkWidget*) _tmp21_, FALSE, fill, (guint) 0);
#line 110 "../src/ZoomWidget.vala"
	zoom_widget_update_state (self);
#line 80 "../src/ZoomWidget.vala"
	return self;
#line 321 "ZoomWidget.c"
}

ZoomWidget*
zoom_widget_new (gint min,
                 gint max,
                 gint step,
                 gboolean fill)
{
#line 80 "../src/ZoomWidget.vala"
	return zoom_widget_construct (TYPE_ZOOM_WIDGET, min, max, step, fill);
#line 332 "ZoomWidget.c"
}

static void
zoom_widget_update_state (ZoomWidget* self)
{
	GtkButton* _tmp0_;
	gint _tmp1_;
	gint _tmp2_;
	gint _tmp3_;
	gint _tmp4_;
	GtkButton* _tmp5_;
	gint _tmp6_;
	gint _tmp7_;
	gint _tmp8_;
	gint _tmp9_;
	GtkButton* _tmp10_;
	gint _tmp11_;
	gint _tmp12_;
	gchar* _tmp13_;
	gchar* _tmp14_;
#line 115 "../src/ZoomWidget.vala"
	g_return_if_fail (self != NULL);
#line 116 "../src/ZoomWidget.vala"
	_tmp0_ = self->priv->_zoom_in;
#line 116 "../src/ZoomWidget.vala"
	_tmp1_ = zoom_widget_get_value (self);
#line 116 "../src/ZoomWidget.vala"
	_tmp2_ = _tmp1_;
#line 116 "../src/ZoomWidget.vala"
	_tmp3_ = zoom_widget_get_max (self);
#line 116 "../src/ZoomWidget.vala"
	_tmp4_ = _tmp3_;
#line 116 "../src/ZoomWidget.vala"
	gtk_widget_set_sensitive ((GtkWidget*) _tmp0_, _tmp2_ < _tmp4_);
#line 117 "../src/ZoomWidget.vala"
	_tmp5_ = self->priv->_zoom_out;
#line 117 "../src/ZoomWidget.vala"
	_tmp6_ = zoom_widget_get_value (self);
#line 117 "../src/ZoomWidget.vala"
	_tmp7_ = _tmp6_;
#line 117 "../src/ZoomWidget.vala"
	_tmp8_ = zoom_widget_get_min (self);
#line 117 "../src/ZoomWidget.vala"
	_tmp9_ = _tmp8_;
#line 117 "../src/ZoomWidget.vala"
	gtk_widget_set_sensitive ((GtkWidget*) _tmp5_, _tmp7_ > _tmp9_);
#line 118 "../src/ZoomWidget.vala"
	_tmp10_ = self->priv->_zoom_actual;
#line 118 "../src/ZoomWidget.vala"
	_tmp11_ = zoom_widget_get_value (self);
#line 118 "../src/ZoomWidget.vala"
	_tmp12_ = _tmp11_;
#line 118 "../src/ZoomWidget.vala"
	_tmp13_ = g_strdup_printf ("%d%%", _tmp12_);
#line 118 "../src/ZoomWidget.vala"
	_tmp14_ = _tmp13_;
#line 118 "../src/ZoomWidget.vala"
	gtk_button_set_label (_tmp10_, _tmp14_);
#line 118 "../src/ZoomWidget.vala"
	_g_free0 (_tmp14_);
#line 393 "ZoomWidget.c"
}

void
zoom_widget_zoom_in (ZoomWidget* self)
{
	gint _tmp0_;
	gint _tmp1_;
	gint _tmp2_;
#line 122 "../src/ZoomWidget.vala"
	g_return_if_fail (self != NULL);
#line 123 "../src/ZoomWidget.vala"
	_tmp0_ = zoom_widget_get_value (self);
#line 123 "../src/ZoomWidget.vala"
	_tmp1_ = _tmp0_;
#line 123 "../src/ZoomWidget.vala"
	_tmp2_ = self->priv->_step;
#line 123 "../src/ZoomWidget.vala"
	zoom_widget_set_value (self, _tmp1_ + _tmp2_);
#line 412 "ZoomWidget.c"
}

void
zoom_widget_zoom_actual (ZoomWidget* self)
{
#line 127 "../src/ZoomWidget.vala"
	g_return_if_fail (self != NULL);
#line 128 "../src/ZoomWidget.vala"
	zoom_widget_set_value (self, 100);
#line 422 "ZoomWidget.c"
}

void
zoom_widget_zoom_out (ZoomWidget* self)
{
	gint _tmp0_;
	gint _tmp1_;
	gint _tmp2_;
#line 132 "../src/ZoomWidget.vala"
	g_return_if_fail (self != NULL);
#line 133 "../src/ZoomWidget.vala"
	_tmp0_ = zoom_widget_get_value (self);
#line 133 "../src/ZoomWidget.vala"
	_tmp1_ = _tmp0_;
#line 133 "../src/ZoomWidget.vala"
	_tmp2_ = self->priv->_step;
#line 133 "../src/ZoomWidget.vala"
	zoom_widget_set_value (self, _tmp1_ - _tmp2_);
#line 441 "ZoomWidget.c"
}

gint
zoom_widget_get_min (ZoomWidget* self)
{
	gint result;
#line 34 "../src/ZoomWidget.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 35 "../src/ZoomWidget.vala"
	result = self->priv->_min;
#line 35 "../src/ZoomWidget.vala"
	return result;
#line 454 "ZoomWidget.c"
}

void
zoom_widget_set_min (ZoomWidget* self,
                     gint value)
{
#line 37 "../src/ZoomWidget.vala"
	g_return_if_fail (self != NULL);
#line 38 "../src/ZoomWidget.vala"
	self->priv->_min = value;
#line 39 "../src/ZoomWidget.vala"
	value = self->priv->_value;
#line 37 "../src/ZoomWidget.vala"
	g_object_notify_by_pspec ((GObject *) self, zoom_widget_properties[ZOOM_WIDGET_MIN_PROPERTY]);
#line 469 "ZoomWidget.c"
}

gint
zoom_widget_get_max (ZoomWidget* self)
{
	gint result;
#line 44 "../src/ZoomWidget.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 45 "../src/ZoomWidget.vala"
	result = self->priv->_max;
#line 45 "../src/ZoomWidget.vala"
	return result;
#line 482 "ZoomWidget.c"
}

void
zoom_widget_set_max (ZoomWidget* self,
                     gint value)
{
#line 47 "../src/ZoomWidget.vala"
	g_return_if_fail (self != NULL);
#line 48 "../src/ZoomWidget.vala"
	self->priv->_max = value;
#line 49 "../src/ZoomWidget.vala"
	value = self->priv->_value;
#line 47 "../src/ZoomWidget.vala"
	g_object_notify_by_pspec ((GObject *) self, zoom_widget_properties[ZOOM_WIDGET_MAX_PROPERTY]);
#line 497 "ZoomWidget.c"
}

gint
zoom_widget_get_step (ZoomWidget* self)
{
	gint result;
#line 53 "../src/ZoomWidget.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 53 "../src/ZoomWidget.vala"
	result = self->priv->_step;
#line 53 "../src/ZoomWidget.vala"
	return result;
#line 510 "ZoomWidget.c"
}

void
zoom_widget_set_step (ZoomWidget* self,
                      gint value)
{
	gint old_value;
#line 53 "../src/ZoomWidget.vala"
	g_return_if_fail (self != NULL);
#line 53 "../src/ZoomWidget.vala"
	old_value = zoom_widget_get_step (self);
#line 53 "../src/ZoomWidget.vala"
	if (old_value != value) {
#line 53 "../src/ZoomWidget.vala"
		self->priv->_step = value;
#line 53 "../src/ZoomWidget.vala"
		g_object_notify_by_pspec ((GObject *) self, zoom_widget_properties[ZOOM_WIDGET_STEP_PROPERTY]);
#line 528 "ZoomWidget.c"
	}
}

gint
zoom_widget_get_value (ZoomWidget* self)
{
	gint result;
#line 56 "../src/ZoomWidget.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 57 "../src/ZoomWidget.vala"
	result = self->priv->_value;
#line 57 "../src/ZoomWidget.vala"
	return result;
#line 542 "ZoomWidget.c"
}

void
zoom_widget_set_value (ZoomWidget* self,
                       gint value)
{
	gint orig_value = 0;
	gint _tmp0_ = 0;
	gint _tmp1_;
	gint _tmp2_;
#line 59 "../src/ZoomWidget.vala"
	g_return_if_fail (self != NULL);
#line 60 "../src/ZoomWidget.vala"
	orig_value = self->priv->_value;
#line 61 "../src/ZoomWidget.vala"
	_tmp1_ = zoom_widget_get_min (self);
#line 61 "../src/ZoomWidget.vala"
	_tmp2_ = _tmp1_;
#line 61 "../src/ZoomWidget.vala"
	if (value < _tmp2_) {
#line 563 "ZoomWidget.c"
		gint _tmp3_;
		gint _tmp4_;
#line 61 "../src/ZoomWidget.vala"
		_tmp3_ = zoom_widget_get_min (self);
#line 61 "../src/ZoomWidget.vala"
		_tmp4_ = _tmp3_;
#line 61 "../src/ZoomWidget.vala"
		_tmp0_ = _tmp4_;
#line 572 "ZoomWidget.c"
	} else {
		gint _tmp5_ = 0;
		gint _tmp6_;
		gint _tmp7_;
#line 62 "../src/ZoomWidget.vala"
		_tmp6_ = zoom_widget_get_max (self);
#line 62 "../src/ZoomWidget.vala"
		_tmp7_ = _tmp6_;
#line 62 "../src/ZoomWidget.vala"
		if (value > _tmp7_) {
#line 583 "ZoomWidget.c"
			gint _tmp8_;
			gint _tmp9_;
#line 62 "../src/ZoomWidget.vala"
			_tmp8_ = zoom_widget_get_max (self);
#line 62 "../src/ZoomWidget.vala"
			_tmp9_ = _tmp8_;
#line 62 "../src/ZoomWidget.vala"
			_tmp5_ = _tmp9_;
#line 592 "ZoomWidget.c"
		} else {
#line 63 "../src/ZoomWidget.vala"
			_tmp5_ = value;
#line 596 "ZoomWidget.c"
		}
#line 62 "../src/ZoomWidget.vala"
		_tmp0_ = _tmp5_;
#line 600 "ZoomWidget.c"
	}
#line 61 "../src/ZoomWidget.vala"
	self->priv->_value = _tmp0_;
#line 64 "../src/ZoomWidget.vala"
	if (orig_value != self->priv->_value) {
#line 606 "ZoomWidget.c"
		gdouble _tmp10_;
		gdouble _tmp11_;
#line 65 "../src/ZoomWidget.vala"
		zoom_widget_update_state (self);
#line 66 "../src/ZoomWidget.vala"
		_tmp10_ = zoom_widget_get_factor (self);
#line 66 "../src/ZoomWidget.vala"
		_tmp11_ = _tmp10_;
#line 66 "../src/ZoomWidget.vala"
		g_signal_emit (self, zoom_widget_signals[ZOOM_WIDGET_ZOOM_CHANGED_SIGNAL], 0, _tmp11_);
#line 617 "ZoomWidget.c"
	}
#line 59 "../src/ZoomWidget.vala"
	g_object_notify_by_pspec ((GObject *) self, zoom_widget_properties[ZOOM_WIDGET_VALUE_PROPERTY]);
#line 621 "ZoomWidget.c"
}

gdouble
zoom_widget_get_factor (ZoomWidget* self)
{
	gdouble result;
	gint _tmp0_;
	gint _tmp1_;
#line 72 "../src/ZoomWidget.vala"
	g_return_val_if_fail (self != NULL, 0.0);
#line 73 "../src/ZoomWidget.vala"
	_tmp0_ = zoom_widget_get_value (self);
#line 73 "../src/ZoomWidget.vala"
	_tmp1_ = _tmp0_;
#line 73 "../src/ZoomWidget.vala"
	result = ((gdouble) _tmp1_) / 100;
#line 73 "../src/ZoomWidget.vala"
	return result;
#line 640 "ZoomWidget.c"
}

static void
zoom_widget_class_init (ZoomWidgetClass * klass,
                        gpointer klass_data)
{
#line 24 "../src/ZoomWidget.vala"
	zoom_widget_parent_class = g_type_class_peek_parent (klass);
#line 24 "../src/ZoomWidget.vala"
	g_type_class_adjust_private_offset (klass, &ZoomWidget_private_offset);
#line 24 "../src/ZoomWidget.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_zoom_widget_get_property;
#line 24 "../src/ZoomWidget.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_zoom_widget_set_property;
#line 24 "../src/ZoomWidget.vala"
	G_OBJECT_CLASS (klass)->finalize = zoom_widget_finalize;
#line 24 "../src/ZoomWidget.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), ZOOM_WIDGET_MIN_PROPERTY, zoom_widget_properties[ZOOM_WIDGET_MIN_PROPERTY] = g_param_spec_int ("min", "min", "min", G_MININT, G_MAXINT, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 24 "../src/ZoomWidget.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), ZOOM_WIDGET_MAX_PROPERTY, zoom_widget_properties[ZOOM_WIDGET_MAX_PROPERTY] = g_param_spec_int ("max", "max", "max", G_MININT, G_MAXINT, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 24 "../src/ZoomWidget.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), ZOOM_WIDGET_STEP_PROPERTY, zoom_widget_properties[ZOOM_WIDGET_STEP_PROPERTY] = g_param_spec_int ("step", "step", "step", G_MININT, G_MAXINT, 25, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 24 "../src/ZoomWidget.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), ZOOM_WIDGET_VALUE_PROPERTY, zoom_widget_properties[ZOOM_WIDGET_VALUE_PROPERTY] = g_param_spec_int ("value", "value", "value", G_MININT, G_MAXINT, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 24 "../src/ZoomWidget.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), ZOOM_WIDGET_FACTOR_PROPERTY, zoom_widget_properties[ZOOM_WIDGET_FACTOR_PROPERTY] = g_param_spec_double ("factor", "factor", "factor", -G_MAXDOUBLE, G_MAXDOUBLE, 0.0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 24 "../src/ZoomWidget.vala"
	zoom_widget_signals[ZOOM_WIDGET_ZOOM_CHANGED_SIGNAL] = g_signal_new ("zoom-changed", TYPE_ZOOM_WIDGET, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__DOUBLE, G_TYPE_NONE, 1, G_TYPE_DOUBLE);
#line 669 "ZoomWidget.c"
}

static void
zoom_widget_instance_init (ZoomWidget * self,
                           gpointer klass)
{
#line 24 "../src/ZoomWidget.vala"
	self->priv = zoom_widget_get_instance_private (self);
#line 29 "../src/ZoomWidget.vala"
	self->priv->_min = 100;
#line 30 "../src/ZoomWidget.vala"
	self->priv->_max = 400;
#line 31 "../src/ZoomWidget.vala"
	self->priv->_value = 100;
#line 53 "../src/ZoomWidget.vala"
	self->priv->_step = 25;
#line 686 "ZoomWidget.c"
}

static void
zoom_widget_finalize (GObject * obj)
{
	ZoomWidget * self;
#line 24 "../src/ZoomWidget.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_ZOOM_WIDGET, ZoomWidget);
#line 26 "../src/ZoomWidget.vala"
	_g_object_unref0 (self->priv->_zoom_out);
#line 27 "../src/ZoomWidget.vala"
	_g_object_unref0 (self->priv->_zoom_actual);
#line 28 "../src/ZoomWidget.vala"
	_g_object_unref0 (self->priv->_zoom_in);
#line 24 "../src/ZoomWidget.vala"
	G_OBJECT_CLASS (zoom_widget_parent_class)->finalize (obj);
#line 703 "ZoomWidget.c"
}

static GType
zoom_widget_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (ZoomWidgetClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) zoom_widget_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (ZoomWidget), 0, (GInstanceInitFunc) zoom_widget_instance_init, NULL };
	GType zoom_widget_type_id;
	zoom_widget_type_id = g_type_register_static (gtk_box_get_type (), "ZoomWidget", &g_define_type_info, 0);
	ZoomWidget_private_offset = g_type_add_instance_private (zoom_widget_type_id, sizeof (ZoomWidgetPrivate));
	return zoom_widget_type_id;
}

GType
zoom_widget_get_type (void)
{
	static volatile gsize zoom_widget_type_id__once = 0;
	if (g_once_init_enter (&zoom_widget_type_id__once)) {
		GType zoom_widget_type_id;
		zoom_widget_type_id = zoom_widget_get_type_once ();
		g_once_init_leave (&zoom_widget_type_id__once, zoom_widget_type_id);
	}
	return zoom_widget_type_id__once;
}

static void
_vala_zoom_widget_get_property (GObject * object,
                                guint property_id,
                                GValue * value,
                                GParamSpec * pspec)
{
	ZoomWidget * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_ZOOM_WIDGET, ZoomWidget);
#line 24 "../src/ZoomWidget.vala"
	switch (property_id) {
#line 24 "../src/ZoomWidget.vala"
		case ZOOM_WIDGET_MIN_PROPERTY:
#line 24 "../src/ZoomWidget.vala"
		g_value_set_int (value, zoom_widget_get_min (self));
#line 24 "../src/ZoomWidget.vala"
		break;
#line 24 "../src/ZoomWidget.vala"
		case ZOOM_WIDGET_MAX_PROPERTY:
#line 24 "../src/ZoomWidget.vala"
		g_value_set_int (value, zoom_widget_get_max (self));
#line 24 "../src/ZoomWidget.vala"
		break;
#line 24 "../src/ZoomWidget.vala"
		case ZOOM_WIDGET_STEP_PROPERTY:
#line 24 "../src/ZoomWidget.vala"
		g_value_set_int (value, zoom_widget_get_step (self));
#line 24 "../src/ZoomWidget.vala"
		break;
#line 24 "../src/ZoomWidget.vala"
		case ZOOM_WIDGET_VALUE_PROPERTY:
#line 24 "../src/ZoomWidget.vala"
		g_value_set_int (value, zoom_widget_get_value (self));
#line 24 "../src/ZoomWidget.vala"
		break;
#line 24 "../src/ZoomWidget.vala"
		case ZOOM_WIDGET_FACTOR_PROPERTY:
#line 24 "../src/ZoomWidget.vala"
		g_value_set_double (value, zoom_widget_get_factor (self));
#line 24 "../src/ZoomWidget.vala"
		break;
#line 768 "ZoomWidget.c"
		default:
#line 24 "../src/ZoomWidget.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 24 "../src/ZoomWidget.vala"
		break;
#line 774 "ZoomWidget.c"
	}
}

static void
_vala_zoom_widget_set_property (GObject * object,
                                guint property_id,
                                const GValue * value,
                                GParamSpec * pspec)
{
	ZoomWidget * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_ZOOM_WIDGET, ZoomWidget);
#line 24 "../src/ZoomWidget.vala"
	switch (property_id) {
#line 24 "../src/ZoomWidget.vala"
		case ZOOM_WIDGET_MIN_PROPERTY:
#line 24 "../src/ZoomWidget.vala"
		zoom_widget_set_min (self, g_value_get_int (value));
#line 24 "../src/ZoomWidget.vala"
		break;
#line 24 "../src/ZoomWidget.vala"
		case ZOOM_WIDGET_MAX_PROPERTY:
#line 24 "../src/ZoomWidget.vala"
		zoom_widget_set_max (self, g_value_get_int (value));
#line 24 "../src/ZoomWidget.vala"
		break;
#line 24 "../src/ZoomWidget.vala"
		case ZOOM_WIDGET_STEP_PROPERTY:
#line 24 "../src/ZoomWidget.vala"
		zoom_widget_set_step (self, g_value_get_int (value));
#line 24 "../src/ZoomWidget.vala"
		break;
#line 24 "../src/ZoomWidget.vala"
		case ZOOM_WIDGET_VALUE_PROPERTY:
#line 24 "../src/ZoomWidget.vala"
		zoom_widget_set_value (self, g_value_get_int (value));
#line 24 "../src/ZoomWidget.vala"
		break;
#line 812 "ZoomWidget.c"
		default:
#line 24 "../src/ZoomWidget.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 24 "../src/ZoomWidget.vala"
		break;
#line 818 "ZoomWidget.c"
	}
}

static inline gpointer
_vala_memdup2 (gconstpointer mem,
               gsize byte_size)
{
	gpointer new_mem;
	if (mem && byte_size != 0) {
		new_mem = g_malloc (byte_size);
		memcpy (new_mem, mem, byte_size);
	} else {
		new_mem = NULL;
	}
	return new_mem;
}

