/* DynamicNotebook.c generated by valac 0.56.14, the Vala compiler
 * generated from DynamicNotebook.vala, do not modify */

/*
 *  Copyright (C) 2011-2013 Tom Beckmann <tom@elementaryos.org>
 *
 *  This program or library is free software; you can redistribute it
 *  and/or modify it under the terms of the GNU Lesser General Public
 *  License as published by the Free Software Foundation; either
 *  version 3 of the License, or (at your option) any later version.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General
 *  Public License along with this library; if not, write to the
 *  Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
 *  Boston, MA 02110-1301 USA.
 */
/* a mask to ignore modifiers like num lock or caps lock that are irrelevant to keyboard shortcuts*/
#if !defined VALA_STRICT_C && defined __GNUC__ && __GNUC__ >= 14
#pragma GCC diagnostic warning "-Wimplicit-function-declaration"
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#pragma GCC diagnostic warning "-Wint-conversion"
#pragma GCC diagnostic warning "-Wreturn-mismatch"
#endif

#include <gdk/gdk.h>
#include <gtk/gtk.h>
#include <glib-object.h>
#include <glib.h>
#include <granite.h>
#include <stdlib.h>
#include <string.h>
#include <gio/gio.h>
#include <pango/pango.h>
#include <glib/gi18n-lib.h>
#include <gee.h>
#include <cairo-gobject.h>
#include <float.h>
#include <math.h>

#define MODIFIER_MASK (((GDK_SHIFT_MASK | GDK_SUPER_MASK) | GDK_CONTROL_MASK) | GDK_MOD1_MASK)
#define DYNAMIC_NOTEBOOK_MAX_TAB_WIDTH 174
#define DYNAMIC_NOTEBOOK_TAB_WIDTH_PINNED 18
#define DYNAMIC_NOTEBOOK_ADD_BUTTON_PADDING 5
#if !defined(VALA_EXTERN)
#if defined(_MSC_VER)
#define VALA_EXTERN __declspec(dllexport) extern
#elif __GNUC__ >= 4
#define VALA_EXTERN __attribute__((visibility("default"))) extern
#else
#define VALA_EXTERN extern
#endif
#endif

#define TYPE_TAB_PAGE_CONTAINER (tab_page_container_get_type ())
#define TAB_PAGE_CONTAINER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_TAB_PAGE_CONTAINER, TabPageContainer))
#define TAB_PAGE_CONTAINER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_TAB_PAGE_CONTAINER, TabPageContainerClass))
#define IS_TAB_PAGE_CONTAINER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_TAB_PAGE_CONTAINER))
#define IS_TAB_PAGE_CONTAINER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_TAB_PAGE_CONTAINER))
#define TAB_PAGE_CONTAINER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_TAB_PAGE_CONTAINER, TabPageContainerClass))

typedef struct _TabPageContainer TabPageContainer;
typedef struct _TabPageContainerClass TabPageContainerClass;
typedef struct _TabPageContainerPrivate TabPageContainerPrivate;

#define TYPE_TAB (tab_get_type ())
#define TAB(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_TAB, Tab))
#define TAB_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_TAB, TabClass))
#define IS_TAB(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_TAB))
#define IS_TAB_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_TAB))
#define TAB_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_TAB, TabClass))

typedef struct _Tab Tab;
typedef struct _TabClass TabClass;
enum  {
	TAB_PAGE_CONTAINER_0_PROPERTY,
	TAB_PAGE_CONTAINER_TAB_PROPERTY,
	TAB_PAGE_CONTAINER_NUM_PROPERTIES
};
static GParamSpec* tab_page_container_properties[TAB_PAGE_CONTAINER_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
typedef struct _TabPrivate TabPrivate;
enum  {
	TAB_0_PROPERTY,
	TAB_LABEL_PROPERTY,
	TAB_TOOLTIP_PROPERTY,
	TAB_PINNED_PROPERTY,
	TAB_PINNABLE_PROPERTY,
	TAB_RESTORE_DATA_PROPERTY,
	TAB_PAGE_PROPERTY,
	TAB_ICON_PROPERTY,
	TAB_WORKING_PROPERTY,
	TAB_ELLIPSIZE_MODE_PROPERTY,
	TAB_FIXED_PROPERTY,
	TAB_MENU_PROPERTY,
	TAB_CLOSABLE_PROPERTY,
	TAB_IS_CURRENT_TAB_PROPERTY,
	TAB_NUM_PROPERTIES
};
static GParamSpec* tab_properties[TAB_NUM_PROPERTIES];
#define _g_free0(var) (var = (g_free (var), NULL))
typedef struct _Block14Data Block14Data;
enum  {
	TAB_CLOSED_SIGNAL,
	TAB_CLOSE_OTHERS_SIGNAL,
	TAB_NEW_WINDOW_SIGNAL,
	TAB_DUPLICATE_SIGNAL,
	TAB_PIN_SWITCH_SIGNAL,
	TAB_NUM_SIGNALS
};
static guint tab_signals[TAB_NUM_SIGNALS] = {0};

#define TYPE_CLOSED_TABS (closed_tabs_get_type ())
#define CLOSED_TABS(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_CLOSED_TABS, ClosedTabs))
#define CLOSED_TABS_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_CLOSED_TABS, ClosedTabsClass))
#define IS_CLOSED_TABS(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_CLOSED_TABS))
#define IS_CLOSED_TABS_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_CLOSED_TABS))
#define CLOSED_TABS_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_CLOSED_TABS, ClosedTabsClass))

typedef struct _ClosedTabs ClosedTabs;
typedef struct _ClosedTabsClass ClosedTabsClass;
typedef struct _ClosedTabsPrivate ClosedTabsPrivate;

#define CLOSED_TABS_TYPE_ENTRY (closed_tabs_entry_get_type ())
typedef struct _ClosedTabsEntry ClosedTabsEntry;
enum  {
	CLOSED_TABS_0_PROPERTY,
	CLOSED_TABS_MAX_RESTORABLE_TABS_PROPERTY,
	CLOSED_TABS_EMPTY_PROPERTY,
	CLOSED_TABS_MENU_PROPERTY,
	CLOSED_TABS_NUM_PROPERTIES
};
static GParamSpec* closed_tabs_properties[CLOSED_TABS_NUM_PROPERTIES];
#define _closed_tabs_entry_free0(var) ((var == NULL) ? NULL : (var = (closed_tabs_entry_free (var), NULL)))
typedef struct _Block15Data Block15Data;
enum  {
	CLOSED_TABS_RESTORED_SIGNAL,
	CLOSED_TABS_CLEARED_SIGNAL,
	CLOSED_TABS_NUM_SIGNALS
};
static guint closed_tabs_signals[CLOSED_TABS_NUM_SIGNALS] = {0};

#define TYPE_DYNAMIC_NOTEBOOK (dynamic_notebook_get_type ())
#define DYNAMIC_NOTEBOOK(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_DYNAMIC_NOTEBOOK, DynamicNotebook))
#define DYNAMIC_NOTEBOOK_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_DYNAMIC_NOTEBOOK, DynamicNotebookClass))
#define IS_DYNAMIC_NOTEBOOK(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_DYNAMIC_NOTEBOOK))
#define IS_DYNAMIC_NOTEBOOK_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_DYNAMIC_NOTEBOOK))
#define DYNAMIC_NOTEBOOK_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_DYNAMIC_NOTEBOOK, DynamicNotebookClass))

typedef struct _DynamicNotebook DynamicNotebook;
typedef struct _DynamicNotebookClass DynamicNotebookClass;
typedef struct _DynamicNotebookPrivate DynamicNotebookPrivate;
typedef enum  {
	DYNAMIC_NOTEBOOK_TAB_BAR_BEHAVIOR_ALWAYS = 0,
	DYNAMIC_NOTEBOOK_TAB_BAR_BEHAVIOR_SINGLE = 1,
	DYNAMIC_NOTEBOOK_TAB_BAR_BEHAVIOR_NEVER = 2
} DynamicNotebookTabBarBehavior;

#define DYNAMIC_NOTEBOOK_TYPE_TAB_BAR_BEHAVIOR (dynamic_notebook_tab_bar_behavior_get_type ())
enum  {
	DYNAMIC_NOTEBOOK_0_PROPERTY,
	DYNAMIC_NOTEBOOK_N_TABS_PROPERTY,
	DYNAMIC_NOTEBOOK_SHOW_TABS_PROPERTY,
	DYNAMIC_NOTEBOOK_SHOW_ICONS_PROPERTY,
	DYNAMIC_NOTEBOOK_TABS_CLOSABLE_PROPERTY,
	DYNAMIC_NOTEBOOK_ALLOW_DRAG_PROPERTY,
	DYNAMIC_NOTEBOOK_ALLOW_NEW_WINDOW_PROPERTY,
	DYNAMIC_NOTEBOOK_ALLOW_DUPLICATION_PROPERTY,
	DYNAMIC_NOTEBOOK_ALLOW_RESTORING_PROPERTY,
	DYNAMIC_NOTEBOOK_MAX_RESTORABLE_TABS_PROPERTY,
	DYNAMIC_NOTEBOOK_ADD_BUTTON_VISIBLE_PROPERTY,
	DYNAMIC_NOTEBOOK_ALLOW_PINNING_PROPERTY,
	DYNAMIC_NOTEBOOK_FORCE_LEFT_PROPERTY,
	DYNAMIC_NOTEBOOK_ADD_BUTTON_TOOLTIP_PROPERTY,
	DYNAMIC_NOTEBOOK_CURRENT_PROPERTY,
	DYNAMIC_NOTEBOOK_TABS_PROPERTY,
	DYNAMIC_NOTEBOOK_GROUP_NAME_PROPERTY,
	DYNAMIC_NOTEBOOK_TAB_BAR_BEHAVIOR_PROPERTY,
	DYNAMIC_NOTEBOOK_MENU_PROPERTY,
	DYNAMIC_NOTEBOOK_NUM_PROPERTIES
};
static GParamSpec* dynamic_notebook_properties[DYNAMIC_NOTEBOOK_NUM_PROPERTIES];
typedef struct _Block16Data Block16Data;
typedef struct _Block17Data Block17Data;
typedef struct _Block18Data Block18Data;
enum  {
	DYNAMIC_NOTEBOOK_TAB_ADDED_SIGNAL,
	DYNAMIC_NOTEBOOK_TAB_REMOVED_SIGNAL,
	DYNAMIC_NOTEBOOK_TAB_SWITCHED_SIGNAL,
	DYNAMIC_NOTEBOOK_TAB_REORDERED_SIGNAL,
	DYNAMIC_NOTEBOOK_TAB_MOVED_SIGNAL,
	DYNAMIC_NOTEBOOK_TAB_DUPLICATED_SIGNAL,
	DYNAMIC_NOTEBOOK_TAB_RESTORED_SIGNAL,
	DYNAMIC_NOTEBOOK_NEW_TAB_REQUESTED_SIGNAL,
	DYNAMIC_NOTEBOOK_CLOSE_TAB_REQUESTED_SIGNAL,
	DYNAMIC_NOTEBOOK_NUM_SIGNALS
};
static guint dynamic_notebook_signals[DYNAMIC_NOTEBOOK_NUM_SIGNALS] = {0};
#define _vala_assert(expr, msg) if G_LIKELY (expr) ; else g_assertion_message_expr (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);
#define _vala_return_if_fail(expr, msg) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return; }
#define _vala_return_val_if_fail(expr, msg, val) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return val; }
#define _vala_warn_if_fail(expr, msg) if G_LIKELY (expr) ; else g_warn_message (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);

struct _TabPageContainer {
	GtkEventBox parent_instance;
	TabPageContainerPrivate * priv;
};

struct _TabPageContainerClass {
	GtkEventBoxClass parent_class;
};

struct _TabPageContainerPrivate {
	Tab* _tab;
};

struct _Tab {
	GtkEventBox parent_instance;
	TabPrivate * priv;
	GraniteWidgetsDroppedDelegate dropped_callback;
	gpointer dropped_callback_target;
	GDestroyNotify dropped_callback_target_destroy_notify;
	TabPageContainer* page_container;
	GtkImage* _icon;
	GtkMenuItem* new_window_m;
	GtkMenuItem* duplicate_m;
	GtkMenuItem* pin_m;
};

struct _TabClass {
	GtkEventBoxClass parent_class;
};

struct _TabPrivate {
	GtkLabel* _label;
	gboolean _pinned;
	gboolean _pinnable;
	gchar* _restore_data;
	GtkSpinner* _working;
	gboolean __working;
	gboolean _fixed;
	GtkMenu* _menu;
	gboolean _closable;
	gboolean _is_current_tab;
	gboolean cursor_over_tab;
	gboolean cursor_over_close_button;
	GtkRevealer* close_button_revealer;
};

struct _Block14Data {
	int _ref_count_;
	Tab* self;
	GtkMenuItem* close_other_m;
};

struct _ClosedTabs {
	GObject parent_instance;
	ClosedTabsPrivate * priv;
};

struct _ClosedTabsClass {
	GObjectClass parent_class;
};

struct _ClosedTabsEntry {
	gchar* label;
	gchar* restore_data;
	GIcon* icon;
	GraniteWidgetsDroppedDelegate dropped_callback;
	gpointer dropped_callback_target;
};

struct _ClosedTabsPrivate {
	gint _max_restorable_tabs;
	GeeLinkedList* closed_tabs;
};

struct _Block15Data {
	int _ref_count_;
	ClosedTabs* self;
	ClosedTabsEntry* entry;
};

struct _DynamicNotebook {
	GtkEventBox parent_instance;
	DynamicNotebookPrivate * priv;
};

struct _DynamicNotebookClass {
	GtkEventBoxClass parent_class;
};

struct _DynamicNotebookPrivate {
	gboolean _show_icons;
	gboolean _tabs_closable;
	gboolean _allow_drag;
	gboolean _allow_new_window;
	gboolean _allow_duplication;
	gboolean _allow_restoring;
	gboolean _add_button_visible;
	gboolean _allow_pinning;
	gboolean _force_left;
	gchar* _add_button_tooltip;
	GList* _tabs;
	DynamicNotebookTabBarBehavior _tab_bar_behavior;
	GtkMenu* _menu;
	ClosedTabs* closed_tabs;
	GtkNotebook* notebook;
	gint tab_width;
	Tab* old_tab;
	GtkMenuItem* new_tab_m;
	GtkMenuItem* restore_tab_m;
	GtkButton* add_button;
	GtkButton* restore_button;
};

struct _Block16Data {
	int _ref_count_;
	DynamicNotebook* self;
	gboolean value;
};

struct _Block17Data {
	int _ref_count_;
	DynamicNotebook* self;
	gboolean value;
};

struct _Block18Data {
	int _ref_count_;
	DynamicNotebook* self;
	gboolean value;
};

static gint TabPageContainer_private_offset;
static gpointer tab_page_container_parent_class = NULL;
static gint Tab_private_offset;
static gpointer tab_parent_class = NULL;
static gint ClosedTabs_private_offset;
static gpointer closed_tabs_parent_class = NULL;
static gint DynamicNotebook_private_offset;
static gpointer dynamic_notebook_parent_class = NULL;

VALA_EXTERN GType tab_page_container_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (TabPageContainer, g_object_unref)
VALA_EXTERN GType tab_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (Tab, g_object_unref)
VALA_EXTERN TabPageContainer* tab_page_container_new (Tab* tab);
VALA_EXTERN TabPageContainer* tab_page_container_construct (GType object_type,
                                                Tab* tab);
VALA_EXTERN Tab* tab_page_container_get_tab (TabPageContainer* self);
VALA_EXTERN void tab_page_container_set_tab (TabPageContainer* self,
                                 Tab* value);
static GObject * tab_page_container_constructor (GType type,
                                          guint n_construct_properties,
                                          GObjectConstructParam * construct_properties);
static void tab_page_container_finalize (GObject * obj);
static GType tab_page_container_get_type_once (void);
static void _vala_tab_page_container_get_property (GObject * object,
                                            guint property_id,
                                            GValue * value,
                                            GParamSpec * pspec);
static void _vala_tab_page_container_set_property (GObject * object,
                                            guint property_id,
                                            const GValue * value,
                                            GParamSpec * pspec);
VALA_EXTERN Tab* tab_new (const gchar* label,
              GIcon* icon,
              GtkWidget* page);
VALA_EXTERN Tab* tab_construct (GType object_type,
                    const gchar* label,
                    GIcon* icon,
                    GtkWidget* page);
VALA_EXTERN void tab_set_page (Tab* self,
                   GtkWidget* value);
VALA_EXTERN void tab_close (Tab* self);
static void tab_update_close_button_visibility (Tab* self);
static gboolean tab_close_button_is_visible (Tab* self);
VALA_EXTERN const gchar* tab_get_label (Tab* self);
VALA_EXTERN void tab_set_label (Tab* self,
                    const gchar* value);
VALA_EXTERN gchar* tab_get_tooltip (Tab* self);
VALA_EXTERN void tab_set_tooltip (Tab* self,
                      const gchar* value);
VALA_EXTERN gboolean tab_get_pinned (Tab* self);
VALA_EXTERN void tab_set_pinned (Tab* self,
                     gboolean value);
VALA_EXTERN gboolean tab_get_pinnable (Tab* self);
VALA_EXTERN void tab_set_pinnable (Tab* self,
                       gboolean value);
VALA_EXTERN const gchar* tab_get_restore_data (Tab* self);
VALA_EXTERN void tab_set_restore_data (Tab* self,
                           const gchar* value);
VALA_EXTERN GtkWidget* tab_get_page (Tab* self);
VALA_EXTERN GIcon* tab_get_icon (Tab* self);
VALA_EXTERN void tab_set_icon (Tab* self,
                   GIcon* value);
VALA_EXTERN gboolean tab_get_working (Tab* self);
VALA_EXTERN void tab_set_working (Tab* self,
                      gboolean value);
VALA_EXTERN PangoEllipsizeMode tab_get_ellipsize_mode (Tab* self);
VALA_EXTERN void tab_set_ellipsize_mode (Tab* self,
                             PangoEllipsizeMode value);
VALA_EXTERN gboolean tab_get_fixed (Tab* self) G_GNUC_DEPRECATED ;
VALA_EXTERN void tab_set_fixed (Tab* self,
                    gboolean value) G_GNUC_DEPRECATED ;
VALA_EXTERN GtkMenu* tab_get_menu (Tab* self);
VALA_EXTERN void tab_set_menu (Tab* self,
                   GtkMenu* value);
VALA_EXTERN void tab_set_closable (Tab* self,
                       gboolean value);
VALA_EXTERN void tab_set_is_current_tab (Tab* self,
                             gboolean value);
static GObject * tab_constructor (GType type,
                           guint n_construct_properties,
                           GObjectConstructParam * construct_properties);
static Block14Data* block14_data_ref (Block14Data* _data14_);
static void block14_data_unref (void * _userdata_);
static void _tab___lambda4_ (Tab* self);
static void __tab___lambda4__gtk_menu_item_activate (GtkMenuItem* _sender,
                                              gpointer self);
static void _tab___lambda5_ (Tab* self);
static void __tab___lambda5__gtk_menu_item_activate (GtkMenuItem* _sender,
                                              gpointer self);
static void _tab___lambda6_ (Tab* self);
static void __tab___lambda6__gtk_menu_item_activate (GtkMenuItem* _sender,
                                              gpointer self);
static void _tab___lambda7_ (Tab* self);
static void __tab___lambda7__gtk_menu_item_activate (GtkMenuItem* _sender,
                                              gpointer self);
static void _tab___lambda8_ (Tab* self);
static void __tab___lambda8__gtk_menu_item_activate (GtkMenuItem* _sender,
                                              gpointer self);
static gboolean _tab___lambda9_ (Tab* self,
                          GdkEventScroll* e);
static gboolean __tab___lambda9__gtk_widget_scroll_event (GtkWidget* _sender,
                                                   GdkEventScroll* event,
                                                   gpointer self);
static gboolean _tab___lambda10_ (Block14Data* _data14_,
                           GdkEventButton* e);
static gboolean __tab___lambda10__gtk_widget_button_press_event (GtkWidget* _sender,
                                                          GdkEventButton* event,
                                                          gpointer self);
static gboolean _tab___lambda11_ (Tab* self,
                           GdkEventCrossing* e);
static gboolean __tab___lambda11__gtk_widget_enter_notify_event (GtkWidget* _sender,
                                                          GdkEventCrossing* event,
                                                          gpointer self);
static gboolean _tab___lambda12_ (Tab* self,
                           GdkEventCrossing* e);
static gboolean __tab___lambda12__gtk_widget_leave_notify_event (GtkWidget* _sender,
                                                          GdkEventCrossing* event,
                                                          gpointer self);
static gboolean _tab___lambda13_ (Tab* self,
                           GdkEventCrossing* e);
static gboolean __tab___lambda13__gtk_widget_enter_notify_event (GtkWidget* _sender,
                                                          GdkEventCrossing* event,
                                                          gpointer self);
static gboolean _tab___lambda14_ (Tab* self,
                           GdkEventCrossing* e);
static gboolean __tab___lambda14__gtk_widget_leave_notify_event (GtkWidget* _sender,
                                                          GdkEventCrossing* event,
                                                          gpointer self);
static gboolean _tab___lambda15_ (Tab* self);
static gboolean __tab___lambda15__gtk_widget_button_press_event (GtkWidget* _sender,
                                                          GdkEventButton* event,
                                                          gpointer self);
static void _tab___lambda16_ (Tab* self);
static void __tab___lambda16__gtk_button_clicked (GtkButton* _sender,
                                           gpointer self);
static void tab_finalize (GObject * obj);
static GType tab_get_type_once (void);
static void _vala_tab_get_property (GObject * object,
                             guint property_id,
                             GValue * value,
                             GParamSpec * pspec);
static void _vala_tab_set_property (GObject * object,
                             guint property_id,
                             const GValue * value,
                             GParamSpec * pspec);
VALA_EXTERN GType closed_tabs_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (ClosedTabs, g_object_unref)
VALA_EXTERN GType closed_tabs_entry_get_type (void) G_GNUC_CONST ;
VALA_EXTERN ClosedTabsEntry* closed_tabs_entry_dup (const ClosedTabsEntry* self);
VALA_EXTERN void closed_tabs_entry_free (ClosedTabsEntry* self);
VALA_EXTERN void closed_tabs_entry_copy (const ClosedTabsEntry* self,
                             ClosedTabsEntry* dest);
VALA_EXTERN void closed_tabs_entry_destroy (ClosedTabsEntry* self);
G_DEFINE_AUTO_CLEANUP_CLEAR_FUNC (ClosedTabsEntry, closed_tabs_entry_destroy)
VALA_EXTERN ClosedTabs* closed_tabs_new (void);
VALA_EXTERN ClosedTabs* closed_tabs_construct (GType object_type);
VALA_EXTERN void closed_tabs_push (ClosedTabs* self,
                       Tab* tab);
VALA_EXTERN gint closed_tabs_get_max_restorable_tabs (ClosedTabs* self);
VALA_EXTERN void closed_tabs_pop (ClosedTabs* self,
                      ClosedTabsEntry* result);
VALA_EXTERN void closed_tabs_pick (ClosedTabs* self,
                       const gchar* search,
                       ClosedTabsEntry* result);
VALA_EXTERN void closed_tabs_set_max_restorable_tabs (ClosedTabs* self,
                                          gint value);
VALA_EXTERN gboolean closed_tabs_get_empty (ClosedTabs* self);
VALA_EXTERN GtkMenu* closed_tabs_get_menu (ClosedTabs* self);
static Block15Data* block15_data_ref (Block15Data* _data15_);
static void block15_data_unref (void * _userdata_);
static void _closed_tabs_menu_____lambda17_ (Block15Data* _data15_);
static void __closed_tabs_menu_____lambda17__gtk_menu_item_activate (GtkMenuItem* _sender,
                                                              gpointer self);
static void _closed_tabs_menu____lambda18_ (ClosedTabs* self);
static void __closed_tabs_menu____lambda18__gtk_menu_item_activate (GtkMenuItem* _sender,
                                                             gpointer self);
static void g_cclosure_user_marshal_VOID__STRING_STRING_OBJECT (GClosure * closure,
                                                         GValue * return_value,
                                                         guint n_param_values,
                                                         const GValue * param_values,
                                                         gpointer invocation_hint,
                                                         gpointer marshal_data);
static GObject * closed_tabs_constructor (GType type,
                                   guint n_construct_properties,
                                   GObjectConstructParam * construct_properties);
static void closed_tabs_finalize (GObject * obj);
static GType closed_tabs_get_type_once (void);
static void _vala_closed_tabs_get_property (GObject * object,
                                     guint property_id,
                                     GValue * value,
                                     GParamSpec * pspec);
static void _vala_closed_tabs_set_property (GObject * object,
                                     guint property_id,
                                     const GValue * value,
                                     GParamSpec * pspec);
VALA_EXTERN GType dynamic_notebook_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (DynamicNotebook, g_object_unref)
VALA_EXTERN GType dynamic_notebook_tab_bar_behavior_get_type (void) G_GNUC_CONST ;
static void _g_object_unref0_ (gpointer var);
static inline void _g_list_free__g_object_unref0_ (GList* self);
VALA_EXTERN DynamicNotebook* dynamic_notebook_new (void);
VALA_EXTERN DynamicNotebook* dynamic_notebook_construct (GType object_type);
static void dynamic_notebook_on_switch_page (DynamicNotebook* self,
                                      GtkWidget* page,
                                      guint pagenum);
static void dynamic_notebook_on_page_added (DynamicNotebook* self,
                                     GtkWidget* page,
                                     guint pagenum);
static void dynamic_notebook_insert_callbacks (DynamicNotebook* self,
                                        Tab* tab);
static void dynamic_notebook_update_tabs_visibility (DynamicNotebook* self);
static void dynamic_notebook_on_page_removed (DynamicNotebook* self,
                                       GtkWidget* page,
                                       guint pagenum);
static void dynamic_notebook_remove_callbacks (DynamicNotebook* self,
                                        Tab* tab);
static void dynamic_notebook_on_page_reordered (DynamicNotebook* self,
                                         GtkWidget* page,
                                         guint pagenum);
static void dynamic_notebook_recalc_order (DynamicNotebook* self);
static GtkNotebook* dynamic_notebook_on_create_window (DynamicNotebook* self,
                                                GtkWidget* page,
                                                gint x,
                                                gint y);
VALA_EXTERN gint dynamic_notebook_get_n_tabs (DynamicNotebook* self);
VALA_EXTERN gboolean dynamic_notebook_get_force_left (DynamicNotebook* self);
static void dynamic_notebook_recalc_size (DynamicNotebook* self);
static void dynamic_notebook_restore_last_tab (DynamicNotebook* self);
VALA_EXTERN gboolean dynamic_notebook_get_allow_restoring (DynamicNotebook* self);
static void dynamic_notebook_switch_pin_tab (DynamicNotebook* self,
                                      Tab* tab);
VALA_EXTERN gboolean dynamic_notebook_get_allow_pinning (DynamicNotebook* self);
VALA_EXTERN void dynamic_notebook_remove_tab (DynamicNotebook* self,
                                  Tab* tab);
VALA_EXTERN gint dynamic_notebook_get_tab_position (DynamicNotebook* self,
                                        Tab* tab);
VALA_EXTERN void dynamic_notebook_next_page (DynamicNotebook* self);
VALA_EXTERN void dynamic_notebook_previous_page (DynamicNotebook* self);
static void dynamic_notebook_real_show (GtkWidget* base);
VALA_EXTERN GList* dynamic_notebook_get_children (DynamicNotebook* self);
VALA_EXTERN void dynamic_notebook_set_tab_position (DynamicNotebook* self,
                                        Tab* tab,
                                        gint position);
VALA_EXTERN Tab* dynamic_notebook_get_tab_by_index (DynamicNotebook* self,
                                        gint index);
VALA_EXTERN Tab* dynamic_notebook_get_tab_by_widget (DynamicNotebook* self,
                                         GtkWidget* widget);
VALA_EXTERN GtkWidget* dynamic_notebook_get_nth_page (DynamicNotebook* self,
                                          gint index);
VALA_EXTERN guint dynamic_notebook_insert_tab (DynamicNotebook* self,
                                   Tab* tab,
                                   gint index);
VALA_EXTERN GList* dynamic_notebook_get_tabs (DynamicNotebook* self);
VALA_EXTERN gboolean dynamic_notebook_get_allow_drag (DynamicNotebook* self);
VALA_EXTERN gboolean dynamic_notebook_get_allow_new_window (DynamicNotebook* self);
VALA_EXTERN gboolean dynamic_notebook_get_allow_duplication (DynamicNotebook* self);
VALA_EXTERN gboolean dynamic_notebook_get_tabs_closable (DynamicNotebook* self);
static void dynamic_notebook_on_tab_closed (DynamicNotebook* self,
                                     Tab* tab);
static void _dynamic_notebook_on_tab_closed_tab_closed (Tab* _sender,
                                                 gpointer self);
static void dynamic_notebook_on_close_others (DynamicNotebook* self,
                                       Tab* tab);
static void _dynamic_notebook_on_close_others_tab_close_others (Tab* _sender,
                                                         gpointer self);
static void dynamic_notebook_on_new_window (DynamicNotebook* self,
                                     Tab* tab);
static void _dynamic_notebook_on_new_window_tab_new_window (Tab* _sender,
                                                     gpointer self);
static void dynamic_notebook_on_duplicate (DynamicNotebook* self,
                                    Tab* tab);
static void _dynamic_notebook_on_duplicate_tab_duplicate (Tab* _sender,
                                                   gpointer self);
static void dynamic_notebook_on_pin_switch (DynamicNotebook* self,
                                     Tab* tab);
static void _dynamic_notebook_on_pin_switch_tab_pin_switch (Tab* _sender,
                                                     gpointer self);
VALA_EXTERN gboolean dynamic_notebook_get_show_tabs (DynamicNotebook* self);
VALA_EXTERN void dynamic_notebook_set_show_tabs (DynamicNotebook* self,
                                     gboolean value);
VALA_EXTERN gboolean dynamic_notebook_get_show_icons (DynamicNotebook* self) G_GNUC_DEPRECATED ;
VALA_EXTERN void dynamic_notebook_set_show_icons (DynamicNotebook* self,
                                      gboolean value) G_GNUC_DEPRECATED ;
VALA_EXTERN void dynamic_notebook_set_tabs_closable (DynamicNotebook* self,
                                         gboolean value);
static Block16Data* block16_data_ref (Block16Data* _data16_);
static void block16_data_unref (void * _userdata_);
static void _dynamic_notebook_tabs_closable____lambda21_ (Block16Data* _data16_,
                                                   Tab* t);
static void __dynamic_notebook_tabs_closable____lambda21__gfunc (gconstpointer data,
                                                          gpointer self);
VALA_EXTERN void dynamic_notebook_set_allow_drag (DynamicNotebook* self,
                                      gboolean value);
static Block17Data* block17_data_ref (Block17Data* _data17_);
static void block17_data_unref (void * _userdata_);
static void _dynamic_notebook_allow_drag___lambda19_ (Block17Data* _data17_,
                                               Tab* t);
static void __dynamic_notebook_allow_drag___lambda19__gfunc (gconstpointer data,
                                                      gpointer self);
VALA_EXTERN void dynamic_notebook_set_allow_new_window (DynamicNotebook* self,
                                            gboolean value);
static Block18Data* block18_data_ref (Block18Data* _data18_);
static void block18_data_unref (void * _userdata_);
static void _dynamic_notebook_allow_new_window___lambda20_ (Block18Data* _data18_,
                                                     Tab* t);
static void __dynamic_notebook_allow_new_window___lambda20__gfunc (gconstpointer data,
                                                            gpointer self);
VALA_EXTERN void dynamic_notebook_set_allow_duplication (DynamicNotebook* self,
                                             gboolean value);
VALA_EXTERN void dynamic_notebook_set_allow_restoring (DynamicNotebook* self,
                                           gboolean value);
VALA_EXTERN gint dynamic_notebook_get_max_restorable_tabs (DynamicNotebook* self);
VALA_EXTERN void dynamic_notebook_set_max_restorable_tabs (DynamicNotebook* self,
                                               gint value);
VALA_EXTERN gboolean dynamic_notebook_get_add_button_visible (DynamicNotebook* self);
VALA_EXTERN void dynamic_notebook_set_add_button_visible (DynamicNotebook* self,
                                              gboolean value);
VALA_EXTERN void dynamic_notebook_set_allow_pinning (DynamicNotebook* self,
                                         gboolean value);
VALA_EXTERN void dynamic_notebook_set_force_left (DynamicNotebook* self,
                                      gboolean value);
VALA_EXTERN const gchar* dynamic_notebook_get_add_button_tooltip (DynamicNotebook* self);
VALA_EXTERN void dynamic_notebook_set_add_button_tooltip (DynamicNotebook* self,
                                              const gchar* value);
VALA_EXTERN Tab* dynamic_notebook_get_current (DynamicNotebook* self);
VALA_EXTERN void dynamic_notebook_set_current (DynamicNotebook* self,
                                   Tab* value);
VALA_EXTERN const gchar* dynamic_notebook_get_group_name (DynamicNotebook* self);
VALA_EXTERN void dynamic_notebook_set_group_name (DynamicNotebook* self,
                                      const gchar* value);
VALA_EXTERN DynamicNotebookTabBarBehavior dynamic_notebook_get_tab_bar_behavior (DynamicNotebook* self);
VALA_EXTERN void dynamic_notebook_set_tab_bar_behavior (DynamicNotebook* self,
                                            DynamicNotebookTabBarBehavior value);
VALA_EXTERN GtkMenu* dynamic_notebook_get_menu (DynamicNotebook* self);
static void dynamic_notebook_set_menu (DynamicNotebook* self,
                                GtkMenu* value);
static void g_cclosure_user_marshal_VOID__OBJECT_OBJECT (GClosure * closure,
                                                  GValue * return_value,
                                                  guint n_param_values,
                                                  const GValue * param_values,
                                                  gpointer invocation_hint,
                                                  gpointer marshal_data);
static void g_cclosure_user_marshal_VOID__OBJECT_INT (GClosure * closure,
                                               GValue * return_value,
                                               guint n_param_values,
                                               const GValue * param_values,
                                               gpointer invocation_hint,
                                               gpointer marshal_data);
static void g_cclosure_user_marshal_VOID__OBJECT_INT_INT (GClosure * closure,
                                                   GValue * return_value,
                                                   guint n_param_values,
                                                   const GValue * param_values,
                                                   gpointer invocation_hint,
                                                   gpointer marshal_data);
static void g_cclosure_user_marshal_BOOLEAN__OBJECT (GClosure * closure,
                                              GValue * return_value,
                                              guint n_param_values,
                                              const GValue * param_values,
                                              gpointer invocation_hint,
                                              gpointer marshal_data);
static GObject * dynamic_notebook_constructor (GType type,
                                        guint n_construct_properties,
                                        GObjectConstructParam * construct_properties);
static gboolean _dynamic_notebook___lambda22_ (DynamicNotebook* self,
                                        cairo_t* ctx);
static gboolean __dynamic_notebook___lambda22__gtk_widget_draw (GtkWidget* _sender,
                                                         cairo_t* cr,
                                                         gpointer self);
static void _dynamic_notebook___lambda23_ (DynamicNotebook* self);
static void __dynamic_notebook___lambda23__gtk_menu_item_activate (GtkMenuItem* _sender,
                                                            gpointer self);
static void _dynamic_notebook___lambda24_ (DynamicNotebook* self);
static void __dynamic_notebook___lambda24__gtk_menu_item_activate (GtkMenuItem* _sender,
                                                            gpointer self);
static void _dynamic_notebook___lambda25_ (DynamicNotebook* self,
                                    const gchar* label,
                                    const gchar* restore_data,
                                    GIcon* icon);
static void __dynamic_notebook___lambda25__closed_tabs_restored (ClosedTabs* _sender,
                                                          const gchar* label,
                                                          const gchar* restore_data,
                                                          GIcon* icon,
                                                          gpointer self);
static void _dynamic_notebook___lambda26_ (DynamicNotebook* self);
static void __dynamic_notebook___lambda26__closed_tabs_cleared (ClosedTabs* _sender,
                                                         gpointer self);
static void _dynamic_notebook___lambda27_ (DynamicNotebook* self);
static void __dynamic_notebook___lambda27__gtk_button_clicked (GtkButton* _sender,
                                                        gpointer self);
static gboolean _dynamic_notebook___lambda28_ (DynamicNotebook* self,
                                        GdkEventButton* e);
static gboolean __dynamic_notebook___lambda28__gtk_widget_button_press_event (GtkWidget* _sender,
                                                                       GdkEventButton* event,
                                                                       gpointer self);
static void _dynamic_notebook___lambda29_ (DynamicNotebook* self);
static void __dynamic_notebook___lambda29__gtk_button_clicked (GtkButton* _sender,
                                                        gpointer self);
static void _dynamic_notebook___lambda30_ (DynamicNotebook* self);
static void __dynamic_notebook___lambda30__gtk_widget_size_allocate (GtkWidget* _sender,
                                                              GtkAllocation* allocation,
                                                              gpointer self);
static gboolean _dynamic_notebook___lambda31_ (DynamicNotebook* self,
                                        GdkEventButton* e);
static gboolean __dynamic_notebook___lambda31__gtk_widget_button_press_event (GtkWidget* _sender,
                                                                       GdkEventButton* event,
                                                                       gpointer self);
static gboolean _dynamic_notebook___lambda32_ (DynamicNotebook* self,
                                        GdkEventKey* e);
static gboolean __dynamic_notebook___lambda32__gtk_widget_key_press_event (GtkWidget* _sender,
                                                                    GdkEventKey* event,
                                                                    gpointer self);
static void _dynamic_notebook___lambda33_ (DynamicNotebook* self);
static void _dynamic_notebook_on_switch_page_gtk_notebook_switch_page (GtkNotebook* _sender,
                                                                GtkWidget* page,
                                                                guint page_num,
                                                                gpointer self);
static void _dynamic_notebook_on_page_added_gtk_notebook_page_added (GtkNotebook* _sender,
                                                              GtkWidget* child,
                                                              guint page_num,
                                                              gpointer self);
static void _dynamic_notebook_on_page_removed_gtk_notebook_page_removed (GtkNotebook* _sender,
                                                                  GtkWidget* child,
                                                                  guint page_num,
                                                                  gpointer self);
static void _dynamic_notebook_on_page_reordered_gtk_notebook_page_reordered (GtkNotebook* _sender,
                                                                      GtkWidget* child,
                                                                      guint page_num,
                                                                      gpointer self);
static GtkNotebook* _dynamic_notebook_on_create_window_gtk_notebook_create_window (GtkNotebook* _sender,
                                                                            GtkWidget* page,
                                                                            gint x,
                                                                            gint y,
                                                                            gpointer self);
static void __dynamic_notebook___lambda33__gtk_widget_destroy (GtkWidget* _sender,
                                                        gpointer self);
static void dynamic_notebook_finalize (GObject * obj);
static GType dynamic_notebook_get_type_once (void);
static void _vala_dynamic_notebook_get_property (GObject * object,
                                          guint property_id,
                                          GValue * value,
                                          GParamSpec * pspec);
static void _vala_dynamic_notebook_set_property (GObject * object,
                                          guint property_id,
                                          const GValue * value,
                                          GParamSpec * pspec);

static inline gpointer
tab_page_container_get_instance_private (TabPageContainer* self)
{
	return G_STRUCT_MEMBER_P (self, TabPageContainer_private_offset);
}

TabPageContainer*
tab_page_container_construct (GType object_type,
                              Tab* tab)
{
	TabPageContainer * self = NULL;
#line 34 "../src/DynamicNotebook.vala"
	g_return_val_if_fail (tab != NULL, NULL);
#line 35 "../src/DynamicNotebook.vala"
	self = (TabPageContainer*) g_object_new (object_type, "tab", tab, NULL);
#line 34 "../src/DynamicNotebook.vala"
	return self;
#line 804 "DynamicNotebook.c"
}

TabPageContainer*
tab_page_container_new (Tab* tab)
{
#line 34 "../src/DynamicNotebook.vala"
	return tab_page_container_construct (TYPE_TAB_PAGE_CONTAINER, tab);
#line 812 "DynamicNotebook.c"
}

Tab*
tab_page_container_get_tab (TabPageContainer* self)
{
	Tab* result;
	Tab* _tmp0_;
#line 30 "../src/DynamicNotebook.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 30 "../src/DynamicNotebook.vala"
	_tmp0_ = self->priv->_tab;
#line 30 "../src/DynamicNotebook.vala"
	result = _tmp0_;
#line 30 "../src/DynamicNotebook.vala"
	return result;
#line 828 "DynamicNotebook.c"
}

void
tab_page_container_set_tab (TabPageContainer* self,
                            Tab* value)
{
#line 31 "../src/DynamicNotebook.vala"
	g_return_if_fail (self != NULL);
#line 31 "../src/DynamicNotebook.vala"
	self->priv->_tab = value;
#line 31 "../src/DynamicNotebook.vala"
	g_object_notify_by_pspec ((GObject *) self, tab_page_container_properties[TAB_PAGE_CONTAINER_TAB_PROPERTY]);
#line 841 "DynamicNotebook.c"
}

static GObject *
tab_page_container_constructor (GType type,
                                guint n_construct_properties,
                                GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	TabPageContainer * self;
	GtkGrid* _tmp0_;
	GtkGrid* _tmp1_;
#line 38 "../src/DynamicNotebook.vala"
	parent_class = G_OBJECT_CLASS (tab_page_container_parent_class);
#line 38 "../src/DynamicNotebook.vala"
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
#line 38 "../src/DynamicNotebook.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_TAB_PAGE_CONTAINER, TabPageContainer);
#line 39 "../src/DynamicNotebook.vala"
	_tmp0_ = (GtkGrid*) gtk_grid_new ();
#line 39 "../src/DynamicNotebook.vala"
	g_object_ref_sink (_tmp0_);
#line 39 "../src/DynamicNotebook.vala"
	_tmp1_ = _tmp0_;
#line 39 "../src/DynamicNotebook.vala"
	gtk_container_add ((GtkContainer*) self, (GtkWidget*) _tmp1_);
#line 39 "../src/DynamicNotebook.vala"
	_g_object_unref0 (_tmp1_);
#line 38 "../src/DynamicNotebook.vala"
	return obj;
#line 872 "DynamicNotebook.c"
}

static void
tab_page_container_class_init (TabPageContainerClass * klass,
                               gpointer klass_data)
{
#line 26 "../src/DynamicNotebook.vala"
	tab_page_container_parent_class = g_type_class_peek_parent (klass);
#line 26 "../src/DynamicNotebook.vala"
	g_type_class_adjust_private_offset (klass, &TabPageContainer_private_offset);
#line 26 "../src/DynamicNotebook.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_tab_page_container_get_property;
#line 26 "../src/DynamicNotebook.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_tab_page_container_set_property;
#line 26 "../src/DynamicNotebook.vala"
	G_OBJECT_CLASS (klass)->constructor = tab_page_container_constructor;
#line 26 "../src/DynamicNotebook.vala"
	G_OBJECT_CLASS (klass)->finalize = tab_page_container_finalize;
#line 26 "../src/DynamicNotebook.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), TAB_PAGE_CONTAINER_TAB_PROPERTY, tab_page_container_properties[TAB_PAGE_CONTAINER_TAB_PROPERTY] = g_param_spec_object ("tab", "tab", "tab", TYPE_TAB, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 893 "DynamicNotebook.c"
}

static void
tab_page_container_instance_init (TabPageContainer * self,
                                  gpointer klass)
{
#line 26 "../src/DynamicNotebook.vala"
	self->priv = tab_page_container_get_instance_private (self);
#line 27 "../src/DynamicNotebook.vala"
	self->priv->_tab = NULL;
#line 904 "DynamicNotebook.c"
}

static void
tab_page_container_finalize (GObject * obj)
{
	TabPageContainer * self;
#line 26 "../src/DynamicNotebook.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_TAB_PAGE_CONTAINER, TabPageContainer);
#line 26 "../src/DynamicNotebook.vala"
	G_OBJECT_CLASS (tab_page_container_parent_class)->finalize (obj);
#line 915 "DynamicNotebook.c"
}

static GType
tab_page_container_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (TabPageContainerClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) tab_page_container_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (TabPageContainer), 0, (GInstanceInitFunc) tab_page_container_instance_init, NULL };
	GType tab_page_container_type_id;
	tab_page_container_type_id = g_type_register_static (gtk_event_box_get_type (), "TabPageContainer", &g_define_type_info, 0);
	TabPageContainer_private_offset = g_type_add_instance_private (tab_page_container_type_id, sizeof (TabPageContainerPrivate));
	return tab_page_container_type_id;
}

GType
tab_page_container_get_type (void)
{
	static volatile gsize tab_page_container_type_id__once = 0;
	if (g_once_init_enter (&tab_page_container_type_id__once)) {
		GType tab_page_container_type_id;
		tab_page_container_type_id = tab_page_container_get_type_once ();
		g_once_init_leave (&tab_page_container_type_id__once, tab_page_container_type_id);
	}
	return tab_page_container_type_id__once;
}

static void
_vala_tab_page_container_get_property (GObject * object,
                                       guint property_id,
                                       GValue * value,
                                       GParamSpec * pspec)
{
	TabPageContainer * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_TAB_PAGE_CONTAINER, TabPageContainer);
#line 26 "../src/DynamicNotebook.vala"
	switch (property_id) {
#line 26 "../src/DynamicNotebook.vala"
		case TAB_PAGE_CONTAINER_TAB_PROPERTY:
#line 26 "../src/DynamicNotebook.vala"
		g_value_set_object (value, tab_page_container_get_tab (self));
#line 26 "../src/DynamicNotebook.vala"
		break;
#line 956 "DynamicNotebook.c"
		default:
#line 26 "../src/DynamicNotebook.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 26 "../src/DynamicNotebook.vala"
		break;
#line 962 "DynamicNotebook.c"
	}
}

static void
_vala_tab_page_container_set_property (GObject * object,
                                       guint property_id,
                                       const GValue * value,
                                       GParamSpec * pspec)
{
	TabPageContainer * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_TAB_PAGE_CONTAINER, TabPageContainer);
#line 26 "../src/DynamicNotebook.vala"
	switch (property_id) {
#line 26 "../src/DynamicNotebook.vala"
		case TAB_PAGE_CONTAINER_TAB_PROPERTY:
#line 26 "../src/DynamicNotebook.vala"
		tab_page_container_set_tab (self, g_value_get_object (value));
#line 26 "../src/DynamicNotebook.vala"
		break;
#line 982 "DynamicNotebook.c"
		default:
#line 26 "../src/DynamicNotebook.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 26 "../src/DynamicNotebook.vala"
		break;
#line 988 "DynamicNotebook.c"
	}
}

static inline gpointer
tab_get_instance_private (Tab* self)
{
	return G_STRUCT_MEMBER_P (self, Tab_private_offset);
}

/**
         * With this you can construct a Tab. It is linked to the page that is shown on focus.
         * A Tab can have a icon on the right side. You can pass null on the constructor to
         * create a tab without a icon.
         **/
Tab*
tab_construct (GType object_type,
               const gchar* label,
               GIcon* icon,
               GtkWidget* page)
{
	Tab * self = NULL;
#line 212 "../src/DynamicNotebook.vala"
	self = (Tab*) g_object_new (object_type, "label", label, "icon", icon, NULL);
#line 213 "../src/DynamicNotebook.vala"
	if (page != NULL) {
#line 214 "../src/DynamicNotebook.vala"
		tab_set_page (self, page);
#line 1016 "DynamicNotebook.c"
	}
#line 211 "../src/DynamicNotebook.vala"
	return self;
#line 1020 "DynamicNotebook.c"
}

Tab*
tab_new (const gchar* label,
         GIcon* icon,
         GtkWidget* page)
{
#line 211 "../src/DynamicNotebook.vala"
	return tab_construct (TYPE_TAB, label, icon, page);
#line 1030 "DynamicNotebook.c"
}

void
tab_close (Tab* self)
{
#line 374 "../src/DynamicNotebook.vala"
	g_return_if_fail (self != NULL);
#line 375 "../src/DynamicNotebook.vala"
	g_signal_emit (self, tab_signals[TAB_CLOSED_SIGNAL], 0);
#line 1040 "DynamicNotebook.c"
}

static void
tab_update_close_button_visibility (Tab* self)
{
	GtkRevealer* _tmp0_;
	GtkRevealer* _tmp1_;
	gboolean _tmp2_ = FALSE;
	gboolean _tmp3_ = FALSE;
	GtkRevealer* _tmp6_;
#line 378 "../src/DynamicNotebook.vala"
	g_return_if_fail (self != NULL);
#line 381 "../src/DynamicNotebook.vala"
	_tmp0_ = self->priv->close_button_revealer;
#line 381 "../src/DynamicNotebook.vala"
	gtk_widget_set_no_show_all ((GtkWidget*) _tmp0_, self->priv->_pinned);
#line 382 "../src/DynamicNotebook.vala"
	_tmp1_ = self->priv->close_button_revealer;
#line 382 "../src/DynamicNotebook.vala"
	gtk_widget_set_visible ((GtkWidget*) _tmp1_, !self->priv->_pinned);
#line 384 "../src/DynamicNotebook.vala"
	if (self->priv->_closable) {
#line 384 "../src/DynamicNotebook.vala"
		_tmp3_ = !self->priv->_pinned;
#line 1065 "DynamicNotebook.c"
	} else {
#line 384 "../src/DynamicNotebook.vala"
		_tmp3_ = FALSE;
#line 1069 "DynamicNotebook.c"
	}
#line 384 "../src/DynamicNotebook.vala"
	if (_tmp3_) {
#line 1073 "DynamicNotebook.c"
		gboolean _tmp4_ = FALSE;
		gboolean _tmp5_ = FALSE;
#line 385 "../src/DynamicNotebook.vala"
		if (self->priv->cursor_over_tab) {
#line 385 "../src/DynamicNotebook.vala"
			_tmp5_ = TRUE;
#line 1080 "DynamicNotebook.c"
		} else {
#line 385 "../src/DynamicNotebook.vala"
			_tmp5_ = self->priv->cursor_over_close_button;
#line 1084 "DynamicNotebook.c"
		}
#line 385 "../src/DynamicNotebook.vala"
		if (_tmp5_) {
#line 385 "../src/DynamicNotebook.vala"
			_tmp4_ = TRUE;
#line 1090 "DynamicNotebook.c"
		} else {
#line 385 "../src/DynamicNotebook.vala"
			_tmp4_ = self->priv->_is_current_tab;
#line 1094 "DynamicNotebook.c"
		}
#line 385 "../src/DynamicNotebook.vala"
		_tmp2_ = _tmp4_;
#line 1098 "DynamicNotebook.c"
	} else {
#line 384 "../src/DynamicNotebook.vala"
		_tmp2_ = FALSE;
#line 1102 "DynamicNotebook.c"
	}
#line 384 "../src/DynamicNotebook.vala"
	_tmp6_ = self->priv->close_button_revealer;
#line 384 "../src/DynamicNotebook.vala"
	gtk_revealer_set_reveal_child (_tmp6_, _tmp2_);
#line 1108 "DynamicNotebook.c"
}

static gboolean
tab_close_button_is_visible (Tab* self)
{
	gboolean _tmp0_ = FALSE;
	GtkRevealer* _tmp1_;
	gboolean _tmp2_;
	gboolean _tmp3_;
	gboolean result;
#line 388 "../src/DynamicNotebook.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 389 "../src/DynamicNotebook.vala"
	_tmp1_ = self->priv->close_button_revealer;
#line 389 "../src/DynamicNotebook.vala"
	_tmp2_ = gtk_widget_get_visible ((GtkWidget*) _tmp1_);
#line 389 "../src/DynamicNotebook.vala"
	_tmp3_ = _tmp2_;
#line 389 "../src/DynamicNotebook.vala"
	if (_tmp3_) {
#line 1129 "DynamicNotebook.c"
		GtkRevealer* _tmp4_;
		gboolean _tmp5_;
		gboolean _tmp6_;
#line 389 "../src/DynamicNotebook.vala"
		_tmp4_ = self->priv->close_button_revealer;
#line 389 "../src/DynamicNotebook.vala"
		_tmp5_ = gtk_revealer_get_child_revealed (_tmp4_);
#line 389 "../src/DynamicNotebook.vala"
		_tmp6_ = _tmp5_;
#line 389 "../src/DynamicNotebook.vala"
		_tmp0_ = _tmp6_;
#line 1141 "DynamicNotebook.c"
	} else {
#line 389 "../src/DynamicNotebook.vala"
		_tmp0_ = FALSE;
#line 1145 "DynamicNotebook.c"
	}
#line 389 "../src/DynamicNotebook.vala"
	result = _tmp0_;
#line 389 "../src/DynamicNotebook.vala"
	return result;
#line 1151 "DynamicNotebook.c"
}

const gchar*
tab_get_label (Tab* self)
{
	const gchar* result;
	GtkLabel* _tmp0_;
	const gchar* _tmp1_;
	const gchar* _tmp2_;
#line 49 "../src/DynamicNotebook.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 49 "../src/DynamicNotebook.vala"
	_tmp0_ = self->priv->_label;
#line 49 "../src/DynamicNotebook.vala"
	_tmp1_ = gtk_label_get_label (_tmp0_);
#line 49 "../src/DynamicNotebook.vala"
	_tmp2_ = _tmp1_;
#line 49 "../src/DynamicNotebook.vala"
	result = _tmp2_;
#line 49 "../src/DynamicNotebook.vala"
	return result;
#line 1173 "DynamicNotebook.c"
}

void
tab_set_label (Tab* self,
               const gchar* value)
{
	GtkLabel* _tmp0_;
#line 51 "../src/DynamicNotebook.vala"
	g_return_if_fail (self != NULL);
#line 52 "../src/DynamicNotebook.vala"
	_tmp0_ = self->priv->_label;
#line 52 "../src/DynamicNotebook.vala"
	gtk_label_set_label (_tmp0_, value);
#line 51 "../src/DynamicNotebook.vala"
	g_object_notify_by_pspec ((GObject *) self, tab_properties[TAB_LABEL_PROPERTY]);
#line 1189 "DynamicNotebook.c"
}

gchar*
tab_get_tooltip (Tab* self)
{
	gchar* result;
	GtkLabel* _tmp0_;
	gchar* _tmp1_;
#line 56 "../src/DynamicNotebook.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 56 "../src/DynamicNotebook.vala"
	_tmp0_ = self->priv->_label;
#line 56 "../src/DynamicNotebook.vala"
	_tmp1_ = gtk_widget_get_tooltip_text ((GtkWidget*) _tmp0_);
#line 56 "../src/DynamicNotebook.vala"
	result = _tmp1_;
#line 56 "../src/DynamicNotebook.vala"
	return result;
#line 1208 "DynamicNotebook.c"
}

void
tab_set_tooltip (Tab* self,
                 const gchar* value)
{
	GtkLabel* _tmp0_;
#line 57 "../src/DynamicNotebook.vala"
	g_return_if_fail (self != NULL);
#line 57 "../src/DynamicNotebook.vala"
	_tmp0_ = self->priv->_label;
#line 57 "../src/DynamicNotebook.vala"
	gtk_widget_set_tooltip_text ((GtkWidget*) _tmp0_, value);
#line 57 "../src/DynamicNotebook.vala"
	g_object_notify_by_pspec ((GObject *) self, tab_properties[TAB_TOOLTIP_PROPERTY]);
#line 1224 "DynamicNotebook.c"
}

gboolean
tab_get_pinned (Tab* self)
{
	gboolean result;
#line 62 "../src/DynamicNotebook.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 62 "../src/DynamicNotebook.vala"
	result = self->priv->_pinned;
#line 62 "../src/DynamicNotebook.vala"
	return result;
#line 1237 "DynamicNotebook.c"
}

void
tab_set_pinned (Tab* self,
                gboolean value)
{
	gboolean _tmp0_;
	gboolean _tmp1_;
#line 64 "../src/DynamicNotebook.vala"
	g_return_if_fail (self != NULL);
#line 65 "../src/DynamicNotebook.vala"
	_tmp0_ = tab_get_pinnable (self);
#line 65 "../src/DynamicNotebook.vala"
	_tmp1_ = _tmp0_;
#line 65 "../src/DynamicNotebook.vala"
	if (_tmp1_) {
#line 66 "../src/DynamicNotebook.vala"
		if (value != self->priv->_pinned) {
#line 67 "../src/DynamicNotebook.vala"
			if (value) {
#line 1258 "DynamicNotebook.c"
				GtkLabel* _tmp2_;
				GtkImage* _tmp3_;
				GtkSpinner* _tmp4_;
#line 68 "../src/DynamicNotebook.vala"
				_tmp2_ = self->priv->_label;
#line 68 "../src/DynamicNotebook.vala"
				gtk_widget_set_visible ((GtkWidget*) _tmp2_, FALSE);
#line 69 "../src/DynamicNotebook.vala"
				_tmp3_ = self->_icon;
#line 69 "../src/DynamicNotebook.vala"
				gtk_widget_set_margin_start ((GtkWidget*) _tmp3_, 1);
#line 70 "../src/DynamicNotebook.vala"
				_tmp4_ = self->priv->_working;
#line 70 "../src/DynamicNotebook.vala"
				gtk_widget_set_margin_start ((GtkWidget*) _tmp4_, 1);
#line 1274 "DynamicNotebook.c"
			} else {
				GtkLabel* _tmp5_;
				GtkImage* _tmp6_;
				GtkSpinner* _tmp7_;
#line 72 "../src/DynamicNotebook.vala"
				_tmp5_ = self->priv->_label;
#line 72 "../src/DynamicNotebook.vala"
				gtk_widget_set_visible ((GtkWidget*) _tmp5_, TRUE);
#line 73 "../src/DynamicNotebook.vala"
				_tmp6_ = self->_icon;
#line 73 "../src/DynamicNotebook.vala"
				gtk_widget_set_margin_start ((GtkWidget*) _tmp6_, 0);
#line 74 "../src/DynamicNotebook.vala"
				_tmp7_ = self->priv->_working;
#line 74 "../src/DynamicNotebook.vala"
				gtk_widget_set_margin_start ((GtkWidget*) _tmp7_, 0);
#line 1291 "DynamicNotebook.c"
			}
#line 77 "../src/DynamicNotebook.vala"
			self->priv->_pinned = value;
#line 78 "../src/DynamicNotebook.vala"
			tab_update_close_button_visibility (self);
#line 79 "../src/DynamicNotebook.vala"
			g_signal_emit (self, tab_signals[TAB_PIN_SWITCH_SIGNAL], 0);
#line 1299 "DynamicNotebook.c"
		}
	}
#line 64 "../src/DynamicNotebook.vala"
	g_object_notify_by_pspec ((GObject *) self, tab_properties[TAB_PINNED_PROPERTY]);
#line 1304 "DynamicNotebook.c"
}

gboolean
tab_get_pinnable (Tab* self)
{
	gboolean result;
#line 87 "../src/DynamicNotebook.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 87 "../src/DynamicNotebook.vala"
	result = self->priv->_pinnable;
#line 87 "../src/DynamicNotebook.vala"
	return result;
#line 1317 "DynamicNotebook.c"
}

void
tab_set_pinnable (Tab* self,
                  gboolean value)
{
#line 88 "../src/DynamicNotebook.vala"
	g_return_if_fail (self != NULL);
#line 89 "../src/DynamicNotebook.vala"
	if (!value) {
#line 90 "../src/DynamicNotebook.vala"
		tab_set_pinned (self, FALSE);
#line 1330 "DynamicNotebook.c"
	}
#line 93 "../src/DynamicNotebook.vala"
	self->priv->_pinnable = value;
#line 88 "../src/DynamicNotebook.vala"
	g_object_notify_by_pspec ((GObject *) self, tab_properties[TAB_PINNABLE_PROPERTY]);
#line 1336 "DynamicNotebook.c"
}

const gchar*
tab_get_restore_data (Tab* self)
{
	const gchar* result;
	const gchar* _tmp0_;
#line 102 "../src/DynamicNotebook.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 102 "../src/DynamicNotebook.vala"
	_tmp0_ = self->priv->_restore_data;
#line 102 "../src/DynamicNotebook.vala"
	result = _tmp0_;
#line 102 "../src/DynamicNotebook.vala"
	return result;
#line 1352 "DynamicNotebook.c"
}

void
tab_set_restore_data (Tab* self,
                      const gchar* value)
{
	gchar* old_value;
#line 102 "../src/DynamicNotebook.vala"
	g_return_if_fail (self != NULL);
#line 102 "../src/DynamicNotebook.vala"
	old_value = tab_get_restore_data (self);
#line 102 "../src/DynamicNotebook.vala"
	if (g_strcmp0 (value, old_value) != 0) {
#line 1366 "DynamicNotebook.c"
		gchar* _tmp0_;
#line 102 "../src/DynamicNotebook.vala"
		_tmp0_ = g_strdup (value);
#line 102 "../src/DynamicNotebook.vala"
		_g_free0 (self->priv->_restore_data);
#line 102 "../src/DynamicNotebook.vala"
		self->priv->_restore_data = _tmp0_;
#line 102 "../src/DynamicNotebook.vala"
		g_object_notify_by_pspec ((GObject *) self, tab_properties[TAB_RESTORE_DATA_PROPERTY]);
#line 1376 "DynamicNotebook.c"
	}
}

GtkWidget*
tab_get_page (Tab* self)
{
	GtkWidget* result;
	TabPageContainer* _tmp0_;
	GtkWidget* _tmp1_;
#line 115 "../src/DynamicNotebook.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 116 "../src/DynamicNotebook.vala"
	_tmp0_ = self->page_container;
#line 116 "../src/DynamicNotebook.vala"
	_tmp1_ = gtk_bin_get_child ((GtkBin*) _tmp0_);
#line 116 "../src/DynamicNotebook.vala"
	result = _tmp1_;
#line 116 "../src/DynamicNotebook.vala"
	return result;
#line 1396 "DynamicNotebook.c"
}

void
tab_set_page (Tab* self,
              GtkWidget* value)
{
	GtkWidget* container_child = NULL;
	TabPageContainer* _tmp0_;
	GtkWidget* _tmp1_;
	GtkWidget* _tmp2_;
	GtkContainer* value_parent = NULL;
	GtkContainer* _tmp5_;
	GtkContainer* _tmp6_;
	TabPageContainer* _tmp10_;
#line 118 "../src/DynamicNotebook.vala"
	g_return_if_fail (self != NULL);
#line 119 "../src/DynamicNotebook.vala"
	_tmp0_ = self->page_container;
#line 119 "../src/DynamicNotebook.vala"
	_tmp1_ = gtk_bin_get_child ((GtkBin*) _tmp0_);
#line 119 "../src/DynamicNotebook.vala"
	container_child = _tmp1_;
#line 120 "../src/DynamicNotebook.vala"
	_tmp2_ = container_child;
#line 120 "../src/DynamicNotebook.vala"
	if (_tmp2_ != NULL) {
#line 1423 "DynamicNotebook.c"
		TabPageContainer* _tmp3_;
		GtkWidget* _tmp4_;
#line 121 "../src/DynamicNotebook.vala"
		_tmp3_ = self->page_container;
#line 121 "../src/DynamicNotebook.vala"
		_tmp4_ = container_child;
#line 121 "../src/DynamicNotebook.vala"
		gtk_container_remove ((GtkContainer*) _tmp3_, _tmp4_);
#line 1432 "DynamicNotebook.c"
	}
#line 124 "../src/DynamicNotebook.vala"
	_tmp5_ = gtk_widget_get_parent (value);
#line 124 "../src/DynamicNotebook.vala"
	value_parent = _tmp5_;
#line 125 "../src/DynamicNotebook.vala"
	_tmp6_ = value_parent;
#line 125 "../src/DynamicNotebook.vala"
	if (_tmp6_ != NULL) {
#line 1442 "DynamicNotebook.c"
		GtkContainer* _tmp7_;
		TabPageContainer* _tmp8_;
#line 126 "../src/DynamicNotebook.vala"
		_tmp7_ = value_parent;
#line 126 "../src/DynamicNotebook.vala"
		gtk_container_remove (_tmp7_, value);
#line 127 "../src/DynamicNotebook.vala"
		_tmp8_ = self->page_container;
#line 127 "../src/DynamicNotebook.vala"
		gtk_container_add ((GtkContainer*) _tmp8_, value);
#line 1453 "DynamicNotebook.c"
	} else {
		TabPageContainer* _tmp9_;
#line 129 "../src/DynamicNotebook.vala"
		_tmp9_ = self->page_container;
#line 129 "../src/DynamicNotebook.vala"
		gtk_container_add ((GtkContainer*) _tmp9_, value);
#line 1460 "DynamicNotebook.c"
	}
#line 132 "../src/DynamicNotebook.vala"
	_tmp10_ = self->page_container;
#line 132 "../src/DynamicNotebook.vala"
	gtk_widget_show_all ((GtkWidget*) _tmp10_);
#line 118 "../src/DynamicNotebook.vala"
	g_object_notify_by_pspec ((GObject *) self, tab_properties[TAB_PAGE_PROPERTY]);
#line 1468 "DynamicNotebook.c"
}

GIcon*
tab_get_icon (Tab* self)
{
	GIcon* result;
	GtkImage* _tmp0_;
	GIcon* _tmp1_;
	GIcon* _tmp2_;
#line 138 "../src/DynamicNotebook.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 138 "../src/DynamicNotebook.vala"
	_tmp0_ = self->_icon;
#line 138 "../src/DynamicNotebook.vala"
	g_object_get (_tmp0_, "gicon", &_tmp1_, NULL);
#line 138 "../src/DynamicNotebook.vala"
	_tmp2_ = _tmp1_;
#line 138 "../src/DynamicNotebook.vala"
	result = _tmp2_;
#line 138 "../src/DynamicNotebook.vala"
	return result;
#line 1490 "DynamicNotebook.c"
}

void
tab_set_icon (Tab* self,
              GIcon* value)
{
	GtkImage* _tmp0_;
#line 139 "../src/DynamicNotebook.vala"
	g_return_if_fail (self != NULL);
#line 139 "../src/DynamicNotebook.vala"
	_tmp0_ = self->_icon;
#line 139 "../src/DynamicNotebook.vala"
	g_object_set (_tmp0_, "gicon", value, NULL);
#line 139 "../src/DynamicNotebook.vala"
	g_object_notify_by_pspec ((GObject *) self, tab_properties[TAB_ICON_PROPERTY]);
#line 1506 "DynamicNotebook.c"
}

gboolean
tab_get_working (Tab* self)
{
	gboolean result;
#line 145 "../src/DynamicNotebook.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 145 "../src/DynamicNotebook.vala"
	result = self->priv->__working;
#line 145 "../src/DynamicNotebook.vala"
	return result;
#line 1519 "DynamicNotebook.c"
}

void
tab_set_working (Tab* self,
                 gboolean value)
{
	GtkSpinner* _tmp0_;
	GtkImage* _tmp1_;
#line 147 "../src/DynamicNotebook.vala"
	g_return_if_fail (self != NULL);
#line 148 "../src/DynamicNotebook.vala"
	_tmp0_ = self->priv->_working;
#line 148 "../src/DynamicNotebook.vala"
	gtk_widget_set_visible ((GtkWidget*) _tmp0_, value);
#line 148 "../src/DynamicNotebook.vala"
	self->priv->__working = value;
#line 149 "../src/DynamicNotebook.vala"
	_tmp1_ = self->_icon;
#line 149 "../src/DynamicNotebook.vala"
	gtk_widget_set_visible ((GtkWidget*) _tmp1_, !value);
#line 147 "../src/DynamicNotebook.vala"
	g_object_notify_by_pspec ((GObject *) self, tab_properties[TAB_WORKING_PROPERTY]);
#line 1542 "DynamicNotebook.c"
}

PangoEllipsizeMode
tab_get_ellipsize_mode (Tab* self)
{
	PangoEllipsizeMode result;
	GtkLabel* _tmp0_;
	PangoEllipsizeMode _tmp1_;
	PangoEllipsizeMode _tmp2_;
#line 154 "../src/DynamicNotebook.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 154 "../src/DynamicNotebook.vala"
	_tmp0_ = self->priv->_label;
#line 154 "../src/DynamicNotebook.vala"
	_tmp1_ = gtk_label_get_ellipsize (_tmp0_);
#line 154 "../src/DynamicNotebook.vala"
	_tmp2_ = _tmp1_;
#line 154 "../src/DynamicNotebook.vala"
	result = _tmp2_;
#line 154 "../src/DynamicNotebook.vala"
	return result;
#line 1564 "DynamicNotebook.c"
}

void
tab_set_ellipsize_mode (Tab* self,
                        PangoEllipsizeMode value)
{
	GtkLabel* _tmp0_;
#line 155 "../src/DynamicNotebook.vala"
	g_return_if_fail (self != NULL);
#line 155 "../src/DynamicNotebook.vala"
	_tmp0_ = self->priv->_label;
#line 155 "../src/DynamicNotebook.vala"
	gtk_label_set_ellipsize (_tmp0_, value);
#line 155 "../src/DynamicNotebook.vala"
	g_object_notify_by_pspec ((GObject *) self, tab_properties[TAB_ELLIPSIZE_MODE_PROPERTY]);
#line 1580 "DynamicNotebook.c"
}

gboolean
tab_get_fixed (Tab* self)
{
	gboolean result;
#line 161 "../src/DynamicNotebook.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 161 "../src/DynamicNotebook.vala"
	result = self->priv->_fixed;
#line 161 "../src/DynamicNotebook.vala"
	return result;
#line 1593 "DynamicNotebook.c"
}

void
tab_set_fixed (Tab* self,
               gboolean value)
{
#line 162 "../src/DynamicNotebook.vala"
	g_return_if_fail (self != NULL);
#line 163 "../src/DynamicNotebook.vala"
	if (value != self->priv->_fixed) {
#line 1604 "DynamicNotebook.c"
		GtkLabel* _tmp0_;
#line 164 "../src/DynamicNotebook.vala"
		self->priv->_fixed = value;
#line 165 "../src/DynamicNotebook.vala"
		_tmp0_ = self->priv->_label;
#line 165 "../src/DynamicNotebook.vala"
		gtk_widget_set_visible ((GtkWidget*) _tmp0_, value);
#line 1612 "DynamicNotebook.c"
	}
#line 162 "../src/DynamicNotebook.vala"
	g_object_notify_by_pspec ((GObject *) self, tab_properties[TAB_FIXED_PROPERTY]);
#line 1616 "DynamicNotebook.c"
}

GtkMenu*
tab_get_menu (Tab* self)
{
	GtkMenu* result;
	GtkMenu* _tmp0_;
#line 170 "../src/DynamicNotebook.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 170 "../src/DynamicNotebook.vala"
	_tmp0_ = self->priv->_menu;
#line 170 "../src/DynamicNotebook.vala"
	result = _tmp0_;
#line 170 "../src/DynamicNotebook.vala"
	return result;
#line 1632 "DynamicNotebook.c"
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 170 "../src/DynamicNotebook.vala"
	return self ? g_object_ref (self) : NULL;
#line 1640 "DynamicNotebook.c"
}

void
tab_set_menu (Tab* self,
              GtkMenu* value)
{
	GtkMenu* old_value;
#line 170 "../src/DynamicNotebook.vala"
	g_return_if_fail (self != NULL);
#line 170 "../src/DynamicNotebook.vala"
	old_value = tab_get_menu (self);
#line 170 "../src/DynamicNotebook.vala"
	if (old_value != value) {
#line 1654 "DynamicNotebook.c"
		GtkMenu* _tmp0_;
#line 170 "../src/DynamicNotebook.vala"
		_tmp0_ = _g_object_ref0 (value);
#line 170 "../src/DynamicNotebook.vala"
		_g_object_unref0 (self->priv->_menu);
#line 170 "../src/DynamicNotebook.vala"
		self->priv->_menu = _tmp0_;
#line 170 "../src/DynamicNotebook.vala"
		g_object_notify_by_pspec ((GObject *) self, tab_properties[TAB_MENU_PROPERTY]);
#line 1664 "DynamicNotebook.c"
	}
}

void
tab_set_closable (Tab* self,
                  gboolean value)
{
#line 174 "../src/DynamicNotebook.vala"
	g_return_if_fail (self != NULL);
#line 175 "../src/DynamicNotebook.vala"
	if (value == self->priv->_closable) {
#line 176 "../src/DynamicNotebook.vala"
		return;
#line 1678 "DynamicNotebook.c"
	}
#line 178 "../src/DynamicNotebook.vala"
	self->priv->_closable = value;
#line 179 "../src/DynamicNotebook.vala"
	tab_update_close_button_visibility (self);
#line 174 "../src/DynamicNotebook.vala"
	g_object_notify_by_pspec ((GObject *) self, tab_properties[TAB_CLOSABLE_PROPERTY]);
#line 1686 "DynamicNotebook.c"
}

void
tab_set_is_current_tab (Tab* self,
                        gboolean value)
{
#line 190 "../src/DynamicNotebook.vala"
	g_return_if_fail (self != NULL);
#line 191 "../src/DynamicNotebook.vala"
	self->priv->_is_current_tab = value;
#line 192 "../src/DynamicNotebook.vala"
	tab_update_close_button_visibility (self);
#line 190 "../src/DynamicNotebook.vala"
	g_object_notify_by_pspec ((GObject *) self, tab_properties[TAB_IS_CURRENT_TAB_PROPERTY]);
#line 1701 "DynamicNotebook.c"
}

static Block14Data*
block14_data_ref (Block14Data* _data14_)
{
#line 218 "../src/DynamicNotebook.vala"
	g_atomic_int_inc (&_data14_->_ref_count_);
#line 218 "../src/DynamicNotebook.vala"
	return _data14_;
#line 1711 "DynamicNotebook.c"
}

static void
block14_data_unref (void * _userdata_)
{
	Block14Data* _data14_;
	_data14_ = (Block14Data*) _userdata_;
#line 218 "../src/DynamicNotebook.vala"
	if (g_atomic_int_dec_and_test (&_data14_->_ref_count_)) {
#line 1721 "DynamicNotebook.c"
		Tab* self;
#line 218 "../src/DynamicNotebook.vala"
		self = _data14_->self;
#line 218 "../src/DynamicNotebook.vala"
		_g_object_unref0 (_data14_->close_other_m);
#line 218 "../src/DynamicNotebook.vala"
		_g_object_unref0 (self);
#line 218 "../src/DynamicNotebook.vala"
		g_slice_free (Block14Data, _data14_);
#line 1731 "DynamicNotebook.c"
	}
}

static void
_tab___lambda4_ (Tab* self)
{
#line 270 "../src/DynamicNotebook.vala"
	g_signal_emit (self, tab_signals[TAB_CLOSED_SIGNAL], 0);
#line 1740 "DynamicNotebook.c"
}

static void
__tab___lambda4__gtk_menu_item_activate (GtkMenuItem* _sender,
                                         gpointer self)
{
#line 270 "../src/DynamicNotebook.vala"
	_tab___lambda4_ ((Tab*) self);
#line 1749 "DynamicNotebook.c"
}

static void
_tab___lambda5_ (Tab* self)
{
#line 271 "../src/DynamicNotebook.vala"
	g_signal_emit (self, tab_signals[TAB_CLOSE_OTHERS_SIGNAL], 0);
#line 1757 "DynamicNotebook.c"
}

static void
__tab___lambda5__gtk_menu_item_activate (GtkMenuItem* _sender,
                                         gpointer self)
{
#line 271 "../src/DynamicNotebook.vala"
	_tab___lambda5_ ((Tab*) self);
#line 1766 "DynamicNotebook.c"
}

static void
_tab___lambda6_ (Tab* self)
{
#line 272 "../src/DynamicNotebook.vala"
	g_signal_emit (self, tab_signals[TAB_NEW_WINDOW_SIGNAL], 0);
#line 1774 "DynamicNotebook.c"
}

static void
__tab___lambda6__gtk_menu_item_activate (GtkMenuItem* _sender,
                                         gpointer self)
{
#line 272 "../src/DynamicNotebook.vala"
	_tab___lambda6_ ((Tab*) self);
#line 1783 "DynamicNotebook.c"
}

static void
_tab___lambda7_ (Tab* self)
{
#line 273 "../src/DynamicNotebook.vala"
	g_signal_emit (self, tab_signals[TAB_DUPLICATE_SIGNAL], 0);
#line 1791 "DynamicNotebook.c"
}

static void
__tab___lambda7__gtk_menu_item_activate (GtkMenuItem* _sender,
                                         gpointer self)
{
#line 273 "../src/DynamicNotebook.vala"
	_tab___lambda7_ ((Tab*) self);
#line 1800 "DynamicNotebook.c"
}

static void
_tab___lambda8_ (Tab* self)
{
	gboolean _tmp0_;
	gboolean _tmp1_;
#line 274 "../src/DynamicNotebook.vala"
	_tmp0_ = tab_get_pinned (self);
#line 274 "../src/DynamicNotebook.vala"
	_tmp1_ = _tmp0_;
#line 274 "../src/DynamicNotebook.vala"
	tab_set_pinned (self, !_tmp1_);
#line 1814 "DynamicNotebook.c"
}

static void
__tab___lambda8__gtk_menu_item_activate (GtkMenuItem* _sender,
                                         gpointer self)
{
#line 274 "../src/DynamicNotebook.vala"
	_tab___lambda8_ ((Tab*) self);
#line 1823 "DynamicNotebook.c"
}

static gboolean
_tab___lambda9_ (Tab* self,
                 GdkEventScroll* e)
{
	GtkNotebook* notebook = NULL;
	GtkContainer* _tmp0_;
	GtkNotebook* _tmp1_;
	gboolean result;
#line 276 "../src/DynamicNotebook.vala"
	g_return_val_if_fail (e != NULL, FALSE);
#line 277 "../src/DynamicNotebook.vala"
	_tmp0_ = gtk_widget_get_parent ((GtkWidget*) self);
#line 277 "../src/DynamicNotebook.vala"
	_tmp1_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_TYPE (_tmp0_, gtk_notebook_get_type ()) ? ((GtkNotebook*) _tmp0_) : NULL);
#line 277 "../src/DynamicNotebook.vala"
	notebook = _tmp1_;
#line 278 "../src/DynamicNotebook.vala"
	switch (e->direction) {
#line 278 "../src/DynamicNotebook.vala"
		case GDK_SCROLL_UP:
#line 278 "../src/DynamicNotebook.vala"
		case GDK_SCROLL_LEFT:
#line 1848 "DynamicNotebook.c"
		{
			GtkNotebook* _tmp2_;
			gint _tmp3_;
			gint _tmp4_;
#line 281 "../src/DynamicNotebook.vala"
			_tmp2_ = notebook;
#line 281 "../src/DynamicNotebook.vala"
			g_object_get (_tmp2_, "page", &_tmp3_, NULL);
#line 281 "../src/DynamicNotebook.vala"
			_tmp4_ = _tmp3_;
#line 281 "../src/DynamicNotebook.vala"
			if (_tmp4_ > 0) {
#line 1861 "DynamicNotebook.c"
				GtkNotebook* _tmp5_;
				gint _tmp6_;
				gint _tmp7_;
#line 282 "../src/DynamicNotebook.vala"
				_tmp5_ = notebook;
#line 282 "../src/DynamicNotebook.vala"
				g_object_get (_tmp5_, "page", &_tmp6_, NULL);
#line 282 "../src/DynamicNotebook.vala"
				_tmp7_ = _tmp6_;
#line 282 "../src/DynamicNotebook.vala"
				g_object_set (_tmp5_, "page", _tmp7_ - 1, NULL);
#line 283 "../src/DynamicNotebook.vala"
				result = TRUE;
#line 283 "../src/DynamicNotebook.vala"
				_g_object_unref0 (notebook);
#line 283 "../src/DynamicNotebook.vala"
				return result;
#line 1879 "DynamicNotebook.c"
			}
#line 285 "../src/DynamicNotebook.vala"
			break;
#line 1883 "DynamicNotebook.c"
		}
#line 278 "../src/DynamicNotebook.vala"
		case GDK_SCROLL_DOWN:
#line 278 "../src/DynamicNotebook.vala"
		case GDK_SCROLL_RIGHT:
#line 1889 "DynamicNotebook.c"
		{
			GtkNotebook* _tmp8_;
			gint _tmp9_;
			gint _tmp10_;
			GtkNotebook* _tmp11_;
#line 289 "../src/DynamicNotebook.vala"
			_tmp8_ = notebook;
#line 289 "../src/DynamicNotebook.vala"
			g_object_get (_tmp8_, "page", &_tmp9_, NULL);
#line 289 "../src/DynamicNotebook.vala"
			_tmp10_ = _tmp9_;
#line 289 "../src/DynamicNotebook.vala"
			_tmp11_ = notebook;
#line 289 "../src/DynamicNotebook.vala"
			if (_tmp10_ < gtk_notebook_get_n_pages (_tmp11_)) {
#line 1905 "DynamicNotebook.c"
				GtkNotebook* _tmp12_;
				gint _tmp13_;
				gint _tmp14_;
#line 290 "../src/DynamicNotebook.vala"
				_tmp12_ = notebook;
#line 290 "../src/DynamicNotebook.vala"
				g_object_get (_tmp12_, "page", &_tmp13_, NULL);
#line 290 "../src/DynamicNotebook.vala"
				_tmp14_ = _tmp13_;
#line 290 "../src/DynamicNotebook.vala"
				g_object_set (_tmp12_, "page", _tmp14_ + 1, NULL);
#line 291 "../src/DynamicNotebook.vala"
				result = TRUE;
#line 291 "../src/DynamicNotebook.vala"
				_g_object_unref0 (notebook);
#line 291 "../src/DynamicNotebook.vala"
				return result;
#line 1923 "DynamicNotebook.c"
			}
#line 293 "../src/DynamicNotebook.vala"
			break;
#line 1927 "DynamicNotebook.c"
		}
		default:
#line 278 "../src/DynamicNotebook.vala"
		break;
#line 1932 "DynamicNotebook.c"
	}
#line 296 "../src/DynamicNotebook.vala"
	result = FALSE;
#line 296 "../src/DynamicNotebook.vala"
	_g_object_unref0 (notebook);
#line 296 "../src/DynamicNotebook.vala"
	return result;
#line 1940 "DynamicNotebook.c"
}

static gboolean
__tab___lambda9__gtk_widget_scroll_event (GtkWidget* _sender,
                                          GdkEventScroll* event,
                                          gpointer self)
{
	gboolean result;
	result = _tab___lambda9_ ((Tab*) self, event);
#line 276 "../src/DynamicNotebook.vala"
	return result;
#line 1952 "DynamicNotebook.c"
}

static gboolean
_tab___lambda10_ (Block14Data* _data14_,
                  GdkEventButton* e)
{
	Tab* self;
	gboolean _tmp0_ = FALSE;
	gboolean result;
#line 299 "../src/DynamicNotebook.vala"
	self = _data14_->self;
#line 299 "../src/DynamicNotebook.vala"
	g_return_val_if_fail (e != NULL, FALSE);
#line 300 "../src/DynamicNotebook.vala"
	if (e->button == ((guint) 2)) {
#line 300 "../src/DynamicNotebook.vala"
		_tmp0_ = tab_close_button_is_visible (self);
#line 1970 "DynamicNotebook.c"
	} else {
#line 300 "../src/DynamicNotebook.vala"
		_tmp0_ = FALSE;
#line 1974 "DynamicNotebook.c"
	}
#line 300 "../src/DynamicNotebook.vala"
	if (_tmp0_) {
#line 301 "../src/DynamicNotebook.vala"
		e->state = e->state & MODIFIER_MASK;
#line 303 "../src/DynamicNotebook.vala"
		if (e->state == 0) {
#line 304 "../src/DynamicNotebook.vala"
			g_signal_emit (self, tab_signals[TAB_CLOSED_SIGNAL], 0);
#line 1984 "DynamicNotebook.c"
		} else {
#line 305 "../src/DynamicNotebook.vala"
			if (e->state == GDK_SHIFT_MASK) {
#line 306 "../src/DynamicNotebook.vala"
				g_signal_emit (self, tab_signals[TAB_CLOSE_OTHERS_SIGNAL], 0);
#line 1990 "DynamicNotebook.c"
			}
		}
	} else {
		gboolean _tmp1_ = FALSE;
		gboolean _tmp2_ = FALSE;
#line 308 "../src/DynamicNotebook.vala"
		if (e->button == ((guint) 1)) {
#line 308 "../src/DynamicNotebook.vala"
			_tmp2_ = e->type == GDK_2BUTTON_PRESS;
#line 2000 "DynamicNotebook.c"
		} else {
#line 308 "../src/DynamicNotebook.vala"
			_tmp2_ = FALSE;
#line 2004 "DynamicNotebook.c"
		}
#line 308 "../src/DynamicNotebook.vala"
		if (_tmp2_) {
#line 2008 "DynamicNotebook.c"
			GtkMenuItem* _tmp3_;
			gboolean _tmp4_;
			gboolean _tmp5_;
#line 308 "../src/DynamicNotebook.vala"
			_tmp3_ = self->duplicate_m;
#line 308 "../src/DynamicNotebook.vala"
			_tmp4_ = gtk_widget_get_visible ((GtkWidget*) _tmp3_);
#line 308 "../src/DynamicNotebook.vala"
			_tmp5_ = _tmp4_;
#line 308 "../src/DynamicNotebook.vala"
			_tmp1_ = _tmp5_;
#line 2020 "DynamicNotebook.c"
		} else {
#line 308 "../src/DynamicNotebook.vala"
			_tmp1_ = FALSE;
#line 2024 "DynamicNotebook.c"
		}
#line 308 "../src/DynamicNotebook.vala"
		if (_tmp1_) {
#line 309 "../src/DynamicNotebook.vala"
			g_signal_emit (self, tab_signals[TAB_DUPLICATE_SIGNAL], 0);
#line 2030 "DynamicNotebook.c"
		} else {
#line 310 "../src/DynamicNotebook.vala"
			if (e->button == ((guint) 3)) {
#line 2034 "DynamicNotebook.c"
				GtkMenu* _tmp6_;
				GtkContainer* cont = NULL;
				GtkContainer* _tmp7_;
				GtkContainer* _tmp8_;
				guint _tmp9_ = 0U;
				GtkContainer* _tmp10_;
				guint num_tabs = 0U;
				GtkMenuItem* _tmp14_;
				GtkMenuItem* _tmp15_;
				GtkMenuItem* _tmp16_;
				GtkMenuItem* _tmp17_;
				gboolean _tmp18_;
				gboolean _tmp19_;
#line 311 "../src/DynamicNotebook.vala"
				_tmp6_ = self->priv->_menu;
#line 311 "../src/DynamicNotebook.vala"
				gtk_menu_popup_at_pointer (_tmp6_, (GdkEvent*) e);
#line 312 "../src/DynamicNotebook.vala"
				_tmp7_ = gtk_widget_get_parent ((GtkWidget*) self);
#line 312 "../src/DynamicNotebook.vala"
				_tmp8_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_TYPE (_tmp7_, gtk_container_get_type ()) ? ((GtkContainer*) _tmp7_) : NULL);
#line 312 "../src/DynamicNotebook.vala"
				cont = _tmp8_;
#line 313 "../src/DynamicNotebook.vala"
				_tmp10_ = cont;
#line 313 "../src/DynamicNotebook.vala"
				if (_tmp10_ == NULL) {
#line 313 "../src/DynamicNotebook.vala"
					_tmp9_ = (guint) 0;
#line 2064 "DynamicNotebook.c"
				} else {
					GtkContainer* _tmp11_;
					GList* _tmp12_;
					GList* _tmp13_;
#line 313 "../src/DynamicNotebook.vala"
					_tmp11_ = cont;
#line 313 "../src/DynamicNotebook.vala"
					_tmp12_ = gtk_container_get_children (_tmp11_);
#line 313 "../src/DynamicNotebook.vala"
					_tmp13_ = _tmp12_;
#line 313 "../src/DynamicNotebook.vala"
					_tmp9_ = g_list_length (_tmp13_);
#line 313 "../src/DynamicNotebook.vala"
					(_tmp13_ == NULL) ? NULL : (_tmp13_ = (g_list_free (_tmp13_), NULL));
#line 2079 "DynamicNotebook.c"
				}
#line 313 "../src/DynamicNotebook.vala"
				num_tabs = _tmp9_;
#line 314 "../src/DynamicNotebook.vala"
				_tmp14_ = _data14_->close_other_m;
#line 314 "../src/DynamicNotebook.vala"
				gtk_menu_item_set_label (_tmp14_, ngettext (_ ("Close Other Tab"), _ ("Close Other Tabs"), (gulong) (num_tabs - 1)));
#line 315 "../src/DynamicNotebook.vala"
				_tmp15_ = _data14_->close_other_m;
#line 315 "../src/DynamicNotebook.vala"
				gtk_widget_set_sensitive ((GtkWidget*) _tmp15_, num_tabs != ((guint) 1));
#line 316 "../src/DynamicNotebook.vala"
				_tmp16_ = self->new_window_m;
#line 316 "../src/DynamicNotebook.vala"
				gtk_widget_set_sensitive ((GtkWidget*) _tmp16_, num_tabs != ((guint) 1));
#line 317 "../src/DynamicNotebook.vala"
				_tmp17_ = self->pin_m;
#line 317 "../src/DynamicNotebook.vala"
				gtk_menu_item_set_label (_tmp17_, "Pin");
#line 318 "../src/DynamicNotebook.vala"
				_tmp18_ = tab_get_pinned (self);
#line 318 "../src/DynamicNotebook.vala"
				_tmp19_ = _tmp18_;
#line 318 "../src/DynamicNotebook.vala"
				if (_tmp19_) {
#line 2105 "DynamicNotebook.c"
					GtkMenuItem* _tmp20_;
#line 319 "../src/DynamicNotebook.vala"
					_tmp20_ = self->pin_m;
#line 319 "../src/DynamicNotebook.vala"
					gtk_menu_item_set_label (_tmp20_, "Unpin");
#line 2111 "DynamicNotebook.c"
				}
#line 310 "../src/DynamicNotebook.vala"
				_g_object_unref0 (cont);
#line 2115 "DynamicNotebook.c"
			} else {
#line 322 "../src/DynamicNotebook.vala"
				result = FALSE;
#line 322 "../src/DynamicNotebook.vala"
				return result;
#line 2121 "DynamicNotebook.c"
			}
		}
	}
#line 325 "../src/DynamicNotebook.vala"
	result = TRUE;
#line 325 "../src/DynamicNotebook.vala"
	return result;
#line 2129 "DynamicNotebook.c"
}

static gboolean
__tab___lambda10__gtk_widget_button_press_event (GtkWidget* _sender,
                                                 GdkEventButton* event,
                                                 gpointer self)
{
	gboolean result;
	result = _tab___lambda10_ (self, event);
#line 299 "../src/DynamicNotebook.vala"
	return result;
#line 2141 "DynamicNotebook.c"
}

static gboolean
_tab___lambda11_ (Tab* self,
                  GdkEventCrossing* e)
{
	gboolean result;
#line 328 "../src/DynamicNotebook.vala"
	g_return_val_if_fail (e != NULL, FALSE);
#line 329 "../src/DynamicNotebook.vala"
	self->priv->cursor_over_tab = TRUE;
#line 330 "../src/DynamicNotebook.vala"
	tab_update_close_button_visibility (self);
#line 331 "../src/DynamicNotebook.vala"
	result = FALSE;
#line 331 "../src/DynamicNotebook.vala"
	return result;
#line 2159 "DynamicNotebook.c"
}

static gboolean
__tab___lambda11__gtk_widget_enter_notify_event (GtkWidget* _sender,
                                                 GdkEventCrossing* event,
                                                 gpointer self)
{
	gboolean result;
	result = _tab___lambda11_ ((Tab*) self, event);
#line 328 "../src/DynamicNotebook.vala"
	return result;
#line 2171 "DynamicNotebook.c"
}

static gboolean
_tab___lambda12_ (Tab* self,
                  GdkEventCrossing* e)
{
	gboolean result;
#line 334 "../src/DynamicNotebook.vala"
	g_return_val_if_fail (e != NULL, FALSE);
#line 337 "../src/DynamicNotebook.vala"
	if (!self->priv->cursor_over_tab) {
#line 338 "../src/DynamicNotebook.vala"
		result = FALSE;
#line 338 "../src/DynamicNotebook.vala"
		return result;
#line 2187 "DynamicNotebook.c"
	}
#line 340 "../src/DynamicNotebook.vala"
	self->priv->cursor_over_tab = FALSE;
#line 341 "../src/DynamicNotebook.vala"
	tab_update_close_button_visibility (self);
#line 342 "../src/DynamicNotebook.vala"
	result = FALSE;
#line 342 "../src/DynamicNotebook.vala"
	return result;
#line 2197 "DynamicNotebook.c"
}

static gboolean
__tab___lambda12__gtk_widget_leave_notify_event (GtkWidget* _sender,
                                                 GdkEventCrossing* event,
                                                 gpointer self)
{
	gboolean result;
	result = _tab___lambda12_ ((Tab*) self, event);
#line 334 "../src/DynamicNotebook.vala"
	return result;
#line 2209 "DynamicNotebook.c"
}

static gboolean
_tab___lambda13_ (Tab* self,
                  GdkEventCrossing* e)
{
	gboolean result;
#line 350 "../src/DynamicNotebook.vala"
	g_return_val_if_fail (e != NULL, FALSE);
#line 351 "../src/DynamicNotebook.vala"
	self->priv->cursor_over_close_button = TRUE;
#line 352 "../src/DynamicNotebook.vala"
	tab_update_close_button_visibility (self);
#line 353 "../src/DynamicNotebook.vala"
	result = FALSE;
#line 353 "../src/DynamicNotebook.vala"
	return result;
#line 2227 "DynamicNotebook.c"
}

static gboolean
__tab___lambda13__gtk_widget_enter_notify_event (GtkWidget* _sender,
                                                 GdkEventCrossing* event,
                                                 gpointer self)
{
	gboolean result;
	result = _tab___lambda13_ ((Tab*) self, event);
#line 350 "../src/DynamicNotebook.vala"
	return result;
#line 2239 "DynamicNotebook.c"
}

static gboolean
_tab___lambda14_ (Tab* self,
                  GdkEventCrossing* e)
{
	gboolean result;
#line 356 "../src/DynamicNotebook.vala"
	g_return_val_if_fail (e != NULL, FALSE);
#line 359 "../src/DynamicNotebook.vala"
	if (!self->priv->cursor_over_close_button) {
#line 360 "../src/DynamicNotebook.vala"
		result = FALSE;
#line 360 "../src/DynamicNotebook.vala"
		return result;
#line 2255 "DynamicNotebook.c"
	}
#line 362 "../src/DynamicNotebook.vala"
	self->priv->cursor_over_close_button = FALSE;
#line 363 "../src/DynamicNotebook.vala"
	tab_update_close_button_visibility (self);
#line 364 "../src/DynamicNotebook.vala"
	result = FALSE;
#line 364 "../src/DynamicNotebook.vala"
	return result;
#line 2265 "DynamicNotebook.c"
}

static gboolean
__tab___lambda14__gtk_widget_leave_notify_event (GtkWidget* _sender,
                                                 GdkEventCrossing* event,
                                                 gpointer self)
{
	gboolean result;
	result = _tab___lambda14_ ((Tab*) self, event);
#line 356 "../src/DynamicNotebook.vala"
	return result;
#line 2277 "DynamicNotebook.c"
}

static gboolean
_tab___lambda15_ (Tab* self)
{
	gboolean result;
#line 367 "../src/DynamicNotebook.vala"
	result = TRUE;
#line 367 "../src/DynamicNotebook.vala"
	return result;
#line 2288 "DynamicNotebook.c"
}

static gboolean
__tab___lambda15__gtk_widget_button_press_event (GtkWidget* _sender,
                                                 GdkEventButton* event,
                                                 gpointer self)
{
	gboolean result;
	result = _tab___lambda15_ ((Tab*) self);
#line 367 "../src/DynamicNotebook.vala"
	return result;
#line 2300 "DynamicNotebook.c"
}

static void
_tab___lambda16_ (Tab* self)
{
#line 368 "../src/DynamicNotebook.vala"
	g_signal_emit (self, tab_signals[TAB_CLOSED_SIGNAL], 0);
#line 2308 "DynamicNotebook.c"
}

static void
__tab___lambda16__gtk_button_clicked (GtkButton* _sender,
                                      gpointer self)
{
#line 368 "../src/DynamicNotebook.vala"
	_tab___lambda16_ ((Tab*) self);
#line 2317 "DynamicNotebook.c"
}

static GObject *
tab_constructor (GType type,
                 guint n_construct_properties,
                 GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	Tab * self;
	Block14Data* _data14_;
	GtkLabel* _tmp0_;
	GtkLabel* _tmp1_;
	GtkLabel* _tmp2_;
	const gchar* _tmp3_;
	const gchar* _tmp4_;
	GtkLabel* _tmp5_;
	GtkImage* _tmp6_;
	GtkImage* _tmp7_;
	GtkImage* _tmp8_;
	GtkImage* _tmp9_;
	GtkSpinner* _tmp10_;
	GtkSpinner* _tmp11_;
	GtkSpinner* _tmp12_;
	GtkButton* close_button = NULL;
	GtkButton* _tmp13_;
	GtkButton* _tmp14_;
	GtkButton* _tmp15_;
	GtkButton* _tmp16_;
	GtkRevealer* _tmp17_;
	GtkRevealer* _tmp18_;
	GtkRevealer* _tmp19_;
	GtkButton* _tmp20_;
	GtkGrid* tab_layout = NULL;
	GtkGrid* _tmp21_;
	GtkGrid* _tmp22_;
	GtkGrid* _tmp23_;
	GtkGrid* _tmp24_;
	GtkRevealer* _tmp25_;
	GtkGrid* _tmp26_;
	GtkLabel* _tmp27_;
	GtkGrid* _tmp28_;
	GtkImage* _tmp29_;
	GtkGrid* _tmp30_;
	GtkSpinner* _tmp31_;
	GtkGrid* _tmp32_;
	TabPageContainer* _tmp33_;
	GtkMenu* _tmp34_;
	GtkMenu* _tmp35_;
	GtkMenuItem* close_m = NULL;
	GtkMenuItem* _tmp36_;
	GtkMenuItem* _tmp37_;
	GtkMenuItem* _tmp38_;
	GtkMenuItem* _tmp39_;
	GtkMenuItem* _tmp40_;
	GtkMenu* _tmp41_;
	GtkMenuItem* _tmp42_;
	GtkMenu* _tmp43_;
	GtkMenuItem* _tmp44_;
	GtkMenu* _tmp45_;
	GtkMenuItem* _tmp46_;
	GtkMenu* _tmp47_;
	GtkMenuItem* _tmp48_;
	GtkMenu* _tmp49_;
	GtkMenuItem* _tmp50_;
	GtkMenu* _tmp51_;
	GtkMenuItem* _tmp52_;
	GtkMenuItem* _tmp53_;
	GtkMenuItem* _tmp54_;
	GtkMenuItem* _tmp55_;
	GtkMenuItem* _tmp56_;
	GtkButton* _tmp57_;
	GtkButton* _tmp58_;
	TabPageContainer* _tmp59_;
	GtkButton* _tmp60_;
#line 218 "../src/DynamicNotebook.vala"
	parent_class = G_OBJECT_CLASS (tab_parent_class);
#line 218 "../src/DynamicNotebook.vala"
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
#line 218 "../src/DynamicNotebook.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_TAB, Tab);
#line 218 "../src/DynamicNotebook.vala"
	_data14_ = g_slice_new0 (Block14Data);
#line 218 "../src/DynamicNotebook.vala"
	_data14_->_ref_count_ = 1;
#line 218 "../src/DynamicNotebook.vala"
	_data14_->self = g_object_ref (self);
#line 219 "../src/DynamicNotebook.vala"
	_tmp0_ = (GtkLabel*) gtk_label_new (NULL);
#line 219 "../src/DynamicNotebook.vala"
	g_object_ref_sink (_tmp0_);
#line 219 "../src/DynamicNotebook.vala"
	_g_object_unref0 (self->priv->_label);
#line 219 "../src/DynamicNotebook.vala"
	self->priv->_label = _tmp0_;
#line 220 "../src/DynamicNotebook.vala"
	_tmp1_ = self->priv->_label;
#line 220 "../src/DynamicNotebook.vala"
	gtk_widget_set_hexpand ((GtkWidget*) _tmp1_, TRUE);
#line 221 "../src/DynamicNotebook.vala"
	_tmp2_ = self->priv->_label;
#line 221 "../src/DynamicNotebook.vala"
	_tmp3_ = tab_get_label (self);
#line 221 "../src/DynamicNotebook.vala"
	_tmp4_ = _tmp3_;
#line 221 "../src/DynamicNotebook.vala"
	gtk_widget_set_tooltip_text ((GtkWidget*) _tmp2_, _tmp4_);
#line 222 "../src/DynamicNotebook.vala"
	_tmp5_ = self->priv->_label;
#line 222 "../src/DynamicNotebook.vala"
	gtk_label_set_ellipsize (_tmp5_, PANGO_ELLIPSIZE_END);
#line 224 "../src/DynamicNotebook.vala"
	_tmp6_ = (GtkImage*) gtk_image_new ();
#line 224 "../src/DynamicNotebook.vala"
	g_object_ref_sink (_tmp6_);
#line 224 "../src/DynamicNotebook.vala"
	_g_object_unref0 (self->_icon);
#line 224 "../src/DynamicNotebook.vala"
	self->_icon = _tmp6_;
#line 225 "../src/DynamicNotebook.vala"
	_tmp7_ = self->_icon;
#line 225 "../src/DynamicNotebook.vala"
	g_object_set (_tmp7_, "icon-size", (gint) GTK_ICON_SIZE_MENU, NULL);
#line 226 "../src/DynamicNotebook.vala"
	_tmp8_ = self->_icon;
#line 226 "../src/DynamicNotebook.vala"
	gtk_widget_set_visible ((GtkWidget*) _tmp8_, TRUE);
#line 227 "../src/DynamicNotebook.vala"
	_tmp9_ = self->_icon;
#line 227 "../src/DynamicNotebook.vala"
	gtk_widget_set_size_request ((GtkWidget*) _tmp9_, 16, 16);
#line 229 "../src/DynamicNotebook.vala"
	_tmp10_ = (GtkSpinner*) gtk_spinner_new ();
#line 229 "../src/DynamicNotebook.vala"
	g_object_ref_sink (_tmp10_);
#line 229 "../src/DynamicNotebook.vala"
	_g_object_unref0 (self->priv->_working);
#line 229 "../src/DynamicNotebook.vala"
	self->priv->_working = _tmp10_;
#line 230 "../src/DynamicNotebook.vala"
	_tmp11_ = self->priv->_working;
#line 230 "../src/DynamicNotebook.vala"
	gtk_widget_set_size_request ((GtkWidget*) _tmp11_, 16, 16);
#line 231 "../src/DynamicNotebook.vala"
	_tmp12_ = self->priv->_working;
#line 231 "../src/DynamicNotebook.vala"
	gtk_spinner_start (_tmp12_);
#line 233 "../src/DynamicNotebook.vala"
	_tmp13_ = (GtkButton*) gtk_button_new_from_icon_name ("window-close-symbolic", (GtkIconSize) GTK_ICON_SIZE_MENU);
#line 233 "../src/DynamicNotebook.vala"
	g_object_ref_sink (_tmp13_);
#line 233 "../src/DynamicNotebook.vala"
	close_button = _tmp13_;
#line 234 "../src/DynamicNotebook.vala"
	_tmp14_ = close_button;
#line 234 "../src/DynamicNotebook.vala"
	gtk_widget_set_tooltip_text ((GtkWidget*) _tmp14_, _ ("Close Tab"));
#line 235 "../src/DynamicNotebook.vala"
	_tmp15_ = close_button;
#line 235 "../src/DynamicNotebook.vala"
	gtk_widget_set_valign ((GtkWidget*) _tmp15_, GTK_ALIGN_CENTER);
#line 236 "../src/DynamicNotebook.vala"
	_tmp16_ = close_button;
#line 236 "../src/DynamicNotebook.vala"
	gtk_button_set_relief (_tmp16_, GTK_RELIEF_NONE);
#line 238 "../src/DynamicNotebook.vala"
	_tmp17_ = (GtkRevealer*) gtk_revealer_new ();
#line 238 "../src/DynamicNotebook.vala"
	g_object_ref_sink (_tmp17_);
#line 238 "../src/DynamicNotebook.vala"
	_g_object_unref0 (self->priv->close_button_revealer);
#line 238 "../src/DynamicNotebook.vala"
	self->priv->close_button_revealer = _tmp17_;
#line 239 "../src/DynamicNotebook.vala"
	_tmp18_ = self->priv->close_button_revealer;
#line 239 "../src/DynamicNotebook.vala"
	gtk_revealer_set_transition_type (_tmp18_, GTK_REVEALER_TRANSITION_TYPE_CROSSFADE);
#line 240 "../src/DynamicNotebook.vala"
	_tmp19_ = self->priv->close_button_revealer;
#line 240 "../src/DynamicNotebook.vala"
	_tmp20_ = close_button;
#line 240 "../src/DynamicNotebook.vala"
	gtk_container_add ((GtkContainer*) _tmp19_, (GtkWidget*) _tmp20_);
#line 242 "../src/DynamicNotebook.vala"
	_tmp21_ = (GtkGrid*) gtk_grid_new ();
#line 242 "../src/DynamicNotebook.vala"
	g_object_ref_sink (_tmp21_);
#line 242 "../src/DynamicNotebook.vala"
	tab_layout = _tmp21_;
#line 243 "../src/DynamicNotebook.vala"
	_tmp22_ = tab_layout;
#line 243 "../src/DynamicNotebook.vala"
	gtk_widget_set_hexpand ((GtkWidget*) _tmp22_, FALSE);
#line 244 "../src/DynamicNotebook.vala"
	_tmp23_ = tab_layout;
#line 244 "../src/DynamicNotebook.vala"
	gtk_orientable_set_orientation ((GtkOrientable*) _tmp23_, GTK_ORIENTATION_HORIZONTAL);
#line 245 "../src/DynamicNotebook.vala"
	_tmp24_ = tab_layout;
#line 245 "../src/DynamicNotebook.vala"
	_tmp25_ = self->priv->close_button_revealer;
#line 245 "../src/DynamicNotebook.vala"
	gtk_container_add ((GtkContainer*) _tmp24_, (GtkWidget*) _tmp25_);
#line 246 "../src/DynamicNotebook.vala"
	_tmp26_ = tab_layout;
#line 246 "../src/DynamicNotebook.vala"
	_tmp27_ = self->priv->_label;
#line 246 "../src/DynamicNotebook.vala"
	gtk_container_add ((GtkContainer*) _tmp26_, (GtkWidget*) _tmp27_);
#line 247 "../src/DynamicNotebook.vala"
	_tmp28_ = tab_layout;
#line 247 "../src/DynamicNotebook.vala"
	_tmp29_ = self->_icon;
#line 247 "../src/DynamicNotebook.vala"
	gtk_container_add ((GtkContainer*) _tmp28_, (GtkWidget*) _tmp29_);
#line 248 "../src/DynamicNotebook.vala"
	_tmp30_ = tab_layout;
#line 248 "../src/DynamicNotebook.vala"
	_tmp31_ = self->priv->_working;
#line 248 "../src/DynamicNotebook.vala"
	gtk_container_add ((GtkContainer*) _tmp30_, (GtkWidget*) _tmp31_);
#line 250 "../src/DynamicNotebook.vala"
	gtk_event_box_set_visible_window ((GtkEventBox*) self, TRUE);
#line 252 "../src/DynamicNotebook.vala"
	_tmp32_ = tab_layout;
#line 252 "../src/DynamicNotebook.vala"
	gtk_container_add ((GtkContainer*) self, (GtkWidget*) _tmp32_);
#line 253 "../src/DynamicNotebook.vala"
	gtk_widget_show_all ((GtkWidget*) self);
#line 255 "../src/DynamicNotebook.vala"
	_tmp33_ = tab_page_container_new (self);
#line 255 "../src/DynamicNotebook.vala"
	g_object_ref_sink (_tmp33_);
#line 255 "../src/DynamicNotebook.vala"
	_g_object_unref0 (self->page_container);
#line 255 "../src/DynamicNotebook.vala"
	self->page_container = _tmp33_;
#line 257 "../src/DynamicNotebook.vala"
	_tmp34_ = (GtkMenu*) gtk_menu_new ();
#line 257 "../src/DynamicNotebook.vala"
	g_object_ref_sink (_tmp34_);
#line 257 "../src/DynamicNotebook.vala"
	_tmp35_ = _tmp34_;
#line 257 "../src/DynamicNotebook.vala"
	tab_set_menu (self, _tmp35_);
#line 257 "../src/DynamicNotebook.vala"
	_g_object_unref0 (_tmp35_);
#line 258 "../src/DynamicNotebook.vala"
	_tmp36_ = (GtkMenuItem*) gtk_menu_item_new_with_label (_ ("Close Tab"));
#line 258 "../src/DynamicNotebook.vala"
	g_object_ref_sink (_tmp36_);
#line 258 "../src/DynamicNotebook.vala"
	close_m = _tmp36_;
#line 259 "../src/DynamicNotebook.vala"
	_tmp37_ = (GtkMenuItem*) gtk_menu_item_new_with_label ("");
#line 259 "../src/DynamicNotebook.vala"
	g_object_ref_sink (_tmp37_);
#line 259 "../src/DynamicNotebook.vala"
	_data14_->close_other_m = _tmp37_;
#line 260 "../src/DynamicNotebook.vala"
	_tmp38_ = (GtkMenuItem*) gtk_menu_item_new_with_label ("");
#line 260 "../src/DynamicNotebook.vala"
	g_object_ref_sink (_tmp38_);
#line 260 "../src/DynamicNotebook.vala"
	_g_object_unref0 (self->pin_m);
#line 260 "../src/DynamicNotebook.vala"
	self->pin_m = _tmp38_;
#line 261 "../src/DynamicNotebook.vala"
	_tmp39_ = (GtkMenuItem*) gtk_menu_item_new_with_label (_ ("Open in a New Window"));
#line 261 "../src/DynamicNotebook.vala"
	g_object_ref_sink (_tmp39_);
#line 261 "../src/DynamicNotebook.vala"
	_g_object_unref0 (self->new_window_m);
#line 261 "../src/DynamicNotebook.vala"
	self->new_window_m = _tmp39_;
#line 262 "../src/DynamicNotebook.vala"
	_tmp40_ = (GtkMenuItem*) gtk_menu_item_new_with_label (_ ("Duplicate"));
#line 262 "../src/DynamicNotebook.vala"
	g_object_ref_sink (_tmp40_);
#line 262 "../src/DynamicNotebook.vala"
	_g_object_unref0 (self->duplicate_m);
#line 262 "../src/DynamicNotebook.vala"
	self->duplicate_m = _tmp40_;
#line 263 "../src/DynamicNotebook.vala"
	_tmp41_ = self->priv->_menu;
#line 263 "../src/DynamicNotebook.vala"
	_tmp42_ = _data14_->close_other_m;
#line 263 "../src/DynamicNotebook.vala"
	gtk_menu_shell_append ((GtkMenuShell*) _tmp41_, _tmp42_);
#line 264 "../src/DynamicNotebook.vala"
	_tmp43_ = self->priv->_menu;
#line 264 "../src/DynamicNotebook.vala"
	_tmp44_ = close_m;
#line 264 "../src/DynamicNotebook.vala"
	gtk_menu_shell_append ((GtkMenuShell*) _tmp43_, _tmp44_);
#line 265 "../src/DynamicNotebook.vala"
	_tmp45_ = self->priv->_menu;
#line 265 "../src/DynamicNotebook.vala"
	_tmp46_ = self->new_window_m;
#line 265 "../src/DynamicNotebook.vala"
	gtk_menu_shell_append ((GtkMenuShell*) _tmp45_, _tmp46_);
#line 266 "../src/DynamicNotebook.vala"
	_tmp47_ = self->priv->_menu;
#line 266 "../src/DynamicNotebook.vala"
	_tmp48_ = self->duplicate_m;
#line 266 "../src/DynamicNotebook.vala"
	gtk_menu_shell_append ((GtkMenuShell*) _tmp47_, _tmp48_);
#line 267 "../src/DynamicNotebook.vala"
	_tmp49_ = self->priv->_menu;
#line 267 "../src/DynamicNotebook.vala"
	_tmp50_ = self->pin_m;
#line 267 "../src/DynamicNotebook.vala"
	gtk_menu_shell_append ((GtkMenuShell*) _tmp49_, _tmp50_);
#line 268 "../src/DynamicNotebook.vala"
	_tmp51_ = self->priv->_menu;
#line 268 "../src/DynamicNotebook.vala"
	gtk_widget_show_all ((GtkWidget*) _tmp51_);
#line 270 "../src/DynamicNotebook.vala"
	_tmp52_ = close_m;
#line 270 "../src/DynamicNotebook.vala"
	g_signal_connect_object (_tmp52_, "activate", (GCallback) __tab___lambda4__gtk_menu_item_activate, self, 0);
#line 271 "../src/DynamicNotebook.vala"
	_tmp53_ = _data14_->close_other_m;
#line 271 "../src/DynamicNotebook.vala"
	g_signal_connect_object (_tmp53_, "activate", (GCallback) __tab___lambda5__gtk_menu_item_activate, self, 0);
#line 272 "../src/DynamicNotebook.vala"
	_tmp54_ = self->new_window_m;
#line 272 "../src/DynamicNotebook.vala"
	g_signal_connect_object (_tmp54_, "activate", (GCallback) __tab___lambda6__gtk_menu_item_activate, self, 0);
#line 273 "../src/DynamicNotebook.vala"
	_tmp55_ = self->duplicate_m;
#line 273 "../src/DynamicNotebook.vala"
	g_signal_connect_object (_tmp55_, "activate", (GCallback) __tab___lambda7__gtk_menu_item_activate, self, 0);
#line 274 "../src/DynamicNotebook.vala"
	_tmp56_ = self->pin_m;
#line 274 "../src/DynamicNotebook.vala"
	g_signal_connect_object (_tmp56_, "activate", (GCallback) __tab___lambda8__gtk_menu_item_activate, self, 0);
#line 276 "../src/DynamicNotebook.vala"
	g_signal_connect_object ((GtkWidget*) self, "scroll-event", (GCallback) __tab___lambda9__gtk_widget_scroll_event, self, 0);
#line 299 "../src/DynamicNotebook.vala"
	g_signal_connect_data ((GtkWidget*) self, "button-press-event", (GCallback) __tab___lambda10__gtk_widget_button_press_event, block14_data_ref (_data14_), (GClosureNotify) block14_data_unref, 0);
#line 328 "../src/DynamicNotebook.vala"
	g_signal_connect_object ((GtkWidget*) self, "enter-notify-event", (GCallback) __tab___lambda11__gtk_widget_enter_notify_event, self, 0);
#line 334 "../src/DynamicNotebook.vala"
	g_signal_connect_object ((GtkWidget*) self, "leave-notify-event", (GCallback) __tab___lambda12__gtk_widget_leave_notify_event, self, 0);
#line 350 "../src/DynamicNotebook.vala"
	_tmp57_ = close_button;
#line 350 "../src/DynamicNotebook.vala"
	g_signal_connect_object ((GtkWidget*) _tmp57_, "enter-notify-event", (GCallback) __tab___lambda13__gtk_widget_enter_notify_event, self, 0);
#line 356 "../src/DynamicNotebook.vala"
	_tmp58_ = close_button;
#line 356 "../src/DynamicNotebook.vala"
	g_signal_connect_object ((GtkWidget*) _tmp58_, "leave-notify-event", (GCallback) __tab___lambda14__gtk_widget_leave_notify_event, self, 0);
#line 367 "../src/DynamicNotebook.vala"
	_tmp59_ = self->page_container;
#line 367 "../src/DynamicNotebook.vala"
	g_signal_connect_object ((GtkWidget*) _tmp59_, "button-press-event", (GCallback) __tab___lambda15__gtk_widget_button_press_event, self, 0);
#line 368 "../src/DynamicNotebook.vala"
	_tmp60_ = close_button;
#line 368 "../src/DynamicNotebook.vala"
	g_signal_connect_object (_tmp60_, "clicked", (GCallback) __tab___lambda16__gtk_button_clicked, self, 0);
#line 369 "../src/DynamicNotebook.vala"
	tab_set_working (self, FALSE);
#line 371 "../src/DynamicNotebook.vala"
	tab_update_close_button_visibility (self);
#line 218 "../src/DynamicNotebook.vala"
	_g_object_unref0 (close_m);
#line 218 "../src/DynamicNotebook.vala"
	_g_object_unref0 (tab_layout);
#line 218 "../src/DynamicNotebook.vala"
	_g_object_unref0 (close_button);
#line 218 "../src/DynamicNotebook.vala"
	block14_data_unref (_data14_);
#line 218 "../src/DynamicNotebook.vala"
	_data14_ = NULL;
#line 218 "../src/DynamicNotebook.vala"
	return obj;
#line 2695 "DynamicNotebook.c"
}

static void
tab_class_init (TabClass * klass,
                gpointer klass_data)
{
#line 46 "../src/DynamicNotebook.vala"
	tab_parent_class = g_type_class_peek_parent (klass);
#line 46 "../src/DynamicNotebook.vala"
	g_type_class_adjust_private_offset (klass, &Tab_private_offset);
#line 46 "../src/DynamicNotebook.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_tab_get_property;
#line 46 "../src/DynamicNotebook.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_tab_set_property;
#line 46 "../src/DynamicNotebook.vala"
	G_OBJECT_CLASS (klass)->constructor = tab_constructor;
#line 46 "../src/DynamicNotebook.vala"
	G_OBJECT_CLASS (klass)->finalize = tab_finalize;
#line 46 "../src/DynamicNotebook.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), TAB_LABEL_PROPERTY, tab_properties[TAB_LABEL_PROPERTY] = g_param_spec_string ("label", "label", "label", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 46 "../src/DynamicNotebook.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), TAB_TOOLTIP_PROPERTY, tab_properties[TAB_TOOLTIP_PROPERTY] = g_param_spec_string ("tooltip", "tooltip", "tooltip", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 46 "../src/DynamicNotebook.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), TAB_PINNED_PROPERTY, tab_properties[TAB_PINNED_PROPERTY] = g_param_spec_boolean ("pinned", "pinned", "pinned", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 46 "../src/DynamicNotebook.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), TAB_PINNABLE_PROPERTY, tab_properties[TAB_PINNABLE_PROPERTY] = g_param_spec_boolean ("pinnable", "pinnable", "pinnable", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 2722 "DynamicNotebook.c"
	/**
	         * Data which will be kept once the tab is deleted, and which will be used by
	         * the application to restore the data into the restored tab. Let it empty if
	         * the tab should not be restored.
	         **/
#line 46 "../src/DynamicNotebook.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), TAB_RESTORE_DATA_PROPERTY, tab_properties[TAB_RESTORE_DATA_PROPERTY] = g_param_spec_string ("restore-data", "restore-data", "restore-data", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 46 "../src/DynamicNotebook.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), TAB_PAGE_PROPERTY, tab_properties[TAB_PAGE_PROPERTY] = g_param_spec_object ("page", "page", "page", gtk_widget_get_type (), G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 46 "../src/DynamicNotebook.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), TAB_ICON_PROPERTY, tab_properties[TAB_ICON_PROPERTY] = g_param_spec_object ("icon", "icon", "icon", g_icon_get_type (), G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 46 "../src/DynamicNotebook.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), TAB_WORKING_PROPERTY, tab_properties[TAB_WORKING_PROPERTY] = g_param_spec_boolean ("working", "working", "working", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 46 "../src/DynamicNotebook.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), TAB_ELLIPSIZE_MODE_PROPERTY, tab_properties[TAB_ELLIPSIZE_MODE_PROPERTY] = g_param_spec_enum ("ellipsize-mode", "ellipsize-mode", "ellipsize-mode", pango_ellipsize_mode_get_type (), 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 46 "../src/DynamicNotebook.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), TAB_FIXED_PROPERTY, tab_properties[TAB_FIXED_PROPERTY] = g_param_spec_boolean ("fixed", "fixed", "fixed", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_DEPRECATED));
#line 46 "../src/DynamicNotebook.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), TAB_MENU_PROPERTY, tab_properties[TAB_MENU_PROPERTY] = g_param_spec_object ("menu", "menu", "menu", gtk_menu_get_type (), G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 46 "../src/DynamicNotebook.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), TAB_CLOSABLE_PROPERTY, tab_properties[TAB_CLOSABLE_PROPERTY] = g_param_spec_boolean ("closable", "closable", "closable", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_WRITABLE));
#line 46 "../src/DynamicNotebook.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), TAB_IS_CURRENT_TAB_PROPERTY, tab_properties[TAB_IS_CURRENT_TAB_PROPERTY] = g_param_spec_boolean ("is-current-tab", "is-current-tab", "is-current-tab", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_WRITABLE));
#line 46 "../src/DynamicNotebook.vala"
	tab_signals[TAB_CLOSED_SIGNAL] = g_signal_new ("closed", TYPE_TAB, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
#line 46 "../src/DynamicNotebook.vala"
	tab_signals[TAB_CLOSE_OTHERS_SIGNAL] = g_signal_new ("close-others", TYPE_TAB, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
#line 46 "../src/DynamicNotebook.vala"
	tab_signals[TAB_NEW_WINDOW_SIGNAL] = g_signal_new ("new-window", TYPE_TAB, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
#line 46 "../src/DynamicNotebook.vala"
	tab_signals[TAB_DUPLICATE_SIGNAL] = g_signal_new ("duplicate", TYPE_TAB, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
#line 46 "../src/DynamicNotebook.vala"
	tab_signals[TAB_PIN_SWITCH_SIGNAL] = g_signal_new ("pin-switch", TYPE_TAB, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
#line 2756 "DynamicNotebook.c"
}

static void
tab_instance_init (Tab * self,
                   gpointer klass)
{
	gchar* _tmp0_;
#line 46 "../src/DynamicNotebook.vala"
	self->priv = tab_get_instance_private (self);
#line 60 "../src/DynamicNotebook.vala"
	self->priv->_pinned = FALSE;
#line 85 "../src/DynamicNotebook.vala"
	self->priv->_pinnable = TRUE;
#line 102 "../src/DynamicNotebook.vala"
	_tmp0_ = g_strdup ("");
#line 102 "../src/DynamicNotebook.vala"
	self->priv->_restore_data = _tmp0_;
#line 111 "../src/DynamicNotebook.vala"
	self->dropped_callback = NULL;
#line 111 "../src/DynamicNotebook.vala"
	self->dropped_callback_target = NULL;
#line 111 "../src/DynamicNotebook.vala"
	self->dropped_callback_target_destroy_notify = NULL;
#line 172 "../src/DynamicNotebook.vala"
	self->priv->_closable = TRUE;
#line 188 "../src/DynamicNotebook.vala"
	self->priv->_is_current_tab = FALSE;
#line 196 "../src/DynamicNotebook.vala"
	self->priv->cursor_over_tab = FALSE;
#line 197 "../src/DynamicNotebook.vala"
	self->priv->cursor_over_close_button = FALSE;
#line 2788 "DynamicNotebook.c"
}

static void
tab_finalize (GObject * obj)
{
	Tab * self;
#line 46 "../src/DynamicNotebook.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_TAB, Tab);
#line 47 "../src/DynamicNotebook.vala"
	_g_object_unref0 (self->priv->_label);
#line 102 "../src/DynamicNotebook.vala"
	_g_free0 (self->priv->_restore_data);
#line 111 "../src/DynamicNotebook.vala"
	(self->dropped_callback_target_destroy_notify == NULL) ? NULL : (self->dropped_callback_target_destroy_notify (self->dropped_callback_target), NULL);
#line 111 "../src/DynamicNotebook.vala"
	self->dropped_callback = NULL;
#line 111 "../src/DynamicNotebook.vala"
	self->dropped_callback_target = NULL;
#line 111 "../src/DynamicNotebook.vala"
	self->dropped_callback_target_destroy_notify = NULL;
#line 113 "../src/DynamicNotebook.vala"
	_g_object_unref0 (self->page_container);
#line 136 "../src/DynamicNotebook.vala"
	_g_object_unref0 (self->_icon);
#line 142 "../src/DynamicNotebook.vala"
	_g_object_unref0 (self->priv->_working);
#line 170 "../src/DynamicNotebook.vala"
	_g_object_unref0 (self->priv->_menu);
#line 184 "../src/DynamicNotebook.vala"
	_g_object_unref0 (self->new_window_m);
#line 185 "../src/DynamicNotebook.vala"
	_g_object_unref0 (self->duplicate_m);
#line 186 "../src/DynamicNotebook.vala"
	_g_object_unref0 (self->pin_m);
#line 198 "../src/DynamicNotebook.vala"
	_g_object_unref0 (self->priv->close_button_revealer);
#line 46 "../src/DynamicNotebook.vala"
	G_OBJECT_CLASS (tab_parent_class)->finalize (obj);
#line 2827 "DynamicNotebook.c"
}

/**
     * This is a standard tab which can be used in a notebook to form a tabbed UI.
     */
static GType
tab_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (TabClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) tab_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (Tab), 0, (GInstanceInitFunc) tab_instance_init, NULL };
	GType tab_type_id;
	tab_type_id = g_type_register_static (gtk_event_box_get_type (), "Tab", &g_define_type_info, 0);
	Tab_private_offset = g_type_add_instance_private (tab_type_id, sizeof (TabPrivate));
	return tab_type_id;
}

GType
tab_get_type (void)
{
	static volatile gsize tab_type_id__once = 0;
	if (g_once_init_enter (&tab_type_id__once)) {
		GType tab_type_id;
		tab_type_id = tab_get_type_once ();
		g_once_init_leave (&tab_type_id__once, tab_type_id);
	}
	return tab_type_id__once;
}

static void
_vala_tab_get_property (GObject * object,
                        guint property_id,
                        GValue * value,
                        GParamSpec * pspec)
{
	Tab * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_TAB, Tab);
#line 46 "../src/DynamicNotebook.vala"
	switch (property_id) {
#line 46 "../src/DynamicNotebook.vala"
		case TAB_LABEL_PROPERTY:
#line 46 "../src/DynamicNotebook.vala"
		g_value_set_string (value, tab_get_label (self));
#line 46 "../src/DynamicNotebook.vala"
		break;
#line 46 "../src/DynamicNotebook.vala"
		case TAB_TOOLTIP_PROPERTY:
#line 46 "../src/DynamicNotebook.vala"
		g_value_take_string (value, tab_get_tooltip (self));
#line 46 "../src/DynamicNotebook.vala"
		break;
#line 46 "../src/DynamicNotebook.vala"
		case TAB_PINNED_PROPERTY:
#line 46 "../src/DynamicNotebook.vala"
		g_value_set_boolean (value, tab_get_pinned (self));
#line 46 "../src/DynamicNotebook.vala"
		break;
#line 46 "../src/DynamicNotebook.vala"
		case TAB_PINNABLE_PROPERTY:
#line 46 "../src/DynamicNotebook.vala"
		g_value_set_boolean (value, tab_get_pinnable (self));
#line 46 "../src/DynamicNotebook.vala"
		break;
#line 46 "../src/DynamicNotebook.vala"
		case TAB_RESTORE_DATA_PROPERTY:
#line 46 "../src/DynamicNotebook.vala"
		g_value_set_string (value, tab_get_restore_data (self));
#line 46 "../src/DynamicNotebook.vala"
		break;
#line 46 "../src/DynamicNotebook.vala"
		case TAB_PAGE_PROPERTY:
#line 46 "../src/DynamicNotebook.vala"
		g_value_set_object (value, tab_get_page (self));
#line 46 "../src/DynamicNotebook.vala"
		break;
#line 46 "../src/DynamicNotebook.vala"
		case TAB_ICON_PROPERTY:
#line 46 "../src/DynamicNotebook.vala"
		g_value_take_object (value, tab_get_icon (self));
#line 46 "../src/DynamicNotebook.vala"
		break;
#line 46 "../src/DynamicNotebook.vala"
		case TAB_WORKING_PROPERTY:
#line 46 "../src/DynamicNotebook.vala"
		g_value_set_boolean (value, tab_get_working (self));
#line 46 "../src/DynamicNotebook.vala"
		break;
#line 46 "../src/DynamicNotebook.vala"
		case TAB_ELLIPSIZE_MODE_PROPERTY:
#line 46 "../src/DynamicNotebook.vala"
		g_value_set_enum (value, tab_get_ellipsize_mode (self));
#line 46 "../src/DynamicNotebook.vala"
		break;
#line 46 "../src/DynamicNotebook.vala"
		case TAB_FIXED_PROPERTY:
G_GNUC_BEGIN_IGNORE_DEPRECATIONS
#line 2922 "DynamicNotebook.c"
		g_value_set_boolean (value, tab_get_fixed (self));
G_GNUC_END_IGNORE_DEPRECATIONS
#line 46 "../src/DynamicNotebook.vala"
		break;
#line 46 "../src/DynamicNotebook.vala"
		case TAB_MENU_PROPERTY:
#line 46 "../src/DynamicNotebook.vala"
		g_value_set_object (value, tab_get_menu (self));
#line 46 "../src/DynamicNotebook.vala"
		break;
#line 2933 "DynamicNotebook.c"
		default:
#line 46 "../src/DynamicNotebook.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 46 "../src/DynamicNotebook.vala"
		break;
#line 2939 "DynamicNotebook.c"
	}
}

static void
_vala_tab_set_property (GObject * object,
                        guint property_id,
                        const GValue * value,
                        GParamSpec * pspec)
{
	Tab * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_TAB, Tab);
#line 46 "../src/DynamicNotebook.vala"
	switch (property_id) {
#line 46 "../src/DynamicNotebook.vala"
		case TAB_LABEL_PROPERTY:
#line 46 "../src/DynamicNotebook.vala"
		tab_set_label (self, g_value_get_string (value));
#line 46 "../src/DynamicNotebook.vala"
		break;
#line 46 "../src/DynamicNotebook.vala"
		case TAB_TOOLTIP_PROPERTY:
#line 46 "../src/DynamicNotebook.vala"
		tab_set_tooltip (self, g_value_get_string (value));
#line 46 "../src/DynamicNotebook.vala"
		break;
#line 46 "../src/DynamicNotebook.vala"
		case TAB_PINNED_PROPERTY:
#line 46 "../src/DynamicNotebook.vala"
		tab_set_pinned (self, g_value_get_boolean (value));
#line 46 "../src/DynamicNotebook.vala"
		break;
#line 46 "../src/DynamicNotebook.vala"
		case TAB_PINNABLE_PROPERTY:
#line 46 "../src/DynamicNotebook.vala"
		tab_set_pinnable (self, g_value_get_boolean (value));
#line 46 "../src/DynamicNotebook.vala"
		break;
#line 46 "../src/DynamicNotebook.vala"
		case TAB_RESTORE_DATA_PROPERTY:
#line 46 "../src/DynamicNotebook.vala"
		tab_set_restore_data (self, g_value_get_string (value));
#line 46 "../src/DynamicNotebook.vala"
		break;
#line 46 "../src/DynamicNotebook.vala"
		case TAB_PAGE_PROPERTY:
#line 46 "../src/DynamicNotebook.vala"
		tab_set_page (self, g_value_get_object (value));
#line 46 "../src/DynamicNotebook.vala"
		break;
#line 46 "../src/DynamicNotebook.vala"
		case TAB_ICON_PROPERTY:
#line 46 "../src/DynamicNotebook.vala"
		tab_set_icon (self, g_value_get_object (value));
#line 46 "../src/DynamicNotebook.vala"
		break;
#line 46 "../src/DynamicNotebook.vala"
		case TAB_WORKING_PROPERTY:
#line 46 "../src/DynamicNotebook.vala"
		tab_set_working (self, g_value_get_boolean (value));
#line 46 "../src/DynamicNotebook.vala"
		break;
#line 46 "../src/DynamicNotebook.vala"
		case TAB_ELLIPSIZE_MODE_PROPERTY:
#line 46 "../src/DynamicNotebook.vala"
		tab_set_ellipsize_mode (self, g_value_get_enum (value));
#line 46 "../src/DynamicNotebook.vala"
		break;
#line 46 "../src/DynamicNotebook.vala"
		case TAB_FIXED_PROPERTY:
G_GNUC_BEGIN_IGNORE_DEPRECATIONS
#line 3010 "DynamicNotebook.c"
		tab_set_fixed (self, g_value_get_boolean (value));
G_GNUC_END_IGNORE_DEPRECATIONS
#line 46 "../src/DynamicNotebook.vala"
		break;
#line 46 "../src/DynamicNotebook.vala"
		case TAB_MENU_PROPERTY:
#line 46 "../src/DynamicNotebook.vala"
		tab_set_menu (self, g_value_get_object (value));
#line 46 "../src/DynamicNotebook.vala"
		break;
#line 46 "../src/DynamicNotebook.vala"
		case TAB_CLOSABLE_PROPERTY:
#line 46 "../src/DynamicNotebook.vala"
		tab_set_closable (self, g_value_get_boolean (value));
#line 46 "../src/DynamicNotebook.vala"
		break;
#line 46 "../src/DynamicNotebook.vala"
		case TAB_IS_CURRENT_TAB_PROPERTY:
#line 46 "../src/DynamicNotebook.vala"
		tab_set_is_current_tab (self, g_value_get_boolean (value));
#line 46 "../src/DynamicNotebook.vala"
		break;
#line 3033 "DynamicNotebook.c"
		default:
#line 46 "../src/DynamicNotebook.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 46 "../src/DynamicNotebook.vala"
		break;
#line 3039 "DynamicNotebook.c"
	}
}

static inline gpointer
closed_tabs_get_instance_private (ClosedTabs* self)
{
	return G_STRUCT_MEMBER_P (self, ClosedTabs_private_offset);
}

ClosedTabs*
closed_tabs_construct (GType object_type)
{
	ClosedTabs * self = NULL;
#line 416 "../src/DynamicNotebook.vala"
	self = (ClosedTabs*) g_object_new (object_type, NULL);
#line 416 "../src/DynamicNotebook.vala"
	return self;
#line 3057 "DynamicNotebook.c"
}

ClosedTabs*
closed_tabs_new (void)
{
#line 416 "../src/DynamicNotebook.vala"
	return closed_tabs_construct (TYPE_CLOSED_TABS);
#line 3065 "DynamicNotebook.c"
}

void
closed_tabs_push (ClosedTabs* self,
                  Tab* tab)
{
	ClosedTabsEntry e = {0};
	const gchar* _tmp12_;
	const gchar* _tmp13_;
	gchar* _tmp14_;
	const gchar* _tmp15_;
	const gchar* _tmp16_;
	gchar* _tmp17_;
	GIcon* _tmp18_;
	GIcon* _tmp19_;
	GraniteWidgetsDroppedDelegate _tmp20_;
	gpointer _tmp20__target;
	ClosedTabsEntry _tmp21_ = {0};
	GeeLinkedList* _tmp22_;
	ClosedTabsEntry _tmp23_;
	GeeLinkedList* _tmp24_;
	gint _tmp25_;
	gint _tmp26_;
	gint _tmp27_;
	gint _tmp28_;
#line 430 "../src/DynamicNotebook.vala"
	g_return_if_fail (self != NULL);
#line 430 "../src/DynamicNotebook.vala"
	g_return_if_fail (tab != NULL);
#line 3095 "DynamicNotebook.c"
	{
		GeeLinkedList* _entry_list = NULL;
		GeeLinkedList* _tmp0_;
		gint _entry_size = 0;
		GeeLinkedList* _tmp1_;
		gint _tmp2_;
		gint _tmp3_;
		gint _entry_index = 0;
#line 431 "../src/DynamicNotebook.vala"
		_tmp0_ = self->priv->closed_tabs;
#line 431 "../src/DynamicNotebook.vala"
		_entry_list = _tmp0_;
#line 431 "../src/DynamicNotebook.vala"
		_tmp1_ = _entry_list;
#line 431 "../src/DynamicNotebook.vala"
		_tmp2_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp1_);
#line 431 "../src/DynamicNotebook.vala"
		_tmp3_ = _tmp2_;
#line 431 "../src/DynamicNotebook.vala"
		_entry_size = _tmp3_;
#line 431 "../src/DynamicNotebook.vala"
		_entry_index = -1;
#line 431 "../src/DynamicNotebook.vala"
		while (TRUE) {
#line 3120 "DynamicNotebook.c"
			gint _tmp4_;
			gint _tmp5_;
			ClosedTabsEntry* entry = NULL;
			GeeLinkedList* _tmp6_;
			gpointer _tmp7_;
			const gchar* _tmp8_;
			const gchar* _tmp9_;
			ClosedTabsEntry* _tmp10_;
			const gchar* _tmp11_;
#line 431 "../src/DynamicNotebook.vala"
			_entry_index = _entry_index + 1;
#line 431 "../src/DynamicNotebook.vala"
			_tmp4_ = _entry_index;
#line 431 "../src/DynamicNotebook.vala"
			_tmp5_ = _entry_size;
#line 431 "../src/DynamicNotebook.vala"
			if (!(_tmp4_ < _tmp5_)) {
#line 431 "../src/DynamicNotebook.vala"
				break;
#line 3140 "DynamicNotebook.c"
			}
#line 431 "../src/DynamicNotebook.vala"
			_tmp6_ = _entry_list;
#line 431 "../src/DynamicNotebook.vala"
			_tmp7_ = gee_abstract_list_get ((GeeAbstractList*) _tmp6_, _entry_index);
#line 431 "../src/DynamicNotebook.vala"
			entry = (ClosedTabsEntry*) _tmp7_;
#line 432 "../src/DynamicNotebook.vala"
			_tmp8_ = tab_get_restore_data (tab);
#line 432 "../src/DynamicNotebook.vala"
			_tmp9_ = _tmp8_;
#line 432 "../src/DynamicNotebook.vala"
			_tmp10_ = entry;
#line 432 "../src/DynamicNotebook.vala"
			_tmp11_ = (*_tmp10_).restore_data;
#line 432 "../src/DynamicNotebook.vala"
			if (g_strcmp0 (_tmp9_, _tmp11_) == 0) {
#line 433 "../src/DynamicNotebook.vala"
				_closed_tabs_entry_free0 (entry);
#line 433 "../src/DynamicNotebook.vala"
				return;
#line 3162 "DynamicNotebook.c"
			}
#line 431 "../src/DynamicNotebook.vala"
			_closed_tabs_entry_free0 (entry);
#line 3166 "DynamicNotebook.c"
		}
	}
#line 436 "../src/DynamicNotebook.vala"
	_tmp12_ = tab_get_label (tab);
#line 436 "../src/DynamicNotebook.vala"
	_tmp13_ = _tmp12_;
#line 436 "../src/DynamicNotebook.vala"
	_tmp14_ = g_strdup (_tmp13_);
#line 436 "../src/DynamicNotebook.vala"
	_tmp15_ = tab_get_restore_data (tab);
#line 436 "../src/DynamicNotebook.vala"
	_tmp16_ = _tmp15_;
#line 436 "../src/DynamicNotebook.vala"
	_tmp17_ = g_strdup (_tmp16_);
#line 436 "../src/DynamicNotebook.vala"
	_tmp18_ = tab_get_icon (tab);
#line 436 "../src/DynamicNotebook.vala"
	_tmp19_ = _tmp18_;
#line 436 "../src/DynamicNotebook.vala"
	_tmp20_ = tab->dropped_callback;
#line 436 "../src/DynamicNotebook.vala"
	_tmp20__target = tab->dropped_callback_target;
#line 436 "../src/DynamicNotebook.vala"
	_g_free0 (_tmp21_.label);
#line 436 "../src/DynamicNotebook.vala"
	_tmp21_.label = _tmp14_;
#line 436 "../src/DynamicNotebook.vala"
	_g_free0 (_tmp21_.restore_data);
#line 436 "../src/DynamicNotebook.vala"
	_tmp21_.restore_data = _tmp17_;
#line 436 "../src/DynamicNotebook.vala"
	_g_object_unref0 (_tmp21_.icon);
#line 436 "../src/DynamicNotebook.vala"
	_tmp21_.icon = _tmp19_;
#line 436 "../src/DynamicNotebook.vala"
	_tmp21_.dropped_callback = _tmp20_;
#line 436 "../src/DynamicNotebook.vala"
	_tmp21_.dropped_callback_target = _tmp20__target;
#line 436 "../src/DynamicNotebook.vala"
	e = _tmp21_;
#line 437 "../src/DynamicNotebook.vala"
	_tmp22_ = self->priv->closed_tabs;
#line 437 "../src/DynamicNotebook.vala"
	_tmp23_ = e;
#line 437 "../src/DynamicNotebook.vala"
	gee_abstract_collection_add ((GeeAbstractCollection*) _tmp22_, &_tmp23_);
#line 440 "../src/DynamicNotebook.vala"
	_tmp24_ = self->priv->closed_tabs;
#line 440 "../src/DynamicNotebook.vala"
	_tmp25_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp24_);
#line 440 "../src/DynamicNotebook.vala"
	_tmp26_ = _tmp25_;
#line 440 "../src/DynamicNotebook.vala"
	_tmp27_ = closed_tabs_get_max_restorable_tabs (self);
#line 440 "../src/DynamicNotebook.vala"
	_tmp28_ = _tmp27_;
#line 440 "../src/DynamicNotebook.vala"
	if (_tmp26_ > _tmp28_) {
#line 3225 "DynamicNotebook.c"
		ClosedTabsEntry* elem = NULL;
		GeeLinkedList* _tmp29_;
		gpointer _tmp30_;
		GraniteWidgetsDroppedDelegate dropped_callback = NULL;
		ClosedTabsEntry* _tmp31_;
		GraniteWidgetsDroppedDelegate _tmp32_;
		gpointer _tmp32__target;
		gpointer dropped_callback_target;
		GraniteWidgetsDroppedDelegate _tmp33_;
		gpointer _tmp33__target;
#line 441 "../src/DynamicNotebook.vala"
		_tmp29_ = self->priv->closed_tabs;
#line 441 "../src/DynamicNotebook.vala"
		_tmp30_ = gee_deque_poll_head ((GeeDeque*) _tmp29_);
#line 441 "../src/DynamicNotebook.vala"
		elem = (ClosedTabsEntry*) _tmp30_;
#line 442 "../src/DynamicNotebook.vala"
		_tmp31_ = elem;
#line 442 "../src/DynamicNotebook.vala"
		_tmp32_ = (*_tmp31_).dropped_callback;
#line 442 "../src/DynamicNotebook.vala"
		_tmp32__target = (*_tmp31_).dropped_callback_target;
#line 442 "../src/DynamicNotebook.vala"
		dropped_callback = _tmp32_;
#line 442 "../src/DynamicNotebook.vala"
		dropped_callback_target = _tmp32__target;
#line 444 "../src/DynamicNotebook.vala"
		_tmp33_ = dropped_callback;
#line 444 "../src/DynamicNotebook.vala"
		_tmp33__target = dropped_callback_target;
#line 444 "../src/DynamicNotebook.vala"
		if (_tmp33_ != NULL) {
#line 3258 "DynamicNotebook.c"
			GraniteWidgetsDroppedDelegate _tmp34_;
			gpointer _tmp34__target;
#line 445 "../src/DynamicNotebook.vala"
			_tmp34_ = dropped_callback;
#line 445 "../src/DynamicNotebook.vala"
			_tmp34__target = dropped_callback_target;
#line 445 "../src/DynamicNotebook.vala"
			_tmp34_ (_tmp34__target);
#line 3267 "DynamicNotebook.c"
		}
#line 440 "../src/DynamicNotebook.vala"
		_closed_tabs_entry_free0 (elem);
#line 3271 "DynamicNotebook.c"
	}
#line 430 "../src/DynamicNotebook.vala"
	closed_tabs_entry_destroy (&e);
#line 3275 "DynamicNotebook.c"
}

void
closed_tabs_pop (ClosedTabs* self,
                 ClosedTabsEntry* result)
{
	GeeLinkedList* _tmp0_;
	gint _tmp1_;
	gint _tmp2_;
	GeeLinkedList* _tmp3_;
	gpointer _tmp4_;
	ClosedTabsEntry* _tmp5_;
	ClosedTabsEntry _tmp6_;
	ClosedTabsEntry _tmp7_ = {0};
	ClosedTabsEntry _tmp8_;
#line 449 "../src/DynamicNotebook.vala"
	g_return_if_fail (self != NULL);
#line 450 "../src/DynamicNotebook.vala"
	_tmp0_ = self->priv->closed_tabs;
#line 450 "../src/DynamicNotebook.vala"
	_tmp1_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp0_);
#line 450 "../src/DynamicNotebook.vala"
	_tmp2_ = _tmp1_;
#line 450 "../src/DynamicNotebook.vala"
	_vala_assert (_tmp2_ > 0, "closed_tabs.size > 0");
#line 451 "../src/DynamicNotebook.vala"
	_tmp3_ = self->priv->closed_tabs;
#line 451 "../src/DynamicNotebook.vala"
	_tmp4_ = gee_deque_poll_tail ((GeeDeque*) _tmp3_);
#line 451 "../src/DynamicNotebook.vala"
	_tmp5_ = (ClosedTabsEntry*) _tmp4_;
#line 451 "../src/DynamicNotebook.vala"
	_tmp6_ = *_tmp5_;
#line 451 "../src/DynamicNotebook.vala"
	closed_tabs_entry_copy (&_tmp6_, &_tmp7_);
#line 451 "../src/DynamicNotebook.vala"
	_tmp8_ = _tmp7_;
#line 451 "../src/DynamicNotebook.vala"
	_closed_tabs_entry_free0 (_tmp5_);
#line 451 "../src/DynamicNotebook.vala"
	*result = _tmp8_;
#line 451 "../src/DynamicNotebook.vala"
	return;
#line 3319 "DynamicNotebook.c"
}

void
closed_tabs_pick (ClosedTabs* self,
                  const gchar* search,
                  ClosedTabsEntry* result)
{
	ClosedTabsEntry picked = {0};
	ClosedTabsEntry _tmp0_ = {0};
#line 454 "../src/DynamicNotebook.vala"
	g_return_if_fail (self != NULL);
#line 454 "../src/DynamicNotebook.vala"
	g_return_if_fail (search != NULL);
#line 455 "../src/DynamicNotebook.vala"
	_g_free0 (_tmp0_.label);
#line 455 "../src/DynamicNotebook.vala"
	_tmp0_.label = NULL;
#line 455 "../src/DynamicNotebook.vala"
	_g_free0 (_tmp0_.restore_data);
#line 455 "../src/DynamicNotebook.vala"
	_tmp0_.restore_data = NULL;
#line 455 "../src/DynamicNotebook.vala"
	_g_object_unref0 (_tmp0_.icon);
#line 455 "../src/DynamicNotebook.vala"
	_tmp0_.icon = NULL;
#line 455 "../src/DynamicNotebook.vala"
	picked = _tmp0_;
#line 3347 "DynamicNotebook.c"
	{
		gint i = 0;
#line 457 "../src/DynamicNotebook.vala"
		i = 0;
#line 3352 "DynamicNotebook.c"
		{
			gboolean _tmp1_ = FALSE;
#line 457 "../src/DynamicNotebook.vala"
			_tmp1_ = TRUE;
#line 457 "../src/DynamicNotebook.vala"
			while (TRUE) {
#line 3359 "DynamicNotebook.c"
				GeeLinkedList* _tmp3_;
				gint _tmp4_;
				gint _tmp5_;
				ClosedTabsEntry* entry = NULL;
				GeeLinkedList* _tmp6_;
				gpointer _tmp7_;
				ClosedTabsEntry* _tmp8_;
				const gchar* _tmp9_;
#line 457 "../src/DynamicNotebook.vala"
				if (!_tmp1_) {
#line 3370 "DynamicNotebook.c"
					gint _tmp2_;
#line 457 "../src/DynamicNotebook.vala"
					_tmp2_ = i;
#line 457 "../src/DynamicNotebook.vala"
					i = _tmp2_ + 1;
#line 3376 "DynamicNotebook.c"
				}
#line 457 "../src/DynamicNotebook.vala"
				_tmp1_ = FALSE;
#line 457 "../src/DynamicNotebook.vala"
				_tmp3_ = self->priv->closed_tabs;
#line 457 "../src/DynamicNotebook.vala"
				_tmp4_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp3_);
#line 457 "../src/DynamicNotebook.vala"
				_tmp5_ = _tmp4_;
#line 457 "../src/DynamicNotebook.vala"
				if (!(i < _tmp5_)) {
#line 457 "../src/DynamicNotebook.vala"
					break;
#line 3390 "DynamicNotebook.c"
				}
#line 458 "../src/DynamicNotebook.vala"
				_tmp6_ = self->priv->closed_tabs;
#line 458 "../src/DynamicNotebook.vala"
				_tmp7_ = gee_abstract_list_get ((GeeAbstractList*) _tmp6_, i);
#line 458 "../src/DynamicNotebook.vala"
				entry = (ClosedTabsEntry*) _tmp7_;
#line 460 "../src/DynamicNotebook.vala"
				_tmp8_ = entry;
#line 460 "../src/DynamicNotebook.vala"
				_tmp9_ = (*_tmp8_).restore_data;
#line 460 "../src/DynamicNotebook.vala"
				if (g_strcmp0 (_tmp9_, search) == 0) {
#line 3404 "DynamicNotebook.c"
					GeeLinkedList* _tmp10_;
					gpointer _tmp11_;
					ClosedTabsEntry* _tmp12_;
					ClosedTabsEntry _tmp13_;
					ClosedTabsEntry _tmp14_ = {0};
#line 461 "../src/DynamicNotebook.vala"
					_tmp10_ = self->priv->closed_tabs;
#line 461 "../src/DynamicNotebook.vala"
					_tmp11_ = gee_abstract_list_remove_at ((GeeAbstractList*) _tmp10_, i);
#line 461 "../src/DynamicNotebook.vala"
					_tmp12_ = (ClosedTabsEntry*) _tmp11_;
#line 461 "../src/DynamicNotebook.vala"
					_tmp13_ = *_tmp12_;
#line 461 "../src/DynamicNotebook.vala"
					closed_tabs_entry_copy (&_tmp13_, &_tmp14_);
#line 461 "../src/DynamicNotebook.vala"
					closed_tabs_entry_destroy (&picked);
#line 461 "../src/DynamicNotebook.vala"
					picked = _tmp14_;
#line 461 "../src/DynamicNotebook.vala"
					_closed_tabs_entry_free0 (_tmp12_);
#line 462 "../src/DynamicNotebook.vala"
					_closed_tabs_entry_free0 (entry);
#line 462 "../src/DynamicNotebook.vala"
					break;
#line 3430 "DynamicNotebook.c"
				}
#line 457 "../src/DynamicNotebook.vala"
				_closed_tabs_entry_free0 (entry);
#line 3434 "DynamicNotebook.c"
			}
		}
	}
#line 466 "../src/DynamicNotebook.vala"
	*result = picked;
#line 466 "../src/DynamicNotebook.vala"
	return;
#line 3442 "DynamicNotebook.c"
}

gint
closed_tabs_get_max_restorable_tabs (ClosedTabs* self)
{
	gint result;
#line 400 "../src/DynamicNotebook.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 400 "../src/DynamicNotebook.vala"
	result = self->priv->_max_restorable_tabs;
#line 400 "../src/DynamicNotebook.vala"
	return result;
#line 3455 "DynamicNotebook.c"
}

void
closed_tabs_set_max_restorable_tabs (ClosedTabs* self,
                                     gint value)
{
#line 401 "../src/DynamicNotebook.vala"
	g_return_if_fail (self != NULL);
#line 402 "../src/DynamicNotebook.vala"
	_vala_assert (value > 0, "value > 0");
#line 403 "../src/DynamicNotebook.vala"
	self->priv->_max_restorable_tabs = value;
#line 401 "../src/DynamicNotebook.vala"
	g_object_notify_by_pspec ((GObject *) self, closed_tabs_properties[CLOSED_TABS_MAX_RESTORABLE_TABS_PROPERTY]);
#line 3470 "DynamicNotebook.c"
}

gboolean
closed_tabs_get_empty (ClosedTabs* self)
{
	gboolean result;
	GeeLinkedList* _tmp0_;
	gint _tmp1_;
	gint _tmp2_;
#line 425 "../src/DynamicNotebook.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 426 "../src/DynamicNotebook.vala"
	_tmp0_ = self->priv->closed_tabs;
#line 426 "../src/DynamicNotebook.vala"
	_tmp1_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp0_);
#line 426 "../src/DynamicNotebook.vala"
	_tmp2_ = _tmp1_;
#line 426 "../src/DynamicNotebook.vala"
	result = _tmp2_ == 0;
#line 426 "../src/DynamicNotebook.vala"
	return result;
#line 3492 "DynamicNotebook.c"
}

static Block15Data*
block15_data_ref (Block15Data* _data15_)
{
#line 473 "../src/DynamicNotebook.vala"
	g_atomic_int_inc (&_data15_->_ref_count_);
#line 473 "../src/DynamicNotebook.vala"
	return _data15_;
#line 3502 "DynamicNotebook.c"
}

static void
block15_data_unref (void * _userdata_)
{
	Block15Data* _data15_;
	_data15_ = (Block15Data*) _userdata_;
#line 473 "../src/DynamicNotebook.vala"
	if (g_atomic_int_dec_and_test (&_data15_->_ref_count_)) {
#line 3512 "DynamicNotebook.c"
		ClosedTabs* self;
#line 473 "../src/DynamicNotebook.vala"
		self = _data15_->self;
#line 473 "../src/DynamicNotebook.vala"
		_closed_tabs_entry_free0 (_data15_->entry);
#line 473 "../src/DynamicNotebook.vala"
		_g_object_unref0 (self);
#line 473 "../src/DynamicNotebook.vala"
		g_slice_free (Block15Data, _data15_);
#line 3522 "DynamicNotebook.c"
	}
}

static void
_closed_tabs_menu_____lambda17_ (Block15Data* _data15_)
{
	ClosedTabs* self;
	ClosedTabsEntry e = {0};
	ClosedTabsEntry* _tmp0_;
	const gchar* _tmp1_;
	ClosedTabsEntry _tmp2_ = {0};
	ClosedTabsEntry _tmp3_;
	const gchar* _tmp4_;
	ClosedTabsEntry _tmp5_;
	const gchar* _tmp6_;
	ClosedTabsEntry _tmp7_;
	GIcon* _tmp8_;
#line 477 "../src/DynamicNotebook.vala"
	self = _data15_->self;
#line 478 "../src/DynamicNotebook.vala"
	_tmp0_ = _data15_->entry;
#line 478 "../src/DynamicNotebook.vala"
	_tmp1_ = (*_tmp0_).restore_data;
#line 478 "../src/DynamicNotebook.vala"
	closed_tabs_pick (self, _tmp1_, &_tmp2_);
#line 478 "../src/DynamicNotebook.vala"
	e = _tmp2_;
#line 479 "../src/DynamicNotebook.vala"
	_tmp3_ = e;
#line 479 "../src/DynamicNotebook.vala"
	_tmp4_ = _tmp3_.label;
#line 479 "../src/DynamicNotebook.vala"
	_tmp5_ = e;
#line 479 "../src/DynamicNotebook.vala"
	_tmp6_ = _tmp5_.restore_data;
#line 479 "../src/DynamicNotebook.vala"
	_tmp7_ = e;
#line 479 "../src/DynamicNotebook.vala"
	_tmp8_ = _tmp7_.icon;
#line 479 "../src/DynamicNotebook.vala"
	g_signal_emit (self, closed_tabs_signals[CLOSED_TABS_RESTORED_SIGNAL], 0, _tmp4_, _tmp6_, _tmp8_);
#line 477 "../src/DynamicNotebook.vala"
	closed_tabs_entry_destroy (&e);
#line 3566 "DynamicNotebook.c"
}

static void
__closed_tabs_menu_____lambda17__gtk_menu_item_activate (GtkMenuItem* _sender,
                                                         gpointer self)
{
#line 477 "../src/DynamicNotebook.vala"
	_closed_tabs_menu_____lambda17_ (self);
#line 3575 "DynamicNotebook.c"
}

static void
_closed_tabs_menu____lambda18_ (ClosedTabs* self)
{
	GeeLinkedList* _tmp12_;
	{
		GeeLinkedList* _entry_list = NULL;
		GeeLinkedList* _tmp0_;
		gint _entry_size = 0;
		GeeLinkedList* _tmp1_;
		gint _tmp2_;
		gint _tmp3_;
		gint _entry_index = 0;
#line 491 "../src/DynamicNotebook.vala"
		_tmp0_ = self->priv->closed_tabs;
#line 491 "../src/DynamicNotebook.vala"
		_entry_list = _tmp0_;
#line 491 "../src/DynamicNotebook.vala"
		_tmp1_ = _entry_list;
#line 491 "../src/DynamicNotebook.vala"
		_tmp2_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp1_);
#line 491 "../src/DynamicNotebook.vala"
		_tmp3_ = _tmp2_;
#line 491 "../src/DynamicNotebook.vala"
		_entry_size = _tmp3_;
#line 491 "../src/DynamicNotebook.vala"
		_entry_index = -1;
#line 491 "../src/DynamicNotebook.vala"
		while (TRUE) {
#line 3606 "DynamicNotebook.c"
			gint _tmp4_;
			gint _tmp5_;
			ClosedTabsEntry* entry = NULL;
			GeeLinkedList* _tmp6_;
			gpointer _tmp7_;
			ClosedTabsEntry* _tmp8_;
			GraniteWidgetsDroppedDelegate _tmp9_;
			gpointer _tmp9__target;
#line 491 "../src/DynamicNotebook.vala"
			_entry_index = _entry_index + 1;
#line 491 "../src/DynamicNotebook.vala"
			_tmp4_ = _entry_index;
#line 491 "../src/DynamicNotebook.vala"
			_tmp5_ = _entry_size;
#line 491 "../src/DynamicNotebook.vala"
			if (!(_tmp4_ < _tmp5_)) {
#line 491 "../src/DynamicNotebook.vala"
				break;
#line 3625 "DynamicNotebook.c"
			}
#line 491 "../src/DynamicNotebook.vala"
			_tmp6_ = _entry_list;
#line 491 "../src/DynamicNotebook.vala"
			_tmp7_ = gee_abstract_list_get ((GeeAbstractList*) _tmp6_, _entry_index);
#line 491 "../src/DynamicNotebook.vala"
			entry = (ClosedTabsEntry*) _tmp7_;
#line 492 "../src/DynamicNotebook.vala"
			_tmp8_ = entry;
#line 492 "../src/DynamicNotebook.vala"
			_tmp9_ = (*_tmp8_).dropped_callback;
#line 492 "../src/DynamicNotebook.vala"
			_tmp9__target = (*_tmp8_).dropped_callback_target;
#line 492 "../src/DynamicNotebook.vala"
			if (_tmp9_ != NULL) {
#line 3641 "DynamicNotebook.c"
				ClosedTabsEntry* _tmp10_;
				GraniteWidgetsDroppedDelegate _tmp11_;
				gpointer _tmp11__target;
#line 493 "../src/DynamicNotebook.vala"
				_tmp10_ = entry;
#line 493 "../src/DynamicNotebook.vala"
				_tmp11_ = (*_tmp10_).dropped_callback;
#line 493 "../src/DynamicNotebook.vala"
				_tmp11__target = (*_tmp10_).dropped_callback_target;
#line 493 "../src/DynamicNotebook.vala"
				_tmp11_ (_tmp11__target);
#line 3653 "DynamicNotebook.c"
			}
#line 491 "../src/DynamicNotebook.vala"
			_closed_tabs_entry_free0 (entry);
#line 3657 "DynamicNotebook.c"
		}
	}
#line 497 "../src/DynamicNotebook.vala"
	_tmp12_ = self->priv->closed_tabs;
#line 497 "../src/DynamicNotebook.vala"
	gee_abstract_collection_clear ((GeeAbstractCollection*) _tmp12_);
#line 498 "../src/DynamicNotebook.vala"
	g_signal_emit (self, closed_tabs_signals[CLOSED_TABS_CLEARED_SIGNAL], 0);
#line 3666 "DynamicNotebook.c"
}

static void
__closed_tabs_menu____lambda18__gtk_menu_item_activate (GtkMenuItem* _sender,
                                                        gpointer self)
{
#line 490 "../src/DynamicNotebook.vala"
	_closed_tabs_menu____lambda18_ ((ClosedTabs*) self);
#line 3675 "DynamicNotebook.c"
}

GtkMenu*
closed_tabs_get_menu (ClosedTabs* self)
{
	GtkMenu* result;
	GtkMenu* _menu = NULL;
	GtkMenu* _tmp0_;
	gboolean _tmp15_;
	gboolean _tmp16_;
#line 470 "../src/DynamicNotebook.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 471 "../src/DynamicNotebook.vala"
	_tmp0_ = (GtkMenu*) gtk_menu_new ();
#line 471 "../src/DynamicNotebook.vala"
	g_object_ref_sink (_tmp0_);
#line 471 "../src/DynamicNotebook.vala"
	_menu = _tmp0_;
#line 3694 "DynamicNotebook.c"
	{
		GeeLinkedList* _entry_list = NULL;
		GeeLinkedList* _tmp1_;
		gint _entry_size = 0;
		GeeLinkedList* _tmp2_;
		gint _tmp3_;
		gint _tmp4_;
		gint _entry_index = 0;
#line 473 "../src/DynamicNotebook.vala"
		_tmp1_ = self->priv->closed_tabs;
#line 473 "../src/DynamicNotebook.vala"
		_entry_list = _tmp1_;
#line 473 "../src/DynamicNotebook.vala"
		_tmp2_ = _entry_list;
#line 473 "../src/DynamicNotebook.vala"
		_tmp3_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp2_);
#line 473 "../src/DynamicNotebook.vala"
		_tmp4_ = _tmp3_;
#line 473 "../src/DynamicNotebook.vala"
		_entry_size = _tmp4_;
#line 473 "../src/DynamicNotebook.vala"
		_entry_index = -1;
#line 473 "../src/DynamicNotebook.vala"
		while (TRUE) {
#line 3719 "DynamicNotebook.c"
			Block15Data* _data15_;
			gint _tmp5_;
			gint _tmp6_;
			GeeLinkedList* _tmp7_;
			gpointer _tmp8_;
			GtkMenuItem* item = NULL;
			ClosedTabsEntry* _tmp9_;
			const gchar* _tmp10_;
			GtkMenuItem* _tmp11_;
			GtkMenu* _tmp12_;
			GtkMenuItem* _tmp13_;
			GtkMenuItem* _tmp14_;
#line 473 "../src/DynamicNotebook.vala"
			_data15_ = g_slice_new0 (Block15Data);
#line 473 "../src/DynamicNotebook.vala"
			_data15_->_ref_count_ = 1;
#line 473 "../src/DynamicNotebook.vala"
			_data15_->self = g_object_ref (self);
#line 473 "../src/DynamicNotebook.vala"
			_entry_index = _entry_index + 1;
#line 473 "../src/DynamicNotebook.vala"
			_tmp5_ = _entry_index;
#line 473 "../src/DynamicNotebook.vala"
			_tmp6_ = _entry_size;
#line 473 "../src/DynamicNotebook.vala"
			if (!(_tmp5_ < _tmp6_)) {
#line 473 "../src/DynamicNotebook.vala"
				block15_data_unref (_data15_);
#line 473 "../src/DynamicNotebook.vala"
				_data15_ = NULL;
#line 473 "../src/DynamicNotebook.vala"
				break;
#line 3752 "DynamicNotebook.c"
			}
#line 473 "../src/DynamicNotebook.vala"
			_tmp7_ = _entry_list;
#line 473 "../src/DynamicNotebook.vala"
			_tmp8_ = gee_abstract_list_get ((GeeAbstractList*) _tmp7_, _entry_index);
#line 473 "../src/DynamicNotebook.vala"
			_data15_->entry = (ClosedTabsEntry*) _tmp8_;
#line 474 "../src/DynamicNotebook.vala"
			_tmp9_ = _data15_->entry;
#line 474 "../src/DynamicNotebook.vala"
			_tmp10_ = (*_tmp9_).label;
#line 474 "../src/DynamicNotebook.vala"
			_tmp11_ = (GtkMenuItem*) gtk_menu_item_new_with_label (_tmp10_);
#line 474 "../src/DynamicNotebook.vala"
			g_object_ref_sink (_tmp11_);
#line 474 "../src/DynamicNotebook.vala"
			item = _tmp11_;
#line 475 "../src/DynamicNotebook.vala"
			_tmp12_ = _menu;
#line 475 "../src/DynamicNotebook.vala"
			_tmp13_ = item;
#line 475 "../src/DynamicNotebook.vala"
			gtk_menu_shell_prepend ((GtkMenuShell*) _tmp12_, (GtkWidget*) _tmp13_);
#line 477 "../src/DynamicNotebook.vala"
			_tmp14_ = item;
#line 477 "../src/DynamicNotebook.vala"
			g_signal_connect_data (_tmp14_, "activate", (GCallback) __closed_tabs_menu_____lambda17__gtk_menu_item_activate, block15_data_ref (_data15_), (GClosureNotify) block15_data_unref, 0);
#line 473 "../src/DynamicNotebook.vala"
			_g_object_unref0 (item);
#line 473 "../src/DynamicNotebook.vala"
			block15_data_unref (_data15_);
#line 473 "../src/DynamicNotebook.vala"
			_data15_ = NULL;
#line 3786 "DynamicNotebook.c"
		}
	}
#line 483 "../src/DynamicNotebook.vala"
	_tmp15_ = closed_tabs_get_empty (self);
#line 483 "../src/DynamicNotebook.vala"
	_tmp16_ = _tmp15_;
#line 483 "../src/DynamicNotebook.vala"
	if (!_tmp16_) {
#line 3795 "DynamicNotebook.c"
		GtkSeparatorMenuItem* separator = NULL;
		GtkSeparatorMenuItem* _tmp17_;
		GtkMenuItem* item = NULL;
		GtkMenuItem* _tmp18_;
		GtkMenu* _tmp19_;
		GtkSeparatorMenuItem* _tmp20_;
		GtkMenu* _tmp21_;
		GtkMenuItem* _tmp22_;
		GtkMenuItem* _tmp23_;
#line 484 "../src/DynamicNotebook.vala"
		_tmp17_ = (GtkSeparatorMenuItem*) gtk_separator_menu_item_new ();
#line 484 "../src/DynamicNotebook.vala"
		g_object_ref_sink (_tmp17_);
#line 484 "../src/DynamicNotebook.vala"
		separator = _tmp17_;
#line 485 "../src/DynamicNotebook.vala"
		_tmp18_ = (GtkMenuItem*) gtk_menu_item_new_with_label (_ ("Clear All"));
#line 485 "../src/DynamicNotebook.vala"
		g_object_ref_sink (_tmp18_);
#line 485 "../src/DynamicNotebook.vala"
		item = _tmp18_;
#line 487 "../src/DynamicNotebook.vala"
		_tmp19_ = _menu;
#line 487 "../src/DynamicNotebook.vala"
		_tmp20_ = separator;
#line 487 "../src/DynamicNotebook.vala"
		gtk_menu_shell_append ((GtkMenuShell*) _tmp19_, (GtkMenuItem*) _tmp20_);
#line 488 "../src/DynamicNotebook.vala"
		_tmp21_ = _menu;
#line 488 "../src/DynamicNotebook.vala"
		_tmp22_ = item;
#line 488 "../src/DynamicNotebook.vala"
		gtk_menu_shell_append ((GtkMenuShell*) _tmp21_, _tmp22_);
#line 490 "../src/DynamicNotebook.vala"
		_tmp23_ = item;
#line 490 "../src/DynamicNotebook.vala"
		g_signal_connect_object (_tmp23_, "activate", (GCallback) __closed_tabs_menu____lambda18__gtk_menu_item_activate, self, 0);
#line 483 "../src/DynamicNotebook.vala"
		_g_object_unref0 (item);
#line 483 "../src/DynamicNotebook.vala"
		_g_object_unref0 (separator);
#line 3837 "DynamicNotebook.c"
	}
#line 502 "../src/DynamicNotebook.vala"
	result = _menu;
#line 502 "../src/DynamicNotebook.vala"
	return result;
#line 3843 "DynamicNotebook.c"
}

static void
g_cclosure_user_marshal_VOID__STRING_STRING_OBJECT (GClosure * closure,
                                                    GValue * return_value,
                                                    guint n_param_values,
                                                    const GValue * param_values,
                                                    gpointer invocation_hint,
                                                    gpointer marshal_data)
{
	typedef void (*GMarshalFunc_VOID__STRING_STRING_OBJECT) (gpointer data1, const char* arg_1, const char* arg_2, gpointer arg_3, gpointer data2);
	register GMarshalFunc_VOID__STRING_STRING_OBJECT callback;
	register GCClosure * cc;
	register gpointer data1;
	register gpointer data2;
	cc = (GCClosure *) closure;
#line 393 "../src/DynamicNotebook.vala"
	g_return_if_fail (n_param_values == 4);
#line 393 "../src/DynamicNotebook.vala"
	if (G_CCLOSURE_SWAP_DATA (closure)) {
#line 393 "../src/DynamicNotebook.vala"
		data1 = closure->data;
#line 393 "../src/DynamicNotebook.vala"
		data2 = param_values->data[0].v_pointer;
#line 3868 "DynamicNotebook.c"
	} else {
#line 393 "../src/DynamicNotebook.vala"
		data1 = param_values->data[0].v_pointer;
#line 393 "../src/DynamicNotebook.vala"
		data2 = closure->data;
#line 3874 "DynamicNotebook.c"
	}
#line 393 "../src/DynamicNotebook.vala"
	callback = (GMarshalFunc_VOID__STRING_STRING_OBJECT) (marshal_data ? marshal_data : cc->callback);
#line 393 "../src/DynamicNotebook.vala"
	callback (data1, g_value_get_string (param_values + 1), g_value_get_string (param_values + 2), g_value_get_object (param_values + 3), data2);
#line 3880 "DynamicNotebook.c"
}

void
closed_tabs_entry_copy (const ClosedTabsEntry* self,
                        ClosedTabsEntry* dest)
{
	const gchar* _tmp0_;
	gchar* _tmp1_;
	const gchar* _tmp2_;
	gchar* _tmp3_;
	GIcon* _tmp4_;
	GIcon* _tmp5_;
	GraniteWidgetsDroppedDelegate _tmp6_;
	gpointer _tmp6__target;
#line 407 "../src/DynamicNotebook.vala"
	_tmp0_ = (*self).label;
#line 407 "../src/DynamicNotebook.vala"
	_tmp1_ = g_strdup (_tmp0_);
#line 407 "../src/DynamicNotebook.vala"
	_g_free0 ((*dest).label);
#line 407 "../src/DynamicNotebook.vala"
	(*dest).label = _tmp1_;
#line 407 "../src/DynamicNotebook.vala"
	_tmp2_ = (*self).restore_data;
#line 407 "../src/DynamicNotebook.vala"
	_tmp3_ = g_strdup (_tmp2_);
#line 407 "../src/DynamicNotebook.vala"
	_g_free0 ((*dest).restore_data);
#line 407 "../src/DynamicNotebook.vala"
	(*dest).restore_data = _tmp3_;
#line 407 "../src/DynamicNotebook.vala"
	_tmp4_ = (*self).icon;
#line 407 "../src/DynamicNotebook.vala"
	_tmp5_ = _g_object_ref0 (_tmp4_);
#line 407 "../src/DynamicNotebook.vala"
	_g_object_unref0 ((*dest).icon);
#line 407 "../src/DynamicNotebook.vala"
	(*dest).icon = _tmp5_;
#line 407 "../src/DynamicNotebook.vala"
	_tmp6_ = (*self).dropped_callback;
#line 407 "../src/DynamicNotebook.vala"
	_tmp6__target = (*self).dropped_callback_target;
#line 407 "../src/DynamicNotebook.vala"
	(*dest).dropped_callback = _tmp6_;
#line 407 "../src/DynamicNotebook.vala"
	(*dest).dropped_callback_target = _tmp6__target;
#line 3927 "DynamicNotebook.c"
}

void
closed_tabs_entry_destroy (ClosedTabsEntry* self)
{
#line 408 "../src/DynamicNotebook.vala"
	_g_free0 ((*self).label);
#line 409 "../src/DynamicNotebook.vala"
	_g_free0 ((*self).restore_data);
#line 410 "../src/DynamicNotebook.vala"
	_g_object_unref0 ((*self).icon);
#line 3939 "DynamicNotebook.c"
}

ClosedTabsEntry*
closed_tabs_entry_dup (const ClosedTabsEntry* self)
{
	ClosedTabsEntry* dup;
#line 407 "../src/DynamicNotebook.vala"
	dup = g_new0 (ClosedTabsEntry, 1);
#line 407 "../src/DynamicNotebook.vala"
	closed_tabs_entry_copy (self, dup);
#line 407 "../src/DynamicNotebook.vala"
	return dup;
#line 3952 "DynamicNotebook.c"
}

void
closed_tabs_entry_free (ClosedTabsEntry* self)
{
#line 407 "../src/DynamicNotebook.vala"
	closed_tabs_entry_destroy (self);
#line 407 "../src/DynamicNotebook.vala"
	g_free (self);
#line 3962 "DynamicNotebook.c"
}

static GType
closed_tabs_entry_get_type_once (void)
{
	GType closed_tabs_entry_type_id;
	closed_tabs_entry_type_id = g_boxed_type_register_static ("ClosedTabsEntry", (GBoxedCopyFunc) closed_tabs_entry_dup, (GBoxedFreeFunc) closed_tabs_entry_free);
	return closed_tabs_entry_type_id;
}

GType
closed_tabs_entry_get_type (void)
{
	static volatile gsize closed_tabs_entry_type_id__once = 0;
	if (g_once_init_enter (&closed_tabs_entry_type_id__once)) {
		GType closed_tabs_entry_type_id;
		closed_tabs_entry_type_id = closed_tabs_entry_get_type_once ();
		g_once_init_leave (&closed_tabs_entry_type_id__once, closed_tabs_entry_type_id);
	}
	return closed_tabs_entry_type_id__once;
}

static GObject *
closed_tabs_constructor (GType type,
                         guint n_construct_properties,
                         GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	ClosedTabs * self;
	GeeLinkedList* _tmp0_;
#line 420 "../src/DynamicNotebook.vala"
	parent_class = G_OBJECT_CLASS (closed_tabs_parent_class);
#line 420 "../src/DynamicNotebook.vala"
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
#line 420 "../src/DynamicNotebook.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_CLOSED_TABS, ClosedTabs);
#line 421 "../src/DynamicNotebook.vala"
	_tmp0_ = gee_linked_list_new (CLOSED_TABS_TYPE_ENTRY, (GBoxedCopyFunc) closed_tabs_entry_dup, (GDestroyNotify) closed_tabs_entry_free, NULL, NULL, NULL);
#line 421 "../src/DynamicNotebook.vala"
	_g_object_unref0 (self->priv->closed_tabs);
#line 421 "../src/DynamicNotebook.vala"
	self->priv->closed_tabs = _tmp0_;
#line 420 "../src/DynamicNotebook.vala"
	return obj;
#line 4008 "DynamicNotebook.c"
}

static void
closed_tabs_class_init (ClosedTabsClass * klass,
                        gpointer klass_data)
{
#line 393 "../src/DynamicNotebook.vala"
	closed_tabs_parent_class = g_type_class_peek_parent (klass);
#line 393 "../src/DynamicNotebook.vala"
	g_type_class_adjust_private_offset (klass, &ClosedTabs_private_offset);
#line 393 "../src/DynamicNotebook.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_closed_tabs_get_property;
#line 393 "../src/DynamicNotebook.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_closed_tabs_set_property;
#line 393 "../src/DynamicNotebook.vala"
	G_OBJECT_CLASS (klass)->constructor = closed_tabs_constructor;
#line 393 "../src/DynamicNotebook.vala"
	G_OBJECT_CLASS (klass)->finalize = closed_tabs_finalize;
#line 393 "../src/DynamicNotebook.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), CLOSED_TABS_MAX_RESTORABLE_TABS_PROPERTY, closed_tabs_properties[CLOSED_TABS_MAX_RESTORABLE_TABS_PROPERTY] = g_param_spec_int ("max-restorable-tabs", "max-restorable-tabs", "max-restorable-tabs", G_MININT, G_MAXINT, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 393 "../src/DynamicNotebook.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), CLOSED_TABS_EMPTY_PROPERTY, closed_tabs_properties[CLOSED_TABS_EMPTY_PROPERTY] = g_param_spec_boolean ("empty", "empty", "empty", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 393 "../src/DynamicNotebook.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), CLOSED_TABS_MENU_PROPERTY, closed_tabs_properties[CLOSED_TABS_MENU_PROPERTY] = g_param_spec_object ("menu", "menu", "menu", gtk_menu_get_type (), G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 393 "../src/DynamicNotebook.vala"
	closed_tabs_signals[CLOSED_TABS_RESTORED_SIGNAL] = g_signal_new ("restored", TYPE_CLOSED_TABS, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_user_marshal_VOID__STRING_STRING_OBJECT, G_TYPE_NONE, 3, G_TYPE_STRING, G_TYPE_STRING, g_icon_get_type ());
#line 393 "../src/DynamicNotebook.vala"
	closed_tabs_signals[CLOSED_TABS_CLEARED_SIGNAL] = g_signal_new ("cleared", TYPE_CLOSED_TABS, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
#line 4037 "DynamicNotebook.c"
}

static void
closed_tabs_instance_init (ClosedTabs * self,
                           gpointer klass)
{
#line 393 "../src/DynamicNotebook.vala"
	self->priv = closed_tabs_get_instance_private (self);
#line 398 "../src/DynamicNotebook.vala"
	self->priv->_max_restorable_tabs = 10;
#line 4048 "DynamicNotebook.c"
}

static void
closed_tabs_finalize (GObject * obj)
{
	ClosedTabs * self;
#line 393 "../src/DynamicNotebook.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_CLOSED_TABS, ClosedTabs);
#line 414 "../src/DynamicNotebook.vala"
	_g_object_unref0 (self->priv->closed_tabs);
#line 393 "../src/DynamicNotebook.vala"
	G_OBJECT_CLASS (closed_tabs_parent_class)->finalize (obj);
#line 4061 "DynamicNotebook.c"
}

static GType
closed_tabs_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (ClosedTabsClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) closed_tabs_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (ClosedTabs), 0, (GInstanceInitFunc) closed_tabs_instance_init, NULL };
	GType closed_tabs_type_id;
	closed_tabs_type_id = g_type_register_static (G_TYPE_OBJECT, "ClosedTabs", &g_define_type_info, 0);
	ClosedTabs_private_offset = g_type_add_instance_private (closed_tabs_type_id, sizeof (ClosedTabsPrivate));
	return closed_tabs_type_id;
}

GType
closed_tabs_get_type (void)
{
	static volatile gsize closed_tabs_type_id__once = 0;
	if (g_once_init_enter (&closed_tabs_type_id__once)) {
		GType closed_tabs_type_id;
		closed_tabs_type_id = closed_tabs_get_type_once ();
		g_once_init_leave (&closed_tabs_type_id__once, closed_tabs_type_id);
	}
	return closed_tabs_type_id__once;
}

static void
_vala_closed_tabs_get_property (GObject * object,
                                guint property_id,
                                GValue * value,
                                GParamSpec * pspec)
{
	ClosedTabs * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_CLOSED_TABS, ClosedTabs);
#line 393 "../src/DynamicNotebook.vala"
	switch (property_id) {
#line 393 "../src/DynamicNotebook.vala"
		case CLOSED_TABS_MAX_RESTORABLE_TABS_PROPERTY:
#line 393 "../src/DynamicNotebook.vala"
		g_value_set_int (value, closed_tabs_get_max_restorable_tabs (self));
#line 393 "../src/DynamicNotebook.vala"
		break;
#line 393 "../src/DynamicNotebook.vala"
		case CLOSED_TABS_EMPTY_PROPERTY:
#line 393 "../src/DynamicNotebook.vala"
		g_value_set_boolean (value, closed_tabs_get_empty (self));
#line 393 "../src/DynamicNotebook.vala"
		break;
#line 393 "../src/DynamicNotebook.vala"
		case CLOSED_TABS_MENU_PROPERTY:
#line 393 "../src/DynamicNotebook.vala"
		g_value_take_object (value, closed_tabs_get_menu (self));
#line 393 "../src/DynamicNotebook.vala"
		break;
#line 4114 "DynamicNotebook.c"
		default:
#line 393 "../src/DynamicNotebook.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 393 "../src/DynamicNotebook.vala"
		break;
#line 4120 "DynamicNotebook.c"
	}
}

static void
_vala_closed_tabs_set_property (GObject * object,
                                guint property_id,
                                const GValue * value,
                                GParamSpec * pspec)
{
	ClosedTabs * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_CLOSED_TABS, ClosedTabs);
#line 393 "../src/DynamicNotebook.vala"
	switch (property_id) {
#line 393 "../src/DynamicNotebook.vala"
		case CLOSED_TABS_MAX_RESTORABLE_TABS_PROPERTY:
#line 393 "../src/DynamicNotebook.vala"
		closed_tabs_set_max_restorable_tabs (self, g_value_get_int (value));
#line 393 "../src/DynamicNotebook.vala"
		break;
#line 4140 "DynamicNotebook.c"
		default:
#line 393 "../src/DynamicNotebook.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 393 "../src/DynamicNotebook.vala"
		break;
#line 4146 "DynamicNotebook.c"
	}
}

static inline gpointer
dynamic_notebook_get_instance_private (DynamicNotebook* self)
{
	return G_STRUCT_MEMBER_P (self, DynamicNotebook_private_offset);
}

static GType
dynamic_notebook_tab_bar_behavior_get_type_once (void)
{
	static const GEnumValue values[] = {{DYNAMIC_NOTEBOOK_TAB_BAR_BEHAVIOR_ALWAYS, "DYNAMIC_NOTEBOOK_TAB_BAR_BEHAVIOR_ALWAYS", "always"}, {DYNAMIC_NOTEBOOK_TAB_BAR_BEHAVIOR_SINGLE, "DYNAMIC_NOTEBOOK_TAB_BAR_BEHAVIOR_SINGLE", "single"}, {DYNAMIC_NOTEBOOK_TAB_BAR_BEHAVIOR_NEVER, "DYNAMIC_NOTEBOOK_TAB_BAR_BEHAVIOR_NEVER", "never"}, {0, NULL, NULL}};
	GType dynamic_notebook_tab_bar_behavior_type_id;
	dynamic_notebook_tab_bar_behavior_type_id = g_enum_register_static ("DynamicNotebookTabBarBehavior", values);
	return dynamic_notebook_tab_bar_behavior_type_id;
}

GType
dynamic_notebook_tab_bar_behavior_get_type (void)
{
	static volatile gsize dynamic_notebook_tab_bar_behavior_type_id__once = 0;
	if (g_once_init_enter (&dynamic_notebook_tab_bar_behavior_type_id__once)) {
		GType dynamic_notebook_tab_bar_behavior_type_id;
		dynamic_notebook_tab_bar_behavior_type_id = dynamic_notebook_tab_bar_behavior_get_type_once ();
		g_once_init_leave (&dynamic_notebook_tab_bar_behavior_type_id__once, dynamic_notebook_tab_bar_behavior_type_id);
	}
	return dynamic_notebook_tab_bar_behavior_type_id__once;
}

static void
_g_object_unref0_ (gpointer var)
{
#line 674 "../src/DynamicNotebook.vala"
	(var == NULL) ? NULL : (var = (g_object_unref (var), NULL));
#line 4182 "DynamicNotebook.c"
}

static inline void
_g_list_free__g_object_unref0_ (GList* self)
{
#line 674 "../src/DynamicNotebook.vala"
	g_list_free_full (self, (GDestroyNotify) _g_object_unref0_);
#line 4190 "DynamicNotebook.c"
}

/**
         * Create a new dynamic notebook
         */
DynamicNotebook*
dynamic_notebook_construct (GType object_type)
{
	DynamicNotebook * self = NULL;
#line 745 "../src/DynamicNotebook.vala"
	self = (DynamicNotebook*) g_object_new (object_type, NULL);
#line 745 "../src/DynamicNotebook.vala"
	return self;
#line 4204 "DynamicNotebook.c"
}

DynamicNotebook*
dynamic_notebook_new (void)
{
#line 745 "../src/DynamicNotebook.vala"
	return dynamic_notebook_construct (TYPE_DYNAMIC_NOTEBOOK);
#line 4212 "DynamicNotebook.c"
}

static void
dynamic_notebook_on_switch_page (DynamicNotebook* self,
                                 GtkWidget* page,
                                 guint pagenum)
{
	TabPageContainer* cont = NULL;
	TabPageContainer* _tmp0_;
	TabPageContainer* _tmp1_;
	Tab* new_tab = NULL;
	TabPageContainer* _tmp2_;
	Tab* _tmp3_;
	Tab* _tmp4_;
	Tab* _tmp5_;
	Tab* _tmp6_;
	Tab* _tmp8_;
	Tab* _tmp9_;
	Tab* _tmp10_;
	Tab* _tmp11_;
	Tab* _tmp12_;
#line 943 "../src/DynamicNotebook.vala"
	g_return_if_fail (self != NULL);
#line 943 "../src/DynamicNotebook.vala"
	g_return_if_fail (page != NULL);
#line 944 "../src/DynamicNotebook.vala"
	_tmp0_ = _g_object_ref0 (IS_TAB_PAGE_CONTAINER (page) ? ((TabPageContainer*) page) : NULL);
#line 944 "../src/DynamicNotebook.vala"
	cont = _tmp0_;
#line 945 "../src/DynamicNotebook.vala"
	_tmp1_ = cont;
#line 945 "../src/DynamicNotebook.vala"
	if (_tmp1_ == NULL) {
#line 945 "../src/DynamicNotebook.vala"
		_g_object_unref0 (cont);
#line 945 "../src/DynamicNotebook.vala"
		return;
#line 4250 "DynamicNotebook.c"
	}
#line 947 "../src/DynamicNotebook.vala"
	_tmp2_ = cont;
#line 947 "../src/DynamicNotebook.vala"
	_tmp3_ = tab_page_container_get_tab (_tmp2_);
#line 947 "../src/DynamicNotebook.vala"
	_tmp4_ = _tmp3_;
#line 947 "../src/DynamicNotebook.vala"
	_tmp5_ = _g_object_ref0 (_tmp4_);
#line 947 "../src/DynamicNotebook.vala"
	new_tab = _tmp5_;
#line 950 "../src/DynamicNotebook.vala"
	_tmp6_ = self->priv->old_tab;
#line 950 "../src/DynamicNotebook.vala"
	if (_tmp6_ != NULL) {
#line 4266 "DynamicNotebook.c"
		Tab* _tmp7_;
#line 951 "../src/DynamicNotebook.vala"
		_tmp7_ = self->priv->old_tab;
#line 951 "../src/DynamicNotebook.vala"
		tab_set_is_current_tab (_tmp7_, FALSE);
#line 4272 "DynamicNotebook.c"
	}
#line 954 "../src/DynamicNotebook.vala"
	_tmp8_ = new_tab;
#line 954 "../src/DynamicNotebook.vala"
	tab_set_is_current_tab (_tmp8_, TRUE);
#line 956 "../src/DynamicNotebook.vala"
	_tmp9_ = self->priv->old_tab;
#line 956 "../src/DynamicNotebook.vala"
	_tmp10_ = new_tab;
#line 956 "../src/DynamicNotebook.vala"
	g_signal_emit (self, dynamic_notebook_signals[DYNAMIC_NOTEBOOK_TAB_SWITCHED_SIGNAL], 0, _tmp9_, _tmp10_);
#line 958 "../src/DynamicNotebook.vala"
	_tmp11_ = new_tab;
#line 958 "../src/DynamicNotebook.vala"
	_tmp12_ = _g_object_ref0 (_tmp11_);
#line 958 "../src/DynamicNotebook.vala"
	_g_object_unref0 (self->priv->old_tab);
#line 958 "../src/DynamicNotebook.vala"
	self->priv->old_tab = _tmp12_;
#line 943 "../src/DynamicNotebook.vala"
	_g_object_unref0 (new_tab);
#line 943 "../src/DynamicNotebook.vala"
	_g_object_unref0 (cont);
#line 4296 "DynamicNotebook.c"
}

static void
dynamic_notebook_on_page_added (DynamicNotebook* self,
                                GtkWidget* page,
                                guint pagenum)
{
	TabPageContainer* cont = NULL;
	TabPageContainer* _tmp0_;
	TabPageContainer* _tmp1_;
	Tab* t = NULL;
	TabPageContainer* _tmp2_;
	Tab* _tmp3_;
	Tab* _tmp4_;
	Tab* _tmp5_;
	Tab* _tmp6_;
	Tab* _tmp7_;
#line 961 "../src/DynamicNotebook.vala"
	g_return_if_fail (self != NULL);
#line 961 "../src/DynamicNotebook.vala"
	g_return_if_fail (page != NULL);
#line 962 "../src/DynamicNotebook.vala"
	_tmp0_ = _g_object_ref0 (IS_TAB_PAGE_CONTAINER (page) ? ((TabPageContainer*) page) : NULL);
#line 962 "../src/DynamicNotebook.vala"
	cont = _tmp0_;
#line 963 "../src/DynamicNotebook.vala"
	_tmp1_ = cont;
#line 963 "../src/DynamicNotebook.vala"
	if (_tmp1_ == NULL) {
#line 963 "../src/DynamicNotebook.vala"
		_g_object_unref0 (cont);
#line 963 "../src/DynamicNotebook.vala"
		return;
#line 4330 "DynamicNotebook.c"
	}
#line 964 "../src/DynamicNotebook.vala"
	_tmp2_ = cont;
#line 964 "../src/DynamicNotebook.vala"
	_tmp3_ = tab_page_container_get_tab (_tmp2_);
#line 964 "../src/DynamicNotebook.vala"
	_tmp4_ = _tmp3_;
#line 964 "../src/DynamicNotebook.vala"
	_tmp5_ = _g_object_ref0 (_tmp4_);
#line 964 "../src/DynamicNotebook.vala"
	t = _tmp5_;
#line 966 "../src/DynamicNotebook.vala"
	_tmp6_ = t;
#line 966 "../src/DynamicNotebook.vala"
	dynamic_notebook_insert_callbacks (self, _tmp6_);
#line 967 "../src/DynamicNotebook.vala"
	_tmp7_ = t;
#line 967 "../src/DynamicNotebook.vala"
	g_signal_emit (self, dynamic_notebook_signals[DYNAMIC_NOTEBOOK_TAB_ADDED_SIGNAL], 0, _tmp7_);
#line 968 "../src/DynamicNotebook.vala"
	dynamic_notebook_update_tabs_visibility (self);
#line 961 "../src/DynamicNotebook.vala"
	_g_object_unref0 (t);
#line 961 "../src/DynamicNotebook.vala"
	_g_object_unref0 (cont);
#line 4356 "DynamicNotebook.c"
}

static void
dynamic_notebook_on_page_removed (DynamicNotebook* self,
                                  GtkWidget* page,
                                  guint pagenum)
{
	TabPageContainer* cont = NULL;
	TabPageContainer* _tmp0_;
	TabPageContainer* _tmp1_;
	Tab* t = NULL;
	TabPageContainer* _tmp2_;
	Tab* _tmp3_;
	Tab* _tmp4_;
	Tab* _tmp5_;
	Tab* _tmp6_;
	Tab* _tmp7_;
#line 971 "../src/DynamicNotebook.vala"
	g_return_if_fail (self != NULL);
#line 971 "../src/DynamicNotebook.vala"
	g_return_if_fail (page != NULL);
#line 972 "../src/DynamicNotebook.vala"
	_tmp0_ = _g_object_ref0 (IS_TAB_PAGE_CONTAINER (page) ? ((TabPageContainer*) page) : NULL);
#line 972 "../src/DynamicNotebook.vala"
	cont = _tmp0_;
#line 973 "../src/DynamicNotebook.vala"
	_tmp1_ = cont;
#line 973 "../src/DynamicNotebook.vala"
	if (_tmp1_ == NULL) {
#line 973 "../src/DynamicNotebook.vala"
		_g_object_unref0 (cont);
#line 973 "../src/DynamicNotebook.vala"
		return;
#line 4390 "DynamicNotebook.c"
	}
#line 974 "../src/DynamicNotebook.vala"
	_tmp2_ = cont;
#line 974 "../src/DynamicNotebook.vala"
	_tmp3_ = tab_page_container_get_tab (_tmp2_);
#line 974 "../src/DynamicNotebook.vala"
	_tmp4_ = _tmp3_;
#line 974 "../src/DynamicNotebook.vala"
	_tmp5_ = _g_object_ref0 (_tmp4_);
#line 974 "../src/DynamicNotebook.vala"
	t = _tmp5_;
#line 976 "../src/DynamicNotebook.vala"
	_tmp6_ = t;
#line 976 "../src/DynamicNotebook.vala"
	dynamic_notebook_remove_callbacks (self, _tmp6_);
#line 977 "../src/DynamicNotebook.vala"
	_tmp7_ = t;
#line 977 "../src/DynamicNotebook.vala"
	g_signal_emit (self, dynamic_notebook_signals[DYNAMIC_NOTEBOOK_TAB_REMOVED_SIGNAL], 0, _tmp7_);
#line 978 "../src/DynamicNotebook.vala"
	dynamic_notebook_update_tabs_visibility (self);
#line 971 "../src/DynamicNotebook.vala"
	_g_object_unref0 (t);
#line 971 "../src/DynamicNotebook.vala"
	_g_object_unref0 (cont);
#line 4416 "DynamicNotebook.c"
}

static void
dynamic_notebook_on_page_reordered (DynamicNotebook* self,
                                    GtkWidget* page,
                                    guint pagenum)
{
	Tab* _tmp0_;
	Tab* _tmp1_;
#line 981 "../src/DynamicNotebook.vala"
	g_return_if_fail (self != NULL);
#line 981 "../src/DynamicNotebook.vala"
	g_return_if_fail (page != NULL);
#line 982 "../src/DynamicNotebook.vala"
	_tmp0_ = tab_page_container_get_tab (IS_TAB_PAGE_CONTAINER (page) ? ((TabPageContainer*) page) : NULL);
#line 982 "../src/DynamicNotebook.vala"
	_tmp1_ = _tmp0_;
#line 982 "../src/DynamicNotebook.vala"
	g_signal_emit (self, dynamic_notebook_signals[DYNAMIC_NOTEBOOK_TAB_REORDERED_SIGNAL], 0, _tmp1_, (gint) pagenum);
#line 983 "../src/DynamicNotebook.vala"
	dynamic_notebook_recalc_order (self);
#line 4438 "DynamicNotebook.c"
}

static GtkNotebook*
dynamic_notebook_on_create_window (DynamicNotebook* self,
                                   GtkWidget* page,
                                   gint x,
                                   gint y)
{
	Tab* tab = NULL;
	GtkNotebook* _tmp0_;
	GtkWidget* _tmp1_;
	Tab* _tmp2_;
	GtkNotebook* result;
#line 986 "../src/DynamicNotebook.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 986 "../src/DynamicNotebook.vala"
	g_return_val_if_fail (page != NULL, NULL);
#line 987 "../src/DynamicNotebook.vala"
	_tmp0_ = self->priv->notebook;
#line 987 "../src/DynamicNotebook.vala"
	_tmp1_ = gtk_notebook_get_tab_label (_tmp0_, page);
#line 987 "../src/DynamicNotebook.vala"
	_tmp2_ = _g_object_ref0 (IS_TAB (_tmp1_) ? ((Tab*) _tmp1_) : NULL);
#line 987 "../src/DynamicNotebook.vala"
	tab = _tmp2_;
#line 988 "../src/DynamicNotebook.vala"
	g_signal_emit (self, dynamic_notebook_signals[DYNAMIC_NOTEBOOK_TAB_MOVED_SIGNAL], 0, tab, x, y);
#line 989 "../src/DynamicNotebook.vala"
	dynamic_notebook_recalc_order (self);
#line 990 "../src/DynamicNotebook.vala"
	result = G_TYPE_CHECK_INSTANCE_CAST (NULL, gtk_notebook_get_type (), GtkNotebook);
#line 990 "../src/DynamicNotebook.vala"
	_g_object_unref0 (tab);
#line 990 "../src/DynamicNotebook.vala"
	return result;
#line 4474 "DynamicNotebook.c"
}

static void
dynamic_notebook_recalc_order (DynamicNotebook* self)
{
	gboolean _tmp0_ = FALSE;
	gint _tmp1_;
	gint _tmp2_;
	gint pinned_tabs = 0;
#line 993 "../src/DynamicNotebook.vala"
	g_return_if_fail (self != NULL);
#line 994 "../src/DynamicNotebook.vala"
	_tmp1_ = dynamic_notebook_get_n_tabs (self);
#line 994 "../src/DynamicNotebook.vala"
	_tmp2_ = _tmp1_;
#line 994 "../src/DynamicNotebook.vala"
	if (_tmp2_ == 0) {
#line 994 "../src/DynamicNotebook.vala"
		_tmp0_ = TRUE;
#line 4494 "DynamicNotebook.c"
	} else {
		gboolean _tmp3_;
		gboolean _tmp4_;
#line 994 "../src/DynamicNotebook.vala"
		_tmp3_ = dynamic_notebook_get_force_left (self);
#line 994 "../src/DynamicNotebook.vala"
		_tmp4_ = _tmp3_;
#line 994 "../src/DynamicNotebook.vala"
		_tmp0_ = !_tmp4_;
#line 4504 "DynamicNotebook.c"
	}
#line 994 "../src/DynamicNotebook.vala"
	if (_tmp0_) {
#line 995 "../src/DynamicNotebook.vala"
		return;
#line 4510 "DynamicNotebook.c"
	}
#line 997 "../src/DynamicNotebook.vala"
	pinned_tabs = 0;
#line 4514 "DynamicNotebook.c"
	{
		gint i = 0;
#line 998 "../src/DynamicNotebook.vala"
		i = 0;
#line 4519 "DynamicNotebook.c"
		{
			gboolean _tmp5_ = FALSE;
#line 998 "../src/DynamicNotebook.vala"
			_tmp5_ = TRUE;
#line 998 "../src/DynamicNotebook.vala"
			while (TRUE) {
#line 4526 "DynamicNotebook.c"
				GtkNotebook* _tmp7_;
				Tab* tab = NULL;
				GtkNotebook* _tmp8_;
				GtkNotebook* _tmp9_;
				GtkWidget* _tmp10_;
				GtkWidget* _tmp11_;
				Tab* _tmp12_;
				gboolean _tmp13_ = FALSE;
				Tab* _tmp14_;
#line 998 "../src/DynamicNotebook.vala"
				if (!_tmp5_) {
#line 4538 "DynamicNotebook.c"
					gint _tmp6_;
#line 998 "../src/DynamicNotebook.vala"
					_tmp6_ = i;
#line 998 "../src/DynamicNotebook.vala"
					i = _tmp6_ + 1;
#line 4544 "DynamicNotebook.c"
				}
#line 998 "../src/DynamicNotebook.vala"
				_tmp5_ = FALSE;
#line 998 "../src/DynamicNotebook.vala"
				_tmp7_ = self->priv->notebook;
#line 998 "../src/DynamicNotebook.vala"
				if (!(i < gtk_notebook_get_n_pages (_tmp7_))) {
#line 998 "../src/DynamicNotebook.vala"
					break;
#line 4554 "DynamicNotebook.c"
				}
#line 999 "../src/DynamicNotebook.vala"
				_tmp8_ = self->priv->notebook;
#line 999 "../src/DynamicNotebook.vala"
				_tmp9_ = self->priv->notebook;
#line 999 "../src/DynamicNotebook.vala"
				_tmp10_ = gtk_notebook_get_nth_page (_tmp9_, i);
#line 999 "../src/DynamicNotebook.vala"
				_tmp11_ = gtk_notebook_get_tab_label (_tmp8_, _tmp10_);
#line 999 "../src/DynamicNotebook.vala"
				_tmp12_ = _g_object_ref0 (IS_TAB (_tmp11_) ? ((Tab*) _tmp11_) : NULL);
#line 999 "../src/DynamicNotebook.vala"
				tab = _tmp12_;
#line 1000 "../src/DynamicNotebook.vala"
				_tmp14_ = tab;
#line 1000 "../src/DynamicNotebook.vala"
				if (_tmp14_ != NULL) {
#line 4572 "DynamicNotebook.c"
					Tab* _tmp15_;
					gboolean _tmp16_;
					gboolean _tmp17_;
#line 1000 "../src/DynamicNotebook.vala"
					_tmp15_ = tab;
#line 1000 "../src/DynamicNotebook.vala"
					_tmp16_ = tab_get_pinned (_tmp15_);
#line 1000 "../src/DynamicNotebook.vala"
					_tmp17_ = _tmp16_;
#line 1000 "../src/DynamicNotebook.vala"
					_tmp13_ = _tmp17_;
#line 4584 "DynamicNotebook.c"
				} else {
#line 1000 "../src/DynamicNotebook.vala"
					_tmp13_ = FALSE;
#line 4588 "DynamicNotebook.c"
				}
#line 1000 "../src/DynamicNotebook.vala"
				if (_tmp13_) {
#line 4592 "DynamicNotebook.c"
					gint _tmp18_;
#line 1001 "../src/DynamicNotebook.vala"
					_tmp18_ = pinned_tabs;
#line 1001 "../src/DynamicNotebook.vala"
					pinned_tabs = _tmp18_ + 1;
#line 4598 "DynamicNotebook.c"
				}
#line 998 "../src/DynamicNotebook.vala"
				_g_object_unref0 (tab);
#line 4602 "DynamicNotebook.c"
			}
		}
	}
	{
		gint p = 0;
#line 1005 "../src/DynamicNotebook.vala"
		p = 0;
#line 4610 "DynamicNotebook.c"
		{
			gboolean _tmp19_ = FALSE;
#line 1005 "../src/DynamicNotebook.vala"
			_tmp19_ = TRUE;
#line 1005 "../src/DynamicNotebook.vala"
			while (TRUE) {
#line 4617 "DynamicNotebook.c"
				gint sel = 0;
#line 1005 "../src/DynamicNotebook.vala"
				if (!_tmp19_) {
#line 4621 "DynamicNotebook.c"
					gint _tmp20_;
#line 1005 "../src/DynamicNotebook.vala"
					_tmp20_ = p;
#line 1005 "../src/DynamicNotebook.vala"
					p = _tmp20_ + 1;
#line 4627 "DynamicNotebook.c"
				}
#line 1005 "../src/DynamicNotebook.vala"
				_tmp19_ = FALSE;
#line 1005 "../src/DynamicNotebook.vala"
				if (!(p < pinned_tabs)) {
#line 1005 "../src/DynamicNotebook.vala"
					break;
#line 4635 "DynamicNotebook.c"
				}
#line 1006 "../src/DynamicNotebook.vala"
				sel = p;
#line 4639 "DynamicNotebook.c"
				{
					gint i = 0;
#line 1007 "../src/DynamicNotebook.vala"
					i = p;
#line 4644 "DynamicNotebook.c"
					{
						gboolean _tmp21_ = FALSE;
#line 1007 "../src/DynamicNotebook.vala"
						_tmp21_ = TRUE;
#line 1007 "../src/DynamicNotebook.vala"
						while (TRUE) {
#line 4651 "DynamicNotebook.c"
							GtkNotebook* _tmp23_;
							Tab* tab = NULL;
							GtkNotebook* _tmp24_;
							GtkNotebook* _tmp25_;
							GtkWidget* _tmp26_;
							GtkWidget* _tmp27_;
							Tab* _tmp28_;
							gboolean _tmp29_ = FALSE;
							Tab* _tmp30_;
#line 1007 "../src/DynamicNotebook.vala"
							if (!_tmp21_) {
#line 4663 "DynamicNotebook.c"
								gint _tmp22_;
#line 1007 "../src/DynamicNotebook.vala"
								_tmp22_ = i;
#line 1007 "../src/DynamicNotebook.vala"
								i = _tmp22_ + 1;
#line 4669 "DynamicNotebook.c"
							}
#line 1007 "../src/DynamicNotebook.vala"
							_tmp21_ = FALSE;
#line 1007 "../src/DynamicNotebook.vala"
							_tmp23_ = self->priv->notebook;
#line 1007 "../src/DynamicNotebook.vala"
							if (!(i < gtk_notebook_get_n_pages (_tmp23_))) {
#line 1007 "../src/DynamicNotebook.vala"
								break;
#line 4679 "DynamicNotebook.c"
							}
#line 1008 "../src/DynamicNotebook.vala"
							_tmp24_ = self->priv->notebook;
#line 1008 "../src/DynamicNotebook.vala"
							_tmp25_ = self->priv->notebook;
#line 1008 "../src/DynamicNotebook.vala"
							_tmp26_ = gtk_notebook_get_nth_page (_tmp25_, i);
#line 1008 "../src/DynamicNotebook.vala"
							_tmp27_ = gtk_notebook_get_tab_label (_tmp24_, _tmp26_);
#line 1008 "../src/DynamicNotebook.vala"
							_tmp28_ = _g_object_ref0 (IS_TAB (_tmp27_) ? ((Tab*) _tmp27_) : NULL);
#line 1008 "../src/DynamicNotebook.vala"
							tab = _tmp28_;
#line 1009 "../src/DynamicNotebook.vala"
							_tmp30_ = tab;
#line 1009 "../src/DynamicNotebook.vala"
							if (_tmp30_ != NULL) {
#line 4697 "DynamicNotebook.c"
								Tab* _tmp31_;
								gboolean _tmp32_;
								gboolean _tmp33_;
#line 1009 "../src/DynamicNotebook.vala"
								_tmp31_ = tab;
#line 1009 "../src/DynamicNotebook.vala"
								_tmp32_ = tab_get_pinned (_tmp31_);
#line 1009 "../src/DynamicNotebook.vala"
								_tmp33_ = _tmp32_;
#line 1009 "../src/DynamicNotebook.vala"
								_tmp29_ = _tmp33_;
#line 4709 "DynamicNotebook.c"
							} else {
#line 1009 "../src/DynamicNotebook.vala"
								_tmp29_ = FALSE;
#line 4713 "DynamicNotebook.c"
							}
#line 1009 "../src/DynamicNotebook.vala"
							if (_tmp29_) {
#line 1010 "../src/DynamicNotebook.vala"
								sel = i;
#line 1011 "../src/DynamicNotebook.vala"
								_g_object_unref0 (tab);
#line 1011 "../src/DynamicNotebook.vala"
								break;
#line 4723 "DynamicNotebook.c"
							}
#line 1007 "../src/DynamicNotebook.vala"
							_g_object_unref0 (tab);
#line 4727 "DynamicNotebook.c"
						}
					}
				}
#line 1015 "../src/DynamicNotebook.vala"
				if (sel != p) {
#line 4733 "DynamicNotebook.c"
					GtkNotebook* _tmp34_;
					GtkNotebook* _tmp35_;
					GtkWidget* _tmp36_;
#line 1016 "../src/DynamicNotebook.vala"
					_tmp34_ = self->priv->notebook;
#line 1016 "../src/DynamicNotebook.vala"
					_tmp35_ = self->priv->notebook;
#line 1016 "../src/DynamicNotebook.vala"
					_tmp36_ = gtk_notebook_get_nth_page (_tmp35_, sel);
#line 1016 "../src/DynamicNotebook.vala"
					gtk_notebook_reorder_child (_tmp34_, _tmp36_, p);
#line 4745 "DynamicNotebook.c"
				}
			}
		}
	}
}

static void
dynamic_notebook_recalc_size (DynamicNotebook* self)
{
	gint _tmp0_;
	gint _tmp1_;
	gint pinned_tabs = 0;
	gint unpinned_tabs = 0;
	gint offset = 0;
#line 1021 "../src/DynamicNotebook.vala"
	g_return_if_fail (self != NULL);
#line 1022 "../src/DynamicNotebook.vala"
	_tmp0_ = dynamic_notebook_get_n_tabs (self);
#line 1022 "../src/DynamicNotebook.vala"
	_tmp1_ = _tmp0_;
#line 1022 "../src/DynamicNotebook.vala"
	if (_tmp1_ == 0) {
#line 1023 "../src/DynamicNotebook.vala"
		return;
#line 4770 "DynamicNotebook.c"
	}
#line 1025 "../src/DynamicNotebook.vala"
	pinned_tabs = 0;
#line 1026 "../src/DynamicNotebook.vala"
	unpinned_tabs = 0;
#line 4776 "DynamicNotebook.c"
	{
		gint i = 0;
#line 1027 "../src/DynamicNotebook.vala"
		i = 0;
#line 4781 "DynamicNotebook.c"
		{
			gboolean _tmp2_ = FALSE;
#line 1027 "../src/DynamicNotebook.vala"
			_tmp2_ = TRUE;
#line 1027 "../src/DynamicNotebook.vala"
			while (TRUE) {
#line 4788 "DynamicNotebook.c"
				GtkNotebook* _tmp4_;
				GtkNotebook* _tmp5_;
				GtkNotebook* _tmp6_;
				GtkWidget* _tmp7_;
				GtkWidget* _tmp8_;
				gboolean _tmp9_;
				gboolean _tmp10_;
#line 1027 "../src/DynamicNotebook.vala"
				if (!_tmp2_) {
#line 4798 "DynamicNotebook.c"
					gint _tmp3_;
#line 1027 "../src/DynamicNotebook.vala"
					_tmp3_ = i;
#line 1027 "../src/DynamicNotebook.vala"
					i = _tmp3_ + 1;
#line 4804 "DynamicNotebook.c"
				}
#line 1027 "../src/DynamicNotebook.vala"
				_tmp2_ = FALSE;
#line 1027 "../src/DynamicNotebook.vala"
				_tmp4_ = self->priv->notebook;
#line 1027 "../src/DynamicNotebook.vala"
				if (!(i < gtk_notebook_get_n_pages (_tmp4_))) {
#line 1027 "../src/DynamicNotebook.vala"
					break;
#line 4814 "DynamicNotebook.c"
				}
#line 1028 "../src/DynamicNotebook.vala"
				_tmp5_ = self->priv->notebook;
#line 1028 "../src/DynamicNotebook.vala"
				_tmp6_ = self->priv->notebook;
#line 1028 "../src/DynamicNotebook.vala"
				_tmp7_ = gtk_notebook_get_nth_page (_tmp6_, i);
#line 1028 "../src/DynamicNotebook.vala"
				_tmp8_ = gtk_notebook_get_tab_label (_tmp5_, _tmp7_);
#line 1028 "../src/DynamicNotebook.vala"
				_tmp9_ = tab_get_pinned (IS_TAB (_tmp8_) ? ((Tab*) _tmp8_) : NULL);
#line 1028 "../src/DynamicNotebook.vala"
				_tmp10_ = _tmp9_;
#line 1028 "../src/DynamicNotebook.vala"
				if (_tmp10_) {
#line 4830 "DynamicNotebook.c"
					gint _tmp11_;
#line 1029 "../src/DynamicNotebook.vala"
					_tmp11_ = pinned_tabs;
#line 1029 "../src/DynamicNotebook.vala"
					pinned_tabs = _tmp11_ + 1;
#line 4836 "DynamicNotebook.c"
				} else {
					gint _tmp12_;
#line 1031 "../src/DynamicNotebook.vala"
					_tmp12_ = unpinned_tabs;
#line 1031 "../src/DynamicNotebook.vala"
					unpinned_tabs = _tmp12_ + 1;
#line 4843 "DynamicNotebook.c"
				}
			}
		}
	}
#line 1035 "../src/DynamicNotebook.vala"
	if (unpinned_tabs == 0) {
#line 1036 "../src/DynamicNotebook.vala"
		unpinned_tabs = 1;
#line 4852 "DynamicNotebook.c"
	}
#line 1039 "../src/DynamicNotebook.vala"
	offset = 130;
#line 1040 "../src/DynamicNotebook.vala"
	self->priv->tab_width = ((gtk_widget_get_allocated_width ((GtkWidget*) self) - offset) - (pinned_tabs * DYNAMIC_NOTEBOOK_TAB_WIDTH_PINNED)) / unpinned_tabs;
#line 1041 "../src/DynamicNotebook.vala"
	if (self->priv->tab_width > DYNAMIC_NOTEBOOK_MAX_TAB_WIDTH) {
#line 1042 "../src/DynamicNotebook.vala"
		self->priv->tab_width = DYNAMIC_NOTEBOOK_MAX_TAB_WIDTH;
#line 4862 "DynamicNotebook.c"
	}
#line 1044 "../src/DynamicNotebook.vala"
	if (self->priv->tab_width < 0) {
#line 1045 "../src/DynamicNotebook.vala"
		self->priv->tab_width = 0;
#line 4868 "DynamicNotebook.c"
	}
	{
		gint i = 0;
#line 1047 "../src/DynamicNotebook.vala"
		i = 0;
#line 4874 "DynamicNotebook.c"
		{
			gboolean _tmp13_ = FALSE;
#line 1047 "../src/DynamicNotebook.vala"
			_tmp13_ = TRUE;
#line 1047 "../src/DynamicNotebook.vala"
			while (TRUE) {
#line 4881 "DynamicNotebook.c"
				GtkNotebook* _tmp15_;
				GtkNotebook* _tmp16_;
				GtkNotebook* _tmp17_;
				GtkWidget* _tmp18_;
				GtkWidget* _tmp19_;
				GtkNotebook* _tmp20_;
				GtkNotebook* _tmp21_;
				GtkWidget* _tmp22_;
				GtkWidget* _tmp23_;
				gboolean _tmp24_;
				gboolean _tmp25_;
#line 1047 "../src/DynamicNotebook.vala"
				if (!_tmp13_) {
#line 4895 "DynamicNotebook.c"
					gint _tmp14_;
#line 1047 "../src/DynamicNotebook.vala"
					_tmp14_ = i;
#line 1047 "../src/DynamicNotebook.vala"
					i = _tmp14_ + 1;
#line 4901 "DynamicNotebook.c"
				}
#line 1047 "../src/DynamicNotebook.vala"
				_tmp13_ = FALSE;
#line 1047 "../src/DynamicNotebook.vala"
				_tmp15_ = self->priv->notebook;
#line 1047 "../src/DynamicNotebook.vala"
				if (!(i < gtk_notebook_get_n_pages (_tmp15_))) {
#line 1047 "../src/DynamicNotebook.vala"
					break;
#line 4911 "DynamicNotebook.c"
				}
#line 1048 "../src/DynamicNotebook.vala"
				_tmp16_ = self->priv->notebook;
#line 1048 "../src/DynamicNotebook.vala"
				_tmp17_ = self->priv->notebook;
#line 1048 "../src/DynamicNotebook.vala"
				_tmp18_ = gtk_notebook_get_nth_page (_tmp17_, i);
#line 1048 "../src/DynamicNotebook.vala"
				_tmp19_ = gtk_notebook_get_tab_label (_tmp16_, _tmp18_);
#line 1048 "../src/DynamicNotebook.vala"
				g_object_set (_tmp19_, "width-request", self->priv->tab_width, NULL);
#line 1050 "../src/DynamicNotebook.vala"
				_tmp20_ = self->priv->notebook;
#line 1050 "../src/DynamicNotebook.vala"
				_tmp21_ = self->priv->notebook;
#line 1050 "../src/DynamicNotebook.vala"
				_tmp22_ = gtk_notebook_get_nth_page (_tmp21_, i);
#line 1050 "../src/DynamicNotebook.vala"
				_tmp23_ = gtk_notebook_get_tab_label (_tmp20_, _tmp22_);
#line 1050 "../src/DynamicNotebook.vala"
				_tmp24_ = tab_get_pinned (IS_TAB (_tmp23_) ? ((Tab*) _tmp23_) : NULL);
#line 1050 "../src/DynamicNotebook.vala"
				_tmp25_ = _tmp24_;
#line 1050 "../src/DynamicNotebook.vala"
				if (_tmp25_) {
#line 4937 "DynamicNotebook.c"
					GtkNotebook* _tmp26_;
					GtkNotebook* _tmp27_;
					GtkWidget* _tmp28_;
					GtkWidget* _tmp29_;
#line 1051 "../src/DynamicNotebook.vala"
					_tmp26_ = self->priv->notebook;
#line 1051 "../src/DynamicNotebook.vala"
					_tmp27_ = self->priv->notebook;
#line 1051 "../src/DynamicNotebook.vala"
					_tmp28_ = gtk_notebook_get_nth_page (_tmp27_, i);
#line 1051 "../src/DynamicNotebook.vala"
					_tmp29_ = gtk_notebook_get_tab_label (_tmp26_, _tmp28_);
#line 1051 "../src/DynamicNotebook.vala"
					g_object_set (_tmp29_, "width-request", DYNAMIC_NOTEBOOK_TAB_WIDTH_PINNED, NULL);
#line 4952 "DynamicNotebook.c"
				}
			}
		}
	}
}

static void
dynamic_notebook_restore_last_tab (DynamicNotebook* self)
{
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_;
	gboolean _tmp2_;
	ClosedTabsEntry restored = {0};
	ClosedTabs* _tmp6_;
	ClosedTabsEntry _tmp7_ = {0};
	GtkButton* _tmp8_;
	ClosedTabs* _tmp9_;
	gboolean _tmp10_;
	gboolean _tmp11_;
	GtkMenuItem* _tmp12_;
	ClosedTabs* _tmp13_;
	gboolean _tmp14_;
	gboolean _tmp15_;
	ClosedTabsEntry _tmp16_;
	const gchar* _tmp17_;
	ClosedTabsEntry _tmp18_;
	const gchar* _tmp19_;
	ClosedTabsEntry _tmp20_;
	GIcon* _tmp21_;
#line 1058 "../src/DynamicNotebook.vala"
	g_return_if_fail (self != NULL);
#line 1059 "../src/DynamicNotebook.vala"
	_tmp1_ = dynamic_notebook_get_allow_restoring (self);
#line 1059 "../src/DynamicNotebook.vala"
	_tmp2_ = _tmp1_;
#line 1059 "../src/DynamicNotebook.vala"
	if (!_tmp2_) {
#line 1059 "../src/DynamicNotebook.vala"
		_tmp0_ = TRUE;
#line 4992 "DynamicNotebook.c"
	} else {
		ClosedTabs* _tmp3_;
		gboolean _tmp4_;
		gboolean _tmp5_;
#line 1059 "../src/DynamicNotebook.vala"
		_tmp3_ = self->priv->closed_tabs;
#line 1059 "../src/DynamicNotebook.vala"
		_tmp4_ = closed_tabs_get_empty (_tmp3_);
#line 1059 "../src/DynamicNotebook.vala"
		_tmp5_ = _tmp4_;
#line 1059 "../src/DynamicNotebook.vala"
		_tmp0_ = _tmp5_;
#line 5005 "DynamicNotebook.c"
	}
#line 1059 "../src/DynamicNotebook.vala"
	if (_tmp0_) {
#line 1060 "../src/DynamicNotebook.vala"
		return;
#line 5011 "DynamicNotebook.c"
	}
#line 1062 "../src/DynamicNotebook.vala"
	_tmp6_ = self->priv->closed_tabs;
#line 1062 "../src/DynamicNotebook.vala"
	closed_tabs_pop (_tmp6_, &_tmp7_);
#line 1062 "../src/DynamicNotebook.vala"
	restored = _tmp7_;
#line 1063 "../src/DynamicNotebook.vala"
	_tmp8_ = self->priv->restore_button;
#line 1063 "../src/DynamicNotebook.vala"
	_tmp9_ = self->priv->closed_tabs;
#line 1063 "../src/DynamicNotebook.vala"
	_tmp10_ = closed_tabs_get_empty (_tmp9_);
#line 1063 "../src/DynamicNotebook.vala"
	_tmp11_ = _tmp10_;
#line 1063 "../src/DynamicNotebook.vala"
	gtk_widget_set_sensitive ((GtkWidget*) _tmp8_, !_tmp11_);
#line 1064 "../src/DynamicNotebook.vala"
	_tmp12_ = self->priv->restore_tab_m;
#line 1064 "../src/DynamicNotebook.vala"
	_tmp13_ = self->priv->closed_tabs;
#line 1064 "../src/DynamicNotebook.vala"
	_tmp14_ = closed_tabs_get_empty (_tmp13_);
#line 1064 "../src/DynamicNotebook.vala"
	_tmp15_ = _tmp14_;
#line 1064 "../src/DynamicNotebook.vala"
	gtk_widget_set_sensitive ((GtkWidget*) _tmp12_, !_tmp15_);
#line 1065 "../src/DynamicNotebook.vala"
	_tmp16_ = restored;
#line 1065 "../src/DynamicNotebook.vala"
	_tmp17_ = _tmp16_.label;
#line 1065 "../src/DynamicNotebook.vala"
	_tmp18_ = restored;
#line 1065 "../src/DynamicNotebook.vala"
	_tmp19_ = _tmp18_.restore_data;
#line 1065 "../src/DynamicNotebook.vala"
	_tmp20_ = restored;
#line 1065 "../src/DynamicNotebook.vala"
	_tmp21_ = _tmp20_.icon;
#line 1065 "../src/DynamicNotebook.vala"
	g_signal_emit (self, dynamic_notebook_signals[DYNAMIC_NOTEBOOK_TAB_RESTORED_SIGNAL], 0, _tmp17_, _tmp19_, _tmp21_);
#line 1058 "../src/DynamicNotebook.vala"
	closed_tabs_entry_destroy (&restored);
#line 5055 "DynamicNotebook.c"
}

static void
dynamic_notebook_switch_pin_tab (DynamicNotebook* self,
                                 Tab* tab)
{
	gboolean _tmp0_;
	gboolean _tmp1_;
#line 1068 "../src/DynamicNotebook.vala"
	g_return_if_fail (self != NULL);
#line 1068 "../src/DynamicNotebook.vala"
	g_return_if_fail (tab != NULL);
#line 1069 "../src/DynamicNotebook.vala"
	_tmp0_ = dynamic_notebook_get_allow_pinning (self);
#line 1069 "../src/DynamicNotebook.vala"
	_tmp1_ = _tmp0_;
#line 1069 "../src/DynamicNotebook.vala"
	if (!_tmp1_) {
#line 1070 "../src/DynamicNotebook.vala"
		return;
#line 5076 "DynamicNotebook.c"
	}
#line 1073 "../src/DynamicNotebook.vala"
	dynamic_notebook_recalc_order (self);
#line 1074 "../src/DynamicNotebook.vala"
	dynamic_notebook_recalc_size (self);
#line 5082 "DynamicNotebook.c"
}

void
dynamic_notebook_remove_tab (DynamicNotebook* self,
                             Tab* tab)
{
	gint pos = 0;
#line 1077 "../src/DynamicNotebook.vala"
	g_return_if_fail (self != NULL);
#line 1077 "../src/DynamicNotebook.vala"
	g_return_if_fail (tab != NULL);
#line 1078 "../src/DynamicNotebook.vala"
	pos = dynamic_notebook_get_tab_position (self, tab);
#line 1080 "../src/DynamicNotebook.vala"
	if (pos != -1) {
#line 5098 "DynamicNotebook.c"
		GtkNotebook* _tmp0_;
#line 1081 "../src/DynamicNotebook.vala"
		_tmp0_ = self->priv->notebook;
#line 1081 "../src/DynamicNotebook.vala"
		gtk_notebook_remove_page (_tmp0_, pos);
#line 5104 "DynamicNotebook.c"
	}
}

void
dynamic_notebook_next_page (DynamicNotebook* self)
{
	gint _tmp0_ = 0;
	GtkNotebook* _tmp1_;
	gint _tmp2_;
	gint _tmp3_;
	GtkNotebook* _tmp4_;
	GtkNotebook* _tmp9_;
#line 1084 "../src/DynamicNotebook.vala"
	g_return_if_fail (self != NULL);
#line 1085 "../src/DynamicNotebook.vala"
	_tmp1_ = self->priv->notebook;
#line 1085 "../src/DynamicNotebook.vala"
	g_object_get (_tmp1_, "page", &_tmp2_, NULL);
#line 1085 "../src/DynamicNotebook.vala"
	_tmp3_ = _tmp2_;
#line 1085 "../src/DynamicNotebook.vala"
	_tmp4_ = self->priv->notebook;
#line 1085 "../src/DynamicNotebook.vala"
	if ((_tmp3_ + 1) >= gtk_notebook_get_n_pages (_tmp4_)) {
#line 5129 "DynamicNotebook.c"
		GtkNotebook* _tmp5_;
#line 1085 "../src/DynamicNotebook.vala"
		_tmp5_ = self->priv->notebook;
#line 1085 "../src/DynamicNotebook.vala"
		g_object_set (_tmp5_, "page", 0, NULL);
#line 1085 "../src/DynamicNotebook.vala"
		_tmp0_ = 0;
#line 5137 "DynamicNotebook.c"
	} else {
		GtkNotebook* _tmp6_;
		gint _tmp7_;
		gint _tmp8_;
#line 1085 "../src/DynamicNotebook.vala"
		_tmp6_ = self->priv->notebook;
#line 1085 "../src/DynamicNotebook.vala"
		g_object_get (_tmp6_, "page", &_tmp7_, NULL);
#line 1085 "../src/DynamicNotebook.vala"
		_tmp8_ = _tmp7_;
#line 1085 "../src/DynamicNotebook.vala"
		_tmp0_ = _tmp8_ + 1;
#line 5150 "DynamicNotebook.c"
	}
#line 1085 "../src/DynamicNotebook.vala"
	_tmp9_ = self->priv->notebook;
#line 1085 "../src/DynamicNotebook.vala"
	g_object_set (_tmp9_, "page", _tmp0_, NULL);
#line 5156 "DynamicNotebook.c"
}

void
dynamic_notebook_previous_page (DynamicNotebook* self)
{
	gint _tmp0_ = 0;
	GtkNotebook* _tmp1_;
	gint _tmp2_;
	gint _tmp3_;
	GtkNotebook* _tmp9_;
#line 1088 "../src/DynamicNotebook.vala"
	g_return_if_fail (self != NULL);
#line 1089 "../src/DynamicNotebook.vala"
	_tmp1_ = self->priv->notebook;
#line 1089 "../src/DynamicNotebook.vala"
	g_object_get (_tmp1_, "page", &_tmp2_, NULL);
#line 1089 "../src/DynamicNotebook.vala"
	_tmp3_ = _tmp2_;
#line 1089 "../src/DynamicNotebook.vala"
	if ((_tmp3_ - 1) < 0) {
#line 5177 "DynamicNotebook.c"
		GtkNotebook* _tmp4_;
		GtkNotebook* _tmp5_;
#line 1090 "../src/DynamicNotebook.vala"
		_tmp4_ = self->priv->notebook;
#line 1090 "../src/DynamicNotebook.vala"
		_tmp5_ = self->priv->notebook;
#line 1090 "../src/DynamicNotebook.vala"
		g_object_set (_tmp4_, "page", gtk_notebook_get_n_pages (_tmp5_) - 1, NULL);
#line 1090 "../src/DynamicNotebook.vala"
		_tmp0_ = gtk_notebook_get_n_pages (_tmp5_) - 1;
#line 5188 "DynamicNotebook.c"
	} else {
		GtkNotebook* _tmp6_;
		gint _tmp7_;
		gint _tmp8_;
#line 1090 "../src/DynamicNotebook.vala"
		_tmp6_ = self->priv->notebook;
#line 1090 "../src/DynamicNotebook.vala"
		g_object_get (_tmp6_, "page", &_tmp7_, NULL);
#line 1090 "../src/DynamicNotebook.vala"
		_tmp8_ = _tmp7_;
#line 1090 "../src/DynamicNotebook.vala"
		_tmp0_ = _tmp8_ - 1;
#line 5201 "DynamicNotebook.c"
	}
#line 1089 "../src/DynamicNotebook.vala"
	_tmp9_ = self->priv->notebook;
#line 1089 "../src/DynamicNotebook.vala"
	g_object_set (_tmp9_, "page", _tmp0_, NULL);
#line 5207 "DynamicNotebook.c"
}

static void
dynamic_notebook_real_show (GtkWidget* base)
{
	DynamicNotebook * self;
	GtkNotebook* _tmp0_;
#line 1093 "../src/DynamicNotebook.vala"
	self = (DynamicNotebook*) base;
#line 1094 "../src/DynamicNotebook.vala"
	GTK_WIDGET_CLASS (dynamic_notebook_parent_class)->show ((GtkWidget*) G_TYPE_CHECK_INSTANCE_CAST (self, gtk_event_box_get_type (), GtkEventBox));
#line 1095 "../src/DynamicNotebook.vala"
	_tmp0_ = self->priv->notebook;
#line 1095 "../src/DynamicNotebook.vala"
	gtk_widget_show ((GtkWidget*) _tmp0_);
#line 5223 "DynamicNotebook.c"
}

GList*
dynamic_notebook_get_children (DynamicNotebook* self)
{
	GList* list = NULL;
	GtkNotebook* _tmp0_;
	GList* _tmp1_;
	GList* result;
#line 1098 "../src/DynamicNotebook.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 1099 "../src/DynamicNotebook.vala"
	list = NULL;
#line 1101 "../src/DynamicNotebook.vala"
	_tmp0_ = self->priv->notebook;
#line 1101 "../src/DynamicNotebook.vala"
	_tmp1_ = gtk_container_get_children ((GtkContainer*) _tmp0_);
#line 5241 "DynamicNotebook.c"
	{
		GList* child_collection = NULL;
		GList* child_it = NULL;
#line 1101 "../src/DynamicNotebook.vala"
		child_collection = _tmp1_;
#line 1101 "../src/DynamicNotebook.vala"
		for (child_it = child_collection; child_it != NULL; child_it = child_it->next) {
#line 5249 "DynamicNotebook.c"
			GtkWidget* child = NULL;
#line 1101 "../src/DynamicNotebook.vala"
			child = (GtkWidget*) child_it->data;
#line 5253 "DynamicNotebook.c"
			{
				GtkContainer* cont = NULL;
				GtkWidget* _tmp2_;
				GtkContainer* _tmp3_;
				GtkContainer* _tmp4_;
#line 1102 "../src/DynamicNotebook.vala"
				_tmp2_ = child;
#line 1102 "../src/DynamicNotebook.vala"
				_tmp3_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_TYPE (_tmp2_, gtk_container_get_type ()) ? ((GtkContainer*) _tmp2_) : NULL);
#line 1102 "../src/DynamicNotebook.vala"
				cont = _tmp3_;
#line 1103 "../src/DynamicNotebook.vala"
				_tmp4_ = cont;
#line 1103 "../src/DynamicNotebook.vala"
				if (_tmp4_ != NULL) {
#line 5269 "DynamicNotebook.c"
					GtkContainer* _tmp5_;
					GList* _tmp6_;
					GList* _tmp7_;
					gconstpointer _tmp8_;
					GtkWidget* _tmp9_;
#line 1104 "../src/DynamicNotebook.vala"
					_tmp5_ = cont;
#line 1104 "../src/DynamicNotebook.vala"
					_tmp6_ = gtk_container_get_children (_tmp5_);
#line 1104 "../src/DynamicNotebook.vala"
					_tmp7_ = _tmp6_;
#line 1104 "../src/DynamicNotebook.vala"
					_tmp8_ = g_list_nth_data (_tmp7_, (guint) 0);
#line 1104 "../src/DynamicNotebook.vala"
					_tmp9_ = _g_object_ref0 ((GtkWidget*) _tmp8_);
#line 1104 "../src/DynamicNotebook.vala"
					list = g_list_append (list, _tmp9_);
#line 1104 "../src/DynamicNotebook.vala"
					(_tmp7_ == NULL) ? NULL : (_tmp7_ = (g_list_free (_tmp7_), NULL));
#line 5289 "DynamicNotebook.c"
				}
#line 1101 "../src/DynamicNotebook.vala"
				_g_object_unref0 (cont);
#line 5293 "DynamicNotebook.c"
			}
		}
#line 1101 "../src/DynamicNotebook.vala"
		(child_collection == NULL) ? NULL : (child_collection = (g_list_free (child_collection), NULL));
#line 5298 "DynamicNotebook.c"
	}
#line 1108 "../src/DynamicNotebook.vala"
	result = list;
#line 1108 "../src/DynamicNotebook.vala"
	return result;
#line 5304 "DynamicNotebook.c"
}

gint
dynamic_notebook_get_tab_position (DynamicNotebook* self,
                                   Tab* tab)
{
	GtkNotebook* _tmp0_;
	TabPageContainer* _tmp1_;
	gint result;
#line 1111 "../src/DynamicNotebook.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 1111 "../src/DynamicNotebook.vala"
	g_return_val_if_fail (tab != NULL, 0);
#line 1112 "../src/DynamicNotebook.vala"
	_tmp0_ = self->priv->notebook;
#line 1112 "../src/DynamicNotebook.vala"
	_tmp1_ = tab->page_container;
#line 1112 "../src/DynamicNotebook.vala"
	result = gtk_notebook_page_num (_tmp0_, (GtkWidget*) _tmp1_);
#line 1112 "../src/DynamicNotebook.vala"
	return result;
#line 5326 "DynamicNotebook.c"
}

void
dynamic_notebook_set_tab_position (DynamicNotebook* self,
                                   Tab* tab,
                                   gint position)
{
	GtkNotebook* _tmp0_;
	TabPageContainer* _tmp1_;
#line 1115 "../src/DynamicNotebook.vala"
	g_return_if_fail (self != NULL);
#line 1115 "../src/DynamicNotebook.vala"
	g_return_if_fail (tab != NULL);
#line 1116 "../src/DynamicNotebook.vala"
	_tmp0_ = self->priv->notebook;
#line 1116 "../src/DynamicNotebook.vala"
	_tmp1_ = tab->page_container;
#line 1116 "../src/DynamicNotebook.vala"
	gtk_notebook_reorder_child (_tmp0_, (GtkWidget*) _tmp1_, position);
#line 1117 "../src/DynamicNotebook.vala"
	g_signal_emit (self, dynamic_notebook_signals[DYNAMIC_NOTEBOOK_TAB_REORDERED_SIGNAL], 0, tab, position);
#line 1118 "../src/DynamicNotebook.vala"
	dynamic_notebook_recalc_order (self);
#line 5350 "DynamicNotebook.c"
}

Tab*
dynamic_notebook_get_tab_by_index (DynamicNotebook* self,
                                   gint index)
{
	GtkNotebook* _tmp0_;
	GtkNotebook* _tmp1_;
	GtkWidget* _tmp2_;
	GtkWidget* _tmp3_;
	Tab* _tmp4_;
	Tab* result;
#line 1121 "../src/DynamicNotebook.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 1122 "../src/DynamicNotebook.vala"
	_tmp0_ = self->priv->notebook;
#line 1122 "../src/DynamicNotebook.vala"
	_tmp1_ = self->priv->notebook;
#line 1122 "../src/DynamicNotebook.vala"
	_tmp2_ = gtk_notebook_get_nth_page (_tmp1_, index);
#line 1122 "../src/DynamicNotebook.vala"
	_tmp3_ = gtk_notebook_get_tab_label (_tmp0_, _tmp2_);
#line 1122 "../src/DynamicNotebook.vala"
	_tmp4_ = _g_object_ref0 (IS_TAB (_tmp3_) ? ((Tab*) _tmp3_) : NULL);
#line 1122 "../src/DynamicNotebook.vala"
	result = _tmp4_;
#line 1122 "../src/DynamicNotebook.vala"
	return result;
#line 5379 "DynamicNotebook.c"
}

Tab*
dynamic_notebook_get_tab_by_widget (DynamicNotebook* self,
                                    GtkWidget* widget)
{
	GtkNotebook* _tmp0_;
	GtkContainer* _tmp1_;
	GtkWidget* _tmp2_;
	Tab* _tmp3_;
	Tab* result;
#line 1125 "../src/DynamicNotebook.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 1125 "../src/DynamicNotebook.vala"
	g_return_val_if_fail (widget != NULL, NULL);
#line 1126 "../src/DynamicNotebook.vala"
	_tmp0_ = self->priv->notebook;
#line 1126 "../src/DynamicNotebook.vala"
	_tmp1_ = gtk_widget_get_parent (widget);
#line 1126 "../src/DynamicNotebook.vala"
	_tmp2_ = gtk_notebook_get_tab_label (_tmp0_, (GtkWidget*) _tmp1_);
#line 1126 "../src/DynamicNotebook.vala"
	_tmp3_ = _g_object_ref0 (IS_TAB (_tmp2_) ? ((Tab*) _tmp2_) : NULL);
#line 1126 "../src/DynamicNotebook.vala"
	result = _tmp3_;
#line 1126 "../src/DynamicNotebook.vala"
	return result;
#line 5407 "DynamicNotebook.c"
}

GtkWidget*
dynamic_notebook_get_nth_page (DynamicNotebook* self,
                               gint index)
{
	GtkNotebook* _tmp0_;
	GtkWidget* _tmp1_;
	GtkWidget* _tmp2_;
	GtkWidget* result;
#line 1129 "../src/DynamicNotebook.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 1130 "../src/DynamicNotebook.vala"
	_tmp0_ = self->priv->notebook;
#line 1130 "../src/DynamicNotebook.vala"
	_tmp1_ = gtk_notebook_get_nth_page (_tmp0_, index);
#line 1130 "../src/DynamicNotebook.vala"
	_tmp2_ = _g_object_ref0 (_tmp1_);
#line 1130 "../src/DynamicNotebook.vala"
	result = _tmp2_;
#line 1130 "../src/DynamicNotebook.vala"
	return result;
#line 5430 "DynamicNotebook.c"
}

guint
dynamic_notebook_insert_tab (DynamicNotebook* self,
                             Tab* tab,
                             gint index)
{
	GList* _tmp0_;
	GList* _tmp1_;
	gint i = 0;
	GtkNotebook* _tmp7_;
	TabPageContainer* _tmp8_;
	gboolean _tmp9_;
	gboolean _tmp10_;
	GtkNotebook* _tmp11_;
	TabPageContainer* _tmp12_;
	gboolean _tmp13_;
	gboolean _tmp14_;
	GtkMenuItem* _tmp15_;
	gboolean _tmp16_;
	gboolean _tmp17_;
	GtkMenuItem* _tmp18_;
	gboolean _tmp19_;
	gboolean _tmp20_;
	GtkMenuItem* _tmp21_;
	gboolean _tmp22_;
	gboolean _tmp23_;
	gboolean _tmp24_;
	gboolean _tmp25_;
	gboolean _tmp26_;
	gboolean _tmp27_;
	guint result;
#line 1133 "../src/DynamicNotebook.vala"
	g_return_val_if_fail (self != NULL, 0U);
#line 1133 "../src/DynamicNotebook.vala"
	g_return_val_if_fail (tab != NULL, 0U);
#line 1134 "../src/DynamicNotebook.vala"
	_tmp0_ = dynamic_notebook_get_tabs (self);
#line 1134 "../src/DynamicNotebook.vala"
	_tmp1_ = _tmp0_;
#line 1134 "../src/DynamicNotebook.vala"
	g_return_val_if_fail (g_list_index (_tmp1_, tab) < 0, 0);
#line 1136 "../src/DynamicNotebook.vala"
	i = 0;
#line 1137 "../src/DynamicNotebook.vala"
	if (index <= -1) {
#line 5477 "DynamicNotebook.c"
		GtkNotebook* _tmp2_;
		TabPageContainer* _tmp3_;
		GtkNotebook* _tmp4_;
#line 1138 "../src/DynamicNotebook.vala"
		_tmp2_ = self->priv->notebook;
#line 1138 "../src/DynamicNotebook.vala"
		_tmp3_ = tab->page_container;
#line 1138 "../src/DynamicNotebook.vala"
		_tmp4_ = self->priv->notebook;
#line 1138 "../src/DynamicNotebook.vala"
		i = gtk_notebook_insert_page (_tmp2_, (GtkWidget*) _tmp3_, (GtkWidget*) tab, gtk_notebook_get_n_pages (_tmp4_));
#line 5489 "DynamicNotebook.c"
	} else {
		GtkNotebook* _tmp5_;
		TabPageContainer* _tmp6_;
#line 1140 "../src/DynamicNotebook.vala"
		_tmp5_ = self->priv->notebook;
#line 1140 "../src/DynamicNotebook.vala"
		_tmp6_ = tab->page_container;
#line 1140 "../src/DynamicNotebook.vala"
		i = gtk_notebook_insert_page (_tmp5_, (GtkWidget*) _tmp6_, (GtkWidget*) tab, index);
#line 5499 "DynamicNotebook.c"
	}
#line 1142 "../src/DynamicNotebook.vala"
	_tmp7_ = self->priv->notebook;
#line 1142 "../src/DynamicNotebook.vala"
	_tmp8_ = tab->page_container;
#line 1142 "../src/DynamicNotebook.vala"
	_tmp9_ = dynamic_notebook_get_allow_drag (self);
#line 1142 "../src/DynamicNotebook.vala"
	_tmp10_ = _tmp9_;
#line 1142 "../src/DynamicNotebook.vala"
	gtk_notebook_set_tab_reorderable (_tmp7_, (GtkWidget*) _tmp8_, _tmp10_);
#line 1143 "../src/DynamicNotebook.vala"
	_tmp11_ = self->priv->notebook;
#line 1143 "../src/DynamicNotebook.vala"
	_tmp12_ = tab->page_container;
#line 1143 "../src/DynamicNotebook.vala"
	_tmp13_ = dynamic_notebook_get_allow_new_window (self);
#line 1143 "../src/DynamicNotebook.vala"
	_tmp14_ = _tmp13_;
#line 1143 "../src/DynamicNotebook.vala"
	gtk_notebook_set_tab_detachable (_tmp11_, (GtkWidget*) _tmp12_, _tmp14_);
#line 1145 "../src/DynamicNotebook.vala"
	_tmp15_ = tab->duplicate_m;
#line 1145 "../src/DynamicNotebook.vala"
	_tmp16_ = dynamic_notebook_get_allow_duplication (self);
#line 1145 "../src/DynamicNotebook.vala"
	_tmp17_ = _tmp16_;
#line 1145 "../src/DynamicNotebook.vala"
	gtk_widget_set_visible ((GtkWidget*) _tmp15_, _tmp17_);
#line 1146 "../src/DynamicNotebook.vala"
	_tmp18_ = tab->new_window_m;
#line 1146 "../src/DynamicNotebook.vala"
	_tmp19_ = dynamic_notebook_get_allow_new_window (self);
#line 1146 "../src/DynamicNotebook.vala"
	_tmp20_ = _tmp19_;
#line 1146 "../src/DynamicNotebook.vala"
	gtk_widget_set_visible ((GtkWidget*) _tmp18_, _tmp20_);
#line 1147 "../src/DynamicNotebook.vala"
	_tmp21_ = tab->pin_m;
#line 1147 "../src/DynamicNotebook.vala"
	_tmp22_ = dynamic_notebook_get_allow_pinning (self);
#line 1147 "../src/DynamicNotebook.vala"
	_tmp23_ = _tmp22_;
#line 1147 "../src/DynamicNotebook.vala"
	gtk_widget_set_visible ((GtkWidget*) _tmp21_, _tmp23_);
#line 1148 "../src/DynamicNotebook.vala"
	_tmp24_ = dynamic_notebook_get_allow_pinning (self);
#line 1148 "../src/DynamicNotebook.vala"
	_tmp25_ = _tmp24_;
#line 1148 "../src/DynamicNotebook.vala"
	tab_set_pinnable (tab, _tmp25_);
#line 1149 "../src/DynamicNotebook.vala"
	tab_set_pinned (tab, FALSE);
#line 1151 "../src/DynamicNotebook.vala"
	g_object_set ((GtkWidget*) tab, "width-request", self->priv->tab_width, NULL);
#line 1152 "../src/DynamicNotebook.vala"
	dynamic_notebook_recalc_size (self);
#line 1153 "../src/DynamicNotebook.vala"
	dynamic_notebook_recalc_order (self);
#line 1155 "../src/DynamicNotebook.vala"
	_tmp26_ = dynamic_notebook_get_tabs_closable (self);
#line 1155 "../src/DynamicNotebook.vala"
	_tmp27_ = _tmp26_;
#line 1155 "../src/DynamicNotebook.vala"
	if (!_tmp27_) {
#line 1156 "../src/DynamicNotebook.vala"
		tab_set_closable (tab, FALSE);
#line 5567 "DynamicNotebook.c"
	}
#line 1158 "../src/DynamicNotebook.vala"
	result = (guint) i;
#line 1158 "../src/DynamicNotebook.vala"
	return result;
#line 5573 "DynamicNotebook.c"
}

static void
_dynamic_notebook_on_tab_closed_tab_closed (Tab* _sender,
                                            gpointer self)
{
#line 1162 "../src/DynamicNotebook.vala"
	dynamic_notebook_on_tab_closed ((DynamicNotebook*) self, _sender);
#line 5582 "DynamicNotebook.c"
}

static void
_dynamic_notebook_on_close_others_tab_close_others (Tab* _sender,
                                                    gpointer self)
{
#line 1163 "../src/DynamicNotebook.vala"
	dynamic_notebook_on_close_others ((DynamicNotebook*) self, _sender);
#line 5591 "DynamicNotebook.c"
}

static void
_dynamic_notebook_on_new_window_tab_new_window (Tab* _sender,
                                                gpointer self)
{
#line 1164 "../src/DynamicNotebook.vala"
	dynamic_notebook_on_new_window ((DynamicNotebook*) self, _sender);
#line 5600 "DynamicNotebook.c"
}

static void
_dynamic_notebook_on_duplicate_tab_duplicate (Tab* _sender,
                                              gpointer self)
{
#line 1165 "../src/DynamicNotebook.vala"
	dynamic_notebook_on_duplicate ((DynamicNotebook*) self, _sender);
#line 5609 "DynamicNotebook.c"
}

static void
_dynamic_notebook_on_pin_switch_tab_pin_switch (Tab* _sender,
                                                gpointer self)
{
#line 1166 "../src/DynamicNotebook.vala"
	dynamic_notebook_on_pin_switch ((DynamicNotebook*) self, _sender);
#line 5618 "DynamicNotebook.c"
}

static void
dynamic_notebook_insert_callbacks (DynamicNotebook* self,
                                   Tab* tab)
{
#line 1161 "../src/DynamicNotebook.vala"
	g_return_if_fail (self != NULL);
#line 1161 "../src/DynamicNotebook.vala"
	g_return_if_fail (tab != NULL);
#line 1162 "../src/DynamicNotebook.vala"
	g_signal_connect_object (tab, "closed", (GCallback) _dynamic_notebook_on_tab_closed_tab_closed, self, 0);
#line 1163 "../src/DynamicNotebook.vala"
	g_signal_connect_object (tab, "close-others", (GCallback) _dynamic_notebook_on_close_others_tab_close_others, self, 0);
#line 1164 "../src/DynamicNotebook.vala"
	g_signal_connect_object (tab, "new-window", (GCallback) _dynamic_notebook_on_new_window_tab_new_window, self, 0);
#line 1165 "../src/DynamicNotebook.vala"
	g_signal_connect_object (tab, "duplicate", (GCallback) _dynamic_notebook_on_duplicate_tab_duplicate, self, 0);
#line 1166 "../src/DynamicNotebook.vala"
	g_signal_connect_object (tab, "pin-switch", (GCallback) _dynamic_notebook_on_pin_switch_tab_pin_switch, self, 0);
#line 5639 "DynamicNotebook.c"
}

static void
dynamic_notebook_remove_callbacks (DynamicNotebook* self,
                                   Tab* tab)
{
	guint _tmp0_;
	guint _tmp1_;
	guint _tmp2_;
	guint _tmp3_;
	guint _tmp4_;
#line 1169 "../src/DynamicNotebook.vala"
	g_return_if_fail (self != NULL);
#line 1169 "../src/DynamicNotebook.vala"
	g_return_if_fail (tab != NULL);
#line 1170 "../src/DynamicNotebook.vala"
	g_signal_parse_name ("closed", TYPE_TAB, &_tmp0_, NULL, FALSE);
#line 1170 "../src/DynamicNotebook.vala"
	g_signal_handlers_disconnect_matched (tab, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp0_, 0, NULL, (GCallback) _dynamic_notebook_on_tab_closed_tab_closed, self);
#line 1171 "../src/DynamicNotebook.vala"
	g_signal_parse_name ("close-others", TYPE_TAB, &_tmp1_, NULL, FALSE);
#line 1171 "../src/DynamicNotebook.vala"
	g_signal_handlers_disconnect_matched (tab, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp1_, 0, NULL, (GCallback) _dynamic_notebook_on_close_others_tab_close_others, self);
#line 1172 "../src/DynamicNotebook.vala"
	g_signal_parse_name ("new-window", TYPE_TAB, &_tmp2_, NULL, FALSE);
#line 1172 "../src/DynamicNotebook.vala"
	g_signal_handlers_disconnect_matched (tab, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp2_, 0, NULL, (GCallback) _dynamic_notebook_on_new_window_tab_new_window, self);
#line 1173 "../src/DynamicNotebook.vala"
	g_signal_parse_name ("duplicate", TYPE_TAB, &_tmp3_, NULL, FALSE);
#line 1173 "../src/DynamicNotebook.vala"
	g_signal_handlers_disconnect_matched (tab, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp3_, 0, NULL, (GCallback) _dynamic_notebook_on_duplicate_tab_duplicate, self);
#line 1174 "../src/DynamicNotebook.vala"
	g_signal_parse_name ("pin-switch", TYPE_TAB, &_tmp4_, NULL, FALSE);
#line 1174 "../src/DynamicNotebook.vala"
	g_signal_handlers_disconnect_matched (tab, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp4_, 0, NULL, (GCallback) _dynamic_notebook_on_pin_switch_tab_pin_switch, self);
#line 5675 "DynamicNotebook.c"
}

static void
dynamic_notebook_on_tab_closed (DynamicNotebook* self,
                                Tab* tab)
{
	gint pos = 0;
	gboolean _tmp1_ = FALSE;
	gboolean _tmp7_ = FALSE;
	const gchar* _tmp8_;
	const gchar* _tmp9_;
#line 1177 "../src/DynamicNotebook.vala"
	g_return_if_fail (self != NULL);
#line 1177 "../src/DynamicNotebook.vala"
	g_return_if_fail (tab != NULL);
#line 1178 "../src/DynamicNotebook.vala"
	if (g_signal_has_handler_pending (self, g_signal_lookup ("close-tab-requested", TYPE_DYNAMIC_NOTEBOOK), (GQuark) 0, TRUE)) {
#line 5693 "DynamicNotebook.c"
		gboolean sure = FALSE;
		gboolean _tmp0_ = FALSE;
#line 1179 "../src/DynamicNotebook.vala"
		g_signal_emit (self, dynamic_notebook_signals[DYNAMIC_NOTEBOOK_CLOSE_TAB_REQUESTED_SIGNAL], 0, tab, &_tmp0_);
#line 1179 "../src/DynamicNotebook.vala"
		sure = _tmp0_;
#line 1181 "../src/DynamicNotebook.vala"
		if (!sure) {
#line 1182 "../src/DynamicNotebook.vala"
			return;
#line 5704 "DynamicNotebook.c"
		}
	}
#line 1185 "../src/DynamicNotebook.vala"
	pos = dynamic_notebook_get_tab_position (self, tab);
#line 1187 "../src/DynamicNotebook.vala"
	dynamic_notebook_remove_tab (self, tab);
#line 1189 "../src/DynamicNotebook.vala"
	if (pos != -1) {
#line 5713 "DynamicNotebook.c"
		GtkWidget* _tmp2_;
		GtkWidget* _tmp3_;
		GtkContainer* _tmp4_;
#line 1189 "../src/DynamicNotebook.vala"
		_tmp2_ = tab_get_page (tab);
#line 1189 "../src/DynamicNotebook.vala"
		_tmp3_ = _tmp2_;
#line 1189 "../src/DynamicNotebook.vala"
		_tmp4_ = gtk_widget_get_parent (_tmp3_);
#line 1189 "../src/DynamicNotebook.vala"
		_tmp1_ = _tmp4_ != NULL;
#line 5725 "DynamicNotebook.c"
	} else {
#line 1189 "../src/DynamicNotebook.vala"
		_tmp1_ = FALSE;
#line 5729 "DynamicNotebook.c"
	}
#line 1189 "../src/DynamicNotebook.vala"
	if (_tmp1_) {
#line 5733 "DynamicNotebook.c"
		GtkWidget* _tmp5_;
		GtkWidget* _tmp6_;
#line 1190 "../src/DynamicNotebook.vala"
		_tmp5_ = tab_get_page (tab);
#line 1190 "../src/DynamicNotebook.vala"
		_tmp6_ = _tmp5_;
#line 1190 "../src/DynamicNotebook.vala"
		gtk_widget_unparent (_tmp6_);
#line 5742 "DynamicNotebook.c"
	}
#line 1192 "../src/DynamicNotebook.vala"
	_tmp8_ = tab_get_label (tab);
#line 1192 "../src/DynamicNotebook.vala"
	_tmp9_ = _tmp8_;
#line 1192 "../src/DynamicNotebook.vala"
	if (g_strcmp0 (_tmp9_, "") != 0) {
#line 5750 "DynamicNotebook.c"
		const gchar* _tmp10_;
		const gchar* _tmp11_;
#line 1192 "../src/DynamicNotebook.vala"
		_tmp10_ = tab_get_restore_data (tab);
#line 1192 "../src/DynamicNotebook.vala"
		_tmp11_ = _tmp10_;
#line 1192 "../src/DynamicNotebook.vala"
		_tmp7_ = g_strcmp0 (_tmp11_, "") != 0;
#line 5759 "DynamicNotebook.c"
	} else {
#line 1192 "../src/DynamicNotebook.vala"
		_tmp7_ = FALSE;
#line 5763 "DynamicNotebook.c"
	}
#line 1192 "../src/DynamicNotebook.vala"
	if (_tmp7_) {
#line 5767 "DynamicNotebook.c"
		ClosedTabs* _tmp12_;
		GtkButton* _tmp13_;
		ClosedTabs* _tmp14_;
		gboolean _tmp15_;
		gboolean _tmp16_;
		GtkMenuItem* _tmp17_;
		ClosedTabs* _tmp18_;
		gboolean _tmp19_;
		gboolean _tmp20_;
#line 1193 "../src/DynamicNotebook.vala"
		_tmp12_ = self->priv->closed_tabs;
#line 1193 "../src/DynamicNotebook.vala"
		closed_tabs_push (_tmp12_, tab);
#line 1194 "../src/DynamicNotebook.vala"
		_tmp13_ = self->priv->restore_button;
#line 1194 "../src/DynamicNotebook.vala"
		_tmp14_ = self->priv->closed_tabs;
#line 1194 "../src/DynamicNotebook.vala"
		_tmp15_ = closed_tabs_get_empty (_tmp14_);
#line 1194 "../src/DynamicNotebook.vala"
		_tmp16_ = _tmp15_;
#line 1194 "../src/DynamicNotebook.vala"
		gtk_widget_set_sensitive ((GtkWidget*) _tmp13_, !_tmp16_);
#line 1195 "../src/DynamicNotebook.vala"
		_tmp17_ = self->priv->restore_tab_m;
#line 1195 "../src/DynamicNotebook.vala"
		_tmp18_ = self->priv->closed_tabs;
#line 1195 "../src/DynamicNotebook.vala"
		_tmp19_ = closed_tabs_get_empty (_tmp18_);
#line 1195 "../src/DynamicNotebook.vala"
		_tmp20_ = _tmp19_;
#line 1195 "../src/DynamicNotebook.vala"
		gtk_widget_set_sensitive ((GtkWidget*) _tmp17_, !_tmp20_);
#line 5801 "DynamicNotebook.c"
	}
}

static void
dynamic_notebook_on_close_others (DynamicNotebook* self,
                                  Tab* tab)
{
	gint num = 0;
#line 1199 "../src/DynamicNotebook.vala"
	g_return_if_fail (self != NULL);
#line 1199 "../src/DynamicNotebook.vala"
	g_return_if_fail (tab != NULL);
#line 1200 "../src/DynamicNotebook.vala"
	num = 0;
#line 5816 "DynamicNotebook.c"
	{
		gint j = 0;
#line 1202 "../src/DynamicNotebook.vala"
		j = 0;
#line 5821 "DynamicNotebook.c"
		{
			gboolean _tmp0_ = FALSE;
#line 1202 "../src/DynamicNotebook.vala"
			_tmp0_ = TRUE;
#line 1202 "../src/DynamicNotebook.vala"
			while (TRUE) {
#line 5828 "DynamicNotebook.c"
				GList* _tmp2_;
				GList* _tmp3_;
				GList* _tmp4_;
				GList* _tmp5_;
				gconstpointer _tmp6_;
				gint _tmp13_;
				gint _tmp14_;
#line 1202 "../src/DynamicNotebook.vala"
				if (!_tmp0_) {
#line 5838 "DynamicNotebook.c"
					gint _tmp1_;
#line 1202 "../src/DynamicNotebook.vala"
					_tmp1_ = j;
#line 1202 "../src/DynamicNotebook.vala"
					j = _tmp1_ + 1;
#line 5844 "DynamicNotebook.c"
				}
#line 1202 "../src/DynamicNotebook.vala"
				_tmp0_ = FALSE;
#line 1202 "../src/DynamicNotebook.vala"
				_tmp2_ = dynamic_notebook_get_tabs (self);
#line 1202 "../src/DynamicNotebook.vala"
				_tmp3_ = _tmp2_;
#line 1202 "../src/DynamicNotebook.vala"
				if (!(((guint) j) < g_list_length (_tmp3_))) {
#line 1202 "../src/DynamicNotebook.vala"
					break;
#line 5856 "DynamicNotebook.c"
				}
#line 1203 "../src/DynamicNotebook.vala"
				_tmp4_ = dynamic_notebook_get_tabs (self);
#line 1203 "../src/DynamicNotebook.vala"
				_tmp5_ = _tmp4_;
#line 1203 "../src/DynamicNotebook.vala"
				_tmp6_ = g_list_nth_data (_tmp5_, (guint) j);
#line 1203 "../src/DynamicNotebook.vala"
				if (tab != ((Tab*) _tmp6_)) {
#line 5866 "DynamicNotebook.c"
					GList* _tmp7_;
					GList* _tmp8_;
					gconstpointer _tmp9_;
					gint _tmp10_;
					gint _tmp11_;
					gint _tmp12_;
#line 1204 "../src/DynamicNotebook.vala"
					_tmp7_ = dynamic_notebook_get_tabs (self);
#line 1204 "../src/DynamicNotebook.vala"
					_tmp8_ = _tmp7_;
#line 1204 "../src/DynamicNotebook.vala"
					_tmp9_ = g_list_nth_data (_tmp8_, (guint) j);
#line 1204 "../src/DynamicNotebook.vala"
					g_signal_emit ((Tab*) _tmp9_, tab_signals[TAB_CLOSED_SIGNAL], 0);
#line 1205 "../src/DynamicNotebook.vala"
					_tmp10_ = dynamic_notebook_get_n_tabs (self);
#line 1205 "../src/DynamicNotebook.vala"
					_tmp11_ = _tmp10_;
#line 1205 "../src/DynamicNotebook.vala"
					if (num == _tmp11_) {
#line 1205 "../src/DynamicNotebook.vala"
						break;
#line 5889 "DynamicNotebook.c"
					}
#line 1206 "../src/DynamicNotebook.vala"
					_tmp12_ = j;
#line 1206 "../src/DynamicNotebook.vala"
					j = _tmp12_ - 1;
#line 5895 "DynamicNotebook.c"
				}
#line 1209 "../src/DynamicNotebook.vala"
				_tmp13_ = dynamic_notebook_get_n_tabs (self);
#line 1209 "../src/DynamicNotebook.vala"
				_tmp14_ = _tmp13_;
#line 1209 "../src/DynamicNotebook.vala"
				num = _tmp14_;
#line 5903 "DynamicNotebook.c"
			}
		}
	}
}

static void
dynamic_notebook_on_new_window (DynamicNotebook* self,
                                Tab* tab)
{
	GtkNotebook* _tmp0_;
	TabPageContainer* _tmp1_;
	GtkNotebook* _tmp2_ = NULL;
#line 1213 "../src/DynamicNotebook.vala"
	g_return_if_fail (self != NULL);
#line 1213 "../src/DynamicNotebook.vala"
	g_return_if_fail (tab != NULL);
#line 1214 "../src/DynamicNotebook.vala"
	_tmp0_ = self->priv->notebook;
#line 1214 "../src/DynamicNotebook.vala"
	_tmp1_ = tab->page_container;
#line 1214 "../src/DynamicNotebook.vala"
	g_signal_emit_by_name (_tmp0_, "create-window", (GtkWidget*) _tmp1_, 0, 0, &_tmp2_);
#line 5926 "DynamicNotebook.c"
}

static void
dynamic_notebook_on_duplicate (DynamicNotebook* self,
                               Tab* tab)
{
#line 1217 "../src/DynamicNotebook.vala"
	g_return_if_fail (self != NULL);
#line 1217 "../src/DynamicNotebook.vala"
	g_return_if_fail (tab != NULL);
#line 1218 "../src/DynamicNotebook.vala"
	g_signal_emit (self, dynamic_notebook_signals[DYNAMIC_NOTEBOOK_TAB_DUPLICATED_SIGNAL], 0, tab);
#line 5939 "DynamicNotebook.c"
}

static void
dynamic_notebook_on_pin_switch (DynamicNotebook* self,
                                Tab* tab)
{
#line 1221 "../src/DynamicNotebook.vala"
	g_return_if_fail (self != NULL);
#line 1221 "../src/DynamicNotebook.vala"
	g_return_if_fail (tab != NULL);
#line 1222 "../src/DynamicNotebook.vala"
	dynamic_notebook_switch_pin_tab (self, tab);
#line 5952 "DynamicNotebook.c"
}

static void
dynamic_notebook_update_tabs_visibility (DynamicNotebook* self)
{
#line 1225 "../src/DynamicNotebook.vala"
	g_return_if_fail (self != NULL);
#line 1226 "../src/DynamicNotebook.vala"
	if (self->priv->_tab_bar_behavior == DYNAMIC_NOTEBOOK_TAB_BAR_BEHAVIOR_SINGLE) {
#line 5962 "DynamicNotebook.c"
		GtkNotebook* _tmp0_;
		gint _tmp1_;
		gint _tmp2_;
#line 1227 "../src/DynamicNotebook.vala"
		_tmp0_ = self->priv->notebook;
#line 1227 "../src/DynamicNotebook.vala"
		_tmp1_ = dynamic_notebook_get_n_tabs (self);
#line 1227 "../src/DynamicNotebook.vala"
		_tmp2_ = _tmp1_;
#line 1227 "../src/DynamicNotebook.vala"
		gtk_notebook_set_show_tabs (_tmp0_, _tmp2_ > 1);
#line 5974 "DynamicNotebook.c"
	} else {
#line 1228 "../src/DynamicNotebook.vala"
		if (self->priv->_tab_bar_behavior == DYNAMIC_NOTEBOOK_TAB_BAR_BEHAVIOR_NEVER) {
#line 5978 "DynamicNotebook.c"
			GtkNotebook* _tmp3_;
#line 1229 "../src/DynamicNotebook.vala"
			_tmp3_ = self->priv->notebook;
#line 1229 "../src/DynamicNotebook.vala"
			gtk_notebook_set_show_tabs (_tmp3_, FALSE);
#line 5984 "DynamicNotebook.c"
		} else {
#line 1230 "../src/DynamicNotebook.vala"
			if (self->priv->_tab_bar_behavior == DYNAMIC_NOTEBOOK_TAB_BAR_BEHAVIOR_ALWAYS) {
#line 5988 "DynamicNotebook.c"
				GtkNotebook* _tmp4_;
#line 1231 "../src/DynamicNotebook.vala"
				_tmp4_ = self->priv->notebook;
#line 1231 "../src/DynamicNotebook.vala"
				gtk_notebook_set_show_tabs (_tmp4_, TRUE);
#line 5994 "DynamicNotebook.c"
			}
		}
	}
}

gint
dynamic_notebook_get_n_tabs (DynamicNotebook* self)
{
	gint result;
	GtkNotebook* _tmp0_;
#line 518 "../src/DynamicNotebook.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 518 "../src/DynamicNotebook.vala"
	_tmp0_ = self->priv->notebook;
#line 518 "../src/DynamicNotebook.vala"
	result = gtk_notebook_get_n_pages (_tmp0_);
#line 518 "../src/DynamicNotebook.vala"
	return result;
#line 6013 "DynamicNotebook.c"
}

gboolean
dynamic_notebook_get_show_tabs (DynamicNotebook* self)
{
	gboolean result;
	GtkNotebook* _tmp0_;
	gboolean _tmp1_;
	gboolean _tmp2_;
#line 525 "../src/DynamicNotebook.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 525 "../src/DynamicNotebook.vala"
	_tmp0_ = self->priv->notebook;
#line 525 "../src/DynamicNotebook.vala"
	_tmp1_ = gtk_notebook_get_show_tabs (_tmp0_);
#line 525 "../src/DynamicNotebook.vala"
	_tmp2_ = _tmp1_;
#line 525 "../src/DynamicNotebook.vala"
	result = _tmp2_;
#line 525 "../src/DynamicNotebook.vala"
	return result;
#line 6035 "DynamicNotebook.c"
}

void
dynamic_notebook_set_show_tabs (DynamicNotebook* self,
                                gboolean value)
{
	GtkNotebook* _tmp0_;
#line 526 "../src/DynamicNotebook.vala"
	g_return_if_fail (self != NULL);
#line 526 "../src/DynamicNotebook.vala"
	_tmp0_ = self->priv->notebook;
#line 526 "../src/DynamicNotebook.vala"
	gtk_notebook_set_show_tabs (_tmp0_, value);
#line 526 "../src/DynamicNotebook.vala"
	g_object_notify_by_pspec ((GObject *) self, dynamic_notebook_properties[DYNAMIC_NOTEBOOK_SHOW_TABS_PROPERTY]);
#line 6051 "DynamicNotebook.c"
}

gboolean
dynamic_notebook_get_show_icons (DynamicNotebook* self)
{
	gboolean result;
#line 535 "../src/DynamicNotebook.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 535 "../src/DynamicNotebook.vala"
	result = self->priv->_show_icons;
#line 535 "../src/DynamicNotebook.vala"
	return result;
#line 6064 "DynamicNotebook.c"
}

void
dynamic_notebook_set_show_icons (DynamicNotebook* self,
                                 gboolean value)
{
#line 536 "../src/DynamicNotebook.vala"
	g_return_if_fail (self != NULL);
#line 537 "../src/DynamicNotebook.vala"
	self->priv->_show_icons = value;
#line 536 "../src/DynamicNotebook.vala"
	g_object_notify_by_pspec ((GObject *) self, dynamic_notebook_properties[DYNAMIC_NOTEBOOK_SHOW_ICONS_PROPERTY]);
#line 6077 "DynamicNotebook.c"
}

gboolean
dynamic_notebook_get_tabs_closable (DynamicNotebook* self)
{
	gboolean result;
#line 546 "../src/DynamicNotebook.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 546 "../src/DynamicNotebook.vala"
	result = self->priv->_tabs_closable;
#line 546 "../src/DynamicNotebook.vala"
	return result;
#line 6090 "DynamicNotebook.c"
}

static Block16Data*
block16_data_ref (Block16Data* _data16_)
{
#line 547 "../src/DynamicNotebook.vala"
	g_atomic_int_inc (&_data16_->_ref_count_);
#line 547 "../src/DynamicNotebook.vala"
	return _data16_;
#line 6100 "DynamicNotebook.c"
}

static void
block16_data_unref (void * _userdata_)
{
	Block16Data* _data16_;
	_data16_ = (Block16Data*) _userdata_;
#line 547 "../src/DynamicNotebook.vala"
	if (g_atomic_int_dec_and_test (&_data16_->_ref_count_)) {
#line 6110 "DynamicNotebook.c"
		DynamicNotebook* self;
#line 547 "../src/DynamicNotebook.vala"
		self = _data16_->self;
#line 547 "../src/DynamicNotebook.vala"
		_g_object_unref0 (self);
#line 547 "../src/DynamicNotebook.vala"
		g_slice_free (Block16Data, _data16_);
#line 6118 "DynamicNotebook.c"
	}
}

static void
_dynamic_notebook_tabs_closable____lambda21_ (Block16Data* _data16_,
                                              Tab* t)
{
	DynamicNotebook* self;
#line 549 "../src/DynamicNotebook.vala"
	self = _data16_->self;
#line 549 "../src/DynamicNotebook.vala"
	g_return_if_fail (t != NULL);
#line 550 "../src/DynamicNotebook.vala"
	tab_set_closable (t, _data16_->value);
#line 6133 "DynamicNotebook.c"
}

static void
__dynamic_notebook_tabs_closable____lambda21__gfunc (gconstpointer data,
                                                     gpointer self)
{
#line 549 "../src/DynamicNotebook.vala"
	_dynamic_notebook_tabs_closable____lambda21_ (self, (Tab*) data);
#line 6142 "DynamicNotebook.c"
}

void
dynamic_notebook_set_tabs_closable (DynamicNotebook* self,
                                    gboolean value)
{
	Block16Data* _data16_;
#line 547 "../src/DynamicNotebook.vala"
	g_return_if_fail (self != NULL);
#line 547 "../src/DynamicNotebook.vala"
	_data16_ = g_slice_new0 (Block16Data);
#line 547 "../src/DynamicNotebook.vala"
	_data16_->_ref_count_ = 1;
#line 547 "../src/DynamicNotebook.vala"
	_data16_->self = g_object_ref (self);
#line 547 "../src/DynamicNotebook.vala"
	_data16_->value = value;
#line 548 "../src/DynamicNotebook.vala"
	if (_data16_->value != self->priv->_tabs_closable) {
#line 6162 "DynamicNotebook.c"
		GList* _tmp0_;
		GList* _tmp1_;
#line 549 "../src/DynamicNotebook.vala"
		_tmp0_ = dynamic_notebook_get_tabs (self);
#line 549 "../src/DynamicNotebook.vala"
		_tmp1_ = _tmp0_;
#line 549 "../src/DynamicNotebook.vala"
		g_list_foreach (_tmp1_, __dynamic_notebook_tabs_closable____lambda21__gfunc, _data16_);
#line 6171 "DynamicNotebook.c"
	}
#line 552 "../src/DynamicNotebook.vala"
	self->priv->_tabs_closable = _data16_->value;
#line 547 "../src/DynamicNotebook.vala"
	block16_data_unref (_data16_);
#line 547 "../src/DynamicNotebook.vala"
	_data16_ = NULL;
#line 547 "../src/DynamicNotebook.vala"
	g_object_notify_by_pspec ((GObject *) self, dynamic_notebook_properties[DYNAMIC_NOTEBOOK_TABS_CLOSABLE_PROPERTY]);
#line 6181 "DynamicNotebook.c"
}

gboolean
dynamic_notebook_get_allow_drag (DynamicNotebook* self)
{
	gboolean result;
#line 561 "../src/DynamicNotebook.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 561 "../src/DynamicNotebook.vala"
	result = self->priv->_allow_drag;
#line 561 "../src/DynamicNotebook.vala"
	return result;
#line 6194 "DynamicNotebook.c"
}

static Block17Data*
block17_data_ref (Block17Data* _data17_)
{
#line 562 "../src/DynamicNotebook.vala"
	g_atomic_int_inc (&_data17_->_ref_count_);
#line 562 "../src/DynamicNotebook.vala"
	return _data17_;
#line 6204 "DynamicNotebook.c"
}

static void
block17_data_unref (void * _userdata_)
{
	Block17Data* _data17_;
	_data17_ = (Block17Data*) _userdata_;
#line 562 "../src/DynamicNotebook.vala"
	if (g_atomic_int_dec_and_test (&_data17_->_ref_count_)) {
#line 6214 "DynamicNotebook.c"
		DynamicNotebook* self;
#line 562 "../src/DynamicNotebook.vala"
		self = _data17_->self;
#line 562 "../src/DynamicNotebook.vala"
		_g_object_unref0 (self);
#line 562 "../src/DynamicNotebook.vala"
		g_slice_free (Block17Data, _data17_);
#line 6222 "DynamicNotebook.c"
	}
}

static void
_dynamic_notebook_allow_drag___lambda19_ (Block17Data* _data17_,
                                          Tab* t)
{
	DynamicNotebook* self;
	GtkNotebook* _tmp0_;
	TabPageContainer* _tmp1_;
#line 564 "../src/DynamicNotebook.vala"
	self = _data17_->self;
#line 564 "../src/DynamicNotebook.vala"
	g_return_if_fail (t != NULL);
#line 565 "../src/DynamicNotebook.vala"
	_tmp0_ = self->priv->notebook;
#line 565 "../src/DynamicNotebook.vala"
	_tmp1_ = t->page_container;
#line 565 "../src/DynamicNotebook.vala"
	gtk_notebook_set_tab_reorderable (_tmp0_, (GtkWidget*) _tmp1_, _data17_->value);
#line 6243 "DynamicNotebook.c"
}

static void
__dynamic_notebook_allow_drag___lambda19__gfunc (gconstpointer data,
                                                 gpointer self)
{
#line 564 "../src/DynamicNotebook.vala"
	_dynamic_notebook_allow_drag___lambda19_ (self, (Tab*) data);
#line 6252 "DynamicNotebook.c"
}

void
dynamic_notebook_set_allow_drag (DynamicNotebook* self,
                                 gboolean value)
{
	Block17Data* _data17_;
	GList* _tmp0_;
	GList* _tmp1_;
#line 562 "../src/DynamicNotebook.vala"
	g_return_if_fail (self != NULL);
#line 562 "../src/DynamicNotebook.vala"
	_data17_ = g_slice_new0 (Block17Data);
#line 562 "../src/DynamicNotebook.vala"
	_data17_->_ref_count_ = 1;
#line 562 "../src/DynamicNotebook.vala"
	_data17_->self = g_object_ref (self);
#line 562 "../src/DynamicNotebook.vala"
	_data17_->value = value;
#line 563 "../src/DynamicNotebook.vala"
	self->priv->_allow_drag = _data17_->value;
#line 564 "../src/DynamicNotebook.vala"
	_tmp0_ = dynamic_notebook_get_tabs (self);
#line 564 "../src/DynamicNotebook.vala"
	_tmp1_ = _tmp0_;
#line 564 "../src/DynamicNotebook.vala"
	g_list_foreach (_tmp1_, __dynamic_notebook_allow_drag___lambda19__gfunc, _data17_);
#line 562 "../src/DynamicNotebook.vala"
	block17_data_unref (_data17_);
#line 562 "../src/DynamicNotebook.vala"
	_data17_ = NULL;
#line 562 "../src/DynamicNotebook.vala"
	g_object_notify_by_pspec ((GObject *) self, dynamic_notebook_properties[DYNAMIC_NOTEBOOK_ALLOW_DRAG_PROPERTY]);
#line 6286 "DynamicNotebook.c"
}

gboolean
dynamic_notebook_get_allow_new_window (DynamicNotebook* self)
{
	gboolean result;
#line 575 "../src/DynamicNotebook.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 575 "../src/DynamicNotebook.vala"
	result = self->priv->_allow_new_window;
#line 575 "../src/DynamicNotebook.vala"
	return result;
#line 6299 "DynamicNotebook.c"
}

static Block18Data*
block18_data_ref (Block18Data* _data18_)
{
#line 576 "../src/DynamicNotebook.vala"
	g_atomic_int_inc (&_data18_->_ref_count_);
#line 576 "../src/DynamicNotebook.vala"
	return _data18_;
#line 6309 "DynamicNotebook.c"
}

static void
block18_data_unref (void * _userdata_)
{
	Block18Data* _data18_;
	_data18_ = (Block18Data*) _userdata_;
#line 576 "../src/DynamicNotebook.vala"
	if (g_atomic_int_dec_and_test (&_data18_->_ref_count_)) {
#line 6319 "DynamicNotebook.c"
		DynamicNotebook* self;
#line 576 "../src/DynamicNotebook.vala"
		self = _data18_->self;
#line 576 "../src/DynamicNotebook.vala"
		_g_object_unref0 (self);
#line 576 "../src/DynamicNotebook.vala"
		g_slice_free (Block18Data, _data18_);
#line 6327 "DynamicNotebook.c"
	}
}

static void
_dynamic_notebook_allow_new_window___lambda20_ (Block18Data* _data18_,
                                                Tab* t)
{
	DynamicNotebook* self;
	GtkNotebook* _tmp0_;
	TabPageContainer* _tmp1_;
#line 578 "../src/DynamicNotebook.vala"
	self = _data18_->self;
#line 578 "../src/DynamicNotebook.vala"
	g_return_if_fail (t != NULL);
#line 579 "../src/DynamicNotebook.vala"
	_tmp0_ = self->priv->notebook;
#line 579 "../src/DynamicNotebook.vala"
	_tmp1_ = t->page_container;
#line 579 "../src/DynamicNotebook.vala"
	gtk_notebook_set_tab_detachable (_tmp0_, (GtkWidget*) _tmp1_, _data18_->value);
#line 6348 "DynamicNotebook.c"
}

static void
__dynamic_notebook_allow_new_window___lambda20__gfunc (gconstpointer data,
                                                       gpointer self)
{
#line 578 "../src/DynamicNotebook.vala"
	_dynamic_notebook_allow_new_window___lambda20_ (self, (Tab*) data);
#line 6357 "DynamicNotebook.c"
}

void
dynamic_notebook_set_allow_new_window (DynamicNotebook* self,
                                       gboolean value)
{
	Block18Data* _data18_;
	GList* _tmp0_;
	GList* _tmp1_;
#line 576 "../src/DynamicNotebook.vala"
	g_return_if_fail (self != NULL);
#line 576 "../src/DynamicNotebook.vala"
	_data18_ = g_slice_new0 (Block18Data);
#line 576 "../src/DynamicNotebook.vala"
	_data18_->_ref_count_ = 1;
#line 576 "../src/DynamicNotebook.vala"
	_data18_->self = g_object_ref (self);
#line 576 "../src/DynamicNotebook.vala"
	_data18_->value = value;
#line 577 "../src/DynamicNotebook.vala"
	self->priv->_allow_new_window = _data18_->value;
#line 578 "../src/DynamicNotebook.vala"
	_tmp0_ = dynamic_notebook_get_tabs (self);
#line 578 "../src/DynamicNotebook.vala"
	_tmp1_ = _tmp0_;
#line 578 "../src/DynamicNotebook.vala"
	g_list_foreach (_tmp1_, __dynamic_notebook_allow_new_window___lambda20__gfunc, _data18_);
#line 576 "../src/DynamicNotebook.vala"
	block18_data_unref (_data18_);
#line 576 "../src/DynamicNotebook.vala"
	_data18_ = NULL;
#line 576 "../src/DynamicNotebook.vala"
	g_object_notify_by_pspec ((GObject *) self, dynamic_notebook_properties[DYNAMIC_NOTEBOOK_ALLOW_NEW_WINDOW_PROPERTY]);
#line 6391 "DynamicNotebook.c"
}

gboolean
dynamic_notebook_get_allow_duplication (DynamicNotebook* self)
{
	gboolean result;
#line 589 "../src/DynamicNotebook.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 589 "../src/DynamicNotebook.vala"
	result = self->priv->_allow_duplication;
#line 589 "../src/DynamicNotebook.vala"
	return result;
#line 6404 "DynamicNotebook.c"
}

void
dynamic_notebook_set_allow_duplication (DynamicNotebook* self,
                                        gboolean value)
{
	GList* _tmp0_;
	GList* _tmp1_;
#line 590 "../src/DynamicNotebook.vala"
	g_return_if_fail (self != NULL);
#line 591 "../src/DynamicNotebook.vala"
	self->priv->_allow_duplication = value;
#line 593 "../src/DynamicNotebook.vala"
	_tmp0_ = dynamic_notebook_get_tabs (self);
#line 593 "../src/DynamicNotebook.vala"
	_tmp1_ = _tmp0_;
#line 6421 "DynamicNotebook.c"
	{
		GList* tab_collection = NULL;
		GList* tab_it = NULL;
#line 593 "../src/DynamicNotebook.vala"
		tab_collection = _tmp1_;
#line 593 "../src/DynamicNotebook.vala"
		for (tab_it = tab_collection; tab_it != NULL; tab_it = tab_it->next) {
#line 6429 "DynamicNotebook.c"
			Tab* _tmp2_;
			Tab* tab = NULL;
#line 593 "../src/DynamicNotebook.vala"
			_tmp2_ = _g_object_ref0 ((Tab*) tab_it->data);
#line 593 "../src/DynamicNotebook.vala"
			tab = _tmp2_;
#line 6436 "DynamicNotebook.c"
			{
				Tab* _tmp3_;
				GtkMenuItem* _tmp4_;
#line 594 "../src/DynamicNotebook.vala"
				_tmp3_ = tab;
#line 594 "../src/DynamicNotebook.vala"
				_tmp4_ = _tmp3_->duplicate_m;
#line 594 "../src/DynamicNotebook.vala"
				gtk_widget_set_visible ((GtkWidget*) _tmp4_, value);
#line 593 "../src/DynamicNotebook.vala"
				_g_object_unref0 (tab);
#line 6448 "DynamicNotebook.c"
			}
		}
	}
#line 590 "../src/DynamicNotebook.vala"
	g_object_notify_by_pspec ((GObject *) self, dynamic_notebook_properties[DYNAMIC_NOTEBOOK_ALLOW_DUPLICATION_PROPERTY]);
#line 6454 "DynamicNotebook.c"
}

gboolean
dynamic_notebook_get_allow_restoring (DynamicNotebook* self)
{
	gboolean result;
#line 604 "../src/DynamicNotebook.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 604 "../src/DynamicNotebook.vala"
	result = self->priv->_allow_restoring;
#line 604 "../src/DynamicNotebook.vala"
	return result;
#line 6467 "DynamicNotebook.c"
}

void
dynamic_notebook_set_allow_restoring (DynamicNotebook* self,
                                      gboolean value)
{
	GtkMenuItem* _tmp0_;
	GtkButton* _tmp1_;
#line 605 "../src/DynamicNotebook.vala"
	g_return_if_fail (self != NULL);
#line 606 "../src/DynamicNotebook.vala"
	self->priv->_allow_restoring = value;
#line 607 "../src/DynamicNotebook.vala"
	_tmp0_ = self->priv->restore_tab_m;
#line 607 "../src/DynamicNotebook.vala"
	gtk_widget_set_visible ((GtkWidget*) _tmp0_, value);
#line 608 "../src/DynamicNotebook.vala"
	_tmp1_ = self->priv->restore_button;
#line 608 "../src/DynamicNotebook.vala"
	gtk_widget_set_visible ((GtkWidget*) _tmp1_, value);
#line 605 "../src/DynamicNotebook.vala"
	g_object_notify_by_pspec ((GObject *) self, dynamic_notebook_properties[DYNAMIC_NOTEBOOK_ALLOW_RESTORING_PROPERTY]);
#line 6490 "DynamicNotebook.c"
}

gint
dynamic_notebook_get_max_restorable_tabs (DynamicNotebook* self)
{
	gint result;
	ClosedTabs* _tmp0_;
	gint _tmp1_;
	gint _tmp2_;
#line 617 "../src/DynamicNotebook.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 617 "../src/DynamicNotebook.vala"
	_tmp0_ = self->priv->closed_tabs;
#line 617 "../src/DynamicNotebook.vala"
	_tmp1_ = closed_tabs_get_max_restorable_tabs (_tmp0_);
#line 617 "../src/DynamicNotebook.vala"
	_tmp2_ = _tmp1_;
#line 617 "../src/DynamicNotebook.vala"
	result = _tmp2_;
#line 617 "../src/DynamicNotebook.vala"
	return result;
#line 6512 "DynamicNotebook.c"
}

void
dynamic_notebook_set_max_restorable_tabs (DynamicNotebook* self,
                                          gint value)
{
	ClosedTabs* _tmp0_;
#line 618 "../src/DynamicNotebook.vala"
	g_return_if_fail (self != NULL);
#line 618 "../src/DynamicNotebook.vala"
	_tmp0_ = self->priv->closed_tabs;
#line 618 "../src/DynamicNotebook.vala"
	closed_tabs_set_max_restorable_tabs (_tmp0_, value);
#line 618 "../src/DynamicNotebook.vala"
	g_object_notify_by_pspec ((GObject *) self, dynamic_notebook_properties[DYNAMIC_NOTEBOOK_MAX_RESTORABLE_TABS_PROPERTY]);
#line 6528 "DynamicNotebook.c"
}

gboolean
dynamic_notebook_get_add_button_visible (DynamicNotebook* self)
{
	gboolean result;
#line 626 "../src/DynamicNotebook.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 626 "../src/DynamicNotebook.vala"
	result = self->priv->_add_button_visible;
#line 626 "../src/DynamicNotebook.vala"
	return result;
#line 6541 "DynamicNotebook.c"
}

void
dynamic_notebook_set_add_button_visible (DynamicNotebook* self,
                                         gboolean value)
{
#line 627 "../src/DynamicNotebook.vala"
	g_return_if_fail (self != NULL);
#line 628 "../src/DynamicNotebook.vala"
	if (value != self->priv->_add_button_visible) {
#line 6552 "DynamicNotebook.c"
		GtkMenuItem* _tmp4_;
#line 629 "../src/DynamicNotebook.vala"
		if (self->priv->_add_button_visible) {
#line 6556 "DynamicNotebook.c"
			GtkNotebook* _tmp0_;
			GtkButton* _tmp1_;
#line 630 "../src/DynamicNotebook.vala"
			_tmp0_ = self->priv->notebook;
#line 630 "../src/DynamicNotebook.vala"
			_tmp1_ = self->priv->add_button;
#line 630 "../src/DynamicNotebook.vala"
			gtk_container_remove ((GtkContainer*) _tmp0_, (GtkWidget*) _tmp1_);
#line 6565 "DynamicNotebook.c"
		} else {
			GtkNotebook* _tmp2_;
			GtkButton* _tmp3_;
#line 632 "../src/DynamicNotebook.vala"
			_tmp2_ = self->priv->notebook;
#line 632 "../src/DynamicNotebook.vala"
			_tmp3_ = self->priv->add_button;
#line 632 "../src/DynamicNotebook.vala"
			gtk_notebook_set_action_widget (_tmp2_, (GtkWidget*) _tmp3_, GTK_PACK_START);
#line 6575 "DynamicNotebook.c"
		}
#line 635 "../src/DynamicNotebook.vala"
		self->priv->_add_button_visible = value;
#line 636 "../src/DynamicNotebook.vala"
		_tmp4_ = self->priv->new_tab_m;
#line 636 "../src/DynamicNotebook.vala"
		gtk_widget_set_visible ((GtkWidget*) _tmp4_, value);
#line 6583 "DynamicNotebook.c"
	}
#line 627 "../src/DynamicNotebook.vala"
	g_object_notify_by_pspec ((GObject *) self, dynamic_notebook_properties[DYNAMIC_NOTEBOOK_ADD_BUTTON_VISIBLE_PROPERTY]);
#line 6587 "DynamicNotebook.c"
}

gboolean
dynamic_notebook_get_allow_pinning (DynamicNotebook* self)
{
	gboolean result;
#line 643 "../src/DynamicNotebook.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 643 "../src/DynamicNotebook.vala"
	result = self->priv->_allow_pinning;
#line 643 "../src/DynamicNotebook.vala"
	return result;
#line 6600 "DynamicNotebook.c"
}

void
dynamic_notebook_set_allow_pinning (DynamicNotebook* self,
                                    gboolean value)
{
	GList* _tmp0_;
	GList* _tmp1_;
#line 644 "../src/DynamicNotebook.vala"
	g_return_if_fail (self != NULL);
#line 645 "../src/DynamicNotebook.vala"
	self->priv->_allow_pinning = value;
#line 647 "../src/DynamicNotebook.vala"
	_tmp0_ = dynamic_notebook_get_tabs (self);
#line 647 "../src/DynamicNotebook.vala"
	_tmp1_ = _tmp0_;
#line 6617 "DynamicNotebook.c"
	{
		GList* tab_collection = NULL;
		GList* tab_it = NULL;
#line 647 "../src/DynamicNotebook.vala"
		tab_collection = _tmp1_;
#line 647 "../src/DynamicNotebook.vala"
		for (tab_it = tab_collection; tab_it != NULL; tab_it = tab_it->next) {
#line 6625 "DynamicNotebook.c"
			Tab* _tmp2_;
			Tab* tab = NULL;
#line 647 "../src/DynamicNotebook.vala"
			_tmp2_ = _g_object_ref0 ((Tab*) tab_it->data);
#line 647 "../src/DynamicNotebook.vala"
			tab = _tmp2_;
#line 6632 "DynamicNotebook.c"
			{
				Tab* _tmp3_;
#line 648 "../src/DynamicNotebook.vala"
				_tmp3_ = tab;
#line 648 "../src/DynamicNotebook.vala"
				tab_set_pinnable (_tmp3_, value);
#line 647 "../src/DynamicNotebook.vala"
				_g_object_unref0 (tab);
#line 6641 "DynamicNotebook.c"
			}
		}
	}
#line 644 "../src/DynamicNotebook.vala"
	g_object_notify_by_pspec ((GObject *) self, dynamic_notebook_properties[DYNAMIC_NOTEBOOK_ALLOW_PINNING_PROPERTY]);
#line 6647 "DynamicNotebook.c"
}

gboolean
dynamic_notebook_get_force_left (DynamicNotebook* self)
{
	gboolean result;
#line 655 "../src/DynamicNotebook.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 655 "../src/DynamicNotebook.vala"
	result = self->priv->_force_left;
#line 655 "../src/DynamicNotebook.vala"
	return result;
#line 6660 "DynamicNotebook.c"
}

void
dynamic_notebook_set_force_left (DynamicNotebook* self,
                                 gboolean value)
{
#line 656 "../src/DynamicNotebook.vala"
	g_return_if_fail (self != NULL);
#line 656 "../src/DynamicNotebook.vala"
	self->priv->_force_left = value;
#line 656 "../src/DynamicNotebook.vala"
	g_object_notify_by_pspec ((GObject *) self, dynamic_notebook_properties[DYNAMIC_NOTEBOOK_FORCE_LEFT_PROPERTY]);
#line 6673 "DynamicNotebook.c"
}

const gchar*
dynamic_notebook_get_add_button_tooltip (DynamicNotebook* self)
{
	const gchar* result;
	GtkButton* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	const gchar* _tmp3_;
#line 663 "../src/DynamicNotebook.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 663 "../src/DynamicNotebook.vala"
	_tmp0_ = self->priv->add_button;
#line 663 "../src/DynamicNotebook.vala"
	_tmp1_ = gtk_widget_get_tooltip_text ((GtkWidget*) _tmp0_);
#line 663 "../src/DynamicNotebook.vala"
	_tmp2_ = _tmp1_;
#line 663 "../src/DynamicNotebook.vala"
	_g_free0 (self->priv->_add_button_tooltip);
#line 663 "../src/DynamicNotebook.vala"
	self->priv->_add_button_tooltip = _tmp2_;
#line 663 "../src/DynamicNotebook.vala"
	_tmp3_ = self->priv->_add_button_tooltip;
#line 663 "../src/DynamicNotebook.vala"
	result = _tmp3_;
#line 663 "../src/DynamicNotebook.vala"
	return result;
#line 6702 "DynamicNotebook.c"
}

void
dynamic_notebook_set_add_button_tooltip (DynamicNotebook* self,
                                         const gchar* value)
{
	GtkButton* _tmp0_;
#line 664 "../src/DynamicNotebook.vala"
	g_return_if_fail (self != NULL);
#line 664 "../src/DynamicNotebook.vala"
	_tmp0_ = self->priv->add_button;
#line 664 "../src/DynamicNotebook.vala"
	gtk_widget_set_tooltip_text ((GtkWidget*) _tmp0_, value);
#line 664 "../src/DynamicNotebook.vala"
	g_object_notify_by_pspec ((GObject *) self, dynamic_notebook_properties[DYNAMIC_NOTEBOOK_ADD_BUTTON_TOOLTIP_PROPERTY]);
#line 6718 "DynamicNotebook.c"
}

Tab*
dynamic_notebook_get_current (DynamicNotebook* self)
{
	Tab* result;
	GList* _tmp0_;
	GList* _tmp1_;
	GtkNotebook* _tmp2_;
	gconstpointer _tmp3_;
#line 670 "../src/DynamicNotebook.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 670 "../src/DynamicNotebook.vala"
	_tmp0_ = dynamic_notebook_get_tabs (self);
#line 670 "../src/DynamicNotebook.vala"
	_tmp1_ = _tmp0_;
#line 670 "../src/DynamicNotebook.vala"
	_tmp2_ = self->priv->notebook;
#line 670 "../src/DynamicNotebook.vala"
	_tmp3_ = g_list_nth_data (_tmp1_, (guint) gtk_notebook_get_current_page (_tmp2_));
#line 670 "../src/DynamicNotebook.vala"
	result = (Tab*) _tmp3_;
#line 670 "../src/DynamicNotebook.vala"
	return result;
#line 6743 "DynamicNotebook.c"
}

void
dynamic_notebook_set_current (DynamicNotebook* self,
                              Tab* value)
{
	GtkNotebook* _tmp0_;
	GList* _tmp1_;
	GList* _tmp2_;
#line 671 "../src/DynamicNotebook.vala"
	g_return_if_fail (self != NULL);
#line 671 "../src/DynamicNotebook.vala"
	_tmp0_ = self->priv->notebook;
#line 671 "../src/DynamicNotebook.vala"
	_tmp1_ = dynamic_notebook_get_tabs (self);
#line 671 "../src/DynamicNotebook.vala"
	_tmp2_ = _tmp1_;
#line 671 "../src/DynamicNotebook.vala"
	gtk_notebook_set_current_page (_tmp0_, g_list_index (_tmp2_, value));
#line 671 "../src/DynamicNotebook.vala"
	g_object_notify_by_pspec ((GObject *) self, dynamic_notebook_properties[DYNAMIC_NOTEBOOK_CURRENT_PROPERTY]);
#line 6765 "DynamicNotebook.c"
}

GList*
dynamic_notebook_get_tabs (DynamicNotebook* self)
{
	GList* result;
	GList* _tmp9_;
#line 676 "../src/DynamicNotebook.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 677 "../src/DynamicNotebook.vala"
	(self->priv->_tabs == NULL) ? NULL : (self->priv->_tabs = (_g_list_free__g_object_unref0_ (self->priv->_tabs), NULL));
#line 677 "../src/DynamicNotebook.vala"
	self->priv->_tabs = NULL;
#line 6779 "DynamicNotebook.c"
	{
		gint i = 0;
#line 678 "../src/DynamicNotebook.vala"
		i = 0;
#line 6784 "DynamicNotebook.c"
		{
			gboolean _tmp0_ = FALSE;
#line 678 "../src/DynamicNotebook.vala"
			_tmp0_ = TRUE;
#line 678 "../src/DynamicNotebook.vala"
			while (TRUE) {
#line 6791 "DynamicNotebook.c"
				gint _tmp2_;
				gint _tmp3_;
				GtkNotebook* _tmp4_;
				GtkNotebook* _tmp5_;
				GtkWidget* _tmp6_;
				GtkWidget* _tmp7_;
				Tab* _tmp8_;
#line 678 "../src/DynamicNotebook.vala"
				if (!_tmp0_) {
#line 6801 "DynamicNotebook.c"
					gint _tmp1_;
#line 678 "../src/DynamicNotebook.vala"
					_tmp1_ = i;
#line 678 "../src/DynamicNotebook.vala"
					i = _tmp1_ + 1;
#line 6807 "DynamicNotebook.c"
				}
#line 678 "../src/DynamicNotebook.vala"
				_tmp0_ = FALSE;
#line 678 "../src/DynamicNotebook.vala"
				_tmp2_ = dynamic_notebook_get_n_tabs (self);
#line 678 "../src/DynamicNotebook.vala"
				_tmp3_ = _tmp2_;
#line 678 "../src/DynamicNotebook.vala"
				if (!(i < _tmp3_)) {
#line 678 "../src/DynamicNotebook.vala"
					break;
#line 6819 "DynamicNotebook.c"
				}
#line 679 "../src/DynamicNotebook.vala"
				_tmp4_ = self->priv->notebook;
#line 679 "../src/DynamicNotebook.vala"
				_tmp5_ = self->priv->notebook;
#line 679 "../src/DynamicNotebook.vala"
				_tmp6_ = gtk_notebook_get_nth_page (_tmp5_, i);
#line 679 "../src/DynamicNotebook.vala"
				_tmp7_ = gtk_notebook_get_tab_label (_tmp4_, _tmp6_);
#line 679 "../src/DynamicNotebook.vala"
				_tmp8_ = _g_object_ref0 (IS_TAB (_tmp7_) ? ((Tab*) _tmp7_) : NULL);
#line 679 "../src/DynamicNotebook.vala"
				self->priv->_tabs = g_list_append (self->priv->_tabs, _tmp8_);
#line 6833 "DynamicNotebook.c"
			}
		}
	}
#line 681 "../src/DynamicNotebook.vala"
	_tmp9_ = self->priv->_tabs;
#line 681 "../src/DynamicNotebook.vala"
	result = _tmp9_;
#line 681 "../src/DynamicNotebook.vala"
	return result;
#line 6843 "DynamicNotebook.c"
}

const gchar*
dynamic_notebook_get_group_name (DynamicNotebook* self)
{
	const gchar* result;
	GtkNotebook* _tmp0_;
	const gchar* _tmp1_;
	const gchar* _tmp2_;
#line 686 "../src/DynamicNotebook.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 686 "../src/DynamicNotebook.vala"
	_tmp0_ = self->priv->notebook;
#line 686 "../src/DynamicNotebook.vala"
	_tmp1_ = gtk_notebook_get_group_name (_tmp0_);
#line 686 "../src/DynamicNotebook.vala"
	_tmp2_ = _tmp1_;
#line 686 "../src/DynamicNotebook.vala"
	result = _tmp2_;
#line 686 "../src/DynamicNotebook.vala"
	return result;
#line 6865 "DynamicNotebook.c"
}

void
dynamic_notebook_set_group_name (DynamicNotebook* self,
                                 const gchar* value)
{
	GtkNotebook* _tmp0_;
#line 687 "../src/DynamicNotebook.vala"
	g_return_if_fail (self != NULL);
#line 687 "../src/DynamicNotebook.vala"
	_tmp0_ = self->priv->notebook;
#line 687 "../src/DynamicNotebook.vala"
	gtk_notebook_set_group_name (_tmp0_, value);
#line 687 "../src/DynamicNotebook.vala"
	g_object_notify_by_pspec ((GObject *) self, dynamic_notebook_properties[DYNAMIC_NOTEBOOK_GROUP_NAME_PROPERTY]);
#line 6881 "DynamicNotebook.c"
}

DynamicNotebookTabBarBehavior
dynamic_notebook_get_tab_bar_behavior (DynamicNotebook* self)
{
	DynamicNotebookTabBarBehavior result;
#line 705 "../src/DynamicNotebook.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 705 "../src/DynamicNotebook.vala"
	result = self->priv->_tab_bar_behavior;
#line 705 "../src/DynamicNotebook.vala"
	return result;
#line 6894 "DynamicNotebook.c"
}

void
dynamic_notebook_set_tab_bar_behavior (DynamicNotebook* self,
                                       DynamicNotebookTabBarBehavior value)
{
#line 700 "../src/DynamicNotebook.vala"
	g_return_if_fail (self != NULL);
#line 701 "../src/DynamicNotebook.vala"
	self->priv->_tab_bar_behavior = value;
#line 702 "../src/DynamicNotebook.vala"
	dynamic_notebook_update_tabs_visibility (self);
#line 700 "../src/DynamicNotebook.vala"
	g_object_notify_by_pspec ((GObject *) self, dynamic_notebook_properties[DYNAMIC_NOTEBOOK_TAB_BAR_BEHAVIOR_PROPERTY]);
#line 6909 "DynamicNotebook.c"
}

GtkMenu*
dynamic_notebook_get_menu (DynamicNotebook* self)
{
	GtkMenu* result;
	GtkMenu* _tmp0_;
#line 713 "../src/DynamicNotebook.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 713 "../src/DynamicNotebook.vala"
	_tmp0_ = self->priv->_menu;
#line 713 "../src/DynamicNotebook.vala"
	result = _tmp0_;
#line 713 "../src/DynamicNotebook.vala"
	return result;
#line 6925 "DynamicNotebook.c"
}

static void
dynamic_notebook_set_menu (DynamicNotebook* self,
                           GtkMenu* value)
{
	GtkMenu* old_value;
#line 713 "../src/DynamicNotebook.vala"
	g_return_if_fail (self != NULL);
#line 713 "../src/DynamicNotebook.vala"
	old_value = dynamic_notebook_get_menu (self);
#line 713 "../src/DynamicNotebook.vala"
	if (old_value != value) {
#line 6939 "DynamicNotebook.c"
		GtkMenu* _tmp0_;
#line 713 "../src/DynamicNotebook.vala"
		_tmp0_ = _g_object_ref0 (value);
#line 713 "../src/DynamicNotebook.vala"
		_g_object_unref0 (self->priv->_menu);
#line 713 "../src/DynamicNotebook.vala"
		self->priv->_menu = _tmp0_;
#line 713 "../src/DynamicNotebook.vala"
		g_object_notify_by_pspec ((GObject *) self, dynamic_notebook_properties[DYNAMIC_NOTEBOOK_MENU_PROPERTY]);
#line 6949 "DynamicNotebook.c"
	}
}

static void
g_cclosure_user_marshal_VOID__OBJECT_OBJECT (GClosure * closure,
                                             GValue * return_value,
                                             guint n_param_values,
                                             const GValue * param_values,
                                             gpointer invocation_hint,
                                             gpointer marshal_data)
{
	typedef void (*GMarshalFunc_VOID__OBJECT_OBJECT) (gpointer data1, gpointer arg_1, gpointer arg_2, gpointer data2);
	register GMarshalFunc_VOID__OBJECT_OBJECT callback;
	register GCClosure * cc;
	register gpointer data1;
	register gpointer data2;
	cc = (GCClosure *) closure;
#line 513 "../src/DynamicNotebook.vala"
	g_return_if_fail (n_param_values == 3);
#line 513 "../src/DynamicNotebook.vala"
	if (G_CCLOSURE_SWAP_DATA (closure)) {
#line 513 "../src/DynamicNotebook.vala"
		data1 = closure->data;
#line 513 "../src/DynamicNotebook.vala"
		data2 = param_values->data[0].v_pointer;
#line 6975 "DynamicNotebook.c"
	} else {
#line 513 "../src/DynamicNotebook.vala"
		data1 = param_values->data[0].v_pointer;
#line 513 "../src/DynamicNotebook.vala"
		data2 = closure->data;
#line 6981 "DynamicNotebook.c"
	}
#line 513 "../src/DynamicNotebook.vala"
	callback = (GMarshalFunc_VOID__OBJECT_OBJECT) (marshal_data ? marshal_data : cc->callback);
#line 513 "../src/DynamicNotebook.vala"
	callback (data1, g_value_get_object (param_values + 1), g_value_get_object (param_values + 2), data2);
#line 6987 "DynamicNotebook.c"
}

static void
g_cclosure_user_marshal_VOID__OBJECT_INT (GClosure * closure,
                                          GValue * return_value,
                                          guint n_param_values,
                                          const GValue * param_values,
                                          gpointer invocation_hint,
                                          gpointer marshal_data)
{
	typedef void (*GMarshalFunc_VOID__OBJECT_INT) (gpointer data1, gpointer arg_1, gint arg_2, gpointer data2);
	register GMarshalFunc_VOID__OBJECT_INT callback;
	register GCClosure * cc;
	register gpointer data1;
	register gpointer data2;
	cc = (GCClosure *) closure;
#line 513 "../src/DynamicNotebook.vala"
	g_return_if_fail (n_param_values == 3);
#line 513 "../src/DynamicNotebook.vala"
	if (G_CCLOSURE_SWAP_DATA (closure)) {
#line 513 "../src/DynamicNotebook.vala"
		data1 = closure->data;
#line 513 "../src/DynamicNotebook.vala"
		data2 = param_values->data[0].v_pointer;
#line 7012 "DynamicNotebook.c"
	} else {
#line 513 "../src/DynamicNotebook.vala"
		data1 = param_values->data[0].v_pointer;
#line 513 "../src/DynamicNotebook.vala"
		data2 = closure->data;
#line 7018 "DynamicNotebook.c"
	}
#line 513 "../src/DynamicNotebook.vala"
	callback = (GMarshalFunc_VOID__OBJECT_INT) (marshal_data ? marshal_data : cc->callback);
#line 513 "../src/DynamicNotebook.vala"
	callback (data1, g_value_get_object (param_values + 1), g_value_get_int (param_values + 2), data2);
#line 7024 "DynamicNotebook.c"
}

static void
g_cclosure_user_marshal_VOID__OBJECT_INT_INT (GClosure * closure,
                                              GValue * return_value,
                                              guint n_param_values,
                                              const GValue * param_values,
                                              gpointer invocation_hint,
                                              gpointer marshal_data)
{
	typedef void (*GMarshalFunc_VOID__OBJECT_INT_INT) (gpointer data1, gpointer arg_1, gint arg_2, gint arg_3, gpointer data2);
	register GMarshalFunc_VOID__OBJECT_INT_INT callback;
	register GCClosure * cc;
	register gpointer data1;
	register gpointer data2;
	cc = (GCClosure *) closure;
#line 513 "../src/DynamicNotebook.vala"
	g_return_if_fail (n_param_values == 4);
#line 513 "../src/DynamicNotebook.vala"
	if (G_CCLOSURE_SWAP_DATA (closure)) {
#line 513 "../src/DynamicNotebook.vala"
		data1 = closure->data;
#line 513 "../src/DynamicNotebook.vala"
		data2 = param_values->data[0].v_pointer;
#line 7049 "DynamicNotebook.c"
	} else {
#line 513 "../src/DynamicNotebook.vala"
		data1 = param_values->data[0].v_pointer;
#line 513 "../src/DynamicNotebook.vala"
		data2 = closure->data;
#line 7055 "DynamicNotebook.c"
	}
#line 513 "../src/DynamicNotebook.vala"
	callback = (GMarshalFunc_VOID__OBJECT_INT_INT) (marshal_data ? marshal_data : cc->callback);
#line 513 "../src/DynamicNotebook.vala"
	callback (data1, g_value_get_object (param_values + 1), g_value_get_int (param_values + 2), g_value_get_int (param_values + 3), data2);
#line 7061 "DynamicNotebook.c"
}

static void
g_cclosure_user_marshal_BOOLEAN__OBJECT (GClosure * closure,
                                         GValue * return_value,
                                         guint n_param_values,
                                         const GValue * param_values,
                                         gpointer invocation_hint,
                                         gpointer marshal_data)
{
	typedef gboolean (*GMarshalFunc_BOOLEAN__OBJECT) (gpointer data1, gpointer arg_1, gpointer data2);
	register GMarshalFunc_BOOLEAN__OBJECT callback;
	register GCClosure * cc;
	register gpointer data1;
	register gpointer data2;
	gboolean v_return;
	cc = (GCClosure *) closure;
#line 513 "../src/DynamicNotebook.vala"
	g_return_if_fail (return_value != NULL);
#line 513 "../src/DynamicNotebook.vala"
	g_return_if_fail (n_param_values == 2);
#line 513 "../src/DynamicNotebook.vala"
	if (G_CCLOSURE_SWAP_DATA (closure)) {
#line 513 "../src/DynamicNotebook.vala"
		data1 = closure->data;
#line 513 "../src/DynamicNotebook.vala"
		data2 = param_values->data[0].v_pointer;
#line 7089 "DynamicNotebook.c"
	} else {
#line 513 "../src/DynamicNotebook.vala"
		data1 = param_values->data[0].v_pointer;
#line 513 "../src/DynamicNotebook.vala"
		data2 = closure->data;
#line 7095 "DynamicNotebook.c"
	}
#line 513 "../src/DynamicNotebook.vala"
	callback = (GMarshalFunc_BOOLEAN__OBJECT) (marshal_data ? marshal_data : cc->callback);
#line 513 "../src/DynamicNotebook.vala"
	v_return = callback (data1, g_value_get_object (param_values + 1), data2);
#line 513 "../src/DynamicNotebook.vala"
	g_value_set_boolean (return_value, v_return);
#line 7103 "DynamicNotebook.c"
}

static gboolean
_dynamic_notebook___lambda22_ (DynamicNotebook* self,
                               cairo_t* ctx)
{
	GtkStyleContext* _tmp0_;
	gboolean result;
#line 759 "../src/DynamicNotebook.vala"
	g_return_val_if_fail (ctx != NULL, FALSE);
#line 760 "../src/DynamicNotebook.vala"
	_tmp0_ = gtk_widget_get_style_context ((GtkWidget*) self);
#line 760 "../src/DynamicNotebook.vala"
	gtk_render_activity (_tmp0_, ctx, (gdouble) 0, (gdouble) 0, (gdouble) gtk_widget_get_allocated_width ((GtkWidget*) self), (gdouble) 27);
#line 761 "../src/DynamicNotebook.vala"
	result = FALSE;
#line 761 "../src/DynamicNotebook.vala"
	return result;
#line 7122 "DynamicNotebook.c"
}

static gboolean
__dynamic_notebook___lambda22__gtk_widget_draw (GtkWidget* _sender,
                                                cairo_t* cr,
                                                gpointer self)
{
	gboolean result;
	result = _dynamic_notebook___lambda22_ ((DynamicNotebook*) self, cr);
#line 759 "../src/DynamicNotebook.vala"
	return result;
#line 7134 "DynamicNotebook.c"
}

static void
_dynamic_notebook___lambda23_ (DynamicNotebook* self)
{
#line 775 "../src/DynamicNotebook.vala"
	g_signal_emit (self, dynamic_notebook_signals[DYNAMIC_NOTEBOOK_NEW_TAB_REQUESTED_SIGNAL], 0);
#line 7142 "DynamicNotebook.c"
}

static void
__dynamic_notebook___lambda23__gtk_menu_item_activate (GtkMenuItem* _sender,
                                                       gpointer self)
{
#line 774 "../src/DynamicNotebook.vala"
	_dynamic_notebook___lambda23_ ((DynamicNotebook*) self);
#line 7151 "DynamicNotebook.c"
}

static void
_dynamic_notebook___lambda24_ (DynamicNotebook* self)
{
#line 779 "../src/DynamicNotebook.vala"
	dynamic_notebook_restore_last_tab (self);
#line 7159 "DynamicNotebook.c"
}

static void
__dynamic_notebook___lambda24__gtk_menu_item_activate (GtkMenuItem* _sender,
                                                       gpointer self)
{
#line 778 "../src/DynamicNotebook.vala"
	_dynamic_notebook___lambda24_ ((DynamicNotebook*) self);
#line 7168 "DynamicNotebook.c"
}

static void
_dynamic_notebook___lambda25_ (DynamicNotebook* self,
                               const gchar* label,
                               const gchar* restore_data,
                               GIcon* icon)
{
	gboolean _tmp0_;
	gboolean _tmp1_;
	GtkButton* _tmp2_;
	ClosedTabs* _tmp3_;
	gboolean _tmp4_;
	gboolean _tmp5_;
	GtkMenuItem* _tmp6_;
	ClosedTabs* _tmp7_;
	gboolean _tmp8_;
	gboolean _tmp9_;
#line 783 "../src/DynamicNotebook.vala"
	g_return_if_fail (label != NULL);
#line 783 "../src/DynamicNotebook.vala"
	g_return_if_fail (restore_data != NULL);
#line 784 "../src/DynamicNotebook.vala"
	_tmp0_ = dynamic_notebook_get_allow_restoring (self);
#line 784 "../src/DynamicNotebook.vala"
	_tmp1_ = _tmp0_;
#line 784 "../src/DynamicNotebook.vala"
	if (!_tmp1_) {
#line 785 "../src/DynamicNotebook.vala"
		return;
#line 7199 "DynamicNotebook.c"
	}
#line 786 "../src/DynamicNotebook.vala"
	_tmp2_ = self->priv->restore_button;
#line 786 "../src/DynamicNotebook.vala"
	_tmp3_ = self->priv->closed_tabs;
#line 786 "../src/DynamicNotebook.vala"
	_tmp4_ = closed_tabs_get_empty (_tmp3_);
#line 786 "../src/DynamicNotebook.vala"
	_tmp5_ = _tmp4_;
#line 786 "../src/DynamicNotebook.vala"
	gtk_widget_set_sensitive ((GtkWidget*) _tmp2_, !_tmp5_);
#line 787 "../src/DynamicNotebook.vala"
	_tmp6_ = self->priv->restore_tab_m;
#line 787 "../src/DynamicNotebook.vala"
	_tmp7_ = self->priv->closed_tabs;
#line 787 "../src/DynamicNotebook.vala"
	_tmp8_ = closed_tabs_get_empty (_tmp7_);
#line 787 "../src/DynamicNotebook.vala"
	_tmp9_ = _tmp8_;
#line 787 "../src/DynamicNotebook.vala"
	gtk_widget_set_sensitive ((GtkWidget*) _tmp6_, !_tmp9_);
#line 788 "../src/DynamicNotebook.vala"
	g_signal_emit (self, dynamic_notebook_signals[DYNAMIC_NOTEBOOK_TAB_RESTORED_SIGNAL], 0, label, restore_data, icon);
#line 7223 "DynamicNotebook.c"
}

static void
__dynamic_notebook___lambda25__closed_tabs_restored (ClosedTabs* _sender,
                                                     const gchar* label,
                                                     const gchar* restore_data,
                                                     GIcon* icon,
                                                     gpointer self)
{
#line 783 "../src/DynamicNotebook.vala"
	_dynamic_notebook___lambda25_ ((DynamicNotebook*) self, label, restore_data, icon);
#line 7235 "DynamicNotebook.c"
}

static void
_dynamic_notebook___lambda26_ (DynamicNotebook* self)
{
	GtkButton* _tmp0_;
	GtkMenuItem* _tmp1_;
#line 792 "../src/DynamicNotebook.vala"
	_tmp0_ = self->priv->restore_button;
#line 792 "../src/DynamicNotebook.vala"
	gtk_widget_set_sensitive ((GtkWidget*) _tmp0_, FALSE);
#line 793 "../src/DynamicNotebook.vala"
	_tmp1_ = self->priv->restore_tab_m;
#line 793 "../src/DynamicNotebook.vala"
	gtk_widget_set_sensitive ((GtkWidget*) _tmp1_, FALSE);
#line 7251 "DynamicNotebook.c"
}

static void
__dynamic_notebook___lambda26__closed_tabs_cleared (ClosedTabs* _sender,
                                                    gpointer self)
{
#line 791 "../src/DynamicNotebook.vala"
	_dynamic_notebook___lambda26_ ((DynamicNotebook*) self);
#line 7260 "DynamicNotebook.c"
}

static void
_dynamic_notebook___lambda27_ (DynamicNotebook* self)
{
#line 819 "../src/DynamicNotebook.vala"
	g_signal_emit (self, dynamic_notebook_signals[DYNAMIC_NOTEBOOK_NEW_TAB_REQUESTED_SIGNAL], 0);
#line 7268 "DynamicNotebook.c"
}

static void
__dynamic_notebook___lambda27__gtk_button_clicked (GtkButton* _sender,
                                                   gpointer self)
{
#line 818 "../src/DynamicNotebook.vala"
	_dynamic_notebook___lambda27_ ((DynamicNotebook*) self);
#line 7277 "DynamicNotebook.c"
}

static gboolean
_dynamic_notebook___lambda28_ (DynamicNotebook* self,
                               GdkEventButton* e)
{
	gboolean _tmp0_ = FALSE;
	gboolean result;
#line 822 "../src/DynamicNotebook.vala"
	g_return_val_if_fail (e != NULL, FALSE);
#line 824 "../src/DynamicNotebook.vala"
	if (e->type == GDK_2BUTTON_PRESS) {
#line 824 "../src/DynamicNotebook.vala"
		_tmp0_ = e->button == ((guint) 1);
#line 7292 "DynamicNotebook.c"
	} else {
#line 824 "../src/DynamicNotebook.vala"
		_tmp0_ = FALSE;
#line 7296 "DynamicNotebook.c"
	}
#line 824 "../src/DynamicNotebook.vala"
	result = _tmp0_;
#line 824 "../src/DynamicNotebook.vala"
	return result;
#line 7302 "DynamicNotebook.c"
}

static gboolean
__dynamic_notebook___lambda28__gtk_widget_button_press_event (GtkWidget* _sender,
                                                              GdkEventButton* event,
                                                              gpointer self)
{
	gboolean result;
	result = _dynamic_notebook___lambda28_ ((DynamicNotebook*) self, event);
#line 822 "../src/DynamicNotebook.vala"
	return result;
#line 7314 "DynamicNotebook.c"
}

static void
_dynamic_notebook___lambda29_ (DynamicNotebook* self)
{
	GtkMenu* menu = NULL;
	ClosedTabs* _tmp0_;
	GtkMenu* _tmp1_;
	GtkMenu* _tmp2_;
	GtkMenu* _tmp3_;
	GtkButton* _tmp4_;
	GtkMenu* _tmp5_;
	GtkMenu* _tmp6_;
	GtkButton* _tmp7_;
#line 828 "../src/DynamicNotebook.vala"
	_tmp0_ = self->priv->closed_tabs;
#line 828 "../src/DynamicNotebook.vala"
	_tmp1_ = closed_tabs_get_menu (_tmp0_);
#line 828 "../src/DynamicNotebook.vala"
	_tmp2_ = _tmp1_;
#line 828 "../src/DynamicNotebook.vala"
	menu = _tmp2_;
#line 829 "../src/DynamicNotebook.vala"
	_tmp3_ = menu;
#line 829 "../src/DynamicNotebook.vala"
	_tmp4_ = self->priv->restore_button;
#line 829 "../src/DynamicNotebook.vala"
	g_object_set (_tmp3_, "attach-widget", (GtkWidget*) _tmp4_, NULL);
#line 830 "../src/DynamicNotebook.vala"
	_tmp5_ = menu;
#line 830 "../src/DynamicNotebook.vala"
	gtk_widget_show_all ((GtkWidget*) _tmp5_);
#line 831 "../src/DynamicNotebook.vala"
	_tmp6_ = menu;
#line 831 "../src/DynamicNotebook.vala"
	_tmp7_ = self->priv->restore_button;
#line 831 "../src/DynamicNotebook.vala"
	gtk_menu_popup_at_widget (_tmp6_, (GtkWidget*) _tmp7_, GDK_GRAVITY_SOUTH_EAST, GDK_GRAVITY_NORTH_EAST, NULL);
#line 827 "../src/DynamicNotebook.vala"
	_g_object_unref0 (menu);
#line 7355 "DynamicNotebook.c"
}

static void
__dynamic_notebook___lambda29__gtk_button_clicked (GtkButton* _sender,
                                                   gpointer self)
{
#line 827 "../src/DynamicNotebook.vala"
	_dynamic_notebook___lambda29_ ((DynamicNotebook*) self);
#line 7364 "DynamicNotebook.c"
}

static void
_dynamic_notebook___lambda30_ (DynamicNotebook* self)
{
#line 838 "../src/DynamicNotebook.vala"
	dynamic_notebook_recalc_size (self);
#line 7372 "DynamicNotebook.c"
}

static void
__dynamic_notebook___lambda30__gtk_widget_size_allocate (GtkWidget* _sender,
                                                         GtkAllocation* allocation,
                                                         gpointer self)
{
#line 837 "../src/DynamicNotebook.vala"
	_dynamic_notebook___lambda30_ ((DynamicNotebook*) self);
#line 7382 "DynamicNotebook.c"
}

static gboolean
_dynamic_notebook___lambda31_ (DynamicNotebook* self,
                               GdkEventButton* e)
{
	gboolean _tmp0_ = FALSE;
	gboolean result;
#line 841 "../src/DynamicNotebook.vala"
	g_return_val_if_fail (e != NULL, FALSE);
#line 842 "../src/DynamicNotebook.vala"
	if (e->type == GDK_2BUTTON_PRESS) {
#line 842 "../src/DynamicNotebook.vala"
		_tmp0_ = e->button == ((guint) 1);
#line 7397 "DynamicNotebook.c"
	} else {
#line 842 "../src/DynamicNotebook.vala"
		_tmp0_ = FALSE;
#line 7401 "DynamicNotebook.c"
	}
#line 842 "../src/DynamicNotebook.vala"
	if (_tmp0_) {
#line 843 "../src/DynamicNotebook.vala"
		g_signal_emit (self, dynamic_notebook_signals[DYNAMIC_NOTEBOOK_NEW_TAB_REQUESTED_SIGNAL], 0);
#line 7407 "DynamicNotebook.c"
	} else {
		gboolean _tmp1_ = FALSE;
#line 844 "../src/DynamicNotebook.vala"
		if (e->button == ((guint) 2)) {
#line 7412 "DynamicNotebook.c"
			gboolean _tmp2_;
			gboolean _tmp3_;
#line 844 "../src/DynamicNotebook.vala"
			_tmp2_ = dynamic_notebook_get_allow_restoring (self);
#line 844 "../src/DynamicNotebook.vala"
			_tmp3_ = _tmp2_;
#line 844 "../src/DynamicNotebook.vala"
			_tmp1_ = _tmp3_;
#line 7421 "DynamicNotebook.c"
		} else {
#line 844 "../src/DynamicNotebook.vala"
			_tmp1_ = FALSE;
#line 7425 "DynamicNotebook.c"
		}
#line 844 "../src/DynamicNotebook.vala"
		if (_tmp1_) {
#line 845 "../src/DynamicNotebook.vala"
			dynamic_notebook_restore_last_tab (self);
#line 846 "../src/DynamicNotebook.vala"
			result = TRUE;
#line 846 "../src/DynamicNotebook.vala"
			return result;
#line 7435 "DynamicNotebook.c"
		} else {
			gboolean _tmp4_ = FALSE;
#line 847 "../src/DynamicNotebook.vala"
			if (e->button == ((guint) 3)) {
#line 7440 "DynamicNotebook.c"
				gboolean _tmp5_ = FALSE;
				gboolean _tmp6_;
				gboolean _tmp7_;
#line 847 "../src/DynamicNotebook.vala"
				_tmp6_ = dynamic_notebook_get_allow_restoring (self);
#line 847 "../src/DynamicNotebook.vala"
				_tmp7_ = _tmp6_;
#line 847 "../src/DynamicNotebook.vala"
				if (_tmp7_) {
#line 847 "../src/DynamicNotebook.vala"
					_tmp5_ = TRUE;
#line 7452 "DynamicNotebook.c"
				} else {
					gboolean _tmp8_;
					gboolean _tmp9_;
#line 847 "../src/DynamicNotebook.vala"
					_tmp8_ = dynamic_notebook_get_add_button_visible (self);
#line 847 "../src/DynamicNotebook.vala"
					_tmp9_ = _tmp8_;
#line 847 "../src/DynamicNotebook.vala"
					_tmp5_ = _tmp9_;
#line 7462 "DynamicNotebook.c"
				}
#line 847 "../src/DynamicNotebook.vala"
				_tmp4_ = _tmp5_;
#line 7466 "DynamicNotebook.c"
			} else {
#line 847 "../src/DynamicNotebook.vala"
				_tmp4_ = FALSE;
#line 7470 "DynamicNotebook.c"
			}
#line 847 "../src/DynamicNotebook.vala"
			if (_tmp4_) {
#line 7474 "DynamicNotebook.c"
				GtkMenu* _tmp10_;
#line 848 "../src/DynamicNotebook.vala"
				_tmp10_ = self->priv->_menu;
#line 848 "../src/DynamicNotebook.vala"
				gtk_menu_popup_at_pointer (_tmp10_, (GdkEvent*) e);
#line 7480 "DynamicNotebook.c"
			}
		}
	}
#line 851 "../src/DynamicNotebook.vala"
	result = FALSE;
#line 851 "../src/DynamicNotebook.vala"
	return result;
#line 7488 "DynamicNotebook.c"
}

static gboolean
__dynamic_notebook___lambda31__gtk_widget_button_press_event (GtkWidget* _sender,
                                                              GdkEventButton* event,
                                                              gpointer self)
{
	gboolean result;
	result = _dynamic_notebook___lambda31_ ((DynamicNotebook*) self, event);
#line 841 "../src/DynamicNotebook.vala"
	return result;
#line 7500 "DynamicNotebook.c"
}

static gboolean
_dynamic_notebook___lambda32_ (DynamicNotebook* self,
                               GdkEventKey* e)
{
	gboolean result;
#line 854 "../src/DynamicNotebook.vala"
	g_return_val_if_fail (e != NULL, FALSE);
#line 855 "../src/DynamicNotebook.vala"
	e->state = e->state & MODIFIER_MASK;
#line 857 "../src/DynamicNotebook.vala"
	switch (e->keyval) {
#line 857 "../src/DynamicNotebook.vala"
		case GDK_KEY_w:
#line 857 "../src/DynamicNotebook.vala"
		case GDK_KEY_W:
#line 7518 "DynamicNotebook.c"
		{
#line 860 "../src/DynamicNotebook.vala"
			if (e->state == GDK_CONTROL_MASK) {
#line 7522 "DynamicNotebook.c"
				gboolean _tmp0_;
				gboolean _tmp1_;
				Tab* _tmp2_;
				Tab* _tmp3_;
#line 861 "../src/DynamicNotebook.vala"
				_tmp0_ = dynamic_notebook_get_tabs_closable (self);
#line 861 "../src/DynamicNotebook.vala"
				_tmp1_ = _tmp0_;
#line 861 "../src/DynamicNotebook.vala"
				if (!_tmp1_) {
#line 862 "../src/DynamicNotebook.vala"
					break;
#line 7535 "DynamicNotebook.c"
				}
#line 865 "../src/DynamicNotebook.vala"
				_tmp2_ = dynamic_notebook_get_current (self);
#line 865 "../src/DynamicNotebook.vala"
				_tmp3_ = _tmp2_;
#line 865 "../src/DynamicNotebook.vala"
				tab_close (_tmp3_);
#line 866 "../src/DynamicNotebook.vala"
				result = TRUE;
#line 866 "../src/DynamicNotebook.vala"
				return result;
#line 7547 "DynamicNotebook.c"
			}
#line 869 "../src/DynamicNotebook.vala"
			break;
#line 7551 "DynamicNotebook.c"
		}
#line 857 "../src/DynamicNotebook.vala"
		case GDK_KEY_t:
#line 857 "../src/DynamicNotebook.vala"
		case GDK_KEY_T:
#line 7557 "DynamicNotebook.c"
		{
#line 873 "../src/DynamicNotebook.vala"
			if (e->state == GDK_CONTROL_MASK) {
#line 874 "../src/DynamicNotebook.vala"
				g_signal_emit (self, dynamic_notebook_signals[DYNAMIC_NOTEBOOK_NEW_TAB_REQUESTED_SIGNAL], 0);
#line 875 "../src/DynamicNotebook.vala"
				result = TRUE;
#line 875 "../src/DynamicNotebook.vala"
				return result;
#line 7567 "DynamicNotebook.c"
			} else {
				gboolean _tmp4_ = FALSE;
#line 876 "../src/DynamicNotebook.vala"
				if (e->state == (GDK_CONTROL_MASK | GDK_SHIFT_MASK)) {
#line 7572 "DynamicNotebook.c"
					gboolean _tmp5_;
					gboolean _tmp6_;
#line 876 "../src/DynamicNotebook.vala"
					_tmp5_ = dynamic_notebook_get_allow_restoring (self);
#line 876 "../src/DynamicNotebook.vala"
					_tmp6_ = _tmp5_;
#line 876 "../src/DynamicNotebook.vala"
					_tmp4_ = _tmp6_;
#line 7581 "DynamicNotebook.c"
				} else {
#line 876 "../src/DynamicNotebook.vala"
					_tmp4_ = FALSE;
#line 7585 "DynamicNotebook.c"
				}
#line 876 "../src/DynamicNotebook.vala"
				if (_tmp4_) {
#line 877 "../src/DynamicNotebook.vala"
					dynamic_notebook_restore_last_tab (self);
#line 878 "../src/DynamicNotebook.vala"
					result = TRUE;
#line 878 "../src/DynamicNotebook.vala"
					return result;
#line 7595 "DynamicNotebook.c"
				}
			}
#line 881 "../src/DynamicNotebook.vala"
			break;
#line 7600 "DynamicNotebook.c"
		}
#line 857 "../src/DynamicNotebook.vala"
		case GDK_KEY_Page_Up:
#line 7604 "DynamicNotebook.c"
		{
#line 884 "../src/DynamicNotebook.vala"
			if (e->state == GDK_CONTROL_MASK) {
#line 885 "../src/DynamicNotebook.vala"
				dynamic_notebook_next_page (self);
#line 886 "../src/DynamicNotebook.vala"
				result = TRUE;
#line 886 "../src/DynamicNotebook.vala"
				return result;
#line 7614 "DynamicNotebook.c"
			}
#line 889 "../src/DynamicNotebook.vala"
			break;
#line 7618 "DynamicNotebook.c"
		}
#line 857 "../src/DynamicNotebook.vala"
		case GDK_KEY_Page_Down:
#line 7622 "DynamicNotebook.c"
		{
#line 892 "../src/DynamicNotebook.vala"
			if (e->state == GDK_CONTROL_MASK) {
#line 893 "../src/DynamicNotebook.vala"
				dynamic_notebook_previous_page (self);
#line 894 "../src/DynamicNotebook.vala"
				result = TRUE;
#line 894 "../src/DynamicNotebook.vala"
				return result;
#line 7632 "DynamicNotebook.c"
			}
#line 897 "../src/DynamicNotebook.vala"
			break;
#line 7636 "DynamicNotebook.c"
		}
#line 857 "../src/DynamicNotebook.vala"
		case GDK_KEY_1:
#line 857 "../src/DynamicNotebook.vala"
		case GDK_KEY_2:
#line 857 "../src/DynamicNotebook.vala"
		case GDK_KEY_3:
#line 857 "../src/DynamicNotebook.vala"
		case GDK_KEY_4:
#line 857 "../src/DynamicNotebook.vala"
		case GDK_KEY_5:
#line 857 "../src/DynamicNotebook.vala"
		case GDK_KEY_6:
#line 857 "../src/DynamicNotebook.vala"
		case GDK_KEY_7:
#line 857 "../src/DynamicNotebook.vala"
		case GDK_KEY_8:
#line 7654 "DynamicNotebook.c"
		{
#line 907 "../src/DynamicNotebook.vala"
			if ((e->state & GDK_MOD1_MASK) == GDK_MOD1_MASK) {
#line 7658 "DynamicNotebook.c"
				guint i = 0U;
				gint n_pages = 0;
				GtkNotebook* _tmp7_;
				guint _tmp8_ = 0U;
				GtkNotebook* _tmp9_;
#line 908 "../src/DynamicNotebook.vala"
				i = e->keyval - 49;
#line 909 "../src/DynamicNotebook.vala"
				_tmp7_ = self->priv->notebook;
#line 909 "../src/DynamicNotebook.vala"
				n_pages = gtk_notebook_get_n_pages (_tmp7_);
#line 910 "../src/DynamicNotebook.vala"
				if (i >= ((guint) n_pages)) {
#line 910 "../src/DynamicNotebook.vala"
					_tmp8_ = (guint) (n_pages - 1);
#line 7674 "DynamicNotebook.c"
				} else {
#line 910 "../src/DynamicNotebook.vala"
					_tmp8_ = i;
#line 7678 "DynamicNotebook.c"
				}
#line 910 "../src/DynamicNotebook.vala"
				_tmp9_ = self->priv->notebook;
#line 910 "../src/DynamicNotebook.vala"
				g_object_set (_tmp9_, "page", (gint) _tmp8_, NULL);
#line 911 "../src/DynamicNotebook.vala"
				result = TRUE;
#line 911 "../src/DynamicNotebook.vala"
				return result;
#line 7688 "DynamicNotebook.c"
			}
#line 914 "../src/DynamicNotebook.vala"
			break;
#line 7692 "DynamicNotebook.c"
		}
#line 857 "../src/DynamicNotebook.vala"
		case GDK_KEY_9:
#line 7696 "DynamicNotebook.c"
		{
#line 917 "../src/DynamicNotebook.vala"
			if ((e->state & GDK_MOD1_MASK) == GDK_MOD1_MASK) {
#line 7700 "DynamicNotebook.c"
				GtkNotebook* _tmp10_;
				GtkNotebook* _tmp11_;
#line 918 "../src/DynamicNotebook.vala"
				_tmp10_ = self->priv->notebook;
#line 918 "../src/DynamicNotebook.vala"
				_tmp11_ = self->priv->notebook;
#line 918 "../src/DynamicNotebook.vala"
				g_object_set (_tmp10_, "page", gtk_notebook_get_n_pages (_tmp11_) - 1, NULL);
#line 919 "../src/DynamicNotebook.vala"
				result = TRUE;
#line 919 "../src/DynamicNotebook.vala"
				return result;
#line 7713 "DynamicNotebook.c"
			}
#line 922 "../src/DynamicNotebook.vala"
			break;
#line 7717 "DynamicNotebook.c"
		}
		default:
#line 857 "../src/DynamicNotebook.vala"
		break;
#line 7722 "DynamicNotebook.c"
	}
#line 925 "../src/DynamicNotebook.vala"
	result = FALSE;
#line 925 "../src/DynamicNotebook.vala"
	return result;
#line 7728 "DynamicNotebook.c"
}

static gboolean
__dynamic_notebook___lambda32__gtk_widget_key_press_event (GtkWidget* _sender,
                                                           GdkEventKey* event,
                                                           gpointer self)
{
	gboolean result;
	result = _dynamic_notebook___lambda32_ ((DynamicNotebook*) self, event);
#line 854 "../src/DynamicNotebook.vala"
	return result;
#line 7740 "DynamicNotebook.c"
}

static void
_dynamic_notebook_on_switch_page_gtk_notebook_switch_page (GtkNotebook* _sender,
                                                           GtkWidget* page,
                                                           guint page_num,
                                                           gpointer self)
{
#line 929 "../src/DynamicNotebook.vala"
	dynamic_notebook_on_switch_page ((DynamicNotebook*) self, page, page_num);
#line 7751 "DynamicNotebook.c"
}

static void
_dynamic_notebook_on_page_added_gtk_notebook_page_added (GtkNotebook* _sender,
                                                         GtkWidget* child,
                                                         guint page_num,
                                                         gpointer self)
{
#line 930 "../src/DynamicNotebook.vala"
	dynamic_notebook_on_page_added ((DynamicNotebook*) self, child, page_num);
#line 7762 "DynamicNotebook.c"
}

static void
_dynamic_notebook_on_page_removed_gtk_notebook_page_removed (GtkNotebook* _sender,
                                                             GtkWidget* child,
                                                             guint page_num,
                                                             gpointer self)
{
#line 931 "../src/DynamicNotebook.vala"
	dynamic_notebook_on_page_removed ((DynamicNotebook*) self, child, page_num);
#line 7773 "DynamicNotebook.c"
}

static void
_dynamic_notebook_on_page_reordered_gtk_notebook_page_reordered (GtkNotebook* _sender,
                                                                 GtkWidget* child,
                                                                 guint page_num,
                                                                 gpointer self)
{
#line 932 "../src/DynamicNotebook.vala"
	dynamic_notebook_on_page_reordered ((DynamicNotebook*) self, child, page_num);
#line 7784 "DynamicNotebook.c"
}

static GtkNotebook*
_dynamic_notebook_on_create_window_gtk_notebook_create_window (GtkNotebook* _sender,
                                                               GtkWidget* page,
                                                               gint x,
                                                               gint y,
                                                               gpointer self)
{
	GtkNotebook* result;
	result = dynamic_notebook_on_create_window ((DynamicNotebook*) self, page, x, y);
#line 933 "../src/DynamicNotebook.vala"
	return result;
#line 7798 "DynamicNotebook.c"
}

static void
_dynamic_notebook___lambda33_ (DynamicNotebook* self)
{
	GtkNotebook* _tmp0_;
	guint _tmp1_;
	GtkNotebook* _tmp2_;
	guint _tmp3_;
	GtkNotebook* _tmp4_;
	guint _tmp5_;
	GtkNotebook* _tmp6_;
	guint _tmp7_;
	GtkNotebook* _tmp8_;
	guint _tmp9_;
#line 929 "../src/DynamicNotebook.vala"
	_tmp0_ = self->priv->notebook;
#line 929 "../src/DynamicNotebook.vala"
	g_signal_parse_name ("switch-page", gtk_notebook_get_type (), &_tmp1_, NULL, FALSE);
#line 929 "../src/DynamicNotebook.vala"
	g_signal_handlers_disconnect_matched (_tmp0_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp1_, 0, NULL, (GCallback) _dynamic_notebook_on_switch_page_gtk_notebook_switch_page, self);
#line 930 "../src/DynamicNotebook.vala"
	_tmp2_ = self->priv->notebook;
#line 930 "../src/DynamicNotebook.vala"
	g_signal_parse_name ("page-added", gtk_notebook_get_type (), &_tmp3_, NULL, FALSE);
#line 930 "../src/DynamicNotebook.vala"
	g_signal_handlers_disconnect_matched (_tmp2_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp3_, 0, NULL, (GCallback) _dynamic_notebook_on_page_added_gtk_notebook_page_added, self);
#line 931 "../src/DynamicNotebook.vala"
	_tmp4_ = self->priv->notebook;
#line 931 "../src/DynamicNotebook.vala"
	g_signal_parse_name ("page-removed", gtk_notebook_get_type (), &_tmp5_, NULL, FALSE);
#line 931 "../src/DynamicNotebook.vala"
	g_signal_handlers_disconnect_matched (_tmp4_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp5_, 0, NULL, (GCallback) _dynamic_notebook_on_page_removed_gtk_notebook_page_removed, self);
#line 932 "../src/DynamicNotebook.vala"
	_tmp6_ = self->priv->notebook;
#line 932 "../src/DynamicNotebook.vala"
	g_signal_parse_name ("page-reordered", gtk_notebook_get_type (), &_tmp7_, NULL, FALSE);
#line 932 "../src/DynamicNotebook.vala"
	g_signal_handlers_disconnect_matched (_tmp6_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp7_, 0, NULL, (GCallback) _dynamic_notebook_on_page_reordered_gtk_notebook_page_reordered, self);
#line 933 "../src/DynamicNotebook.vala"
	_tmp8_ = self->priv->notebook;
#line 933 "../src/DynamicNotebook.vala"
	g_signal_parse_name ("create-window", gtk_notebook_get_type (), &_tmp9_, NULL, FALSE);
#line 933 "../src/DynamicNotebook.vala"
	g_signal_handlers_disconnect_matched (_tmp8_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp9_, 0, NULL, (GCallback) _dynamic_notebook_on_create_window_gtk_notebook_create_window, self);
#line 7844 "DynamicNotebook.c"
}

static void
__dynamic_notebook___lambda33__gtk_widget_destroy (GtkWidget* _sender,
                                                   gpointer self)
{
#line 928 "../src/DynamicNotebook.vala"
	_dynamic_notebook___lambda33_ ((DynamicNotebook*) self);
#line 7853 "DynamicNotebook.c"
}

static GObject *
dynamic_notebook_constructor (GType type,
                              guint n_construct_properties,
                              GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	DynamicNotebook * self;
	GtkNotebook* _tmp0_;
	GtkNotebook* _tmp1_;
	GtkStyleContext* _tmp2_;
	GtkNotebook* _tmp3_;
	GtkNotebook* _tmp4_;
	GtkNotebook* _tmp5_;
	GtkMenu* _tmp6_;
	GtkMenu* _tmp7_;
	GtkMenuItem* _tmp8_;
	GtkMenuItem* _tmp9_;
	GtkMenuItem* _tmp10_;
	GtkMenu* _tmp11_;
	GtkMenuItem* _tmp12_;
	GtkMenu* _tmp13_;
	GtkMenuItem* _tmp14_;
	GtkMenu* _tmp15_;
	GtkMenuItem* _tmp16_;
	GtkMenuItem* _tmp17_;
	ClosedTabs* _tmp18_;
	ClosedTabs* _tmp19_;
	ClosedTabs* _tmp20_;
	GtkButton* _tmp21_;
	GtkButton* _tmp22_;
	GtkButton* _tmp23_;
	GtkButton* _tmp24_;
	GtkButton* _tmp25_;
	GtkButton* _tmp26_;
	GtkButton* _tmp27_;
	GtkButton* _tmp28_;
	GtkButton* _tmp29_;
	GtkNotebook* _tmp30_;
	GtkButton* _tmp31_;
	GtkNotebook* _tmp32_;
	GtkButton* _tmp33_;
	GtkButton* _tmp34_;
	GtkButton* _tmp35_;
	GtkButton* _tmp36_;
	GtkMenuItem* _tmp37_;
	gboolean _tmp38_;
	gboolean _tmp39_;
	GtkButton* _tmp40_;
	gboolean _tmp41_;
	gboolean _tmp42_;
	GtkNotebook* _tmp43_;
	GtkNotebook* _tmp44_;
	GtkNotebook* _tmp45_;
	GtkNotebook* _tmp46_;
	GtkNotebook* _tmp47_;
#line 749 "../src/DynamicNotebook.vala"
	parent_class = G_OBJECT_CLASS (dynamic_notebook_parent_class);
#line 749 "../src/DynamicNotebook.vala"
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
#line 749 "../src/DynamicNotebook.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_DYNAMIC_NOTEBOOK, DynamicNotebook);
#line 750 "../src/DynamicNotebook.vala"
	_tmp0_ = (GtkNotebook*) gtk_notebook_new ();
#line 750 "../src/DynamicNotebook.vala"
	g_object_ref_sink (_tmp0_);
#line 750 "../src/DynamicNotebook.vala"
	_g_object_unref0 (self->priv->notebook);
#line 750 "../src/DynamicNotebook.vala"
	self->priv->notebook = _tmp0_;
#line 751 "../src/DynamicNotebook.vala"
	_tmp1_ = self->priv->notebook;
#line 751 "../src/DynamicNotebook.vala"
	gtk_widget_set_can_focus ((GtkWidget*) _tmp1_, FALSE);
#line 752 "../src/DynamicNotebook.vala"
	gtk_event_box_set_visible_window ((GtkEventBox*) self, FALSE);
#line 753 "../src/DynamicNotebook.vala"
	_tmp2_ = gtk_widget_get_style_context ((GtkWidget*) self);
#line 753 "../src/DynamicNotebook.vala"
	gtk_style_context_add_class (_tmp2_, "dynamic-notebook");
#line 755 "../src/DynamicNotebook.vala"
	_tmp3_ = self->priv->notebook;
#line 755 "../src/DynamicNotebook.vala"
	gtk_notebook_set_scrollable (_tmp3_, TRUE);
#line 756 "../src/DynamicNotebook.vala"
	_tmp4_ = self->priv->notebook;
#line 756 "../src/DynamicNotebook.vala"
	gtk_notebook_set_show_border (_tmp4_, FALSE);
#line 757 "../src/DynamicNotebook.vala"
	self->priv->_tab_bar_behavior = DYNAMIC_NOTEBOOK_TAB_BAR_BEHAVIOR_ALWAYS;
#line 759 "../src/DynamicNotebook.vala"
	g_signal_connect_object ((GtkWidget*) self, "draw", (GCallback) __dynamic_notebook___lambda22__gtk_widget_draw, self, 0);
#line 764 "../src/DynamicNotebook.vala"
	_tmp5_ = self->priv->notebook;
#line 764 "../src/DynamicNotebook.vala"
	gtk_container_add ((GtkContainer*) self, (GtkWidget*) _tmp5_);
#line 766 "../src/DynamicNotebook.vala"
	_tmp6_ = (GtkMenu*) gtk_menu_new ();
#line 766 "../src/DynamicNotebook.vala"
	g_object_ref_sink (_tmp6_);
#line 766 "../src/DynamicNotebook.vala"
	_tmp7_ = _tmp6_;
#line 766 "../src/DynamicNotebook.vala"
	dynamic_notebook_set_menu (self, _tmp7_);
#line 766 "../src/DynamicNotebook.vala"
	_g_object_unref0 (_tmp7_);
#line 767 "../src/DynamicNotebook.vala"
	_tmp8_ = (GtkMenuItem*) gtk_menu_item_new_with_label (_ ("New Tab"));
#line 767 "../src/DynamicNotebook.vala"
	g_object_ref_sink (_tmp8_);
#line 767 "../src/DynamicNotebook.vala"
	_g_object_unref0 (self->priv->new_tab_m);
#line 767 "../src/DynamicNotebook.vala"
	self->priv->new_tab_m = _tmp8_;
#line 768 "../src/DynamicNotebook.vala"
	_tmp9_ = (GtkMenuItem*) gtk_menu_item_new_with_label (_ ("Undo Close Tab"));
#line 768 "../src/DynamicNotebook.vala"
	g_object_ref_sink (_tmp9_);
#line 768 "../src/DynamicNotebook.vala"
	_g_object_unref0 (self->priv->restore_tab_m);
#line 768 "../src/DynamicNotebook.vala"
	self->priv->restore_tab_m = _tmp9_;
#line 769 "../src/DynamicNotebook.vala"
	_tmp10_ = self->priv->restore_tab_m;
#line 769 "../src/DynamicNotebook.vala"
	gtk_widget_set_sensitive ((GtkWidget*) _tmp10_, FALSE);
#line 770 "../src/DynamicNotebook.vala"
	_tmp11_ = self->priv->_menu;
#line 770 "../src/DynamicNotebook.vala"
	_tmp12_ = self->priv->new_tab_m;
#line 770 "../src/DynamicNotebook.vala"
	gtk_menu_shell_append ((GtkMenuShell*) _tmp11_, _tmp12_);
#line 771 "../src/DynamicNotebook.vala"
	_tmp13_ = self->priv->_menu;
#line 771 "../src/DynamicNotebook.vala"
	_tmp14_ = self->priv->restore_tab_m;
#line 771 "../src/DynamicNotebook.vala"
	gtk_menu_shell_append ((GtkMenuShell*) _tmp13_, _tmp14_);
#line 772 "../src/DynamicNotebook.vala"
	_tmp15_ = self->priv->_menu;
#line 772 "../src/DynamicNotebook.vala"
	gtk_widget_show_all ((GtkWidget*) _tmp15_);
#line 774 "../src/DynamicNotebook.vala"
	_tmp16_ = self->priv->new_tab_m;
#line 774 "../src/DynamicNotebook.vala"
	g_signal_connect_object (_tmp16_, "activate", (GCallback) __dynamic_notebook___lambda23__gtk_menu_item_activate, self, 0);
#line 778 "../src/DynamicNotebook.vala"
	_tmp17_ = self->priv->restore_tab_m;
#line 778 "../src/DynamicNotebook.vala"
	g_signal_connect_object (_tmp17_, "activate", (GCallback) __dynamic_notebook___lambda24__gtk_menu_item_activate, self, 0);
#line 782 "../src/DynamicNotebook.vala"
	_tmp18_ = closed_tabs_new ();
#line 782 "../src/DynamicNotebook.vala"
	_g_object_unref0 (self->priv->closed_tabs);
#line 782 "../src/DynamicNotebook.vala"
	self->priv->closed_tabs = _tmp18_;
#line 783 "../src/DynamicNotebook.vala"
	_tmp19_ = self->priv->closed_tabs;
#line 783 "../src/DynamicNotebook.vala"
	g_signal_connect_object (_tmp19_, "restored", (GCallback) __dynamic_notebook___lambda25__closed_tabs_restored, self, 0);
#line 791 "../src/DynamicNotebook.vala"
	_tmp20_ = self->priv->closed_tabs;
#line 791 "../src/DynamicNotebook.vala"
	g_signal_connect_object (_tmp20_, "cleared", (GCallback) __dynamic_notebook___lambda26__closed_tabs_cleared, self, 0);
#line 796 "../src/DynamicNotebook.vala"
	_tmp21_ = (GtkButton*) gtk_button_new_from_icon_name ("list-add-symbolic", (GtkIconSize) GTK_ICON_SIZE_MENU);
#line 796 "../src/DynamicNotebook.vala"
	g_object_ref_sink (_tmp21_);
#line 796 "../src/DynamicNotebook.vala"
	_g_object_unref0 (self->priv->add_button);
#line 796 "../src/DynamicNotebook.vala"
	self->priv->add_button = _tmp21_;
#line 797 "../src/DynamicNotebook.vala"
	_tmp22_ = self->priv->add_button;
#line 797 "../src/DynamicNotebook.vala"
	gtk_button_set_relief (_tmp22_, GTK_RELIEF_NONE);
#line 798 "../src/DynamicNotebook.vala"
	_tmp23_ = self->priv->add_button;
#line 798 "../src/DynamicNotebook.vala"
	gtk_widget_set_tooltip_text ((GtkWidget*) _tmp23_, _ ("New Tab"));
#line 807 "../src/DynamicNotebook.vala"
	_tmp24_ = (GtkButton*) gtk_button_new_from_icon_name ("document-open-recent-symbolic", (GtkIconSize) GTK_ICON_SIZE_MENU);
#line 807 "../src/DynamicNotebook.vala"
	g_object_ref_sink (_tmp24_);
#line 807 "../src/DynamicNotebook.vala"
	_g_object_unref0 (self->priv->restore_button);
#line 807 "../src/DynamicNotebook.vala"
	self->priv->restore_button = _tmp24_;
#line 808 "../src/DynamicNotebook.vala"
	_tmp25_ = self->priv->restore_button;
#line 808 "../src/DynamicNotebook.vala"
	gtk_widget_set_margin_end ((GtkWidget*) _tmp25_, 3);
#line 809 "../src/DynamicNotebook.vala"
	_tmp26_ = self->priv->restore_button;
#line 809 "../src/DynamicNotebook.vala"
	gtk_button_set_relief (_tmp26_, GTK_RELIEF_NONE);
#line 810 "../src/DynamicNotebook.vala"
	_tmp27_ = self->priv->restore_button;
#line 810 "../src/DynamicNotebook.vala"
	gtk_widget_set_tooltip_text ((GtkWidget*) _tmp27_, _ ("Closed Tabs"));
#line 811 "../src/DynamicNotebook.vala"
	_tmp28_ = self->priv->restore_button;
#line 811 "../src/DynamicNotebook.vala"
	gtk_widget_set_sensitive ((GtkWidget*) _tmp28_, FALSE);
#line 812 "../src/DynamicNotebook.vala"
	_tmp29_ = self->priv->restore_button;
#line 812 "../src/DynamicNotebook.vala"
	gtk_widget_show ((GtkWidget*) _tmp29_);
#line 814 "../src/DynamicNotebook.vala"
	_tmp30_ = self->priv->notebook;
#line 814 "../src/DynamicNotebook.vala"
	_tmp31_ = self->priv->add_button;
#line 814 "../src/DynamicNotebook.vala"
	gtk_notebook_set_action_widget (_tmp30_, (GtkWidget*) _tmp31_, GTK_PACK_START);
#line 815 "../src/DynamicNotebook.vala"
	_tmp32_ = self->priv->notebook;
#line 815 "../src/DynamicNotebook.vala"
	_tmp33_ = self->priv->restore_button;
#line 815 "../src/DynamicNotebook.vala"
	gtk_notebook_set_action_widget (_tmp32_, (GtkWidget*) _tmp33_, GTK_PACK_END);
#line 818 "../src/DynamicNotebook.vala"
	_tmp34_ = self->priv->add_button;
#line 818 "../src/DynamicNotebook.vala"
	g_signal_connect_object (_tmp34_, "clicked", (GCallback) __dynamic_notebook___lambda27__gtk_button_clicked, self, 0);
#line 822 "../src/DynamicNotebook.vala"
	_tmp35_ = self->priv->add_button;
#line 822 "../src/DynamicNotebook.vala"
	g_signal_connect_object ((GtkWidget*) _tmp35_, "button-press-event", (GCallback) __dynamic_notebook___lambda28__gtk_widget_button_press_event, self, 0);
#line 827 "../src/DynamicNotebook.vala"
	_tmp36_ = self->priv->restore_button;
#line 827 "../src/DynamicNotebook.vala"
	g_signal_connect_object (_tmp36_, "clicked", (GCallback) __dynamic_notebook___lambda29__gtk_button_clicked, self, 0);
#line 834 "../src/DynamicNotebook.vala"
	_tmp37_ = self->priv->restore_tab_m;
#line 834 "../src/DynamicNotebook.vala"
	_tmp38_ = dynamic_notebook_get_allow_restoring (self);
#line 834 "../src/DynamicNotebook.vala"
	_tmp39_ = _tmp38_;
#line 834 "../src/DynamicNotebook.vala"
	gtk_widget_set_visible ((GtkWidget*) _tmp37_, _tmp39_);
#line 835 "../src/DynamicNotebook.vala"
	_tmp40_ = self->priv->restore_button;
#line 835 "../src/DynamicNotebook.vala"
	_tmp41_ = dynamic_notebook_get_allow_restoring (self);
#line 835 "../src/DynamicNotebook.vala"
	_tmp42_ = _tmp41_;
#line 835 "../src/DynamicNotebook.vala"
	gtk_widget_set_visible ((GtkWidget*) _tmp40_, _tmp42_);
#line 837 "../src/DynamicNotebook.vala"
	g_signal_connect_object ((GtkWidget*) self, "size-allocate", (GCallback) __dynamic_notebook___lambda30__gtk_widget_size_allocate, self, 0);
#line 841 "../src/DynamicNotebook.vala"
	g_signal_connect_object ((GtkWidget*) self, "button-press-event", (GCallback) __dynamic_notebook___lambda31__gtk_widget_button_press_event, self, 0);
#line 854 "../src/DynamicNotebook.vala"
	g_signal_connect_object ((GtkWidget*) self, "key-press-event", (GCallback) __dynamic_notebook___lambda32__gtk_widget_key_press_event, self, 0);
#line 928 "../src/DynamicNotebook.vala"
	g_signal_connect_object ((GtkWidget*) self, "destroy", (GCallback) __dynamic_notebook___lambda33__gtk_widget_destroy, self, 0);
#line 936 "../src/DynamicNotebook.vala"
	_tmp43_ = self->priv->notebook;
#line 936 "../src/DynamicNotebook.vala"
	g_signal_connect_object (_tmp43_, "switch-page", (GCallback) _dynamic_notebook_on_switch_page_gtk_notebook_switch_page, self, 0);
#line 937 "../src/DynamicNotebook.vala"
	_tmp44_ = self->priv->notebook;
#line 937 "../src/DynamicNotebook.vala"
	g_signal_connect_object (_tmp44_, "page-added", (GCallback) _dynamic_notebook_on_page_added_gtk_notebook_page_added, self, 0);
#line 938 "../src/DynamicNotebook.vala"
	_tmp45_ = self->priv->notebook;
#line 938 "../src/DynamicNotebook.vala"
	g_signal_connect_object (_tmp45_, "page-removed", (GCallback) _dynamic_notebook_on_page_removed_gtk_notebook_page_removed, self, 0);
#line 939 "../src/DynamicNotebook.vala"
	_tmp46_ = self->priv->notebook;
#line 939 "../src/DynamicNotebook.vala"
	g_signal_connect_object (_tmp46_, "page-reordered", (GCallback) _dynamic_notebook_on_page_reordered_gtk_notebook_page_reordered, self, 0);
#line 940 "../src/DynamicNotebook.vala"
	_tmp47_ = self->priv->notebook;
#line 940 "../src/DynamicNotebook.vala"
	g_signal_connect_object (_tmp47_, "create-window", (GCallback) _dynamic_notebook_on_create_window_gtk_notebook_create_window, self, 0);
#line 749 "../src/DynamicNotebook.vala"
	return obj;
#line 8134 "DynamicNotebook.c"
}

static void
dynamic_notebook_class_init (DynamicNotebookClass * klass,
                             gpointer klass_data)
{
#line 513 "../src/DynamicNotebook.vala"
	dynamic_notebook_parent_class = g_type_class_peek_parent (klass);
#line 513 "../src/DynamicNotebook.vala"
	g_type_class_adjust_private_offset (klass, &DynamicNotebook_private_offset);
#line 513 "../src/DynamicNotebook.vala"
	((GtkWidgetClass *) klass)->show = (void (*) (GtkWidget*)) dynamic_notebook_real_show;
#line 513 "../src/DynamicNotebook.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_dynamic_notebook_get_property;
#line 513 "../src/DynamicNotebook.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_dynamic_notebook_set_property;
#line 513 "../src/DynamicNotebook.vala"
	G_OBJECT_CLASS (klass)->constructor = dynamic_notebook_constructor;
#line 513 "../src/DynamicNotebook.vala"
	G_OBJECT_CLASS (klass)->finalize = dynamic_notebook_finalize;
#line 8155 "DynamicNotebook.c"
	/**
	         * number of pages
	         */
#line 513 "../src/DynamicNotebook.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), DYNAMIC_NOTEBOOK_N_TABS_PROPERTY, dynamic_notebook_properties[DYNAMIC_NOTEBOOK_N_TABS_PROPERTY] = g_param_spec_int ("n-tabs", "n-tabs", "n-tabs", G_MININT, G_MAXINT, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 8161 "DynamicNotebook.c"
	/**
	         * Hide the tab bar and only show the pages
	         */
#line 513 "../src/DynamicNotebook.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), DYNAMIC_NOTEBOOK_SHOW_TABS_PROPERTY, dynamic_notebook_properties[DYNAMIC_NOTEBOOK_SHOW_TABS_PROPERTY] = g_param_spec_boolean ("show-tabs", "show-tabs", "show-tabs", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 513 "../src/DynamicNotebook.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), DYNAMIC_NOTEBOOK_SHOW_ICONS_PROPERTY, dynamic_notebook_properties[DYNAMIC_NOTEBOOK_SHOW_ICONS_PROPERTY] = g_param_spec_boolean ("show-icons", "show-icons", "show-icons", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_DEPRECATED));
#line 513 "../src/DynamicNotebook.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), DYNAMIC_NOTEBOOK_TABS_CLOSABLE_PROPERTY, dynamic_notebook_properties[DYNAMIC_NOTEBOOK_TABS_CLOSABLE_PROPERTY] = g_param_spec_boolean ("tabs-closable", "tabs-closable", "tabs-closable", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 513 "../src/DynamicNotebook.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), DYNAMIC_NOTEBOOK_ALLOW_DRAG_PROPERTY, dynamic_notebook_properties[DYNAMIC_NOTEBOOK_ALLOW_DRAG_PROPERTY] = g_param_spec_boolean ("allow-drag", "allow-drag", "allow-drag", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 513 "../src/DynamicNotebook.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), DYNAMIC_NOTEBOOK_ALLOW_NEW_WINDOW_PROPERTY, dynamic_notebook_properties[DYNAMIC_NOTEBOOK_ALLOW_NEW_WINDOW_PROPERTY] = g_param_spec_boolean ("allow-new-window", "allow-new-window", "allow-new-window", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 513 "../src/DynamicNotebook.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), DYNAMIC_NOTEBOOK_ALLOW_DUPLICATION_PROPERTY, dynamic_notebook_properties[DYNAMIC_NOTEBOOK_ALLOW_DUPLICATION_PROPERTY] = g_param_spec_boolean ("allow-duplication", "allow-duplication", "allow-duplication", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 513 "../src/DynamicNotebook.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), DYNAMIC_NOTEBOOK_ALLOW_RESTORING_PROPERTY, dynamic_notebook_properties[DYNAMIC_NOTEBOOK_ALLOW_RESTORING_PROPERTY] = g_param_spec_boolean ("allow-restoring", "allow-restoring", "allow-restoring", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 8179 "DynamicNotebook.c"
	/**
	         * Set or get the upper limit of the size of the set
	         * of restorable tabs.
	         */
#line 513 "../src/DynamicNotebook.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), DYNAMIC_NOTEBOOK_MAX_RESTORABLE_TABS_PROPERTY, dynamic_notebook_properties[DYNAMIC_NOTEBOOK_MAX_RESTORABLE_TABS_PROPERTY] = g_param_spec_int ("max-restorable-tabs", "max-restorable-tabs", "max-restorable-tabs", G_MININT, G_MAXINT, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 513 "../src/DynamicNotebook.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), DYNAMIC_NOTEBOOK_ADD_BUTTON_VISIBLE_PROPERTY, dynamic_notebook_properties[DYNAMIC_NOTEBOOK_ADD_BUTTON_VISIBLE_PROPERTY] = g_param_spec_boolean ("add-button-visible", "add-button-visible", "add-button-visible", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 513 "../src/DynamicNotebook.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), DYNAMIC_NOTEBOOK_ALLOW_PINNING_PROPERTY, dynamic_notebook_properties[DYNAMIC_NOTEBOOK_ALLOW_PINNING_PROPERTY] = g_param_spec_boolean ("allow-pinning", "allow-pinning", "allow-pinning", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 513 "../src/DynamicNotebook.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), DYNAMIC_NOTEBOOK_FORCE_LEFT_PROPERTY, dynamic_notebook_properties[DYNAMIC_NOTEBOOK_FORCE_LEFT_PROPERTY] = g_param_spec_boolean ("force-left", "force-left", "force-left", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 8192 "DynamicNotebook.c"
	/**
	        * The text shown in the add button tooltip
	        */
#line 513 "../src/DynamicNotebook.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), DYNAMIC_NOTEBOOK_ADD_BUTTON_TOOLTIP_PROPERTY, dynamic_notebook_properties[DYNAMIC_NOTEBOOK_ADD_BUTTON_TOOLTIP_PROPERTY] = g_param_spec_string ("add-button-tooltip", "add-button-tooltip", "add-button-tooltip", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 513 "../src/DynamicNotebook.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), DYNAMIC_NOTEBOOK_CURRENT_PROPERTY, dynamic_notebook_properties[DYNAMIC_NOTEBOOK_CURRENT_PROPERTY] = g_param_spec_object ("current", "current", "current", TYPE_TAB, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 513 "../src/DynamicNotebook.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), DYNAMIC_NOTEBOOK_TABS_PROPERTY, dynamic_notebook_properties[DYNAMIC_NOTEBOOK_TABS_PROPERTY] = g_param_spec_pointer ("tabs", "tabs", "tabs", G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 513 "../src/DynamicNotebook.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), DYNAMIC_NOTEBOOK_GROUP_NAME_PROPERTY, dynamic_notebook_properties[DYNAMIC_NOTEBOOK_GROUP_NAME_PROPERTY] = g_param_spec_string ("group-name", "group-name", "group-name", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 8204 "DynamicNotebook.c"
	/**
	         * The behavior of the tab bar and its visibility
	        */
#line 513 "../src/DynamicNotebook.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), DYNAMIC_NOTEBOOK_TAB_BAR_BEHAVIOR_PROPERTY, dynamic_notebook_properties[DYNAMIC_NOTEBOOK_TAB_BAR_BEHAVIOR_PROPERTY] = g_param_spec_enum ("tab-bar-behavior", "tab-bar-behavior", "tab-bar-behavior", DYNAMIC_NOTEBOOK_TYPE_TAB_BAR_BEHAVIOR, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 8210 "DynamicNotebook.c"
	/**
	         * The menu appearing when the notebook is clicked on a blank space
	         */
#line 513 "../src/DynamicNotebook.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), DYNAMIC_NOTEBOOK_MENU_PROPERTY, dynamic_notebook_properties[DYNAMIC_NOTEBOOK_MENU_PROPERTY] = g_param_spec_object ("menu", "menu", "menu", gtk_menu_get_type (), G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 513 "../src/DynamicNotebook.vala"
	dynamic_notebook_signals[DYNAMIC_NOTEBOOK_TAB_ADDED_SIGNAL] = g_signal_new ("tab-added", TYPE_DYNAMIC_NOTEBOOK, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__OBJECT, G_TYPE_NONE, 1, TYPE_TAB);
#line 513 "../src/DynamicNotebook.vala"
	dynamic_notebook_signals[DYNAMIC_NOTEBOOK_TAB_REMOVED_SIGNAL] = g_signal_new ("tab-removed", TYPE_DYNAMIC_NOTEBOOK, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__OBJECT, G_TYPE_NONE, 1, TYPE_TAB);
#line 513 "../src/DynamicNotebook.vala"
	dynamic_notebook_signals[DYNAMIC_NOTEBOOK_TAB_SWITCHED_SIGNAL] = g_signal_new ("tab-switched", TYPE_DYNAMIC_NOTEBOOK, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_user_marshal_VOID__OBJECT_OBJECT, G_TYPE_NONE, 2, TYPE_TAB, TYPE_TAB);
#line 513 "../src/DynamicNotebook.vala"
	dynamic_notebook_signals[DYNAMIC_NOTEBOOK_TAB_REORDERED_SIGNAL] = g_signal_new ("tab-reordered", TYPE_DYNAMIC_NOTEBOOK, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_user_marshal_VOID__OBJECT_INT, G_TYPE_NONE, 2, TYPE_TAB, G_TYPE_INT);
#line 513 "../src/DynamicNotebook.vala"
	dynamic_notebook_signals[DYNAMIC_NOTEBOOK_TAB_MOVED_SIGNAL] = g_signal_new ("tab-moved", TYPE_DYNAMIC_NOTEBOOK, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_user_marshal_VOID__OBJECT_INT_INT, G_TYPE_NONE, 3, TYPE_TAB, G_TYPE_INT, G_TYPE_INT);
#line 513 "../src/DynamicNotebook.vala"
	dynamic_notebook_signals[DYNAMIC_NOTEBOOK_TAB_DUPLICATED_SIGNAL] = g_signal_new ("tab-duplicated", TYPE_DYNAMIC_NOTEBOOK, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__OBJECT, G_TYPE_NONE, 1, TYPE_TAB);
#line 513 "../src/DynamicNotebook.vala"
	dynamic_notebook_signals[DYNAMIC_NOTEBOOK_TAB_RESTORED_SIGNAL] = g_signal_new ("tab-restored", TYPE_DYNAMIC_NOTEBOOK, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_user_marshal_VOID__STRING_STRING_OBJECT, G_TYPE_NONE, 3, G_TYPE_STRING, G_TYPE_STRING, g_icon_get_type ());
#line 513 "../src/DynamicNotebook.vala"
	dynamic_notebook_signals[DYNAMIC_NOTEBOOK_NEW_TAB_REQUESTED_SIGNAL] = g_signal_new ("new-tab-requested", TYPE_DYNAMIC_NOTEBOOK, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
#line 513 "../src/DynamicNotebook.vala"
	dynamic_notebook_signals[DYNAMIC_NOTEBOOK_CLOSE_TAB_REQUESTED_SIGNAL] = g_signal_new ("close-tab-requested", TYPE_DYNAMIC_NOTEBOOK, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_user_marshal_BOOLEAN__OBJECT, G_TYPE_BOOLEAN, 1, TYPE_TAB);
#line 8234 "DynamicNotebook.c"
}

static void
dynamic_notebook_instance_init (DynamicNotebook * self,
                                gpointer klass)
{
#line 513 "../src/DynamicNotebook.vala"
	self->priv = dynamic_notebook_get_instance_private (self);
#line 544 "../src/DynamicNotebook.vala"
	self->priv->_tabs_closable = TRUE;
#line 559 "../src/DynamicNotebook.vala"
	self->priv->_allow_drag = TRUE;
#line 573 "../src/DynamicNotebook.vala"
	self->priv->_allow_new_window = FALSE;
#line 587 "../src/DynamicNotebook.vala"
	self->priv->_allow_duplication = FALSE;
#line 602 "../src/DynamicNotebook.vala"
	self->priv->_allow_restoring = FALSE;
#line 624 "../src/DynamicNotebook.vala"
	self->priv->_add_button_visible = TRUE;
#line 641 "../src/DynamicNotebook.vala"
	self->priv->_allow_pinning = FALSE;
#line 653 "../src/DynamicNotebook.vala"
	self->priv->_force_left = TRUE;
#line 719 "../src/DynamicNotebook.vala"
	self->priv->tab_width = 150;
#line 8261 "DynamicNotebook.c"
}

static void
dynamic_notebook_finalize (GObject * obj)
{
	DynamicNotebook * self;
#line 513 "../src/DynamicNotebook.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_DYNAMIC_NOTEBOOK, DynamicNotebook);
#line 667 "../src/DynamicNotebook.vala"
	_g_free0 (self->priv->_add_button_tooltip);
#line 674 "../src/DynamicNotebook.vala"
	(self->priv->_tabs == NULL) ? NULL : (self->priv->_tabs = (_g_list_free__g_object_unref0_ (self->priv->_tabs), NULL));
#line 713 "../src/DynamicNotebook.vala"
	_g_object_unref0 (self->priv->_menu);
#line 715 "../src/DynamicNotebook.vala"
	_g_object_unref0 (self->priv->closed_tabs);
#line 717 "../src/DynamicNotebook.vala"
	_g_object_unref0 (self->priv->notebook);
#line 725 "../src/DynamicNotebook.vala"
	_g_object_unref0 (self->priv->old_tab);
#line 734 "../src/DynamicNotebook.vala"
	_g_object_unref0 (self->priv->new_tab_m);
#line 735 "../src/DynamicNotebook.vala"
	_g_object_unref0 (self->priv->restore_tab_m);
#line 737 "../src/DynamicNotebook.vala"
	_g_object_unref0 (self->priv->add_button);
#line 738 "../src/DynamicNotebook.vala"
	_g_object_unref0 (self->priv->restore_button);
#line 513 "../src/DynamicNotebook.vala"
	G_OBJECT_CLASS (dynamic_notebook_parent_class)->finalize (obj);
#line 8292 "DynamicNotebook.c"
}

/**
    * Tab bar widget designed for a variable number of tabs.
    * Supports showing a "New tab" button, restoring closed tabs, "pinning" tabs, and more.
    *
    * {{../doc/images/DynamicNotebook.png}}
    */
static GType
dynamic_notebook_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (DynamicNotebookClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) dynamic_notebook_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (DynamicNotebook), 0, (GInstanceInitFunc) dynamic_notebook_instance_init, NULL };
	GType dynamic_notebook_type_id;
	dynamic_notebook_type_id = g_type_register_static (gtk_event_box_get_type (), "DynamicNotebook", &g_define_type_info, 0);
	DynamicNotebook_private_offset = g_type_add_instance_private (dynamic_notebook_type_id, sizeof (DynamicNotebookPrivate));
	return dynamic_notebook_type_id;
}

GType
dynamic_notebook_get_type (void)
{
	static volatile gsize dynamic_notebook_type_id__once = 0;
	if (g_once_init_enter (&dynamic_notebook_type_id__once)) {
		GType dynamic_notebook_type_id;
		dynamic_notebook_type_id = dynamic_notebook_get_type_once ();
		g_once_init_leave (&dynamic_notebook_type_id__once, dynamic_notebook_type_id);
	}
	return dynamic_notebook_type_id__once;
}

static void
_vala_dynamic_notebook_get_property (GObject * object,
                                     guint property_id,
                                     GValue * value,
                                     GParamSpec * pspec)
{
	DynamicNotebook * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_DYNAMIC_NOTEBOOK, DynamicNotebook);
#line 513 "../src/DynamicNotebook.vala"
	switch (property_id) {
#line 513 "../src/DynamicNotebook.vala"
		case DYNAMIC_NOTEBOOK_N_TABS_PROPERTY:
#line 513 "../src/DynamicNotebook.vala"
		g_value_set_int (value, dynamic_notebook_get_n_tabs (self));
#line 513 "../src/DynamicNotebook.vala"
		break;
#line 513 "../src/DynamicNotebook.vala"
		case DYNAMIC_NOTEBOOK_SHOW_TABS_PROPERTY:
#line 513 "../src/DynamicNotebook.vala"
		g_value_set_boolean (value, dynamic_notebook_get_show_tabs (self));
#line 513 "../src/DynamicNotebook.vala"
		break;
#line 513 "../src/DynamicNotebook.vala"
		case DYNAMIC_NOTEBOOK_SHOW_ICONS_PROPERTY:
G_GNUC_BEGIN_IGNORE_DEPRECATIONS
#line 8348 "DynamicNotebook.c"
		g_value_set_boolean (value, dynamic_notebook_get_show_icons (self));
G_GNUC_END_IGNORE_DEPRECATIONS
#line 513 "../src/DynamicNotebook.vala"
		break;
#line 513 "../src/DynamicNotebook.vala"
		case DYNAMIC_NOTEBOOK_TABS_CLOSABLE_PROPERTY:
#line 513 "../src/DynamicNotebook.vala"
		g_value_set_boolean (value, dynamic_notebook_get_tabs_closable (self));
#line 513 "../src/DynamicNotebook.vala"
		break;
#line 513 "../src/DynamicNotebook.vala"
		case DYNAMIC_NOTEBOOK_ALLOW_DRAG_PROPERTY:
#line 513 "../src/DynamicNotebook.vala"
		g_value_set_boolean (value, dynamic_notebook_get_allow_drag (self));
#line 513 "../src/DynamicNotebook.vala"
		break;
#line 513 "../src/DynamicNotebook.vala"
		case DYNAMIC_NOTEBOOK_ALLOW_NEW_WINDOW_PROPERTY:
#line 513 "../src/DynamicNotebook.vala"
		g_value_set_boolean (value, dynamic_notebook_get_allow_new_window (self));
#line 513 "../src/DynamicNotebook.vala"
		break;
#line 513 "../src/DynamicNotebook.vala"
		case DYNAMIC_NOTEBOOK_ALLOW_DUPLICATION_PROPERTY:
#line 513 "../src/DynamicNotebook.vala"
		g_value_set_boolean (value, dynamic_notebook_get_allow_duplication (self));
#line 513 "../src/DynamicNotebook.vala"
		break;
#line 513 "../src/DynamicNotebook.vala"
		case DYNAMIC_NOTEBOOK_ALLOW_RESTORING_PROPERTY:
#line 513 "../src/DynamicNotebook.vala"
		g_value_set_boolean (value, dynamic_notebook_get_allow_restoring (self));
#line 513 "../src/DynamicNotebook.vala"
		break;
#line 513 "../src/DynamicNotebook.vala"
		case DYNAMIC_NOTEBOOK_MAX_RESTORABLE_TABS_PROPERTY:
#line 513 "../src/DynamicNotebook.vala"
		g_value_set_int (value, dynamic_notebook_get_max_restorable_tabs (self));
#line 513 "../src/DynamicNotebook.vala"
		break;
#line 513 "../src/DynamicNotebook.vala"
		case DYNAMIC_NOTEBOOK_ADD_BUTTON_VISIBLE_PROPERTY:
#line 513 "../src/DynamicNotebook.vala"
		g_value_set_boolean (value, dynamic_notebook_get_add_button_visible (self));
#line 513 "../src/DynamicNotebook.vala"
		break;
#line 513 "../src/DynamicNotebook.vala"
		case DYNAMIC_NOTEBOOK_ALLOW_PINNING_PROPERTY:
#line 513 "../src/DynamicNotebook.vala"
		g_value_set_boolean (value, dynamic_notebook_get_allow_pinning (self));
#line 513 "../src/DynamicNotebook.vala"
		break;
#line 513 "../src/DynamicNotebook.vala"
		case DYNAMIC_NOTEBOOK_FORCE_LEFT_PROPERTY:
#line 513 "../src/DynamicNotebook.vala"
		g_value_set_boolean (value, dynamic_notebook_get_force_left (self));
#line 513 "../src/DynamicNotebook.vala"
		break;
#line 513 "../src/DynamicNotebook.vala"
		case DYNAMIC_NOTEBOOK_ADD_BUTTON_TOOLTIP_PROPERTY:
#line 513 "../src/DynamicNotebook.vala"
		g_value_set_string (value, dynamic_notebook_get_add_button_tooltip (self));
#line 513 "../src/DynamicNotebook.vala"
		break;
#line 513 "../src/DynamicNotebook.vala"
		case DYNAMIC_NOTEBOOK_CURRENT_PROPERTY:
#line 513 "../src/DynamicNotebook.vala"
		g_value_set_object (value, dynamic_notebook_get_current (self));
#line 513 "../src/DynamicNotebook.vala"
		break;
#line 513 "../src/DynamicNotebook.vala"
		case DYNAMIC_NOTEBOOK_TABS_PROPERTY:
#line 513 "../src/DynamicNotebook.vala"
		g_value_set_pointer (value, dynamic_notebook_get_tabs (self));
#line 513 "../src/DynamicNotebook.vala"
		break;
#line 513 "../src/DynamicNotebook.vala"
		case DYNAMIC_NOTEBOOK_GROUP_NAME_PROPERTY:
#line 513 "../src/DynamicNotebook.vala"
		g_value_set_string (value, dynamic_notebook_get_group_name (self));
#line 513 "../src/DynamicNotebook.vala"
		break;
#line 513 "../src/DynamicNotebook.vala"
		case DYNAMIC_NOTEBOOK_TAB_BAR_BEHAVIOR_PROPERTY:
#line 513 "../src/DynamicNotebook.vala"
		g_value_set_enum (value, dynamic_notebook_get_tab_bar_behavior (self));
#line 513 "../src/DynamicNotebook.vala"
		break;
#line 513 "../src/DynamicNotebook.vala"
		case DYNAMIC_NOTEBOOK_MENU_PROPERTY:
#line 513 "../src/DynamicNotebook.vala"
		g_value_set_object (value, dynamic_notebook_get_menu (self));
#line 513 "../src/DynamicNotebook.vala"
		break;
#line 8443 "DynamicNotebook.c"
		default:
#line 513 "../src/DynamicNotebook.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 513 "../src/DynamicNotebook.vala"
		break;
#line 8449 "DynamicNotebook.c"
	}
}

static void
_vala_dynamic_notebook_set_property (GObject * object,
                                     guint property_id,
                                     const GValue * value,
                                     GParamSpec * pspec)
{
	DynamicNotebook * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_DYNAMIC_NOTEBOOK, DynamicNotebook);
#line 513 "../src/DynamicNotebook.vala"
	switch (property_id) {
#line 513 "../src/DynamicNotebook.vala"
		case DYNAMIC_NOTEBOOK_SHOW_TABS_PROPERTY:
#line 513 "../src/DynamicNotebook.vala"
		dynamic_notebook_set_show_tabs (self, g_value_get_boolean (value));
#line 513 "../src/DynamicNotebook.vala"
		break;
#line 513 "../src/DynamicNotebook.vala"
		case DYNAMIC_NOTEBOOK_SHOW_ICONS_PROPERTY:
G_GNUC_BEGIN_IGNORE_DEPRECATIONS
#line 8472 "DynamicNotebook.c"
		dynamic_notebook_set_show_icons (self, g_value_get_boolean (value));
G_GNUC_END_IGNORE_DEPRECATIONS
#line 513 "../src/DynamicNotebook.vala"
		break;
#line 513 "../src/DynamicNotebook.vala"
		case DYNAMIC_NOTEBOOK_TABS_CLOSABLE_PROPERTY:
#line 513 "../src/DynamicNotebook.vala"
		dynamic_notebook_set_tabs_closable (self, g_value_get_boolean (value));
#line 513 "../src/DynamicNotebook.vala"
		break;
#line 513 "../src/DynamicNotebook.vala"
		case DYNAMIC_NOTEBOOK_ALLOW_DRAG_PROPERTY:
#line 513 "../src/DynamicNotebook.vala"
		dynamic_notebook_set_allow_drag (self, g_value_get_boolean (value));
#line 513 "../src/DynamicNotebook.vala"
		break;
#line 513 "../src/DynamicNotebook.vala"
		case DYNAMIC_NOTEBOOK_ALLOW_NEW_WINDOW_PROPERTY:
#line 513 "../src/DynamicNotebook.vala"
		dynamic_notebook_set_allow_new_window (self, g_value_get_boolean (value));
#line 513 "../src/DynamicNotebook.vala"
		break;
#line 513 "../src/DynamicNotebook.vala"
		case DYNAMIC_NOTEBOOK_ALLOW_DUPLICATION_PROPERTY:
#line 513 "../src/DynamicNotebook.vala"
		dynamic_notebook_set_allow_duplication (self, g_value_get_boolean (value));
#line 513 "../src/DynamicNotebook.vala"
		break;
#line 513 "../src/DynamicNotebook.vala"
		case DYNAMIC_NOTEBOOK_ALLOW_RESTORING_PROPERTY:
#line 513 "../src/DynamicNotebook.vala"
		dynamic_notebook_set_allow_restoring (self, g_value_get_boolean (value));
#line 513 "../src/DynamicNotebook.vala"
		break;
#line 513 "../src/DynamicNotebook.vala"
		case DYNAMIC_NOTEBOOK_MAX_RESTORABLE_TABS_PROPERTY:
#line 513 "../src/DynamicNotebook.vala"
		dynamic_notebook_set_max_restorable_tabs (self, g_value_get_int (value));
#line 513 "../src/DynamicNotebook.vala"
		break;
#line 513 "../src/DynamicNotebook.vala"
		case DYNAMIC_NOTEBOOK_ADD_BUTTON_VISIBLE_PROPERTY:
#line 513 "../src/DynamicNotebook.vala"
		dynamic_notebook_set_add_button_visible (self, g_value_get_boolean (value));
#line 513 "../src/DynamicNotebook.vala"
		break;
#line 513 "../src/DynamicNotebook.vala"
		case DYNAMIC_NOTEBOOK_ALLOW_PINNING_PROPERTY:
#line 513 "../src/DynamicNotebook.vala"
		dynamic_notebook_set_allow_pinning (self, g_value_get_boolean (value));
#line 513 "../src/DynamicNotebook.vala"
		break;
#line 513 "../src/DynamicNotebook.vala"
		case DYNAMIC_NOTEBOOK_FORCE_LEFT_PROPERTY:
#line 513 "../src/DynamicNotebook.vala"
		dynamic_notebook_set_force_left (self, g_value_get_boolean (value));
#line 513 "../src/DynamicNotebook.vala"
		break;
#line 513 "../src/DynamicNotebook.vala"
		case DYNAMIC_NOTEBOOK_ADD_BUTTON_TOOLTIP_PROPERTY:
#line 513 "../src/DynamicNotebook.vala"
		dynamic_notebook_set_add_button_tooltip (self, g_value_get_string (value));
#line 513 "../src/DynamicNotebook.vala"
		break;
#line 513 "../src/DynamicNotebook.vala"
		case DYNAMIC_NOTEBOOK_CURRENT_PROPERTY:
#line 513 "../src/DynamicNotebook.vala"
		dynamic_notebook_set_current (self, g_value_get_object (value));
#line 513 "../src/DynamicNotebook.vala"
		break;
#line 513 "../src/DynamicNotebook.vala"
		case DYNAMIC_NOTEBOOK_GROUP_NAME_PROPERTY:
#line 513 "../src/DynamicNotebook.vala"
		dynamic_notebook_set_group_name (self, g_value_get_string (value));
#line 513 "../src/DynamicNotebook.vala"
		break;
#line 513 "../src/DynamicNotebook.vala"
		case DYNAMIC_NOTEBOOK_TAB_BAR_BEHAVIOR_PROPERTY:
#line 513 "../src/DynamicNotebook.vala"
		dynamic_notebook_set_tab_bar_behavior (self, g_value_get_enum (value));
#line 513 "../src/DynamicNotebook.vala"
		break;
#line 513 "../src/DynamicNotebook.vala"
		case DYNAMIC_NOTEBOOK_MENU_PROPERTY:
#line 513 "../src/DynamicNotebook.vala"
		dynamic_notebook_set_menu (self, g_value_get_object (value));
#line 513 "../src/DynamicNotebook.vala"
		break;
#line 8561 "DynamicNotebook.c"
		default:
#line 513 "../src/DynamicNotebook.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 513 "../src/DynamicNotebook.vala"
		break;
#line 8567 "DynamicNotebook.c"
	}
}

